/* BaseObject.c generated by valac 0.56.16, the Vala compiler
 * generated from BaseObject.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	OBJECTS_BASE_OBJECT_0_PROPERTY,
	OBJECTS_BASE_OBJECT_ID_PROPERTY,
	OBJECTS_BASE_OBJECT_NAME_PROPERTY,
	OBJECTS_BASE_OBJECT_KEYWORDS_PROPERTY,
	OBJECTS_BASE_OBJECT_ICON_NAME_PROPERTY,
	OBJECTS_BASE_OBJECT_UPDATE_TIMEOUT_ID_PROPERTY,
	OBJECTS_BASE_OBJECT_ID_STRING_PROPERTY,
	OBJECTS_BASE_OBJECT_VIEW_ID_PROPERTY,
	OBJECTS_BASE_OBJECT_TYPE_DELETE_PROPERTY,
	OBJECTS_BASE_OBJECT_TYPE_ADD_PROPERTY,
	OBJECTS_BASE_OBJECT_TYPE_UPDATE_PROPERTY,
	OBJECTS_BASE_OBJECT_OBJECT_TYPE_PROPERTY,
	OBJECTS_BASE_OBJECT_OBJECT_TYPE_STRING_PROPERTY,
	OBJECTS_BASE_OBJECT_TABLE_NAME_PROPERTY,
	OBJECTS_BASE_OBJECT_COLUMN_ORDER_NAME_PROPERTY,
	OBJECTS_BASE_OBJECT_NUM_PROPERTIES
};
static GParamSpec* objects_base_object_properties[OBJECTS_BASE_OBJECT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	OBJECTS_BASE_OBJECT_DELETED_SIGNAL,
	OBJECTS_BASE_OBJECT_UPDATED_SIGNAL,
	OBJECTS_BASE_OBJECT_NUM_SIGNALS
};
static guint objects_base_object_signals[OBJECTS_BASE_OBJECT_NUM_SIGNALS] = {0};

struct _ObjectsBaseObjectPrivate {
	gchar* _id;
	gchar* _name;
	gchar* _keywords;
	gchar* _icon_name;
	guint _update_timeout_id;
	gchar* _id_string;
	gchar* _view_id;
};

static gint ObjectsBaseObject_private_offset;
static gpointer objects_base_object_parent_class = NULL;

static gchar* objects_base_object_real_get_update_json (ObjectsBaseObject* self,
                                                 const gchar* uuid,
                                                 const gchar* temp_id);
static gchar* objects_base_object_real_get_add_json (ObjectsBaseObject* self,
                                              const gchar* temp_id,
                                              const gchar* uuid);
static gchar* objects_base_object_real_get_move_json (ObjectsBaseObject* self,
                                               const gchar* uuid,
                                               const gchar* new_project_id);
static gchar* objects_base_object_real_to_json (ObjectsBaseObject* self);
static void objects_base_object_finalize (GObject * obj);
static GType objects_base_object_get_type_once (void);
static void _vala_objects_base_object_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_objects_base_object_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
objects_base_object_get_instance_private (ObjectsBaseObject* self)
{
	return G_STRUCT_MEMBER_P (self, ObjectsBaseObject_private_offset);
}

static gchar*
objects_base_object_real_get_update_json (ObjectsBaseObject* self,
                                          const gchar* uuid,
                                          const gchar* temp_id)
{
	gchar* _tmp0_;
	gchar* result;
#line 156 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 157 "../core/Objects/BaseObject.vala"
	_tmp0_ = g_strdup ("");
#line 157 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 157 "../core/Objects/BaseObject.vala"
	return result;
#line 123 "BaseObject.c"
}

gchar*
objects_base_object_get_update_json (ObjectsBaseObject* self,
                                     const gchar* uuid,
                                     const gchar* temp_id)
{
	ObjectsBaseObjectClass* _klass_;
#line 156 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 156 "../core/Objects/BaseObject.vala"
	_klass_ = OBJECTS_BASE_OBJECT_GET_CLASS (self);
#line 156 "../core/Objects/BaseObject.vala"
	if (_klass_->get_update_json) {
#line 156 "../core/Objects/BaseObject.vala"
		return _klass_->get_update_json (self, uuid, temp_id);
#line 140 "BaseObject.c"
	}
#line 156 "../core/Objects/BaseObject.vala"
	return NULL;
#line 144 "BaseObject.c"
}

static gchar*
objects_base_object_real_get_add_json (ObjectsBaseObject* self,
                                       const gchar* temp_id,
                                       const gchar* uuid)
{
	gchar* _tmp0_;
	gchar* result;
#line 160 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (temp_id != NULL, NULL);
#line 160 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 161 "../core/Objects/BaseObject.vala"
	_tmp0_ = g_strdup ("");
#line 161 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 161 "../core/Objects/BaseObject.vala"
	return result;
#line 164 "BaseObject.c"
}

gchar*
objects_base_object_get_add_json (ObjectsBaseObject* self,
                                  const gchar* temp_id,
                                  const gchar* uuid)
{
	ObjectsBaseObjectClass* _klass_;
#line 160 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 160 "../core/Objects/BaseObject.vala"
	_klass_ = OBJECTS_BASE_OBJECT_GET_CLASS (self);
#line 160 "../core/Objects/BaseObject.vala"
	if (_klass_->get_add_json) {
#line 160 "../core/Objects/BaseObject.vala"
		return _klass_->get_add_json (self, temp_id, uuid);
#line 181 "BaseObject.c"
	}
#line 160 "../core/Objects/BaseObject.vala"
	return NULL;
#line 185 "BaseObject.c"
}

static gchar*
objects_base_object_real_get_move_json (ObjectsBaseObject* self,
                                        const gchar* uuid,
                                        const gchar* new_project_id)
{
	gchar* _tmp0_;
	gchar* result;
#line 164 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 164 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (new_project_id != NULL, NULL);
#line 165 "../core/Objects/BaseObject.vala"
	_tmp0_ = g_strdup ("");
#line 165 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 165 "../core/Objects/BaseObject.vala"
	return result;
#line 205 "BaseObject.c"
}

gchar*
objects_base_object_get_move_json (ObjectsBaseObject* self,
                                   const gchar* uuid,
                                   const gchar* new_project_id)
{
	ObjectsBaseObjectClass* _klass_;
#line 164 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../core/Objects/BaseObject.vala"
	_klass_ = OBJECTS_BASE_OBJECT_GET_CLASS (self);
#line 164 "../core/Objects/BaseObject.vala"
	if (_klass_->get_move_json) {
#line 164 "../core/Objects/BaseObject.vala"
		return _klass_->get_move_json (self, uuid, new_project_id);
#line 222 "BaseObject.c"
	}
#line 164 "../core/Objects/BaseObject.vala"
	return NULL;
#line 226 "BaseObject.c"
}

static gchar*
objects_base_object_real_to_json (ObjectsBaseObject* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 169 "../core/Objects/BaseObject.vala"
	_tmp0_ = g_strdup ("");
#line 169 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 169 "../core/Objects/BaseObject.vala"
	return result;
#line 240 "BaseObject.c"
}

gchar*
objects_base_object_to_json (ObjectsBaseObject* self)
{
	ObjectsBaseObjectClass* _klass_;
#line 168 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 168 "../core/Objects/BaseObject.vala"
	_klass_ = OBJECTS_BASE_OBJECT_GET_CLASS (self);
#line 168 "../core/Objects/BaseObject.vala"
	if (_klass_->to_json) {
#line 168 "../core/Objects/BaseObject.vala"
		return _klass_->to_json (self);
#line 255 "BaseObject.c"
	}
#line 168 "../core/Objects/BaseObject.vala"
	return NULL;
#line 259 "BaseObject.c"
}

ObjectsBaseObject*
objects_base_object_construct (GType object_type)
{
	ObjectsBaseObject * self = NULL;
#line 22 "../core/Objects/BaseObject.vala"
	self = (ObjectsBaseObject*) g_object_new (object_type, NULL);
#line 22 "../core/Objects/BaseObject.vala"
	return self;
#line 270 "BaseObject.c"
}

ObjectsBaseObject*
objects_base_object_new (void)
{
#line 22 "../core/Objects/BaseObject.vala"
	return objects_base_object_construct (OBJECTS_TYPE_BASE_OBJECT);
#line 278 "BaseObject.c"
}

const gchar*
objects_base_object_get_id (ObjectsBaseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->priv->_id;
#line 23 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 23 "../core/Objects/BaseObject.vala"
	return result;
#line 294 "BaseObject.c"
}

void
objects_base_object_set_id (ObjectsBaseObject* self,
                            const gchar* value)
{
	gchar* old_value;
#line 23 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 23 "../core/Objects/BaseObject.vala"
	old_value = objects_base_object_get_id (self);
#line 23 "../core/Objects/BaseObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 308 "BaseObject.c"
		gchar* _tmp0_;
#line 23 "../core/Objects/BaseObject.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../core/Objects/BaseObject.vala"
		_g_free0 (self->priv->_id);
#line 23 "../core/Objects/BaseObject.vala"
		self->priv->_id = _tmp0_;
#line 23 "../core/Objects/BaseObject.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_ID_PROPERTY]);
#line 318 "BaseObject.c"
	}
}

const gchar*
objects_base_object_get_name (ObjectsBaseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->priv->_name;
#line 24 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 24 "../core/Objects/BaseObject.vala"
	return result;
#line 335 "BaseObject.c"
}

void
objects_base_object_set_name (ObjectsBaseObject* self,
                              const gchar* value)
{
	gchar* old_value;
#line 24 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 24 "../core/Objects/BaseObject.vala"
	old_value = objects_base_object_get_name (self);
#line 24 "../core/Objects/BaseObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 349 "BaseObject.c"
		gchar* _tmp0_;
#line 24 "../core/Objects/BaseObject.vala"
		_tmp0_ = g_strdup (value);
#line 24 "../core/Objects/BaseObject.vala"
		_g_free0 (self->priv->_name);
#line 24 "../core/Objects/BaseObject.vala"
		self->priv->_name = _tmp0_;
#line 24 "../core/Objects/BaseObject.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_NAME_PROPERTY]);
#line 359 "BaseObject.c"
	}
}

const gchar*
objects_base_object_get_keywords (ObjectsBaseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->priv->_keywords;
#line 25 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 25 "../core/Objects/BaseObject.vala"
	return result;
#line 376 "BaseObject.c"
}

void
objects_base_object_set_keywords (ObjectsBaseObject* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 25 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 25 "../core/Objects/BaseObject.vala"
	old_value = objects_base_object_get_keywords (self);
#line 25 "../core/Objects/BaseObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 390 "BaseObject.c"
		gchar* _tmp0_;
#line 25 "../core/Objects/BaseObject.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../core/Objects/BaseObject.vala"
		_g_free0 (self->priv->_keywords);
#line 25 "../core/Objects/BaseObject.vala"
		self->priv->_keywords = _tmp0_;
#line 25 "../core/Objects/BaseObject.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_KEYWORDS_PROPERTY]);
#line 400 "BaseObject.c"
	}
}

const gchar*
objects_base_object_get_icon_name (ObjectsBaseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->priv->_icon_name;
#line 26 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 26 "../core/Objects/BaseObject.vala"
	return result;
#line 417 "BaseObject.c"
}

void
objects_base_object_set_icon_name (ObjectsBaseObject* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 26 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 26 "../core/Objects/BaseObject.vala"
	old_value = objects_base_object_get_icon_name (self);
#line 26 "../core/Objects/BaseObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 431 "BaseObject.c"
		gchar* _tmp0_;
#line 26 "../core/Objects/BaseObject.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../core/Objects/BaseObject.vala"
		_g_free0 (self->priv->_icon_name);
#line 26 "../core/Objects/BaseObject.vala"
		self->priv->_icon_name = _tmp0_;
#line 26 "../core/Objects/BaseObject.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_ICON_NAME_PROPERTY]);
#line 441 "BaseObject.c"
	}
}

guint
objects_base_object_get_update_timeout_id (ObjectsBaseObject* self)
{
	guint result;
#line 30 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 30 "../core/Objects/BaseObject.vala"
	result = self->priv->_update_timeout_id;
#line 30 "../core/Objects/BaseObject.vala"
	return result;
#line 455 "BaseObject.c"
}

void
objects_base_object_set_update_timeout_id (ObjectsBaseObject* self,
                                           guint value)
{
	guint old_value;
#line 30 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 30 "../core/Objects/BaseObject.vala"
	old_value = objects_base_object_get_update_timeout_id (self);
#line 30 "../core/Objects/BaseObject.vala"
	if (old_value != value) {
#line 30 "../core/Objects/BaseObject.vala"
		self->priv->_update_timeout_id = value;
#line 30 "../core/Objects/BaseObject.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_UPDATE_TIMEOUT_ID_PROPERTY]);
#line 473 "BaseObject.c"
	}
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1589 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1590 "glib-2.0.vapi"
	result = self;
#line 1590 "glib-2.0.vapi"
	return result;
#line 487 "BaseObject.c"
}

const gchar*
objects_base_object_get_id_string (ObjectsBaseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
#line 34 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->priv->_id;
#line 35 "../core/Objects/BaseObject.vala"
	_tmp1_ = string_to_string (_tmp0_);
#line 35 "../core/Objects/BaseObject.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 35 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_id_string);
#line 35 "../core/Objects/BaseObject.vala"
	self->priv->_id_string = _tmp2_;
#line 36 "../core/Objects/BaseObject.vala"
	_tmp3_ = self->priv->_id_string;
#line 36 "../core/Objects/BaseObject.vala"
	result = _tmp3_;
#line 36 "../core/Objects/BaseObject.vala"
	return result;
#line 516 "BaseObject.c"
}

const gchar*
objects_base_object_get_view_id (ObjectsBaseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 40 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->priv->_view_id;
#line 40 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 40 "../core/Objects/BaseObject.vala"
	return result;
#line 532 "BaseObject.c"
}

void
objects_base_object_set_view_id (ObjectsBaseObject* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 40 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 40 "../core/Objects/BaseObject.vala"
	old_value = objects_base_object_get_view_id (self);
#line 40 "../core/Objects/BaseObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 546 "BaseObject.c"
		gchar* _tmp0_;
#line 40 "../core/Objects/BaseObject.vala"
		_tmp0_ = g_strdup (value);
#line 40 "../core/Objects/BaseObject.vala"
		_g_free0 (self->priv->_view_id);
#line 40 "../core/Objects/BaseObject.vala"
		self->priv->_view_id = _tmp0_;
#line 40 "../core/Objects/BaseObject.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_VIEW_ID_PROPERTY]);
#line 556 "BaseObject.c"
	}
}

const gchar*
objects_base_object_get_type_delete (ObjectsBaseObject* self)
{
	const gchar* result;
#line 43 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_ITEM (self)) {
#line 45 "../core/Objects/BaseObject.vala"
		result = "item_delete";
#line 45 "../core/Objects/BaseObject.vala"
		return result;
#line 572 "BaseObject.c"
	} else {
#line 46 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_PROJECT (self)) {
#line 47 "../core/Objects/BaseObject.vala"
			result = "project_delete";
#line 47 "../core/Objects/BaseObject.vala"
			return result;
#line 580 "BaseObject.c"
		} else {
#line 48 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_SECTION (self)) {
#line 49 "../core/Objects/BaseObject.vala"
				result = "section_delete";
#line 49 "../core/Objects/BaseObject.vala"
				return result;
#line 588 "BaseObject.c"
			} else {
#line 50 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 51 "../core/Objects/BaseObject.vala"
					result = "label_delete";
#line 51 "../core/Objects/BaseObject.vala"
					return result;
#line 596 "BaseObject.c"
				} else {
#line 52 "../core/Objects/BaseObject.vala"
					if (OBJECTS_IS_REMINDER (self)) {
#line 53 "../core/Objects/BaseObject.vala"
						result = "reminder_delete";
#line 53 "../core/Objects/BaseObject.vala"
						return result;
#line 604 "BaseObject.c"
					} else {
#line 55 "../core/Objects/BaseObject.vala"
						result = "";
#line 55 "../core/Objects/BaseObject.vala"
						return result;
#line 610 "BaseObject.c"
					}
				}
			}
		}
	}
}

const gchar*
objects_base_object_get_type_add (ObjectsBaseObject* self)
{
	const gchar* result;
#line 61 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_ITEM (self)) {
#line 63 "../core/Objects/BaseObject.vala"
		result = "item_add";
#line 63 "../core/Objects/BaseObject.vala"
		return result;
#line 630 "BaseObject.c"
	} else {
#line 64 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_PROJECT (self)) {
#line 65 "../core/Objects/BaseObject.vala"
			result = "project_add";
#line 65 "../core/Objects/BaseObject.vala"
			return result;
#line 638 "BaseObject.c"
		} else {
#line 66 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_SECTION (self)) {
#line 67 "../core/Objects/BaseObject.vala"
				result = "section_add";
#line 67 "../core/Objects/BaseObject.vala"
				return result;
#line 646 "BaseObject.c"
			} else {
#line 68 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 69 "../core/Objects/BaseObject.vala"
					result = "label_add";
#line 69 "../core/Objects/BaseObject.vala"
					return result;
#line 654 "BaseObject.c"
				} else {
#line 71 "../core/Objects/BaseObject.vala"
					result = "";
#line 71 "../core/Objects/BaseObject.vala"
					return result;
#line 660 "BaseObject.c"
				}
			}
		}
	}
}

const gchar*
objects_base_object_get_type_update (ObjectsBaseObject* self)
{
	const gchar* result;
#line 77 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_ITEM (self)) {
#line 79 "../core/Objects/BaseObject.vala"
		result = "item_update";
#line 79 "../core/Objects/BaseObject.vala"
		return result;
#line 679 "BaseObject.c"
	} else {
#line 80 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_PROJECT (self)) {
#line 81 "../core/Objects/BaseObject.vala"
			result = "project_update";
#line 81 "../core/Objects/BaseObject.vala"
			return result;
#line 687 "BaseObject.c"
		} else {
#line 82 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_SECTION (self)) {
#line 83 "../core/Objects/BaseObject.vala"
				result = "section_update";
#line 83 "../core/Objects/BaseObject.vala"
				return result;
#line 695 "BaseObject.c"
			} else {
#line 84 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 85 "../core/Objects/BaseObject.vala"
					result = "label_update";
#line 85 "../core/Objects/BaseObject.vala"
					return result;
#line 703 "BaseObject.c"
				} else {
#line 87 "../core/Objects/BaseObject.vala"
					result = "";
#line 87 "../core/Objects/BaseObject.vala"
					return result;
#line 709 "BaseObject.c"
				}
			}
		}
	}
}

ObjectType
objects_base_object_get_object_type (ObjectsBaseObject* self)
{
	ObjectType result;
#line 93 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 94 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_PROJECT (self)) {
#line 95 "../core/Objects/BaseObject.vala"
		result = OBJECT_TYPE_PROJECT;
#line 95 "../core/Objects/BaseObject.vala"
		return result;
#line 728 "BaseObject.c"
	} else {
#line 96 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_SECTION (self)) {
#line 97 "../core/Objects/BaseObject.vala"
			result = OBJECT_TYPE_SECTION;
#line 97 "../core/Objects/BaseObject.vala"
			return result;
#line 736 "BaseObject.c"
		} else {
#line 98 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_ITEM (self)) {
#line 99 "../core/Objects/BaseObject.vala"
				result = OBJECT_TYPE_ITEM;
#line 99 "../core/Objects/BaseObject.vala"
				return result;
#line 744 "BaseObject.c"
			} else {
#line 100 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 101 "../core/Objects/BaseObject.vala"
					result = OBJECT_TYPE_LABEL;
#line 101 "../core/Objects/BaseObject.vala"
					return result;
#line 752 "BaseObject.c"
				} else {
#line 103 "../core/Objects/BaseObject.vala"
					result = OBJECT_TYPE_FILTER;
#line 103 "../core/Objects/BaseObject.vala"
					return result;
#line 758 "BaseObject.c"
				}
			}
		}
	}
}

const gchar*
objects_base_object_get_object_type_string (ObjectsBaseObject* self)
{
	const gchar* result;
#line 109 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_PROJECT (self)) {
#line 111 "../core/Objects/BaseObject.vala"
		result = "project";
#line 111 "../core/Objects/BaseObject.vala"
		return result;
#line 777 "BaseObject.c"
	} else {
#line 112 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_SECTION (self)) {
#line 113 "../core/Objects/BaseObject.vala"
			result = "section";
#line 113 "../core/Objects/BaseObject.vala"
			return result;
#line 785 "BaseObject.c"
		} else {
#line 114 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_ITEM (self)) {
#line 115 "../core/Objects/BaseObject.vala"
				result = "item";
#line 115 "../core/Objects/BaseObject.vala"
				return result;
#line 793 "BaseObject.c"
			} else {
#line 116 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 117 "../core/Objects/BaseObject.vala"
					result = "label";
#line 117 "../core/Objects/BaseObject.vala"
					return result;
#line 801 "BaseObject.c"
				} else {
#line 119 "../core/Objects/BaseObject.vala"
					result = "filter";
#line 119 "../core/Objects/BaseObject.vala"
					return result;
#line 807 "BaseObject.c"
				}
			}
		}
	}
}

const gchar*
objects_base_object_get_table_name (ObjectsBaseObject* self)
{
	const gchar* result;
#line 125 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 126 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_ITEM (self)) {
#line 127 "../core/Objects/BaseObject.vala"
		result = "Items";
#line 127 "../core/Objects/BaseObject.vala"
		return result;
#line 826 "BaseObject.c"
	} else {
#line 128 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_SECTION (self)) {
#line 129 "../core/Objects/BaseObject.vala"
			result = "Sections";
#line 129 "../core/Objects/BaseObject.vala"
			return result;
#line 834 "BaseObject.c"
		} else {
#line 130 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_PROJECT (self)) {
#line 131 "../core/Objects/BaseObject.vala"
				result = "Projects";
#line 131 "../core/Objects/BaseObject.vala"
				return result;
#line 842 "BaseObject.c"
			} else {
#line 132 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 133 "../core/Objects/BaseObject.vala"
					result = "Labels";
#line 133 "../core/Objects/BaseObject.vala"
					return result;
#line 850 "BaseObject.c"
				} else {
#line 135 "../core/Objects/BaseObject.vala"
					result = "";
#line 135 "../core/Objects/BaseObject.vala"
					return result;
#line 856 "BaseObject.c"
				}
			}
		}
	}
}

const gchar*
objects_base_object_get_column_order_name (ObjectsBaseObject* self)
{
	const gchar* result;
#line 141 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_ITEM (self)) {
#line 143 "../core/Objects/BaseObject.vala"
		result = "child_order";
#line 143 "../core/Objects/BaseObject.vala"
		return result;
#line 875 "BaseObject.c"
	} else {
#line 144 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_SECTION (self)) {
#line 145 "../core/Objects/BaseObject.vala"
			result = "section_order";
#line 145 "../core/Objects/BaseObject.vala"
			return result;
#line 883 "BaseObject.c"
		} else {
#line 146 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_PROJECT (self)) {
#line 147 "../core/Objects/BaseObject.vala"
				result = "child_order";
#line 147 "../core/Objects/BaseObject.vala"
				return result;
#line 891 "BaseObject.c"
			} else {
#line 148 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 149 "../core/Objects/BaseObject.vala"
					result = "item_order";
#line 149 "../core/Objects/BaseObject.vala"
					return result;
#line 899 "BaseObject.c"
				} else {
#line 151 "../core/Objects/BaseObject.vala"
					result = "";
#line 151 "../core/Objects/BaseObject.vala"
					return result;
#line 905 "BaseObject.c"
				}
			}
		}
	}
}

static void
objects_base_object_class_init (ObjectsBaseObjectClass * klass,
                                gpointer klass_data)
{
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Objects/BaseObject.vala"
	g_type_class_adjust_private_offset (klass, &ObjectsBaseObject_private_offset);
#line 22 "../core/Objects/BaseObject.vala"
	((ObjectsBaseObjectClass *) klass)->get_update_json = (gchar* (*) (ObjectsBaseObject*, const gchar*, const gchar*)) objects_base_object_real_get_update_json;
#line 22 "../core/Objects/BaseObject.vala"
	((ObjectsBaseObjectClass *) klass)->get_add_json = (gchar* (*) (ObjectsBaseObject*, const gchar*, const gchar*)) objects_base_object_real_get_add_json;
#line 22 "../core/Objects/BaseObject.vala"
	((ObjectsBaseObjectClass *) klass)->get_move_json = (gchar* (*) (ObjectsBaseObject*, const gchar*, const gchar*)) objects_base_object_real_get_move_json;
#line 22 "../core/Objects/BaseObject.vala"
	((ObjectsBaseObjectClass *) klass)->to_json = (gchar* (*) (ObjectsBaseObject*)) objects_base_object_real_to_json;
#line 22 "../core/Objects/BaseObject.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_objects_base_object_get_property;
#line 22 "../core/Objects/BaseObject.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_objects_base_object_set_property;
#line 22 "../core/Objects/BaseObject.vala"
	G_OBJECT_CLASS (klass)->finalize = objects_base_object_finalize;
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_ID_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_NAME_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_KEYWORDS_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_KEYWORDS_PROPERTY] = g_param_spec_string ("keywords", "keywords", "keywords", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_ICON_NAME_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_UPDATE_TIMEOUT_ID_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_UPDATE_TIMEOUT_ID_PROPERTY] = g_param_spec_uint ("update-timeout-id", "update-timeout-id", "update-timeout-id", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_ID_STRING_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_ID_STRING_PROPERTY] = g_param_spec_string ("id-string", "id-string", "id-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_VIEW_ID_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_VIEW_ID_PROPERTY] = g_param_spec_string ("view-id", "view-id", "view-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_TYPE_DELETE_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_TYPE_DELETE_PROPERTY] = g_param_spec_string ("type-delete", "type-delete", "type-delete", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_TYPE_ADD_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_TYPE_ADD_PROPERTY] = g_param_spec_string ("type-add", "type-add", "type-add", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_TYPE_UPDATE_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_TYPE_UPDATE_PROPERTY] = g_param_spec_string ("type-update", "type-update", "type-update", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_OBJECT_TYPE_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_OBJECT_TYPE_PROPERTY] = g_param_spec_enum ("object-type", "object-type", "object-type", TYPE_OBJECT_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_OBJECT_TYPE_STRING_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_OBJECT_TYPE_STRING_PROPERTY] = g_param_spec_string ("object-type-string", "object-type-string", "object-type-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_TABLE_NAME_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_TABLE_NAME_PROPERTY] = g_param_spec_string ("table-name", "table-name", "table-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_COLUMN_ORDER_NAME_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_COLUMN_ORDER_NAME_PROPERTY] = g_param_spec_string ("column-order-name", "column-order-name", "column-order-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_signals[OBJECTS_BASE_OBJECT_DELETED_SIGNAL] = g_signal_new ("deleted", OBJECTS_TYPE_BASE_OBJECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_signals[OBJECTS_BASE_OBJECT_UPDATED_SIGNAL] = g_signal_new ("updated", OBJECTS_TYPE_BASE_OBJECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 966 "BaseObject.c"
}

static void
objects_base_object_instance_init (ObjectsBaseObject * self,
                                   gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 22 "../core/Objects/BaseObject.vala"
	self->priv = objects_base_object_get_instance_private (self);
#line 23 "../core/Objects/BaseObject.vala"
	_tmp0_ = g_strdup ("");
#line 23 "../core/Objects/BaseObject.vala"
	self->priv->_id = _tmp0_;
#line 24 "../core/Objects/BaseObject.vala"
	_tmp1_ = g_strdup ("");
#line 24 "../core/Objects/BaseObject.vala"
	self->priv->_name = _tmp1_;
#line 25 "../core/Objects/BaseObject.vala"
	_tmp2_ = g_strdup ("");
#line 25 "../core/Objects/BaseObject.vala"
	self->priv->_keywords = _tmp2_;
#line 26 "../core/Objects/BaseObject.vala"
	_tmp3_ = g_strdup ("");
#line 26 "../core/Objects/BaseObject.vala"
	self->priv->_icon_name = _tmp3_;
#line 30 "../core/Objects/BaseObject.vala"
	self->priv->_update_timeout_id = (guint) 0;
#line 40 "../core/Objects/BaseObject.vala"
	_tmp4_ = g_strdup ("");
#line 40 "../core/Objects/BaseObject.vala"
	self->priv->_view_id = _tmp4_;
#line 1002 "BaseObject.c"
}

static void
objects_base_object_finalize (GObject * obj)
{
	ObjectsBaseObject * self;
#line 22 "../core/Objects/BaseObject.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_BASE_OBJECT, ObjectsBaseObject);
#line 23 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_id);
#line 24 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_name);
#line 25 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_keywords);
#line 26 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_icon_name);
#line 32 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_id_string);
#line 40 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_view_id);
#line 22 "../core/Objects/BaseObject.vala"
	G_OBJECT_CLASS (objects_base_object_parent_class)->finalize (obj);
#line 1025 "BaseObject.c"
}

static GType
objects_base_object_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ObjectsBaseObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) objects_base_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ObjectsBaseObject), 0, (GInstanceInitFunc) objects_base_object_instance_init, NULL };
	GType objects_base_object_type_id;
	objects_base_object_type_id = g_type_register_static (G_TYPE_OBJECT, "ObjectsBaseObject", &g_define_type_info, 0);
	ObjectsBaseObject_private_offset = g_type_add_instance_private (objects_base_object_type_id, sizeof (ObjectsBaseObjectPrivate));
	return objects_base_object_type_id;
}

GType
objects_base_object_get_type (void)
{
	static volatile gsize objects_base_object_type_id__once = 0;
	if (g_once_init_enter (&objects_base_object_type_id__once)) {
		GType objects_base_object_type_id;
		objects_base_object_type_id = objects_base_object_get_type_once ();
		g_once_init_leave (&objects_base_object_type_id__once, objects_base_object_type_id);
	}
	return objects_base_object_type_id__once;
}

static void
_vala_objects_base_object_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	ObjectsBaseObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_BASE_OBJECT, ObjectsBaseObject);
#line 22 "../core/Objects/BaseObject.vala"
	switch (property_id) {
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_ID_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_id (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_NAME_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_name (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_KEYWORDS_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_keywords (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_ICON_NAME_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_icon_name (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_UPDATE_TIMEOUT_ID_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_uint (value, objects_base_object_get_update_timeout_id (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_ID_STRING_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_id_string (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_VIEW_ID_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_view_id (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_TYPE_DELETE_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_type_delete (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_TYPE_ADD_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_type_add (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_TYPE_UPDATE_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_type_update (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_OBJECT_TYPE_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_enum (value, objects_base_object_get_object_type (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_OBJECT_TYPE_STRING_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_object_type_string (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_TABLE_NAME_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_table_name (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_COLUMN_ORDER_NAME_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_column_order_name (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 1144 "BaseObject.c"
		default:
#line 22 "../core/Objects/BaseObject.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 1150 "BaseObject.c"
	}
}

static void
_vala_objects_base_object_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	ObjectsBaseObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_BASE_OBJECT, ObjectsBaseObject);
#line 22 "../core/Objects/BaseObject.vala"
	switch (property_id) {
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_ID_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_id (self, g_value_get_string (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_NAME_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_name (self, g_value_get_string (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_KEYWORDS_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_keywords (self, g_value_get_string (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_ICON_NAME_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_icon_name (self, g_value_get_string (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_UPDATE_TIMEOUT_ID_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_update_timeout_id (self, g_value_get_uint (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_VIEW_ID_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_view_id (self, g_value_get_string (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 1200 "BaseObject.c"
		default:
#line 22 "../core/Objects/BaseObject.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 1206 "BaseObject.c"
	}
}

