/* Label.c generated by valac 0.56.16, the Vala compiler
 * generated from Label.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	OBJECTS_LABEL_0_PROPERTY,
	OBJECTS_LABEL_COLOR_PROPERTY,
	OBJECTS_LABEL_ITEM_ORDER_PROPERTY,
	OBJECTS_LABEL_IS_DELETED_PROPERTY,
	OBJECTS_LABEL_IS_FAVORITE_PROPERTY,
	OBJECTS_LABEL_BACKEND_TYPE_PROPERTY,
	OBJECTS_LABEL_LABEL_COUNT_PROPERTY,
	OBJECTS_LABEL_SHORT_NAME_PROPERTY,
	OBJECTS_LABEL_NUM_PROPERTIES
};
static GParamSpec* objects_label_properties[OBJECTS_LABEL_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
enum  {
	OBJECTS_LABEL_LABEL_COUNT_UPDATED_SIGNAL,
	OBJECTS_LABEL_NUM_SIGNALS
};
static guint objects_label_signals[OBJECTS_LABEL_NUM_SIGNALS] = {0};

struct _ObjectsLabelPrivate {
	gchar* _color;
	gint _item_order;
	gboolean _is_deleted;
	gboolean _is_favorite;
	BackendType _backend_type;
	gint* _label_count;
	gchar* _short_name;
};

static gint ObjectsLabel_private_offset;
static gpointer objects_label_parent_class = NULL;

static gint objects_label_update_label_count (ObjectsLabel* self);
static gchar* objects_label_real_get_add_json (ObjectsBaseObject* base,
                                        const gchar* temp_id,
                                        const gchar* uuid);
static gchar* objects_label_real_get_update_json (ObjectsBaseObject* base,
                                           const gchar* uuid,
                                           const gchar* temp_id);
static void _vala_JsonNode_free (JsonNode* self);
static gint* _int_dup (gint* self);
static GObject * objects_label_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void _objects_label___lambda14_ (ObjectsLabel* self);
static gboolean __lambda15_ (ObjectsLabel* self);
static gboolean ___lambda15__gsource_func (gpointer self);
static void __objects_label___lambda14__objects_base_object_deleted (ObjectsBaseObject* _sender,
                                                              gpointer self);
static void _objects_label___lambda16_ (ObjectsLabel* self,
                                 ObjectsItem* item);
static void __objects_label___lambda16__services_database_item_added (ServicesDatabase* _sender,
                                                               ObjectsItem* item,
                                                               gboolean insert,
                                                               gpointer self);
static void _objects_label___lambda17_ (ObjectsLabel* self,
                                 ObjectsItem* item);
static void __objects_label___lambda17__services_database_item_deleted (ServicesDatabase* _sender,
                                                                 ObjectsItem* item,
                                                                 gpointer self);
static void _objects_label___lambda18_ (ObjectsLabel* self,
                                 ObjectsItem* item);
static void __objects_label___lambda18__services_database_item_updated (ServicesDatabase* _sender,
                                                                 ObjectsItem* item,
                                                                 const gchar* update_id,
                                                                 gpointer self);
static void _objects_label___lambda19_ (ObjectsLabel* self,
                                 ObjectsLabel* label);
static void __objects_label___lambda19__services_database_item_label_added (ServicesDatabase* _sender,
                                                                     ObjectsLabel* label,
                                                                     gpointer self);
static void _objects_label___lambda20_ (ObjectsLabel* self,
                                 ObjectsLabel* label);
static void __objects_label___lambda20__services_database_item_label_deleted (ServicesDatabase* _sender,
                                                                       ObjectsLabel* label,
                                                                       gpointer self);
static void objects_label_finalize (GObject * obj);
static GType objects_label_get_type_once (void);
static void _vala_objects_label_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_objects_label_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
objects_label_get_instance_private (ObjectsLabel* self)
{
	return G_STRUCT_MEMBER_P (self, ObjectsLabel_private_offset);
}

static gint
objects_label_update_label_count (ObjectsLabel* self)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint result;
#line 98 "../core/Objects/Label.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 99 "../core/Objects/Label.vala"
	_tmp0_ = services_database_get_default ();
#line 99 "../core/Objects/Label.vala"
	_tmp1_ = _tmp0_;
#line 99 "../core/Objects/Label.vala"
	_tmp2_ = services_database_get_items_by_label (_tmp1_, self, FALSE);
#line 99 "../core/Objects/Label.vala"
	_tmp3_ = _tmp2_;
#line 99 "../core/Objects/Label.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 99 "../core/Objects/Label.vala"
	_tmp5_ = _tmp4_;
#line 99 "../core/Objects/Label.vala"
	_tmp6_ = _tmp5_;
#line 99 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp3_);
#line 99 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp1_);
#line 99 "../core/Objects/Label.vala"
	result = _tmp6_;
#line 99 "../core/Objects/Label.vala"
	return result;
#line 173 "Label.c"
}

ObjectsLabel*
objects_label_construct_from_json (GType object_type,
                                   JsonNode* node)
{
	ObjectsLabel * self = NULL;
	JsonObject* _tmp0_;
	const gchar* _tmp1_;
#line 102 "../core/Objects/Label.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 102 "../core/Objects/Label.vala"
	self = (ObjectsLabel*) objects_base_object_construct (object_type);
#line 103 "../core/Objects/Label.vala"
	_tmp0_ = json_node_get_object (node);
#line 103 "../core/Objects/Label.vala"
	_tmp1_ = json_object_get_string_member (_tmp0_, "id");
#line 103 "../core/Objects/Label.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) self, _tmp1_);
#line 104 "../core/Objects/Label.vala"
	objects_label_update_from_json (self, node);
#line 105 "../core/Objects/Label.vala"
	objects_label_set_backend_type (self, BACKEND_TYPE_TODOIST);
#line 102 "../core/Objects/Label.vala"
	return self;
#line 199 "Label.c"
}

ObjectsLabel*
objects_label_new_from_json (JsonNode* node)
{
#line 102 "../core/Objects/Label.vala"
	return objects_label_construct_from_json (OBJECTS_TYPE_LABEL, node);
#line 207 "Label.c"
}

ObjectsLabel*
objects_label_construct_from_import_json (GType object_type,
                                          JsonNode* node)
{
	ObjectsLabel * self = NULL;
	JsonObject* _tmp0_;
	const gchar* _tmp1_;
	JsonObject* _tmp2_;
	const gchar* _tmp3_;
	JsonObject* _tmp4_;
	const gchar* _tmp5_;
	Util* _tmp6_;
	Util* _tmp7_;
	JsonObject* _tmp8_;
	const gchar* _tmp9_;
	JsonObject* _tmp10_;
	JsonObject* _tmp11_;
#line 108 "../core/Objects/Label.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 108 "../core/Objects/Label.vala"
	self = (ObjectsLabel*) objects_base_object_construct (object_type);
#line 109 "../core/Objects/Label.vala"
	_tmp0_ = json_node_get_object (node);
#line 109 "../core/Objects/Label.vala"
	_tmp1_ = json_object_get_string_member (_tmp0_, "id");
#line 109 "../core/Objects/Label.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) self, _tmp1_);
#line 110 "../core/Objects/Label.vala"
	_tmp2_ = json_node_get_object (node);
#line 110 "../core/Objects/Label.vala"
	_tmp3_ = json_object_get_string_member (_tmp2_, "name");
#line 110 "../core/Objects/Label.vala"
	objects_base_object_set_name ((ObjectsBaseObject*) self, _tmp3_);
#line 111 "../core/Objects/Label.vala"
	_tmp4_ = json_node_get_object (node);
#line 111 "../core/Objects/Label.vala"
	_tmp5_ = json_object_get_string_member (_tmp4_, "color");
#line 111 "../core/Objects/Label.vala"
	objects_label_set_color (self, _tmp5_);
#line 112 "../core/Objects/Label.vala"
	_tmp6_ = util_get_default ();
#line 112 "../core/Objects/Label.vala"
	_tmp7_ = _tmp6_;
#line 112 "../core/Objects/Label.vala"
	_tmp8_ = json_node_get_object (node);
#line 112 "../core/Objects/Label.vala"
	_tmp9_ = json_object_get_string_member (_tmp8_, "backend_type");
#line 112 "../core/Objects/Label.vala"
	objects_label_set_backend_type (self, util_get_backend_type_by_text (_tmp7_, _tmp9_));
#line 112 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp7_);
#line 113 "../core/Objects/Label.vala"
	_tmp10_ = json_node_get_object (node);
#line 113 "../core/Objects/Label.vala"
	objects_label_set_is_deleted (self, json_object_get_boolean_member (_tmp10_, "is_deleted"));
#line 114 "../core/Objects/Label.vala"
	_tmp11_ = json_node_get_object (node);
#line 114 "../core/Objects/Label.vala"
	objects_label_set_is_favorite (self, json_object_get_boolean_member (_tmp11_, "is_favorite"));
#line 108 "../core/Objects/Label.vala"
	return self;
#line 271 "Label.c"
}

ObjectsLabel*
objects_label_new_from_import_json (JsonNode* node)
{
#line 108 "../core/Objects/Label.vala"
	return objects_label_construct_from_import_json (OBJECTS_TYPE_LABEL, node);
#line 279 "Label.c"
}

void
objects_label_update_from_json (ObjectsLabel* self,
                                JsonNode* node)
{
	JsonObject* _tmp0_;
	const gchar* _tmp1_;
	JsonObject* _tmp2_;
	JsonObject* _tmp5_;
	JsonObject* _tmp7_;
	JsonObject* _tmp9_;
#line 117 "../core/Objects/Label.vala"
	g_return_if_fail (self != NULL);
#line 117 "../core/Objects/Label.vala"
	g_return_if_fail (node != NULL);
#line 118 "../core/Objects/Label.vala"
	_tmp0_ = json_node_get_object (node);
#line 118 "../core/Objects/Label.vala"
	_tmp1_ = json_object_get_string_member (_tmp0_, "name");
#line 118 "../core/Objects/Label.vala"
	objects_base_object_set_name ((ObjectsBaseObject*) self, _tmp1_);
#line 120 "../core/Objects/Label.vala"
	_tmp2_ = json_node_get_object (node);
#line 120 "../core/Objects/Label.vala"
	if (!json_object_get_null_member (_tmp2_, "color")) {
#line 306 "Label.c"
		JsonObject* _tmp3_;
		const gchar* _tmp4_;
#line 121 "../core/Objects/Label.vala"
		_tmp3_ = json_node_get_object (node);
#line 121 "../core/Objects/Label.vala"
		_tmp4_ = json_object_get_string_member (_tmp3_, "color");
#line 121 "../core/Objects/Label.vala"
		objects_label_set_color (self, _tmp4_);
#line 315 "Label.c"
	}
#line 124 "../core/Objects/Label.vala"
	_tmp5_ = json_node_get_object (node);
#line 124 "../core/Objects/Label.vala"
	if (!json_object_get_null_member (_tmp5_, "is_favorite")) {
#line 321 "Label.c"
		JsonObject* _tmp6_;
#line 125 "../core/Objects/Label.vala"
		_tmp6_ = json_node_get_object (node);
#line 125 "../core/Objects/Label.vala"
		objects_label_set_is_favorite (self, json_object_get_boolean_member (_tmp6_, "is_favorite"));
#line 327 "Label.c"
	}
#line 128 "../core/Objects/Label.vala"
	_tmp7_ = json_node_get_object (node);
#line 128 "../core/Objects/Label.vala"
	if (!json_object_get_null_member (_tmp7_, "is_deleted")) {
#line 333 "Label.c"
		JsonObject* _tmp8_;
#line 129 "../core/Objects/Label.vala"
		_tmp8_ = json_node_get_object (node);
#line 129 "../core/Objects/Label.vala"
		objects_label_set_is_deleted (self, json_object_get_boolean_member (_tmp8_, "is_deleted"));
#line 339 "Label.c"
	}
#line 132 "../core/Objects/Label.vala"
	_tmp9_ = json_node_get_object (node);
#line 132 "../core/Objects/Label.vala"
	if (!json_object_get_null_member (_tmp9_, "item_order")) {
#line 345 "Label.c"
		JsonObject* _tmp10_;
#line 133 "../core/Objects/Label.vala"
		_tmp10_ = json_node_get_object (node);
#line 133 "../core/Objects/Label.vala"
		objects_label_set_item_order (self, (gint) ((gint32) json_object_get_int_member (_tmp10_, "item_order")));
#line 351 "Label.c"
	}
}

static gchar*
objects_label_real_get_add_json (ObjectsBaseObject* base,
                                 const gchar* temp_id,
                                 const gchar* uuid)
{
	ObjectsLabel * self;
	gchar* _tmp0_;
	gchar* result;
#line 137 "../core/Objects/Label.vala"
	self = (ObjectsLabel*) base;
#line 137 "../core/Objects/Label.vala"
	g_return_val_if_fail (temp_id != NULL, NULL);
#line 137 "../core/Objects/Label.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 138 "../core/Objects/Label.vala"
	_tmp0_ = objects_base_object_get_update_json ((ObjectsBaseObject*) self, uuid, temp_id);
#line 138 "../core/Objects/Label.vala"
	result = _tmp0_;
#line 138 "../core/Objects/Label.vala"
	return result;
#line 375 "Label.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 188 "../core/Objects/Label.vala"
	g_boxed_free (json_node_get_type (), self);
#line 383 "Label.c"
}

static gchar*
objects_label_real_get_update_json (ObjectsBaseObject* base,
                                    const gchar* uuid,
                                    const gchar* temp_id)
{
	ObjectsLabel * self;
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp2_;
	JsonBuilder* _tmp3_;
	JsonBuilder* _tmp4_;
	JsonBuilder* _tmp5_;
	const gchar* _tmp6_ = NULL;
	JsonBuilder* _tmp7_;
	JsonBuilder* _tmp8_;
	JsonBuilder* _tmp9_;
	JsonBuilder* _tmp12_;
	JsonBuilder* _tmp13_;
	JsonBuilder* _tmp18_;
	JsonBuilder* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	JsonBuilder* _tmp22_;
	JsonBuilder* _tmp23_;
	const gchar* _tmp24_;
	JsonBuilder* _tmp25_;
	JsonBuilder* _tmp26_;
	gint _tmp27_;
	JsonBuilder* _tmp28_;
	JsonBuilder* _tmp29_;
	gboolean _tmp30_;
	JsonBuilder* _tmp31_;
	JsonBuilder* _tmp32_;
	JsonBuilder* _tmp33_;
	JsonBuilder* _tmp34_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp35_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp36_;
	JsonNode* _tmp37_;
	gchar* _tmp38_;
	gchar* result;
#line 140 "../core/Objects/Label.vala"
	self = (ObjectsLabel*) base;
#line 140 "../core/Objects/Label.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 141 "../core/Objects/Label.vala"
	_tmp0_ = json_builder_new ();
#line 141 "../core/Objects/Label.vala"
	builder = _tmp0_;
#line 142 "../core/Objects/Label.vala"
	_tmp1_ = builder;
#line 142 "../core/Objects/Label.vala"
	json_builder_begin_object (_tmp1_);
#line 143 "../core/Objects/Label.vala"
	_tmp2_ = builder;
#line 143 "../core/Objects/Label.vala"
	json_builder_set_member_name (_tmp2_, "commands");
#line 144 "../core/Objects/Label.vala"
	_tmp3_ = builder;
#line 144 "../core/Objects/Label.vala"
	json_builder_begin_array (_tmp3_);
#line 145 "../core/Objects/Label.vala"
	_tmp4_ = builder;
#line 145 "../core/Objects/Label.vala"
	json_builder_begin_object (_tmp4_);
#line 148 "../core/Objects/Label.vala"
	_tmp5_ = builder;
#line 148 "../core/Objects/Label.vala"
	json_builder_set_member_name (_tmp5_, "type");
#line 149 "../core/Objects/Label.vala"
	if (temp_id == NULL) {
#line 149 "../core/Objects/Label.vala"
		_tmp6_ = "label_update";
#line 461 "Label.c"
	} else {
#line 149 "../core/Objects/Label.vala"
		_tmp6_ = "label_add";
#line 465 "Label.c"
	}
#line 149 "../core/Objects/Label.vala"
	_tmp7_ = builder;
#line 149 "../core/Objects/Label.vala"
	json_builder_add_string_value (_tmp7_, _tmp6_);
#line 151 "../core/Objects/Label.vala"
	_tmp8_ = builder;
#line 151 "../core/Objects/Label.vala"
	json_builder_set_member_name (_tmp8_, "uuid");
#line 152 "../core/Objects/Label.vala"
	_tmp9_ = builder;
#line 152 "../core/Objects/Label.vala"
	json_builder_add_string_value (_tmp9_, uuid);
#line 154 "../core/Objects/Label.vala"
	if (temp_id != NULL) {
#line 481 "Label.c"
		JsonBuilder* _tmp10_;
		JsonBuilder* _tmp11_;
#line 155 "../core/Objects/Label.vala"
		_tmp10_ = builder;
#line 155 "../core/Objects/Label.vala"
		json_builder_set_member_name (_tmp10_, "temp_id");
#line 156 "../core/Objects/Label.vala"
		_tmp11_ = builder;
#line 156 "../core/Objects/Label.vala"
		json_builder_add_string_value (_tmp11_, temp_id);
#line 492 "Label.c"
	}
#line 159 "../core/Objects/Label.vala"
	_tmp12_ = builder;
#line 159 "../core/Objects/Label.vala"
	json_builder_set_member_name (_tmp12_, "args");
#line 160 "../core/Objects/Label.vala"
	_tmp13_ = builder;
#line 160 "../core/Objects/Label.vala"
	json_builder_begin_object (_tmp13_);
#line 162 "../core/Objects/Label.vala"
	if (temp_id == NULL) {
#line 504 "Label.c"
		JsonBuilder* _tmp14_;
		JsonBuilder* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
#line 163 "../core/Objects/Label.vala"
		_tmp14_ = builder;
#line 163 "../core/Objects/Label.vala"
		json_builder_set_member_name (_tmp14_, "id");
#line 164 "../core/Objects/Label.vala"
		_tmp15_ = builder;
#line 164 "../core/Objects/Label.vala"
		_tmp16_ = objects_base_object_get_id ((ObjectsBaseObject*) self);
#line 164 "../core/Objects/Label.vala"
		_tmp17_ = _tmp16_;
#line 164 "../core/Objects/Label.vala"
		json_builder_add_string_value (_tmp15_, _tmp17_);
#line 521 "Label.c"
	}
#line 167 "../core/Objects/Label.vala"
	_tmp18_ = builder;
#line 167 "../core/Objects/Label.vala"
	json_builder_set_member_name (_tmp18_, "name");
#line 168 "../core/Objects/Label.vala"
	_tmp19_ = builder;
#line 168 "../core/Objects/Label.vala"
	_tmp20_ = objects_base_object_get_name ((ObjectsBaseObject*) self);
#line 168 "../core/Objects/Label.vala"
	_tmp21_ = _tmp20_;
#line 168 "../core/Objects/Label.vala"
	json_builder_add_string_value (_tmp19_, _tmp21_);
#line 170 "../core/Objects/Label.vala"
	_tmp22_ = builder;
#line 170 "../core/Objects/Label.vala"
	json_builder_set_member_name (_tmp22_, "color");
#line 171 "../core/Objects/Label.vala"
	_tmp23_ = builder;
#line 171 "../core/Objects/Label.vala"
	_tmp24_ = self->priv->_color;
#line 171 "../core/Objects/Label.vala"
	json_builder_add_string_value (_tmp23_, _tmp24_);
#line 173 "../core/Objects/Label.vala"
	_tmp25_ = builder;
#line 173 "../core/Objects/Label.vala"
	json_builder_set_member_name (_tmp25_, "item_order");
#line 174 "../core/Objects/Label.vala"
	_tmp26_ = builder;
#line 174 "../core/Objects/Label.vala"
	_tmp27_ = self->priv->_item_order;
#line 174 "../core/Objects/Label.vala"
	json_builder_add_int_value (_tmp26_, (gint64) _tmp27_);
#line 176 "../core/Objects/Label.vala"
	_tmp28_ = builder;
#line 176 "../core/Objects/Label.vala"
	json_builder_set_member_name (_tmp28_, "is_favorite");
#line 177 "../core/Objects/Label.vala"
	_tmp29_ = builder;
#line 177 "../core/Objects/Label.vala"
	_tmp30_ = self->priv->_is_favorite;
#line 177 "../core/Objects/Label.vala"
	json_builder_add_boolean_value (_tmp29_, _tmp30_);
#line 179 "../core/Objects/Label.vala"
	_tmp31_ = builder;
#line 179 "../core/Objects/Label.vala"
	json_builder_end_object (_tmp31_);
#line 180 "../core/Objects/Label.vala"
	_tmp32_ = builder;
#line 180 "../core/Objects/Label.vala"
	json_builder_end_object (_tmp32_);
#line 181 "../core/Objects/Label.vala"
	_tmp33_ = builder;
#line 181 "../core/Objects/Label.vala"
	json_builder_end_array (_tmp33_);
#line 182 "../core/Objects/Label.vala"
	_tmp34_ = builder;
#line 182 "../core/Objects/Label.vala"
	json_builder_end_object (_tmp34_);
#line 184 "../core/Objects/Label.vala"
	_tmp35_ = json_generator_new ();
#line 184 "../core/Objects/Label.vala"
	generator = _tmp35_;
#line 185 "../core/Objects/Label.vala"
	_tmp36_ = builder;
#line 185 "../core/Objects/Label.vala"
	_tmp37_ = json_builder_get_root (_tmp36_);
#line 185 "../core/Objects/Label.vala"
	root = _tmp37_;
#line 186 "../core/Objects/Label.vala"
	json_generator_set_root (generator, root);
#line 188 "../core/Objects/Label.vala"
	_tmp38_ = json_generator_to_data (generator, NULL);
#line 188 "../core/Objects/Label.vala"
	result = _tmp38_;
#line 188 "../core/Objects/Label.vala"
	__vala_JsonNode_free0 (root);
#line 188 "../core/Objects/Label.vala"
	_g_object_unref0 (generator);
#line 188 "../core/Objects/Label.vala"
	_g_object_unref0 (builder);
#line 188 "../core/Objects/Label.vala"
	return result;
#line 605 "Label.c"
}

ObjectsLabel*
objects_label_construct (GType object_type)
{
	ObjectsLabel * self = NULL;
#line 22 "../core/Objects/Label.vala"
	self = (ObjectsLabel*) objects_base_object_construct (object_type);
#line 22 "../core/Objects/Label.vala"
	return self;
#line 616 "Label.c"
}

ObjectsLabel*
objects_label_new (void)
{
#line 22 "../core/Objects/Label.vala"
	return objects_label_construct (OBJECTS_TYPE_LABEL);
#line 624 "Label.c"
}

const gchar*
objects_label_get_color (ObjectsLabel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../core/Objects/Label.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../core/Objects/Label.vala"
	_tmp0_ = self->priv->_color;
#line 23 "../core/Objects/Label.vala"
	result = _tmp0_;
#line 23 "../core/Objects/Label.vala"
	return result;
#line 640 "Label.c"
}

void
objects_label_set_color (ObjectsLabel* self,
                         const gchar* value)
{
	gchar* old_value;
#line 23 "../core/Objects/Label.vala"
	g_return_if_fail (self != NULL);
#line 23 "../core/Objects/Label.vala"
	old_value = objects_label_get_color (self);
#line 23 "../core/Objects/Label.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 654 "Label.c"
		gchar* _tmp0_;
#line 23 "../core/Objects/Label.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../core/Objects/Label.vala"
		_g_free0 (self->priv->_color);
#line 23 "../core/Objects/Label.vala"
		self->priv->_color = _tmp0_;
#line 23 "../core/Objects/Label.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_label_properties[OBJECTS_LABEL_COLOR_PROPERTY]);
#line 664 "Label.c"
	}
}

gint
objects_label_get_item_order (ObjectsLabel* self)
{
	gint result;
#line 24 "../core/Objects/Label.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 24 "../core/Objects/Label.vala"
	result = self->priv->_item_order;
#line 24 "../core/Objects/Label.vala"
	return result;
#line 678 "Label.c"
}

void
objects_label_set_item_order (ObjectsLabel* self,
                              gint value)
{
	gint old_value;
#line 24 "../core/Objects/Label.vala"
	g_return_if_fail (self != NULL);
#line 24 "../core/Objects/Label.vala"
	old_value = objects_label_get_item_order (self);
#line 24 "../core/Objects/Label.vala"
	if (old_value != value) {
#line 24 "../core/Objects/Label.vala"
		self->priv->_item_order = value;
#line 24 "../core/Objects/Label.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_label_properties[OBJECTS_LABEL_ITEM_ORDER_PROPERTY]);
#line 696 "Label.c"
	}
}

gboolean
objects_label_get_is_deleted (ObjectsLabel* self)
{
	gboolean result;
#line 25 "../core/Objects/Label.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../core/Objects/Label.vala"
	result = self->priv->_is_deleted;
#line 25 "../core/Objects/Label.vala"
	return result;
#line 710 "Label.c"
}

void
objects_label_set_is_deleted (ObjectsLabel* self,
                              gboolean value)
{
	gboolean old_value;
#line 25 "../core/Objects/Label.vala"
	g_return_if_fail (self != NULL);
#line 25 "../core/Objects/Label.vala"
	old_value = objects_label_get_is_deleted (self);
#line 25 "../core/Objects/Label.vala"
	if (old_value != value) {
#line 25 "../core/Objects/Label.vala"
		self->priv->_is_deleted = value;
#line 25 "../core/Objects/Label.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_label_properties[OBJECTS_LABEL_IS_DELETED_PROPERTY]);
#line 728 "Label.c"
	}
}

gboolean
objects_label_get_is_favorite (ObjectsLabel* self)
{
	gboolean result;
#line 26 "../core/Objects/Label.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 26 "../core/Objects/Label.vala"
	result = self->priv->_is_favorite;
#line 26 "../core/Objects/Label.vala"
	return result;
#line 742 "Label.c"
}

void
objects_label_set_is_favorite (ObjectsLabel* self,
                               gboolean value)
{
	gboolean old_value;
#line 26 "../core/Objects/Label.vala"
	g_return_if_fail (self != NULL);
#line 26 "../core/Objects/Label.vala"
	old_value = objects_label_get_is_favorite (self);
#line 26 "../core/Objects/Label.vala"
	if (old_value != value) {
#line 26 "../core/Objects/Label.vala"
		self->priv->_is_favorite = value;
#line 26 "../core/Objects/Label.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_label_properties[OBJECTS_LABEL_IS_FAVORITE_PROPERTY]);
#line 760 "Label.c"
	}
}

BackendType
objects_label_get_backend_type (ObjectsLabel* self)
{
	BackendType result;
#line 27 "../core/Objects/Label.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../core/Objects/Label.vala"
	result = self->priv->_backend_type;
#line 27 "../core/Objects/Label.vala"
	return result;
#line 774 "Label.c"
}

void
objects_label_set_backend_type (ObjectsLabel* self,
                                BackendType value)
{
	BackendType old_value;
#line 27 "../core/Objects/Label.vala"
	g_return_if_fail (self != NULL);
#line 27 "../core/Objects/Label.vala"
	old_value = objects_label_get_backend_type (self);
#line 27 "../core/Objects/Label.vala"
	if (old_value != value) {
#line 27 "../core/Objects/Label.vala"
		self->priv->_backend_type = value;
#line 27 "../core/Objects/Label.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_label_properties[OBJECTS_LABEL_BACKEND_TYPE_PROPERTY]);
#line 792 "Label.c"
	}
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 33 "../core/Objects/Label.vala"
	dup = g_new0 (gint, 1);
#line 33 "../core/Objects/Label.vala"
	memcpy (dup, self, sizeof (gint));
#line 33 "../core/Objects/Label.vala"
	return dup;
#line 806 "Label.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 33 "../core/Objects/Label.vala"
	return self ? _int_dup (self) : NULL;
#line 814 "Label.c"
}

gint
objects_label_get_label_count (ObjectsLabel* self)
{
	gint result;
	gint* _tmp0_;
	gint* _tmp3_;
#line 31 "../core/Objects/Label.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 32 "../core/Objects/Label.vala"
	_tmp0_ = self->priv->_label_count;
#line 32 "../core/Objects/Label.vala"
	if (_tmp0_ == NULL) {
#line 829 "Label.c"
		gint _tmp1_;
		gint* _tmp2_;
#line 33 "../core/Objects/Label.vala"
		_tmp1_ = objects_label_update_label_count (self);
#line 33 "../core/Objects/Label.vala"
		_tmp2_ = __int_dup0 (&_tmp1_);
#line 33 "../core/Objects/Label.vala"
		_g_free0 (self->priv->_label_count);
#line 33 "../core/Objects/Label.vala"
		self->priv->_label_count = _tmp2_;
#line 840 "Label.c"
	}
#line 36 "../core/Objects/Label.vala"
	_tmp3_ = self->priv->_label_count;
#line 36 "../core/Objects/Label.vala"
	result = *_tmp3_;
#line 36 "../core/Objects/Label.vala"
	return result;
#line 848 "Label.c"
}

void
objects_label_set_label_count (ObjectsLabel* self,
                               gint value)
{
	gint* _tmp0_;
#line 39 "../core/Objects/Label.vala"
	g_return_if_fail (self != NULL);
#line 40 "../core/Objects/Label.vala"
	_tmp0_ = __int_dup0 (&value);
#line 40 "../core/Objects/Label.vala"
	_g_free0 (self->priv->_label_count);
#line 40 "../core/Objects/Label.vala"
	self->priv->_label_count = _tmp0_;
#line 39 "../core/Objects/Label.vala"
	g_object_notify_by_pspec ((GObject *) self, objects_label_properties[OBJECTS_LABEL_LABEL_COUNT_PROPERTY]);
#line 866 "Label.c"
}

const gchar*
objects_label_get_short_name (ObjectsLabel* self)
{
	const gchar* result;
	Util* _tmp0_;
	Util* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
#line 46 "../core/Objects/Label.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../core/Objects/Label.vala"
	_tmp0_ = util_get_default ();
#line 47 "../core/Objects/Label.vala"
	_tmp1_ = _tmp0_;
#line 47 "../core/Objects/Label.vala"
	_tmp2_ = objects_base_object_get_name ((ObjectsBaseObject*) self);
#line 47 "../core/Objects/Label.vala"
	_tmp3_ = _tmp2_;
#line 47 "../core/Objects/Label.vala"
	_tmp4_ = util_get_short_name (_tmp1_, _tmp3_, CONSTANTS_SHORT_NAME_SIZE);
#line 47 "../core/Objects/Label.vala"
	_g_free0 (self->priv->_short_name);
#line 47 "../core/Objects/Label.vala"
	self->priv->_short_name = _tmp4_;
#line 47 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp1_);
#line 48 "../core/Objects/Label.vala"
	_tmp5_ = self->priv->_short_name;
#line 48 "../core/Objects/Label.vala"
	result = _tmp5_;
#line 48 "../core/Objects/Label.vala"
	return result;
#line 903 "Label.c"
}

static gboolean
__lambda15_ (ObjectsLabel* self)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean result;
#line 57 "../core/Objects/Label.vala"
	_tmp0_ = services_database_get_default ();
#line 57 "../core/Objects/Label.vala"
	_tmp1_ = _tmp0_;
#line 57 "../core/Objects/Label.vala"
	g_signal_emit_by_name (_tmp1_, "label-deleted", self);
#line 57 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp1_);
#line 58 "../core/Objects/Label.vala"
	result = FALSE;
#line 58 "../core/Objects/Label.vala"
	return result;
#line 924 "Label.c"
}

static gboolean
___lambda15__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda15_ ((ObjectsLabel*) self);
#line 56 "../core/Objects/Label.vala"
	return result;
#line 934 "Label.c"
}

static void
_objects_label___lambda14_ (ObjectsLabel* self)
{
#line 56 "../core/Objects/Label.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda15__gsource_func, g_object_ref (self), g_object_unref);
#line 942 "Label.c"
}

static void
__objects_label___lambda14__objects_base_object_deleted (ObjectsBaseObject* _sender,
                                                         gpointer self)
{
#line 55 "../core/Objects/Label.vala"
	_objects_label___lambda14_ ((ObjectsLabel*) self);
#line 951 "Label.c"
}

static void
_objects_label___lambda16_ (ObjectsLabel* self,
                            ObjectsItem* item)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	ObjectsLabel* _tmp2_;
	ObjectsLabel* _tmp3_;
	gboolean _tmp4_;
#line 62 "../core/Objects/Label.vala"
	g_return_if_fail (item != NULL);
#line 63 "../core/Objects/Label.vala"
	_tmp0_ = objects_base_object_get_id ((ObjectsBaseObject*) self);
#line 63 "../core/Objects/Label.vala"
	_tmp1_ = _tmp0_;
#line 63 "../core/Objects/Label.vala"
	_tmp2_ = objects_item_get_label (item, _tmp1_);
#line 63 "../core/Objects/Label.vala"
	_tmp3_ = _tmp2_;
#line 63 "../core/Objects/Label.vala"
	_tmp4_ = _tmp3_ != NULL;
#line 63 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp3_);
#line 63 "../core/Objects/Label.vala"
	if (_tmp4_) {
#line 979 "Label.c"
		gint _tmp5_;
		gint* _tmp6_;
#line 64 "../core/Objects/Label.vala"
		_tmp5_ = objects_label_update_label_count (self);
#line 64 "../core/Objects/Label.vala"
		_tmp6_ = __int_dup0 (&_tmp5_);
#line 64 "../core/Objects/Label.vala"
		_g_free0 (self->priv->_label_count);
#line 64 "../core/Objects/Label.vala"
		self->priv->_label_count = _tmp6_;
#line 65 "../core/Objects/Label.vala"
		g_signal_emit (self, objects_label_signals[OBJECTS_LABEL_LABEL_COUNT_UPDATED_SIGNAL], 0);
#line 992 "Label.c"
	}
}

static void
__objects_label___lambda16__services_database_item_added (ServicesDatabase* _sender,
                                                          ObjectsItem* item,
                                                          gboolean insert,
                                                          gpointer self)
{
#line 62 "../core/Objects/Label.vala"
	_objects_label___lambda16_ ((ObjectsLabel*) self, item);
#line 1004 "Label.c"
}

static void
_objects_label___lambda17_ (ObjectsLabel* self,
                            ObjectsItem* item)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	ObjectsLabel* _tmp2_;
	ObjectsLabel* _tmp3_;
	gboolean _tmp4_;
#line 69 "../core/Objects/Label.vala"
	g_return_if_fail (item != NULL);
#line 70 "../core/Objects/Label.vala"
	_tmp0_ = objects_base_object_get_id ((ObjectsBaseObject*) self);
#line 70 "../core/Objects/Label.vala"
	_tmp1_ = _tmp0_;
#line 70 "../core/Objects/Label.vala"
	_tmp2_ = objects_item_get_label (item, _tmp1_);
#line 70 "../core/Objects/Label.vala"
	_tmp3_ = _tmp2_;
#line 70 "../core/Objects/Label.vala"
	_tmp4_ = _tmp3_ != NULL;
#line 70 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp3_);
#line 70 "../core/Objects/Label.vala"
	if (_tmp4_) {
#line 1032 "Label.c"
		gint _tmp5_;
		gint* _tmp6_;
#line 71 "../core/Objects/Label.vala"
		_tmp5_ = objects_label_update_label_count (self);
#line 71 "../core/Objects/Label.vala"
		_tmp6_ = __int_dup0 (&_tmp5_);
#line 71 "../core/Objects/Label.vala"
		_g_free0 (self->priv->_label_count);
#line 71 "../core/Objects/Label.vala"
		self->priv->_label_count = _tmp6_;
#line 72 "../core/Objects/Label.vala"
		g_signal_emit (self, objects_label_signals[OBJECTS_LABEL_LABEL_COUNT_UPDATED_SIGNAL], 0);
#line 1045 "Label.c"
	}
}

static void
__objects_label___lambda17__services_database_item_deleted (ServicesDatabase* _sender,
                                                            ObjectsItem* item,
                                                            gpointer self)
{
#line 69 "../core/Objects/Label.vala"
	_objects_label___lambda17_ ((ObjectsLabel*) self, item);
#line 1056 "Label.c"
}

static void
_objects_label___lambda18_ (ObjectsLabel* self,
                            ObjectsItem* item)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	ObjectsLabel* _tmp2_;
	ObjectsLabel* _tmp3_;
	gboolean _tmp4_;
#line 76 "../core/Objects/Label.vala"
	g_return_if_fail (item != NULL);
#line 77 "../core/Objects/Label.vala"
	_tmp0_ = objects_base_object_get_id ((ObjectsBaseObject*) self);
#line 77 "../core/Objects/Label.vala"
	_tmp1_ = _tmp0_;
#line 77 "../core/Objects/Label.vala"
	_tmp2_ = objects_item_get_label (item, _tmp1_);
#line 77 "../core/Objects/Label.vala"
	_tmp3_ = _tmp2_;
#line 77 "../core/Objects/Label.vala"
	_tmp4_ = _tmp3_ != NULL;
#line 77 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp3_);
#line 77 "../core/Objects/Label.vala"
	if (_tmp4_) {
#line 1084 "Label.c"
		gint _tmp5_;
		gint* _tmp6_;
#line 78 "../core/Objects/Label.vala"
		_tmp5_ = objects_label_update_label_count (self);
#line 78 "../core/Objects/Label.vala"
		_tmp6_ = __int_dup0 (&_tmp5_);
#line 78 "../core/Objects/Label.vala"
		_g_free0 (self->priv->_label_count);
#line 78 "../core/Objects/Label.vala"
		self->priv->_label_count = _tmp6_;
#line 79 "../core/Objects/Label.vala"
		g_signal_emit (self, objects_label_signals[OBJECTS_LABEL_LABEL_COUNT_UPDATED_SIGNAL], 0);
#line 1097 "Label.c"
	}
}

static void
__objects_label___lambda18__services_database_item_updated (ServicesDatabase* _sender,
                                                            ObjectsItem* item,
                                                            const gchar* update_id,
                                                            gpointer self)
{
#line 76 "../core/Objects/Label.vala"
	_objects_label___lambda18_ ((ObjectsLabel*) self, item);
#line 1109 "Label.c"
}

static void
_objects_label___lambda19_ (ObjectsLabel* self,
                            ObjectsLabel* label)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 83 "../core/Objects/Label.vala"
	g_return_if_fail (label != NULL);
#line 84 "../core/Objects/Label.vala"
	_tmp0_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
#line 84 "../core/Objects/Label.vala"
	_tmp1_ = _tmp0_;
#line 84 "../core/Objects/Label.vala"
	_tmp2_ = objects_base_object_get_id ((ObjectsBaseObject*) self);
#line 84 "../core/Objects/Label.vala"
	_tmp3_ = _tmp2_;
#line 84 "../core/Objects/Label.vala"
	if (g_strcmp0 (_tmp1_, _tmp3_) == 0) {
#line 1132 "Label.c"
		gint _tmp4_;
		gint* _tmp5_;
#line 85 "../core/Objects/Label.vala"
		_tmp4_ = objects_label_update_label_count (self);
#line 85 "../core/Objects/Label.vala"
		_tmp5_ = __int_dup0 (&_tmp4_);
#line 85 "../core/Objects/Label.vala"
		_g_free0 (self->priv->_label_count);
#line 85 "../core/Objects/Label.vala"
		self->priv->_label_count = _tmp5_;
#line 86 "../core/Objects/Label.vala"
		g_signal_emit (self, objects_label_signals[OBJECTS_LABEL_LABEL_COUNT_UPDATED_SIGNAL], 0);
#line 1145 "Label.c"
	}
}

static void
__objects_label___lambda19__services_database_item_label_added (ServicesDatabase* _sender,
                                                                ObjectsLabel* label,
                                                                gpointer self)
{
#line 83 "../core/Objects/Label.vala"
	_objects_label___lambda19_ ((ObjectsLabel*) self, label);
#line 1156 "Label.c"
}

static void
_objects_label___lambda20_ (ObjectsLabel* self,
                            ObjectsLabel* label)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 90 "../core/Objects/Label.vala"
	g_return_if_fail (label != NULL);
#line 91 "../core/Objects/Label.vala"
	_tmp0_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
#line 91 "../core/Objects/Label.vala"
	_tmp1_ = _tmp0_;
#line 91 "../core/Objects/Label.vala"
	_tmp2_ = objects_base_object_get_id ((ObjectsBaseObject*) self);
#line 91 "../core/Objects/Label.vala"
	_tmp3_ = _tmp2_;
#line 91 "../core/Objects/Label.vala"
	if (g_strcmp0 (_tmp1_, _tmp3_) == 0) {
#line 1179 "Label.c"
		gint _tmp4_;
		gint* _tmp5_;
#line 92 "../core/Objects/Label.vala"
		_tmp4_ = objects_label_update_label_count (self);
#line 92 "../core/Objects/Label.vala"
		_tmp5_ = __int_dup0 (&_tmp4_);
#line 92 "../core/Objects/Label.vala"
		_g_free0 (self->priv->_label_count);
#line 92 "../core/Objects/Label.vala"
		self->priv->_label_count = _tmp5_;
#line 93 "../core/Objects/Label.vala"
		g_signal_emit (self, objects_label_signals[OBJECTS_LABEL_LABEL_COUNT_UPDATED_SIGNAL], 0);
#line 1192 "Label.c"
	}
}

static void
__objects_label___lambda20__services_database_item_label_deleted (ServicesDatabase* _sender,
                                                                  ObjectsLabel* label,
                                                                  gpointer self)
{
#line 90 "../core/Objects/Label.vala"
	_objects_label___lambda20_ ((ObjectsLabel*) self, label);
#line 1203 "Label.c"
}

static GObject *
objects_label_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ObjectsLabel * self;
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	ServicesDatabase* _tmp2_;
	ServicesDatabase* _tmp3_;
	ServicesDatabase* _tmp4_;
	ServicesDatabase* _tmp5_;
	ServicesDatabase* _tmp6_;
	ServicesDatabase* _tmp7_;
	ServicesDatabase* _tmp8_;
	ServicesDatabase* _tmp9_;
#line 54 "../core/Objects/Label.vala"
	parent_class = G_OBJECT_CLASS (objects_label_parent_class);
#line 54 "../core/Objects/Label.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 54 "../core/Objects/Label.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_LABEL, ObjectsLabel);
#line 55 "../core/Objects/Label.vala"
	g_signal_connect_object ((ObjectsBaseObject*) self, "deleted", (GCallback) __objects_label___lambda14__objects_base_object_deleted, self, 0);
#line 62 "../core/Objects/Label.vala"
	_tmp0_ = services_database_get_default ();
#line 62 "../core/Objects/Label.vala"
	_tmp1_ = _tmp0_;
#line 62 "../core/Objects/Label.vala"
	g_signal_connect_object (_tmp1_, "item-added", (GCallback) __objects_label___lambda16__services_database_item_added, self, 0);
#line 62 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp1_);
#line 69 "../core/Objects/Label.vala"
	_tmp2_ = services_database_get_default ();
#line 69 "../core/Objects/Label.vala"
	_tmp3_ = _tmp2_;
#line 69 "../core/Objects/Label.vala"
	g_signal_connect_object (_tmp3_, "item-deleted", (GCallback) __objects_label___lambda17__services_database_item_deleted, self, 0);
#line 69 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp3_);
#line 76 "../core/Objects/Label.vala"
	_tmp4_ = services_database_get_default ();
#line 76 "../core/Objects/Label.vala"
	_tmp5_ = _tmp4_;
#line 76 "../core/Objects/Label.vala"
	g_signal_connect_object (_tmp5_, "item-updated", (GCallback) __objects_label___lambda18__services_database_item_updated, self, 0);
#line 76 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp5_);
#line 83 "../core/Objects/Label.vala"
	_tmp6_ = services_database_get_default ();
#line 83 "../core/Objects/Label.vala"
	_tmp7_ = _tmp6_;
#line 83 "../core/Objects/Label.vala"
	g_signal_connect_object (_tmp7_, "item-label-added", (GCallback) __objects_label___lambda19__services_database_item_label_added, self, 0);
#line 83 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp7_);
#line 90 "../core/Objects/Label.vala"
	_tmp8_ = services_database_get_default ();
#line 90 "../core/Objects/Label.vala"
	_tmp9_ = _tmp8_;
#line 90 "../core/Objects/Label.vala"
	g_signal_connect_object (_tmp9_, "item-label-deleted", (GCallback) __objects_label___lambda20__services_database_item_label_deleted, self, 0);
#line 90 "../core/Objects/Label.vala"
	_g_object_unref0 (_tmp9_);
#line 54 "../core/Objects/Label.vala"
	return obj;
#line 1274 "Label.c"
}

static void
objects_label_class_init (ObjectsLabelClass * klass,
                          gpointer klass_data)
{
#line 22 "../core/Objects/Label.vala"
	objects_label_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Objects/Label.vala"
	g_type_class_adjust_private_offset (klass, &ObjectsLabel_private_offset);
#line 22 "../core/Objects/Label.vala"
	((ObjectsBaseObjectClass *) klass)->get_add_json = (gchar* (*) (ObjectsBaseObject*, const gchar*, const gchar*)) objects_label_real_get_add_json;
#line 22 "../core/Objects/Label.vala"
	((ObjectsBaseObjectClass *) klass)->get_update_json = (gchar* (*) (ObjectsBaseObject*, const gchar*, const gchar*)) objects_label_real_get_update_json;
#line 22 "../core/Objects/Label.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_objects_label_get_property;
#line 22 "../core/Objects/Label.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_objects_label_set_property;
#line 22 "../core/Objects/Label.vala"
	G_OBJECT_CLASS (klass)->constructor = objects_label_constructor;
#line 22 "../core/Objects/Label.vala"
	G_OBJECT_CLASS (klass)->finalize = objects_label_finalize;
#line 22 "../core/Objects/Label.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_LABEL_COLOR_PROPERTY, objects_label_properties[OBJECTS_LABEL_COLOR_PROPERTY] = g_param_spec_string ("color", "color", "color", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Label.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_LABEL_ITEM_ORDER_PROPERTY, objects_label_properties[OBJECTS_LABEL_ITEM_ORDER_PROPERTY] = g_param_spec_int ("item-order", "item-order", "item-order", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Label.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_LABEL_IS_DELETED_PROPERTY, objects_label_properties[OBJECTS_LABEL_IS_DELETED_PROPERTY] = g_param_spec_boolean ("is-deleted", "is-deleted", "is-deleted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Label.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_LABEL_IS_FAVORITE_PROPERTY, objects_label_properties[OBJECTS_LABEL_IS_FAVORITE_PROPERTY] = g_param_spec_boolean ("is-favorite", "is-favorite", "is-favorite", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Label.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_LABEL_BACKEND_TYPE_PROPERTY, objects_label_properties[OBJECTS_LABEL_BACKEND_TYPE_PROPERTY] = g_param_spec_enum ("backend-type", "backend-type", "backend-type", TYPE_BACKEND_TYPE, BACKEND_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Label.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_LABEL_LABEL_COUNT_PROPERTY, objects_label_properties[OBJECTS_LABEL_LABEL_COUNT_PROPERTY] = g_param_spec_int ("label-count", "label-count", "label-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Label.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_LABEL_SHORT_NAME_PROPERTY, objects_label_properties[OBJECTS_LABEL_SHORT_NAME_PROPERTY] = g_param_spec_string ("short-name", "short-name", "short-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/Label.vala"
	objects_label_signals[OBJECTS_LABEL_LABEL_COUNT_UPDATED_SIGNAL] = g_signal_new ("label-count-updated", OBJECTS_TYPE_LABEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1313 "Label.c"
}

static void
objects_label_instance_init (ObjectsLabel * self,
                             gpointer klass)
{
	gchar* _tmp0_;
#line 22 "../core/Objects/Label.vala"
	self->priv = objects_label_get_instance_private (self);
#line 23 "../core/Objects/Label.vala"
	_tmp0_ = g_strdup ("");
#line 23 "../core/Objects/Label.vala"
	self->priv->_color = _tmp0_;
#line 24 "../core/Objects/Label.vala"
	self->priv->_item_order = 0;
#line 25 "../core/Objects/Label.vala"
	self->priv->_is_deleted = FALSE;
#line 26 "../core/Objects/Label.vala"
	self->priv->_is_favorite = FALSE;
#line 27 "../core/Objects/Label.vala"
	self->priv->_backend_type = BACKEND_TYPE_NONE;
#line 29 "../core/Objects/Label.vala"
	self->priv->_label_count = NULL;
#line 1337 "Label.c"
}

static void
objects_label_finalize (GObject * obj)
{
	ObjectsLabel * self;
#line 22 "../core/Objects/Label.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_LABEL, ObjectsLabel);
#line 23 "../core/Objects/Label.vala"
	_g_free0 (self->priv->_color);
#line 29 "../core/Objects/Label.vala"
	_g_free0 (self->priv->_label_count);
#line 44 "../core/Objects/Label.vala"
	_g_free0 (self->priv->_short_name);
#line 22 "../core/Objects/Label.vala"
	G_OBJECT_CLASS (objects_label_parent_class)->finalize (obj);
#line 1354 "Label.c"
}

static GType
objects_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ObjectsLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) objects_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ObjectsLabel), 0, (GInstanceInitFunc) objects_label_instance_init, NULL };
	GType objects_label_type_id;
	objects_label_type_id = g_type_register_static (OBJECTS_TYPE_BASE_OBJECT, "ObjectsLabel", &g_define_type_info, 0);
	ObjectsLabel_private_offset = g_type_add_instance_private (objects_label_type_id, sizeof (ObjectsLabelPrivate));
	return objects_label_type_id;
}

GType
objects_label_get_type (void)
{
	static volatile gsize objects_label_type_id__once = 0;
	if (g_once_init_enter (&objects_label_type_id__once)) {
		GType objects_label_type_id;
		objects_label_type_id = objects_label_get_type_once ();
		g_once_init_leave (&objects_label_type_id__once, objects_label_type_id);
	}
	return objects_label_type_id__once;
}

static void
_vala_objects_label_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	ObjectsLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_LABEL, ObjectsLabel);
#line 22 "../core/Objects/Label.vala"
	switch (property_id) {
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_COLOR_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		g_value_set_string (value, objects_label_get_color (self));
#line 22 "../core/Objects/Label.vala"
		break;
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_ITEM_ORDER_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		g_value_set_int (value, objects_label_get_item_order (self));
#line 22 "../core/Objects/Label.vala"
		break;
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_IS_DELETED_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		g_value_set_boolean (value, objects_label_get_is_deleted (self));
#line 22 "../core/Objects/Label.vala"
		break;
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_IS_FAVORITE_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		g_value_set_boolean (value, objects_label_get_is_favorite (self));
#line 22 "../core/Objects/Label.vala"
		break;
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_BACKEND_TYPE_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		g_value_set_enum (value, objects_label_get_backend_type (self));
#line 22 "../core/Objects/Label.vala"
		break;
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_LABEL_COUNT_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		g_value_set_int (value, objects_label_get_label_count (self));
#line 22 "../core/Objects/Label.vala"
		break;
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_SHORT_NAME_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		g_value_set_string (value, objects_label_get_short_name (self));
#line 22 "../core/Objects/Label.vala"
		break;
#line 1431 "Label.c"
		default:
#line 22 "../core/Objects/Label.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Objects/Label.vala"
		break;
#line 1437 "Label.c"
	}
}

static void
_vala_objects_label_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	ObjectsLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_LABEL, ObjectsLabel);
#line 22 "../core/Objects/Label.vala"
	switch (property_id) {
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_COLOR_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		objects_label_set_color (self, g_value_get_string (value));
#line 22 "../core/Objects/Label.vala"
		break;
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_ITEM_ORDER_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		objects_label_set_item_order (self, g_value_get_int (value));
#line 22 "../core/Objects/Label.vala"
		break;
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_IS_DELETED_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		objects_label_set_is_deleted (self, g_value_get_boolean (value));
#line 22 "../core/Objects/Label.vala"
		break;
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_IS_FAVORITE_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		objects_label_set_is_favorite (self, g_value_get_boolean (value));
#line 22 "../core/Objects/Label.vala"
		break;
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_BACKEND_TYPE_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		objects_label_set_backend_type (self, g_value_get_enum (value));
#line 22 "../core/Objects/Label.vala"
		break;
#line 22 "../core/Objects/Label.vala"
		case OBJECTS_LABEL_LABEL_COUNT_PROPERTY:
#line 22 "../core/Objects/Label.vala"
		objects_label_set_label_count (self, g_value_get_int (value));
#line 22 "../core/Objects/Label.vala"
		break;
#line 1487 "Label.c"
		default:
#line 22 "../core/Objects/Label.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Objects/Label.vala"
		break;
#line 1493 "Label.c"
	}
}

