/* Backend.c generated by valac 0.56.16, the Vala compiler
 * generated from Backend.vala, do not modify */

/*
* Copyright © 2024 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef struct _ServicesCalDAVParamSpecBackend ServicesCalDAVParamSpecBackend;

struct _ServicesCalDAVParamSpecBackend {
	GParamSpec parent_instance;
};

static gpointer services_cal_dav_backend_parent_class = NULL;

static void services_cal_dav_backend_finalize (ServicesCalDAVBackend * obj);
static GType services_cal_dav_backend_get_type_once (void);

gchar*
services_cal_dav_backend_generate_server_url (CalDAVType caldav_type,
                                              const gchar* server_url,
                                              const gchar* username,
                                              const gchar* password)
{
	gchar* _tmp2_;
	gchar* result;
#line 23 "../core/Services/CalDAV/Backend.vala"
	g_return_val_if_fail (server_url != NULL, NULL);
#line 23 "../core/Services/CalDAV/Backend.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 23 "../core/Services/CalDAV/Backend.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 24 "../core/Services/CalDAV/Backend.vala"
	if (caldav_type == CAL_DAV_TYPE_NEXTCLOUD) {
#line 69 "Backend.c"
		gchar* _tmp0_;
#line 25 "../core/Services/CalDAV/Backend.vala"
		_tmp0_ = g_strdup_printf ("%s/remote.php/dav", server_url);
#line 25 "../core/Services/CalDAV/Backend.vala"
		result = _tmp0_;
#line 25 "../core/Services/CalDAV/Backend.vala"
		return result;
#line 77 "Backend.c"
	} else {
#line 26 "../core/Services/CalDAV/Backend.vala"
		if (caldav_type == CAL_DAV_TYPE_RADICALE) {
#line 81 "Backend.c"
			gchar* _tmp1_;
#line 27 "../core/Services/CalDAV/Backend.vala"
			_tmp1_ = g_strdup_printf ("https://%s:%s@%s", username, password, server_url);
#line 27 "../core/Services/CalDAV/Backend.vala"
			result = _tmp1_;
#line 27 "../core/Services/CalDAV/Backend.vala"
			return result;
#line 89 "Backend.c"
		}
	}
#line 30 "../core/Services/CalDAV/Backend.vala"
	_tmp2_ = g_strdup ("");
#line 30 "../core/Services/CalDAV/Backend.vala"
	result = _tmp2_;
#line 30 "../core/Services/CalDAV/Backend.vala"
	return result;
#line 98 "Backend.c"
}

ServicesCalDAVBackend*
services_cal_dav_backend_construct (GType object_type)
{
	ServicesCalDAVBackend* self = NULL;
#line 22 "../core/Services/CalDAV/Backend.vala"
	self = (ServicesCalDAVBackend*) g_type_create_instance (object_type);
#line 22 "../core/Services/CalDAV/Backend.vala"
	return self;
#line 109 "Backend.c"
}

ServicesCalDAVBackend*
services_cal_dav_backend_new (void)
{
#line 22 "../core/Services/CalDAV/Backend.vala"
	return services_cal_dav_backend_construct (SERVICES_CAL_DAV_TYPE_BACKEND);
#line 117 "Backend.c"
}

static void
services_cal_dav_value_backend_init (GValue* value)
{
#line 22 "../core/Services/CalDAV/Backend.vala"
	value->data[0].v_pointer = NULL;
#line 125 "Backend.c"
}

static void
services_cal_dav_value_backend_free_value (GValue* value)
{
#line 22 "../core/Services/CalDAV/Backend.vala"
	if (value->data[0].v_pointer) {
#line 22 "../core/Services/CalDAV/Backend.vala"
		services_cal_dav_backend_unref (value->data[0].v_pointer);
#line 135 "Backend.c"
	}
}

static void
services_cal_dav_value_backend_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
#line 22 "../core/Services/CalDAV/Backend.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "../core/Services/CalDAV/Backend.vala"
		dest_value->data[0].v_pointer = services_cal_dav_backend_ref (src_value->data[0].v_pointer);
#line 147 "Backend.c"
	} else {
#line 22 "../core/Services/CalDAV/Backend.vala"
		dest_value->data[0].v_pointer = NULL;
#line 151 "Backend.c"
	}
}

static gpointer
services_cal_dav_value_backend_peek_pointer (const GValue* value)
{
#line 22 "../core/Services/CalDAV/Backend.vala"
	return value->data[0].v_pointer;
#line 160 "Backend.c"
}

static gchar*
services_cal_dav_value_backend_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
#line 22 "../core/Services/CalDAV/Backend.vala"
	if (collect_values[0].v_pointer) {
#line 171 "Backend.c"
		ServicesCalDAVBackend * object;
		object = collect_values[0].v_pointer;
#line 22 "../core/Services/CalDAV/Backend.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "../core/Services/CalDAV/Backend.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 178 "Backend.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "../core/Services/CalDAV/Backend.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 182 "Backend.c"
		}
#line 22 "../core/Services/CalDAV/Backend.vala"
		value->data[0].v_pointer = services_cal_dav_backend_ref (object);
#line 186 "Backend.c"
	} else {
#line 22 "../core/Services/CalDAV/Backend.vala"
		value->data[0].v_pointer = NULL;
#line 190 "Backend.c"
	}
#line 22 "../core/Services/CalDAV/Backend.vala"
	return NULL;
#line 194 "Backend.c"
}

static gchar*
services_cal_dav_value_backend_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	ServicesCalDAVBackend ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "../core/Services/CalDAV/Backend.vala"
	if (!object_p) {
#line 22 "../core/Services/CalDAV/Backend.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 209 "Backend.c"
	}
#line 22 "../core/Services/CalDAV/Backend.vala"
	if (!value->data[0].v_pointer) {
#line 22 "../core/Services/CalDAV/Backend.vala"
		*object_p = NULL;
#line 215 "Backend.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "../core/Services/CalDAV/Backend.vala"
		*object_p = value->data[0].v_pointer;
#line 219 "Backend.c"
	} else {
#line 22 "../core/Services/CalDAV/Backend.vala"
		*object_p = services_cal_dav_backend_ref (value->data[0].v_pointer);
#line 223 "Backend.c"
	}
#line 22 "../core/Services/CalDAV/Backend.vala"
	return NULL;
#line 227 "Backend.c"
}

GParamSpec*
services_cal_dav_param_spec_backend (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	ServicesCalDAVParamSpecBackend* spec;
#line 22 "../core/Services/CalDAV/Backend.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SERVICES_CAL_DAV_TYPE_BACKEND), NULL);
#line 22 "../core/Services/CalDAV/Backend.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "../core/Services/CalDAV/Backend.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "../core/Services/CalDAV/Backend.vala"
	return G_PARAM_SPEC (spec);
#line 246 "Backend.c"
}

gpointer
services_cal_dav_value_get_backend (const GValue* value)
{
#line 22 "../core/Services/CalDAV/Backend.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SERVICES_CAL_DAV_TYPE_BACKEND), NULL);
#line 22 "../core/Services/CalDAV/Backend.vala"
	return value->data[0].v_pointer;
#line 256 "Backend.c"
}

void
services_cal_dav_value_set_backend (GValue* value,
                                    gpointer v_object)
{
	ServicesCalDAVBackend * old;
#line 22 "../core/Services/CalDAV/Backend.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SERVICES_CAL_DAV_TYPE_BACKEND));
#line 22 "../core/Services/CalDAV/Backend.vala"
	old = value->data[0].v_pointer;
#line 22 "../core/Services/CalDAV/Backend.vala"
	if (v_object) {
#line 22 "../core/Services/CalDAV/Backend.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SERVICES_CAL_DAV_TYPE_BACKEND));
#line 22 "../core/Services/CalDAV/Backend.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../core/Services/CalDAV/Backend.vala"
		value->data[0].v_pointer = v_object;
#line 22 "../core/Services/CalDAV/Backend.vala"
		services_cal_dav_backend_ref (value->data[0].v_pointer);
#line 278 "Backend.c"
	} else {
#line 22 "../core/Services/CalDAV/Backend.vala"
		value->data[0].v_pointer = NULL;
#line 282 "Backend.c"
	}
#line 22 "../core/Services/CalDAV/Backend.vala"
	if (old) {
#line 22 "../core/Services/CalDAV/Backend.vala"
		services_cal_dav_backend_unref (old);
#line 288 "Backend.c"
	}
}

void
services_cal_dav_value_take_backend (GValue* value,
                                     gpointer v_object)
{
	ServicesCalDAVBackend * old;
#line 22 "../core/Services/CalDAV/Backend.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SERVICES_CAL_DAV_TYPE_BACKEND));
#line 22 "../core/Services/CalDAV/Backend.vala"
	old = value->data[0].v_pointer;
#line 22 "../core/Services/CalDAV/Backend.vala"
	if (v_object) {
#line 22 "../core/Services/CalDAV/Backend.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SERVICES_CAL_DAV_TYPE_BACKEND));
#line 22 "../core/Services/CalDAV/Backend.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../core/Services/CalDAV/Backend.vala"
		value->data[0].v_pointer = v_object;
#line 309 "Backend.c"
	} else {
#line 22 "../core/Services/CalDAV/Backend.vala"
		value->data[0].v_pointer = NULL;
#line 313 "Backend.c"
	}
#line 22 "../core/Services/CalDAV/Backend.vala"
	if (old) {
#line 22 "../core/Services/CalDAV/Backend.vala"
		services_cal_dav_backend_unref (old);
#line 319 "Backend.c"
	}
}

static void
services_cal_dav_backend_class_init (ServicesCalDAVBackendClass * klass,
                                     gpointer klass_data)
{
#line 22 "../core/Services/CalDAV/Backend.vala"
	services_cal_dav_backend_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Services/CalDAV/Backend.vala"
	((ServicesCalDAVBackendClass *) klass)->finalize = services_cal_dav_backend_finalize;
#line 331 "Backend.c"
}

static void
services_cal_dav_backend_instance_init (ServicesCalDAVBackend * self,
                                        gpointer klass)
{
#line 22 "../core/Services/CalDAV/Backend.vala"
	self->ref_count = 1;
#line 340 "Backend.c"
}

static void
services_cal_dav_backend_finalize (ServicesCalDAVBackend * obj)
{
	ServicesCalDAVBackend * self;
#line 22 "../core/Services/CalDAV/Backend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SERVICES_CAL_DAV_TYPE_BACKEND, ServicesCalDAVBackend);
#line 22 "../core/Services/CalDAV/Backend.vala"
	g_signal_handlers_destroy (self);
#line 351 "Backend.c"
}

static GType
services_cal_dav_backend_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { services_cal_dav_value_backend_init, services_cal_dav_value_backend_free_value, services_cal_dav_value_backend_copy_value, services_cal_dav_value_backend_peek_pointer, "p", services_cal_dav_value_backend_collect_value, "p", services_cal_dav_value_backend_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ServicesCalDAVBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) services_cal_dav_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServicesCalDAVBackend), 0, (GInstanceInitFunc) services_cal_dav_backend_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType services_cal_dav_backend_type_id;
	services_cal_dav_backend_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ServicesCalDAVBackend", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return services_cal_dav_backend_type_id;
}

GType
services_cal_dav_backend_get_type (void)
{
	static volatile gsize services_cal_dav_backend_type_id__once = 0;
	if (g_once_init_enter (&services_cal_dav_backend_type_id__once)) {
		GType services_cal_dav_backend_type_id;
		services_cal_dav_backend_type_id = services_cal_dav_backend_get_type_once ();
		g_once_init_leave (&services_cal_dav_backend_type_id__once, services_cal_dav_backend_type_id);
	}
	return services_cal_dav_backend_type_id__once;
}

gpointer
services_cal_dav_backend_ref (gpointer instance)
{
	ServicesCalDAVBackend * self;
	self = instance;
#line 22 "../core/Services/CalDAV/Backend.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "../core/Services/CalDAV/Backend.vala"
	return instance;
#line 386 "Backend.c"
}

void
services_cal_dav_backend_unref (gpointer instance)
{
	ServicesCalDAVBackend * self;
	self = instance;
#line 22 "../core/Services/CalDAV/Backend.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "../core/Services/CalDAV/Backend.vala"
		SERVICES_CAL_DAV_BACKEND_GET_CLASS (self)->finalize (self);
#line 22 "../core/Services/CalDAV/Backend.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 400 "Backend.c"
	}
}

