/* Datetime.c generated by valac 0.56.16, the Vala compiler
 * generated from Datetime.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <json-glib/json-glib.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <granite-7.h>
#include <libical-glib/libical-glib.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _UtilsParamSpecDatetime UtilsParamSpecDatetime;

struct _UtilsParamSpecDatetime {
	GParamSpec parent_instance;
};

static gpointer utils_datetime_parent_class = NULL;

static gboolean utils_datetime_check_by_day (const gchar* day,
                                      GArray* day_array);
static void utils_datetime_finalize (UtilsDatetime * obj);
static GType utils_datetime_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

void
utils_datetime_parse_todoist_recurrency (ObjectsDueDate* duedate,
                                         JsonObject* object)
{
	gboolean _tmp0_ = FALSE;
#line 23 "../core/Util/Datetime.vala"
	g_return_if_fail (duedate != NULL);
#line 23 "../core/Util/Datetime.vala"
	g_return_if_fail (object != NULL);
#line 24 "../core/Util/Datetime.vala"
	if (json_object_has_member (object, "lang")) {
#line 81 "Datetime.c"
		const gchar* _tmp1_;
#line 24 "../core/Util/Datetime.vala"
		_tmp1_ = json_object_get_string_member (object, "lang");
#line 24 "../core/Util/Datetime.vala"
		_tmp0_ = g_strcmp0 (_tmp1_, "en") != 0;
#line 87 "Datetime.c"
	} else {
#line 24 "../core/Util/Datetime.vala"
		_tmp0_ = FALSE;
#line 91 "Datetime.c"
	}
#line 24 "../core/Util/Datetime.vala"
	if (_tmp0_) {
#line 25 "../core/Util/Datetime.vala"
		objects_due_date_set_recurrence_supported (duedate, FALSE);
#line 26 "../core/Util/Datetime.vala"
		return;
#line 99 "Datetime.c"
	}
}

gboolean
utils_datetime_has_time (GDateTime* datetime)
{
	gboolean returned = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 30 "../core/Util/Datetime.vala"
	g_return_val_if_fail (datetime != NULL, FALSE);
#line 31 "../core/Util/Datetime.vala"
	if (datetime == NULL) {
#line 32 "../core/Util/Datetime.vala"
		result = FALSE;
#line 32 "../core/Util/Datetime.vala"
		return result;
#line 118 "Datetime.c"
	}
#line 35 "../core/Util/Datetime.vala"
	returned = TRUE;
#line 37 "../core/Util/Datetime.vala"
	if (g_date_time_get_hour (datetime) == 0) {
#line 37 "../core/Util/Datetime.vala"
		_tmp1_ = g_date_time_get_minute (datetime) == 0;
#line 126 "Datetime.c"
	} else {
#line 37 "../core/Util/Datetime.vala"
		_tmp1_ = FALSE;
#line 130 "Datetime.c"
	}
#line 37 "../core/Util/Datetime.vala"
	if (_tmp1_) {
#line 37 "../core/Util/Datetime.vala"
		_tmp0_ = g_date_time_get_second (datetime) == 0;
#line 136 "Datetime.c"
	} else {
#line 37 "../core/Util/Datetime.vala"
		_tmp0_ = FALSE;
#line 140 "Datetime.c"
	}
#line 37 "../core/Util/Datetime.vala"
	if (_tmp0_) {
#line 38 "../core/Util/Datetime.vala"
		returned = FALSE;
#line 146 "Datetime.c"
	}
#line 41 "../core/Util/Datetime.vala"
	result = returned;
#line 41 "../core/Util/Datetime.vala"
	return result;
#line 152 "Datetime.c"
}

gboolean
utils_datetime_is_today (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 44 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 45 "../core/Util/Datetime.vala"
	if (date == NULL) {
#line 46 "../core/Util/Datetime.vala"
		result = FALSE;
#line 46 "../core/Util/Datetime.vala"
		return result;
#line 170 "Datetime.c"
	}
#line 49 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 49 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 49 "../core/Util/Datetime.vala"
	_tmp2_ = granite_date_time_is_same_day (date, _tmp1_);
#line 49 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp1_);
#line 49 "../core/Util/Datetime.vala"
	result = _tmp2_;
#line 49 "../core/Util/Datetime.vala"
	return result;
#line 184 "Datetime.c"
}

gboolean
utils_datetime_is_tomorrow (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 52 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 53 "../core/Util/Datetime.vala"
	if (date == NULL) {
#line 54 "../core/Util/Datetime.vala"
		result = FALSE;
#line 54 "../core/Util/Datetime.vala"
		return result;
#line 204 "Datetime.c"
	}
#line 57 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 57 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 57 "../core/Util/Datetime.vala"
	_tmp2_ = g_date_time_add_days (_tmp1_, 1);
#line 57 "../core/Util/Datetime.vala"
	_tmp3_ = _tmp2_;
#line 57 "../core/Util/Datetime.vala"
	_tmp4_ = granite_date_time_is_same_day (date, _tmp3_);
#line 57 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp3_);
#line 57 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp1_);
#line 57 "../core/Util/Datetime.vala"
	result = _tmp4_;
#line 57 "../core/Util/Datetime.vala"
	return result;
#line 224 "Datetime.c"
}

gboolean
utils_datetime_is_next_week (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 60 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 61 "../core/Util/Datetime.vala"
	if (date == NULL) {
#line 62 "../core/Util/Datetime.vala"
		result = FALSE;
#line 62 "../core/Util/Datetime.vala"
		return result;
#line 244 "Datetime.c"
	}
#line 65 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 65 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 65 "../core/Util/Datetime.vala"
	_tmp2_ = g_date_time_add_days (_tmp1_, 7);
#line 65 "../core/Util/Datetime.vala"
	_tmp3_ = _tmp2_;
#line 65 "../core/Util/Datetime.vala"
	_tmp4_ = granite_date_time_is_same_day (date, _tmp3_);
#line 65 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp3_);
#line 65 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp1_);
#line 65 "../core/Util/Datetime.vala"
	result = _tmp4_;
#line 65 "../core/Util/Datetime.vala"
	return result;
#line 264 "Datetime.c"
}

GDateTime*
utils_datetime_get_date_from_string (const gchar* date)
{
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* result;
#line 68 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 69 "../core/Util/Datetime.vala"
	_tmp0_ = g_time_zone_new_local ();
#line 69 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 69 "../core/Util/Datetime.vala"
	_tmp2_ = g_date_time_new_from_iso8601 (date, _tmp1_);
#line 69 "../core/Util/Datetime.vala"
	_tmp3_ = _tmp2_;
#line 69 "../core/Util/Datetime.vala"
	_g_time_zone_unref0 (_tmp1_);
#line 69 "../core/Util/Datetime.vala"
	result = _tmp3_;
#line 69 "../core/Util/Datetime.vala"
	return result;
#line 291 "Datetime.c"
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3375 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3376 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3376 "glib-2.0.vapi"
	result = _tmp0_;
#line 3376 "glib-2.0.vapi"
	return result;
#line 307 "Datetime.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1499 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1500 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1500 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1500 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1501 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1502 "glib-2.0.vapi"
		start = string_length + start;
#line 334 "Datetime.c"
	}
#line 1504 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1505 "glib-2.0.vapi"
		end = string_length + end;
#line 340 "Datetime.c"
	}
#line 1507 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1507 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 346 "Datetime.c"
	} else {
#line 1507 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 350 "Datetime.c"
	}
#line 1507 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1508 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1508 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 358 "Datetime.c"
	} else {
#line 1508 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 362 "Datetime.c"
	}
#line 1508 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1509 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1510 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1510 "glib-2.0.vapi"
	result = _tmp4_;
#line 1510 "glib-2.0.vapi"
	return result;
#line 374 "Datetime.c"
}

void
utils_datetime_recurrence_to_due (const gchar* rrules,
                                  ObjectsDueDate* due)
{
	ICalRecurrence* recurrence = NULL;
	ICalRecurrence* _tmp0_;
	ICalRecurrenceFrequency freq = 0;
	ICalRecurrence* _tmp1_;
	gshort interval = 0;
	ICalRecurrence* _tmp2_;
	gint count = 0;
	ICalRecurrence* _tmp3_;
	ICalTime* until = NULL;
	ICalRecurrence* _tmp4_;
	ICalTime* _tmp5_;
	ICalTime* _tmp6_;
	RecurrencyType _tmp12_;
	RecurrencyType _tmp13_;
#line 72 "../core/Util/Datetime.vala"
	g_return_if_fail (rrules != NULL);
#line 72 "../core/Util/Datetime.vala"
	g_return_if_fail (due != NULL);
#line 73 "../core/Util/Datetime.vala"
	_tmp0_ = i_cal_recurrence_new_from_string (rrules);
#line 73 "../core/Util/Datetime.vala"
	recurrence = _tmp0_;
#line 75 "../core/Util/Datetime.vala"
	objects_due_date_set_is_recurring (due, TRUE);
#line 77 "../core/Util/Datetime.vala"
	_tmp1_ = recurrence;
#line 77 "../core/Util/Datetime.vala"
	freq = i_cal_recurrence_get_freq (_tmp1_);
#line 78 "../core/Util/Datetime.vala"
	if (freq == I_CAL_MINUTELY_RECURRENCE) {
#line 79 "../core/Util/Datetime.vala"
		objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_MINUTELY);
#line 413 "Datetime.c"
	} else {
#line 80 "../core/Util/Datetime.vala"
		if (freq == I_CAL_HOURLY_RECURRENCE) {
#line 81 "../core/Util/Datetime.vala"
			objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_HOURLY);
#line 419 "Datetime.c"
		} else {
#line 82 "../core/Util/Datetime.vala"
			if (freq == I_CAL_DAILY_RECURRENCE) {
#line 83 "../core/Util/Datetime.vala"
				objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_EVERY_DAY);
#line 425 "Datetime.c"
			} else {
#line 84 "../core/Util/Datetime.vala"
				if (freq == I_CAL_WEEKLY_RECURRENCE) {
#line 85 "../core/Util/Datetime.vala"
					objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_EVERY_WEEK);
#line 431 "Datetime.c"
				} else {
#line 86 "../core/Util/Datetime.vala"
					if (freq == I_CAL_MONTHLY_RECURRENCE) {
#line 87 "../core/Util/Datetime.vala"
						objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_EVERY_MONTH);
#line 437 "Datetime.c"
					} else {
#line 88 "../core/Util/Datetime.vala"
						if (freq == I_CAL_YEARLY_RECURRENCE) {
#line 89 "../core/Util/Datetime.vala"
							objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_EVERY_YEAR);
#line 443 "Datetime.c"
						}
					}
				}
			}
		}
	}
#line 92 "../core/Util/Datetime.vala"
	_tmp2_ = recurrence;
#line 92 "../core/Util/Datetime.vala"
	interval = i_cal_recurrence_get_interval (_tmp2_);
#line 93 "../core/Util/Datetime.vala"
	objects_due_date_set_recurrency_interval (due, (gint) interval);
#line 95 "../core/Util/Datetime.vala"
	_tmp3_ = recurrence;
#line 95 "../core/Util/Datetime.vala"
	count = i_cal_recurrence_get_count (_tmp3_);
#line 96 "../core/Util/Datetime.vala"
	objects_due_date_set_recurrency_count (due, count);
#line 98 "../core/Util/Datetime.vala"
	_tmp4_ = recurrence;
#line 98 "../core/Util/Datetime.vala"
	_tmp5_ = i_cal_recurrence_get_until (_tmp4_);
#line 98 "../core/Util/Datetime.vala"
	until = _tmp5_;
#line 99 "../core/Util/Datetime.vala"
	_tmp6_ = until;
#line 99 "../core/Util/Datetime.vala"
	if (!i_cal_time_is_null_time (_tmp6_)) {
#line 472 "Datetime.c"
		ICalTime* _tmp7_;
		GDateTime* _tmp8_;
		GDateTime* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 100 "../core/Util/Datetime.vala"
		_tmp7_ = until;
#line 100 "../core/Util/Datetime.vala"
		_tmp8_ = util_ical_to_date_time_local (_tmp7_);
#line 100 "../core/Util/Datetime.vala"
		_tmp9_ = _tmp8_;
#line 100 "../core/Util/Datetime.vala"
		_tmp10_ = g_date_time_to_string (_tmp9_);
#line 100 "../core/Util/Datetime.vala"
		_tmp11_ = _tmp10_;
#line 100 "../core/Util/Datetime.vala"
		objects_due_date_set_recurrency_end (due, _tmp11_);
#line 100 "../core/Util/Datetime.vala"
		_g_free0 (_tmp11_);
#line 100 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (_tmp9_);
#line 494 "Datetime.c"
	}
#line 103 "../core/Util/Datetime.vala"
	_tmp12_ = objects_due_date_get_recurrency_type (due);
#line 103 "../core/Util/Datetime.vala"
	_tmp13_ = _tmp12_;
#line 103 "../core/Util/Datetime.vala"
	if (_tmp13_ == RECURRENCY_TYPE_EVERY_WEEK) {
#line 502 "Datetime.c"
		gchar* recurrency_weeks = NULL;
		gchar* _tmp14_;
		GArray* day_array = NULL;
		ICalRecurrence* _tmp15_;
		GArray* _tmp16_;
		GArray* _tmp17_;
		GArray* _tmp20_;
		GArray* _tmp23_;
		GArray* _tmp26_;
		GArray* _tmp29_;
		GArray* _tmp32_;
		GArray* _tmp35_;
		const gchar* _tmp38_;
		gchar** _tmp39_;
		gchar** _tmp40_;
		gchar** _tmp41_;
		gint _tmp41__length1;
		gboolean _tmp42_;
		const gchar* _tmp46_;
#line 104 "../core/Util/Datetime.vala"
		_tmp14_ = g_strdup ("");
#line 104 "../core/Util/Datetime.vala"
		recurrency_weeks = _tmp14_;
#line 105 "../core/Util/Datetime.vala"
		_tmp15_ = recurrence;
#line 105 "../core/Util/Datetime.vala"
		_tmp16_ = i_cal_recurrence_get_by_day_array (_tmp15_);
#line 105 "../core/Util/Datetime.vala"
		day_array = _tmp16_;
#line 107 "../core/Util/Datetime.vala"
		_tmp17_ = day_array;
#line 107 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("1", _tmp17_)) {
#line 536 "Datetime.c"
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 108 "../core/Util/Datetime.vala"
			_tmp18_ = recurrency_weeks;
#line 108 "../core/Util/Datetime.vala"
			_tmp19_ = g_strconcat (_tmp18_, "7,", NULL);
#line 108 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 108 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp19_;
#line 547 "Datetime.c"
		}
#line 111 "../core/Util/Datetime.vala"
		_tmp20_ = day_array;
#line 111 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("2", _tmp20_)) {
#line 553 "Datetime.c"
			const gchar* _tmp21_;
			gchar* _tmp22_;
#line 112 "../core/Util/Datetime.vala"
			_tmp21_ = recurrency_weeks;
#line 112 "../core/Util/Datetime.vala"
			_tmp22_ = g_strconcat (_tmp21_, "1,", NULL);
#line 112 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 112 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp22_;
#line 564 "Datetime.c"
		}
#line 116 "../core/Util/Datetime.vala"
		_tmp23_ = day_array;
#line 116 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("3", _tmp23_)) {
#line 570 "Datetime.c"
			const gchar* _tmp24_;
			gchar* _tmp25_;
#line 117 "../core/Util/Datetime.vala"
			_tmp24_ = recurrency_weeks;
#line 117 "../core/Util/Datetime.vala"
			_tmp25_ = g_strconcat (_tmp24_, "2,", NULL);
#line 117 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 117 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp25_;
#line 581 "Datetime.c"
		}
#line 121 "../core/Util/Datetime.vala"
		_tmp26_ = day_array;
#line 121 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("4", _tmp26_)) {
#line 587 "Datetime.c"
			const gchar* _tmp27_;
			gchar* _tmp28_;
#line 122 "../core/Util/Datetime.vala"
			_tmp27_ = recurrency_weeks;
#line 122 "../core/Util/Datetime.vala"
			_tmp28_ = g_strconcat (_tmp27_, "3,", NULL);
#line 122 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 122 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp28_;
#line 598 "Datetime.c"
		}
#line 126 "../core/Util/Datetime.vala"
		_tmp29_ = day_array;
#line 126 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("5", _tmp29_)) {
#line 604 "Datetime.c"
			const gchar* _tmp30_;
			gchar* _tmp31_;
#line 127 "../core/Util/Datetime.vala"
			_tmp30_ = recurrency_weeks;
#line 127 "../core/Util/Datetime.vala"
			_tmp31_ = g_strconcat (_tmp30_, "4,", NULL);
#line 127 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 127 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp31_;
#line 615 "Datetime.c"
		}
#line 131 "../core/Util/Datetime.vala"
		_tmp32_ = day_array;
#line 131 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("6", _tmp32_)) {
#line 621 "Datetime.c"
			const gchar* _tmp33_;
			gchar* _tmp34_;
#line 132 "../core/Util/Datetime.vala"
			_tmp33_ = recurrency_weeks;
#line 132 "../core/Util/Datetime.vala"
			_tmp34_ = g_strconcat (_tmp33_, "5,", NULL);
#line 132 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 132 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp34_;
#line 632 "Datetime.c"
		}
#line 136 "../core/Util/Datetime.vala"
		_tmp35_ = day_array;
#line 136 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("7", _tmp35_)) {
#line 638 "Datetime.c"
			const gchar* _tmp36_;
			gchar* _tmp37_;
#line 137 "../core/Util/Datetime.vala"
			_tmp36_ = recurrency_weeks;
#line 137 "../core/Util/Datetime.vala"
			_tmp37_ = g_strconcat (_tmp36_, "6,", NULL);
#line 137 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 137 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp37_;
#line 649 "Datetime.c"
		}
#line 140 "../core/Util/Datetime.vala"
		_tmp38_ = recurrency_weeks;
#line 140 "../core/Util/Datetime.vala"
		_tmp40_ = _tmp39_ = g_strsplit (_tmp38_, ",", 0);
#line 140 "../core/Util/Datetime.vala"
		_tmp41_ = _tmp40_;
#line 140 "../core/Util/Datetime.vala"
		_tmp41__length1 = _vala_array_length (_tmp39_);
#line 140 "../core/Util/Datetime.vala"
		_tmp42_ = _vala_array_length (_tmp39_) > 0;
#line 140 "../core/Util/Datetime.vala"
		_tmp41_ = (_vala_array_free (_tmp41_, _tmp41__length1, (GDestroyNotify) g_free), NULL);
#line 140 "../core/Util/Datetime.vala"
		if (_tmp42_) {
#line 665 "Datetime.c"
			const gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
#line 141 "../core/Util/Datetime.vala"
			_tmp43_ = recurrency_weeks;
#line 141 "../core/Util/Datetime.vala"
			_tmp44_ = string_slice (_tmp43_, (glong) 0, (glong) -1);
#line 141 "../core/Util/Datetime.vala"
			_tmp45_ = _tmp44_;
#line 141 "../core/Util/Datetime.vala"
			_g_free0 (_tmp45_);
#line 677 "Datetime.c"
		}
#line 144 "../core/Util/Datetime.vala"
		_tmp46_ = recurrency_weeks;
#line 144 "../core/Util/Datetime.vala"
		objects_due_date_set_recurrency_weeks (due, _tmp46_);
#line 103 "../core/Util/Datetime.vala"
		_g_array_unref0 (day_array);
#line 103 "../core/Util/Datetime.vala"
		_g_free0 (recurrency_weeks);
#line 687 "Datetime.c"
	}
#line 72 "../core/Util/Datetime.vala"
	_g_object_unref0 (until);
#line 72 "../core/Util/Datetime.vala"
	_g_object_unref0 (recurrence);
#line 693 "Datetime.c"
}

static gboolean
utils_datetime_check_by_day (const gchar* day,
                             GArray* day_array)
{
	gboolean result;
#line 148 "../core/Util/Datetime.vala"
	g_return_val_if_fail (day != NULL, FALSE);
#line 148 "../core/Util/Datetime.vala"
	g_return_val_if_fail (day_array != NULL, FALSE);
#line 705 "Datetime.c"
	{
		GArray* _day_collection = NULL;
		guint _day_index = 0U;
#line 149 "../core/Util/Datetime.vala"
		_day_collection = day_array;
#line 149 "../core/Util/Datetime.vala"
		for (_day_index = 0; _day_index < _day_collection->len; _day_index = _day_index + 1) {
#line 713 "Datetime.c"
			gshort _day = 0;
#line 149 "../core/Util/Datetime.vala"
			_day = g_array_index (_day_collection, gshort, _day_index);
#line 717 "Datetime.c"
			{
				gchar* _tmp0_;
				gchar* _tmp1_;
				gboolean _tmp2_;
#line 150 "../core/Util/Datetime.vala"
				_tmp0_ = g_strdup_printf ("%hi", _day);
#line 150 "../core/Util/Datetime.vala"
				_tmp1_ = _tmp0_;
#line 150 "../core/Util/Datetime.vala"
				_tmp2_ = g_strcmp0 (_tmp1_, day) == 0;
#line 150 "../core/Util/Datetime.vala"
				_g_free0 (_tmp1_);
#line 150 "../core/Util/Datetime.vala"
				if (_tmp2_) {
#line 151 "../core/Util/Datetime.vala"
					result = TRUE;
#line 151 "../core/Util/Datetime.vala"
					return result;
#line 736 "Datetime.c"
				}
			}
		}
	}
#line 155 "../core/Util/Datetime.vala"
	result = FALSE;
#line 155 "../core/Util/Datetime.vala"
	return result;
#line 745 "Datetime.c"
}

UtilsDatetime*
utils_datetime_construct (GType object_type)
{
	UtilsDatetime* self = NULL;
#line 22 "../core/Util/Datetime.vala"
	self = (UtilsDatetime*) g_type_create_instance (object_type);
#line 22 "../core/Util/Datetime.vala"
	return self;
#line 756 "Datetime.c"
}

UtilsDatetime*
utils_datetime_new (void)
{
#line 22 "../core/Util/Datetime.vala"
	return utils_datetime_construct (UTILS_TYPE_DATETIME);
#line 764 "Datetime.c"
}

static void
utils_value_datetime_init (GValue* value)
{
#line 22 "../core/Util/Datetime.vala"
	value->data[0].v_pointer = NULL;
#line 772 "Datetime.c"
}

static void
utils_value_datetime_free_value (GValue* value)
{
#line 22 "../core/Util/Datetime.vala"
	if (value->data[0].v_pointer) {
#line 22 "../core/Util/Datetime.vala"
		utils_datetime_unref (value->data[0].v_pointer);
#line 782 "Datetime.c"
	}
}

static void
utils_value_datetime_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 22 "../core/Util/Datetime.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "../core/Util/Datetime.vala"
		dest_value->data[0].v_pointer = utils_datetime_ref (src_value->data[0].v_pointer);
#line 794 "Datetime.c"
	} else {
#line 22 "../core/Util/Datetime.vala"
		dest_value->data[0].v_pointer = NULL;
#line 798 "Datetime.c"
	}
}

static gpointer
utils_value_datetime_peek_pointer (const GValue* value)
{
#line 22 "../core/Util/Datetime.vala"
	return value->data[0].v_pointer;
#line 807 "Datetime.c"
}

static gchar*
utils_value_datetime_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 22 "../core/Util/Datetime.vala"
	if (collect_values[0].v_pointer) {
#line 818 "Datetime.c"
		UtilsDatetime * object;
		object = collect_values[0].v_pointer;
#line 22 "../core/Util/Datetime.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "../core/Util/Datetime.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 825 "Datetime.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "../core/Util/Datetime.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 829 "Datetime.c"
		}
#line 22 "../core/Util/Datetime.vala"
		value->data[0].v_pointer = utils_datetime_ref (object);
#line 833 "Datetime.c"
	} else {
#line 22 "../core/Util/Datetime.vala"
		value->data[0].v_pointer = NULL;
#line 837 "Datetime.c"
	}
#line 22 "../core/Util/Datetime.vala"
	return NULL;
#line 841 "Datetime.c"
}

static gchar*
utils_value_datetime_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	UtilsDatetime ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "../core/Util/Datetime.vala"
	if (!object_p) {
#line 22 "../core/Util/Datetime.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 856 "Datetime.c"
	}
#line 22 "../core/Util/Datetime.vala"
	if (!value->data[0].v_pointer) {
#line 22 "../core/Util/Datetime.vala"
		*object_p = NULL;
#line 862 "Datetime.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "../core/Util/Datetime.vala"
		*object_p = value->data[0].v_pointer;
#line 866 "Datetime.c"
	} else {
#line 22 "../core/Util/Datetime.vala"
		*object_p = utils_datetime_ref (value->data[0].v_pointer);
#line 870 "Datetime.c"
	}
#line 22 "../core/Util/Datetime.vala"
	return NULL;
#line 874 "Datetime.c"
}

GParamSpec*
utils_param_spec_datetime (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	UtilsParamSpecDatetime* spec;
#line 22 "../core/Util/Datetime.vala"
	g_return_val_if_fail (g_type_is_a (object_type, UTILS_TYPE_DATETIME), NULL);
#line 22 "../core/Util/Datetime.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "../core/Util/Datetime.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "../core/Util/Datetime.vala"
	return G_PARAM_SPEC (spec);
#line 893 "Datetime.c"
}

gpointer
utils_value_get_datetime (const GValue* value)
{
#line 22 "../core/Util/Datetime.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTILS_TYPE_DATETIME), NULL);
#line 22 "../core/Util/Datetime.vala"
	return value->data[0].v_pointer;
#line 903 "Datetime.c"
}

void
utils_value_set_datetime (GValue* value,
                          gpointer v_object)
{
	UtilsDatetime * old;
#line 22 "../core/Util/Datetime.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTILS_TYPE_DATETIME));
#line 22 "../core/Util/Datetime.vala"
	old = value->data[0].v_pointer;
#line 22 "../core/Util/Datetime.vala"
	if (v_object) {
#line 22 "../core/Util/Datetime.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UTILS_TYPE_DATETIME));
#line 22 "../core/Util/Datetime.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../core/Util/Datetime.vala"
		value->data[0].v_pointer = v_object;
#line 22 "../core/Util/Datetime.vala"
		utils_datetime_ref (value->data[0].v_pointer);
#line 925 "Datetime.c"
	} else {
#line 22 "../core/Util/Datetime.vala"
		value->data[0].v_pointer = NULL;
#line 929 "Datetime.c"
	}
#line 22 "../core/Util/Datetime.vala"
	if (old) {
#line 22 "../core/Util/Datetime.vala"
		utils_datetime_unref (old);
#line 935 "Datetime.c"
	}
}

void
utils_value_take_datetime (GValue* value,
                           gpointer v_object)
{
	UtilsDatetime * old;
#line 22 "../core/Util/Datetime.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTILS_TYPE_DATETIME));
#line 22 "../core/Util/Datetime.vala"
	old = value->data[0].v_pointer;
#line 22 "../core/Util/Datetime.vala"
	if (v_object) {
#line 22 "../core/Util/Datetime.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UTILS_TYPE_DATETIME));
#line 22 "../core/Util/Datetime.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../core/Util/Datetime.vala"
		value->data[0].v_pointer = v_object;
#line 956 "Datetime.c"
	} else {
#line 22 "../core/Util/Datetime.vala"
		value->data[0].v_pointer = NULL;
#line 960 "Datetime.c"
	}
#line 22 "../core/Util/Datetime.vala"
	if (old) {
#line 22 "../core/Util/Datetime.vala"
		utils_datetime_unref (old);
#line 966 "Datetime.c"
	}
}

static void
utils_datetime_class_init (UtilsDatetimeClass * klass,
                           gpointer klass_data)
{
#line 22 "../core/Util/Datetime.vala"
	utils_datetime_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Util/Datetime.vala"
	((UtilsDatetimeClass *) klass)->finalize = utils_datetime_finalize;
#line 978 "Datetime.c"
}

static void
utils_datetime_instance_init (UtilsDatetime * self,
                              gpointer klass)
{
#line 22 "../core/Util/Datetime.vala"
	self->ref_count = 1;
#line 987 "Datetime.c"
}

static void
utils_datetime_finalize (UtilsDatetime * obj)
{
	UtilsDatetime * self;
#line 22 "../core/Util/Datetime.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UTILS_TYPE_DATETIME, UtilsDatetime);
#line 22 "../core/Util/Datetime.vala"
	g_signal_handlers_destroy (self);
#line 998 "Datetime.c"
}

static GType
utils_datetime_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { utils_value_datetime_init, utils_value_datetime_free_value, utils_value_datetime_copy_value, utils_value_datetime_peek_pointer, "p", utils_value_datetime_collect_value, "p", utils_value_datetime_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UtilsDatetimeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) utils_datetime_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UtilsDatetime), 0, (GInstanceInitFunc) utils_datetime_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType utils_datetime_type_id;
	utils_datetime_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UtilsDatetime", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return utils_datetime_type_id;
}

GType
utils_datetime_get_type (void)
{
	static volatile gsize utils_datetime_type_id__once = 0;
	if (g_once_init_enter (&utils_datetime_type_id__once)) {
		GType utils_datetime_type_id;
		utils_datetime_type_id = utils_datetime_get_type_once ();
		g_once_init_leave (&utils_datetime_type_id__once, utils_datetime_type_id);
	}
	return utils_datetime_type_id__once;
}

gpointer
utils_datetime_ref (gpointer instance)
{
	UtilsDatetime * self;
	self = instance;
#line 22 "../core/Util/Datetime.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "../core/Util/Datetime.vala"
	return instance;
#line 1033 "Datetime.c"
}

void
utils_datetime_unref (gpointer instance)
{
	UtilsDatetime * self;
	self = instance;
#line 22 "../core/Util/Datetime.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "../core/Util/Datetime.vala"
		UTILS_DATETIME_GET_CLASS (self)->finalize (self);
#line 22 "../core/Util/Datetime.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1047 "Datetime.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

