/* Calendar.c generated by valac 0.56.16, the Vala compiler
 * generated from Calendar.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WIDGETS_CALENDAR_CALENDAR_0_PROPERTY,
	WIDGETS_CALENDAR_CALENDAR_BLOCK_PAST_DAYS_PROPERTY,
	WIDGETS_CALENDAR_CALENDAR_CURRENT_DATE_PROPERTY,
	WIDGETS_CALENDAR_CALENDAR_DATE_PROPERTY,
	WIDGETS_CALENDAR_CALENDAR_NUM_PROPERTIES
};
static GParamSpec* widgets_calendar_calendar_properties[WIDGETS_CALENDAR_CALENDAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
enum  {
	WIDGETS_CALENDAR_CALENDAR_DAY_SELECTED_SIGNAL,
	WIDGETS_CALENDAR_CALENDAR_NUM_SIGNALS
};
static guint widgets_calendar_calendar_signals[WIDGETS_CALENDAR_CALENDAR_NUM_SIGNALS] = {0};

struct _WidgetsCalendarCalendarPrivate {
	WidgetsCalendarCalendarHeader* calendar_header;
	WidgetsCalendarCalendarWeek* calendar_week;
	WidgetsCalendarCalendarView* calendar_view;
	gboolean _block_past_days;
	gint month_nav;
	gint year_nav;
	gint day_nav;
	GDateTime* _current_date;
	GDateTime* _date;
};

static gint WidgetsCalendarCalendar_private_offset;
static gpointer widgets_calendar_calendar_parent_class = NULL;

static void widgets_calendar_calendar_fill_days (WidgetsCalendarCalendar* self,
                                          GDateTime* date,
                                          gboolean show_day);
static void widgets_calendar_calendar_today (WidgetsCalendarCalendar* self);
static void widgets_calendar_calendar_view_date (WidgetsCalendarCalendar* self,
                                          GDateTime* date);
static GObject * widgets_calendar_calendar_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void _widgets_calendar_calendar___lambda101_ (WidgetsCalendarCalendar* self);
static void __widgets_calendar_calendar___lambda101__widgets_calendar_calendar_header_left_clicked (WidgetsCalendarCalendarHeader* _sender,
                                                                                             gpointer self);
static void _widgets_calendar_calendar___lambda102_ (WidgetsCalendarCalendar* self);
static void __widgets_calendar_calendar___lambda102__widgets_calendar_calendar_header_center_clicked (WidgetsCalendarCalendarHeader* _sender,
                                                                                               gpointer self);
static void _widgets_calendar_calendar___lambda103_ (WidgetsCalendarCalendar* self);
static void __widgets_calendar_calendar___lambda103__widgets_calendar_calendar_header_right_clicked (WidgetsCalendarCalendarHeader* _sender,
                                                                                              gpointer self);
static void _widgets_calendar_calendar___lambda104_ (WidgetsCalendarCalendar* self,
                                              gint day);
static void __widgets_calendar_calendar___lambda104__widgets_calendar_calendar_view_day_selected (WidgetsCalendarCalendarView* _sender,
                                                                                           gint day,
                                                                                           gpointer self);
static void _widgets_calendar_calendar___lambda105_ (WidgetsCalendarCalendar* self,
                                              const gchar* key);
static void __widgets_calendar_calendar___lambda105__g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self);
static void widgets_calendar_calendar_finalize (GObject * obj);
static GType widgets_calendar_calendar_get_type_once (void);
static void _vala_widgets_calendar_calendar_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_widgets_calendar_calendar_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

static inline gpointer
widgets_calendar_calendar_get_instance_private (WidgetsCalendarCalendar* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsCalendarCalendar_private_offset);
}

WidgetsCalendarCalendar*
widgets_calendar_calendar_construct (GType object_type,
                                     gboolean block_past_days)
{
	WidgetsCalendarCalendar * self = NULL;
#line 56 "../core/Widgets/Calendar/Calendar.vala"
	self = (WidgetsCalendarCalendar*) g_object_new (object_type, "block-past-days", block_past_days, "orientation", GTK_ORIENTATION_VERTICAL, NULL);
#line 55 "../core/Widgets/Calendar/Calendar.vala"
	return self;
#line 130 "Calendar.c"
}

WidgetsCalendarCalendar*
widgets_calendar_calendar_new (gboolean block_past_days)
{
#line 55 "../core/Widgets/Calendar/Calendar.vala"
	return widgets_calendar_calendar_construct (WIDGETS_CALENDAR_TYPE_CALENDAR, block_past_days);
#line 138 "Calendar.c"
}

void
widgets_calendar_calendar_next_month (WidgetsCalendarCalendar* self)
{
	GDateTime* date = NULL;
	GDateTime* _tmp0_;
#line 99 "../core/Widgets/Calendar/Calendar.vala"
	g_return_if_fail (self != NULL);
#line 100 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->month_nav = self->priv->month_nav + 1;
#line 102 "../core/Widgets/Calendar/Calendar.vala"
	if (self->priv->month_nav > 12) {
#line 103 "../core/Widgets/Calendar/Calendar.vala"
		self->priv->year_nav = self->priv->year_nav + 1;
#line 104 "../core/Widgets/Calendar/Calendar.vala"
		self->priv->month_nav = 1;
#line 156 "Calendar.c"
	}
#line 107 "../core/Widgets/Calendar/Calendar.vala"
	_tmp0_ = g_date_time_new_local (self->priv->year_nav, self->priv->month_nav, 1, 0, 0, (gdouble) 0);
#line 107 "../core/Widgets/Calendar/Calendar.vala"
	date = _tmp0_;
#line 108 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_fill_days (self, date, FALSE);
#line 99 "../core/Widgets/Calendar/Calendar.vala"
	_g_date_time_unref0 (date);
#line 166 "Calendar.c"
}

void
widgets_calendar_calendar_previous_month (WidgetsCalendarCalendar* self)
{
	GDateTime* date = NULL;
	GDateTime* _tmp0_;
#line 111 "../core/Widgets/Calendar/Calendar.vala"
	g_return_if_fail (self != NULL);
#line 112 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->month_nav = self->priv->month_nav - 1;
#line 114 "../core/Widgets/Calendar/Calendar.vala"
	if (self->priv->month_nav < 1) {
#line 115 "../core/Widgets/Calendar/Calendar.vala"
		self->priv->year_nav = self->priv->year_nav - 1;
#line 116 "../core/Widgets/Calendar/Calendar.vala"
		self->priv->month_nav = 12;
#line 184 "Calendar.c"
	}
#line 119 "../core/Widgets/Calendar/Calendar.vala"
	_tmp0_ = g_date_time_new_local (self->priv->year_nav, self->priv->month_nav, 1, 0, 0, (gdouble) 0);
#line 119 "../core/Widgets/Calendar/Calendar.vala"
	date = _tmp0_;
#line 120 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_fill_days (self, date, FALSE);
#line 111 "../core/Widgets/Calendar/Calendar.vala"
	_g_date_time_unref0 (date);
#line 194 "Calendar.c"
}

static void
widgets_calendar_calendar_today (WidgetsCalendarCalendar* self)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
#line 123 "../core/Widgets/Calendar/Calendar.vala"
	g_return_if_fail (self != NULL);
#line 124 "../core/Widgets/Calendar/Calendar.vala"
	_tmp0_ = widgets_calendar_calendar_get_current_date (self);
#line 124 "../core/Widgets/Calendar/Calendar.vala"
	_tmp1_ = _tmp0_;
#line 124 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->year_nav = g_date_time_get_year (_tmp1_);
#line 125 "../core/Widgets/Calendar/Calendar.vala"
	_tmp2_ = widgets_calendar_calendar_get_current_date (self);
#line 125 "../core/Widgets/Calendar/Calendar.vala"
	_tmp3_ = _tmp2_;
#line 125 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->month_nav = g_date_time_get_month (_tmp3_);
#line 126 "../core/Widgets/Calendar/Calendar.vala"
	_tmp4_ = widgets_calendar_calendar_get_current_date (self);
#line 126 "../core/Widgets/Calendar/Calendar.vala"
	_tmp5_ = _tmp4_;
#line 126 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->day_nav = g_date_time_get_day_of_month (_tmp5_);
#line 128 "../core/Widgets/Calendar/Calendar.vala"
	_tmp6_ = widgets_calendar_calendar_get_current_date (self);
#line 128 "../core/Widgets/Calendar/Calendar.vala"
	_tmp7_ = _tmp6_;
#line 128 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_fill_days (self, _tmp7_, FALSE);
#line 234 "Calendar.c"
}

static void
widgets_calendar_calendar_view_date (WidgetsCalendarCalendar* self,
                                     GDateTime* date)
{
#line 131 "../core/Widgets/Calendar/Calendar.vala"
	g_return_if_fail (self != NULL);
#line 131 "../core/Widgets/Calendar/Calendar.vala"
	g_return_if_fail (date != NULL);
#line 132 "../core/Widgets/Calendar/Calendar.vala"
	if (date == NULL) {
#line 133 "../core/Widgets/Calendar/Calendar.vala"
		return;
#line 249 "Calendar.c"
	}
#line 136 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->year_nav = g_date_time_get_year (date);
#line 137 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->month_nav = g_date_time_get_month (date);
#line 138 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->day_nav = g_date_time_get_day_of_month (date);
#line 140 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_fill_days (self, date, TRUE);
#line 259 "Calendar.c"
}

static void
widgets_calendar_calendar_fill_days (WidgetsCalendarCalendar* self,
                                     GDateTime* date,
                                     gboolean show_day)
{
	GDateTime* firts_week = NULL;
	GDateTime* _tmp0_;
	gint start_day = 0;
	GDateTime* _tmp1_;
	ServicesSettings* _tmp2_;
	ServicesSettings* _tmp3_;
	GSettings* _tmp4_;
	gint _tmp5_;
	gint max_days = 0;
	Util* _tmp6_;
	Util* _tmp7_;
	gint _tmp8_;
	WidgetsCalendarCalendarView* _tmp9_;
	gboolean _tmp10_;
	WidgetsCalendarCalendarHeader* _tmp11_;
#line 143 "../core/Widgets/Calendar/Calendar.vala"
	g_return_if_fail (self != NULL);
#line 143 "../core/Widgets/Calendar/Calendar.vala"
	g_return_if_fail (date != NULL);
#line 144 "../core/Widgets/Calendar/Calendar.vala"
	_tmp0_ = g_date_time_new_local (self->priv->year_nav, self->priv->month_nav, 1, 0, 0, (gdouble) 0);
#line 144 "../core/Widgets/Calendar/Calendar.vala"
	firts_week = _tmp0_;
#line 145 "../core/Widgets/Calendar/Calendar.vala"
	_tmp1_ = firts_week;
#line 145 "../core/Widgets/Calendar/Calendar.vala"
	_tmp2_ = services_settings_get_default ();
#line 145 "../core/Widgets/Calendar/Calendar.vala"
	_tmp3_ = _tmp2_;
#line 145 "../core/Widgets/Calendar/Calendar.vala"
	_tmp4_ = _tmp3_->settings;
#line 145 "../core/Widgets/Calendar/Calendar.vala"
	_tmp5_ = g_date_time_get_day_of_week (_tmp1_) - g_settings_get_enum (_tmp4_, "start-week");
#line 145 "../core/Widgets/Calendar/Calendar.vala"
	_g_object_unref0 (_tmp3_);
#line 145 "../core/Widgets/Calendar/Calendar.vala"
	start_day = _tmp5_;
#line 146 "../core/Widgets/Calendar/Calendar.vala"
	if (start_day < 0) {
#line 147 "../core/Widgets/Calendar/Calendar.vala"
		start_day += 7;
#line 308 "Calendar.c"
	}
#line 149 "../core/Widgets/Calendar/Calendar.vala"
	start_day = (start_day + 7) % 7;
#line 151 "../core/Widgets/Calendar/Calendar.vala"
	_tmp6_ = util_get_default ();
#line 151 "../core/Widgets/Calendar/Calendar.vala"
	_tmp7_ = _tmp6_;
#line 151 "../core/Widgets/Calendar/Calendar.vala"
	_tmp8_ = util_get_days_of_month (_tmp7_, g_date_time_get_month (date), self->priv->year_nav);
#line 151 "../core/Widgets/Calendar/Calendar.vala"
	_g_object_unref0 (_tmp7_);
#line 151 "../core/Widgets/Calendar/Calendar.vala"
	max_days = _tmp8_;
#line 152 "../core/Widgets/Calendar/Calendar.vala"
	_tmp9_ = self->priv->calendar_view;
#line 152 "../core/Widgets/Calendar/Calendar.vala"
	_tmp10_ = self->priv->_block_past_days;
#line 152 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_view_fill_grid_days (_tmp9_, start_day, max_days, date, show_day, _tmp10_);
#line 153 "../core/Widgets/Calendar/Calendar.vala"
	_tmp11_ = self->priv->calendar_header;
#line 153 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_header_set_date (_tmp11_, date);
#line 143 "../core/Widgets/Calendar/Calendar.vala"
	_g_date_time_unref0 (firts_week);
#line 334 "Calendar.c"
}

void
widgets_calendar_calendar_reset (WidgetsCalendarCalendar* self)
{
	WidgetsCalendarCalendarView* _tmp0_;
#line 156 "../core/Widgets/Calendar/Calendar.vala"
	g_return_if_fail (self != NULL);
#line 157 "../core/Widgets/Calendar/Calendar.vala"
	_tmp0_ = self->priv->calendar_view;
#line 157 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_view_clear_style (_tmp0_);
#line 347 "Calendar.c"
}

gboolean
widgets_calendar_calendar_get_block_past_days (WidgetsCalendarCalendar* self)
{
	gboolean result;
#line 27 "../core/Widgets/Calendar/Calendar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "../core/Widgets/Calendar/Calendar.vala"
	result = self->priv->_block_past_days;
#line 27 "../core/Widgets/Calendar/Calendar.vala"
	return result;
#line 360 "Calendar.c"
}

static void
widgets_calendar_calendar_set_block_past_days (WidgetsCalendarCalendar* self,
                                               gboolean value)
{
	gboolean old_value;
#line 27 "../core/Widgets/Calendar/Calendar.vala"
	g_return_if_fail (self != NULL);
#line 27 "../core/Widgets/Calendar/Calendar.vala"
	old_value = widgets_calendar_calendar_get_block_past_days (self);
#line 27 "../core/Widgets/Calendar/Calendar.vala"
	if (old_value != value) {
#line 27 "../core/Widgets/Calendar/Calendar.vala"
		self->priv->_block_past_days = value;
#line 27 "../core/Widgets/Calendar/Calendar.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_calendar_calendar_properties[WIDGETS_CALENDAR_CALENDAR_BLOCK_PAST_DAYS_PROPERTY]);
#line 378 "Calendar.c"
	}
}

GDateTime*
widgets_calendar_calendar_get_current_date (WidgetsCalendarCalendar* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
#line 35 "../core/Widgets/Calendar/Calendar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../core/Widgets/Calendar/Calendar.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 36 "../core/Widgets/Calendar/Calendar.vala"
	_g_date_time_unref0 (self->priv->_current_date);
#line 36 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->_current_date = _tmp0_;
#line 37 "../core/Widgets/Calendar/Calendar.vala"
	_tmp1_ = self->priv->_current_date;
#line 37 "../core/Widgets/Calendar/Calendar.vala"
	result = _tmp1_;
#line 37 "../core/Widgets/Calendar/Calendar.vala"
	return result;
#line 402 "Calendar.c"
}

GDateTime*
widgets_calendar_calendar_get_date (WidgetsCalendarCalendar* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 48 "../core/Widgets/Calendar/Calendar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../core/Widgets/Calendar/Calendar.vala"
	_tmp0_ = self->priv->_date;
#line 49 "../core/Widgets/Calendar/Calendar.vala"
	result = _tmp0_;
#line 49 "../core/Widgets/Calendar/Calendar.vala"
	return result;
#line 418 "Calendar.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 44 "../core/Widgets/Calendar/Calendar.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 426 "Calendar.c"
}

void
widgets_calendar_calendar_set_date (WidgetsCalendarCalendar* self,
                                    GDateTime* value)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
#line 43 "../core/Widgets/Calendar/Calendar.vala"
	g_return_if_fail (self != NULL);
#line 44 "../core/Widgets/Calendar/Calendar.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 44 "../core/Widgets/Calendar/Calendar.vala"
	_g_date_time_unref0 (self->priv->_date);
#line 44 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->_date = _tmp0_;
#line 45 "../core/Widgets/Calendar/Calendar.vala"
	_tmp1_ = self->priv->_date;
#line 45 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_view_date (self, _tmp1_);
#line 43 "../core/Widgets/Calendar/Calendar.vala"
	g_object_notify_by_pspec ((GObject *) self, widgets_calendar_calendar_properties[WIDGETS_CALENDAR_CALENDAR_DATE_PROPERTY]);
#line 449 "Calendar.c"
}

static void
_widgets_calendar_calendar___lambda101_ (WidgetsCalendarCalendar* self)
{
#line 74 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_previous_month (self);
#line 457 "Calendar.c"
}

static void
__widgets_calendar_calendar___lambda101__widgets_calendar_calendar_header_left_clicked (WidgetsCalendarCalendarHeader* _sender,
                                                                                        gpointer self)
{
#line 73 "../core/Widgets/Calendar/Calendar.vala"
	_widgets_calendar_calendar___lambda101_ ((WidgetsCalendarCalendar*) self);
#line 466 "Calendar.c"
}

static void
_widgets_calendar_calendar___lambda102_ (WidgetsCalendarCalendar* self)
{
#line 78 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_today (self);
#line 474 "Calendar.c"
}

static void
__widgets_calendar_calendar___lambda102__widgets_calendar_calendar_header_center_clicked (WidgetsCalendarCalendarHeader* _sender,
                                                                                          gpointer self)
{
#line 77 "../core/Widgets/Calendar/Calendar.vala"
	_widgets_calendar_calendar___lambda102_ ((WidgetsCalendarCalendar*) self);
#line 483 "Calendar.c"
}

static void
_widgets_calendar_calendar___lambda103_ (WidgetsCalendarCalendar* self)
{
#line 82 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_next_month (self);
#line 491 "Calendar.c"
}

static void
__widgets_calendar_calendar___lambda103__widgets_calendar_calendar_header_right_clicked (WidgetsCalendarCalendarHeader* _sender,
                                                                                         gpointer self)
{
#line 81 "../core/Widgets/Calendar/Calendar.vala"
	_widgets_calendar_calendar___lambda103_ ((WidgetsCalendarCalendar*) self);
#line 500 "Calendar.c"
}

static void
_widgets_calendar_calendar___lambda104_ (WidgetsCalendarCalendar* self,
                                         gint day)
{
	GDateTime* _tmp0_;
#line 86 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->day_nav = day;
#line 87 "../core/Widgets/Calendar/Calendar.vala"
	_tmp0_ = g_date_time_new_local (self->priv->year_nav, self->priv->month_nav, self->priv->day_nav, 0, 0, (gdouble) 0);
#line 87 "../core/Widgets/Calendar/Calendar.vala"
	_g_date_time_unref0 (self->priv->_date);
#line 87 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->_date = _tmp0_;
#line 88 "../core/Widgets/Calendar/Calendar.vala"
	g_signal_emit (self, widgets_calendar_calendar_signals[WIDGETS_CALENDAR_CALENDAR_DAY_SELECTED_SIGNAL], 0);
#line 518 "Calendar.c"
}

static void
__widgets_calendar_calendar___lambda104__widgets_calendar_calendar_view_day_selected (WidgetsCalendarCalendarView* _sender,
                                                                                      gint day,
                                                                                      gpointer self)
{
#line 85 "../core/Widgets/Calendar/Calendar.vala"
	_widgets_calendar_calendar___lambda104_ ((WidgetsCalendarCalendar*) self, day);
#line 528 "Calendar.c"
}

static void
_widgets_calendar_calendar___lambda105_ (WidgetsCalendarCalendar* self,
                                         const gchar* key)
{
#line 91 "../core/Widgets/Calendar/Calendar.vala"
	g_return_if_fail (key != NULL);
#line 92 "../core/Widgets/Calendar/Calendar.vala"
	if (g_strcmp0 (key, "start-week") == 0) {
#line 539 "Calendar.c"
		WidgetsCalendarCalendarWeek* _tmp0_;
#line 93 "../core/Widgets/Calendar/Calendar.vala"
		_tmp0_ = self->priv->calendar_week;
#line 93 "../core/Widgets/Calendar/Calendar.vala"
		widgets_calendar_calendar_week_update (_tmp0_);
#line 94 "../core/Widgets/Calendar/Calendar.vala"
		widgets_calendar_calendar_today (self);
#line 547 "Calendar.c"
	}
}

static void
__widgets_calendar_calendar___lambda105__g_settings_changed (GSettings* _sender,
                                                             const gchar* key,
                                                             gpointer self)
{
#line 91 "../core/Widgets/Calendar/Calendar.vala"
	_widgets_calendar_calendar___lambda105_ ((WidgetsCalendarCalendar*) self, key);
#line 558 "Calendar.c"
}

static GObject *
widgets_calendar_calendar_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsCalendarCalendar * self;
	WidgetsCalendarCalendarHeader* _tmp0_;
	WidgetsCalendarCalendarWeek* _tmp1_;
	WidgetsCalendarCalendarView* _tmp2_;
	WidgetsCalendarCalendarHeader* _tmp3_;
	WidgetsCalendarCalendarWeek* _tmp4_;
	WidgetsCalendarCalendarView* _tmp5_;
	WidgetsCalendarCalendarHeader* _tmp6_;
	WidgetsCalendarCalendarHeader* _tmp7_;
	WidgetsCalendarCalendarHeader* _tmp8_;
	WidgetsCalendarCalendarView* _tmp9_;
	ServicesSettings* _tmp10_;
	ServicesSettings* _tmp11_;
	GSettings* _tmp12_;
#line 62 "../core/Widgets/Calendar/Calendar.vala"
	parent_class = G_OBJECT_CLASS (widgets_calendar_calendar_parent_class);
#line 62 "../core/Widgets/Calendar/Calendar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 62 "../core/Widgets/Calendar/Calendar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_CALENDAR_TYPE_CALENDAR, WidgetsCalendarCalendar);
#line 63 "../core/Widgets/Calendar/Calendar.vala"
	_tmp0_ = widgets_calendar_calendar_header_new ();
#line 63 "../core/Widgets/Calendar/Calendar.vala"
	g_object_ref_sink (_tmp0_);
#line 63 "../core/Widgets/Calendar/Calendar.vala"
	_g_object_unref0 (self->priv->calendar_header);
#line 63 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->calendar_header = _tmp0_;
#line 64 "../core/Widgets/Calendar/Calendar.vala"
	_tmp1_ = widgets_calendar_calendar_week_new ();
#line 64 "../core/Widgets/Calendar/Calendar.vala"
	g_object_ref_sink (_tmp1_);
#line 64 "../core/Widgets/Calendar/Calendar.vala"
	_g_object_unref0 (self->priv->calendar_week);
#line 64 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->calendar_week = _tmp1_;
#line 65 "../core/Widgets/Calendar/Calendar.vala"
	_tmp2_ = widgets_calendar_calendar_view_new ();
#line 65 "../core/Widgets/Calendar/Calendar.vala"
	g_object_ref_sink (_tmp2_);
#line 65 "../core/Widgets/Calendar/Calendar.vala"
	_g_object_unref0 (self->priv->calendar_view);
#line 65 "../core/Widgets/Calendar/Calendar.vala"
	self->priv->calendar_view = _tmp2_;
#line 67 "../core/Widgets/Calendar/Calendar.vala"
	_tmp3_ = self->priv->calendar_header;
#line 67 "../core/Widgets/Calendar/Calendar.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp3_);
#line 68 "../core/Widgets/Calendar/Calendar.vala"
	_tmp4_ = self->priv->calendar_week;
#line 68 "../core/Widgets/Calendar/Calendar.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp4_);
#line 69 "../core/Widgets/Calendar/Calendar.vala"
	_tmp5_ = self->priv->calendar_view;
#line 69 "../core/Widgets/Calendar/Calendar.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp5_);
#line 71 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_today (self);
#line 73 "../core/Widgets/Calendar/Calendar.vala"
	_tmp6_ = self->priv->calendar_header;
#line 73 "../core/Widgets/Calendar/Calendar.vala"
	g_signal_connect_object (_tmp6_, "left-clicked", (GCallback) __widgets_calendar_calendar___lambda101__widgets_calendar_calendar_header_left_clicked, self, 0);
#line 77 "../core/Widgets/Calendar/Calendar.vala"
	_tmp7_ = self->priv->calendar_header;
#line 77 "../core/Widgets/Calendar/Calendar.vala"
	g_signal_connect_object (_tmp7_, "center-clicked", (GCallback) __widgets_calendar_calendar___lambda102__widgets_calendar_calendar_header_center_clicked, self, 0);
#line 81 "../core/Widgets/Calendar/Calendar.vala"
	_tmp8_ = self->priv->calendar_header;
#line 81 "../core/Widgets/Calendar/Calendar.vala"
	g_signal_connect_object (_tmp8_, "right-clicked", (GCallback) __widgets_calendar_calendar___lambda103__widgets_calendar_calendar_header_right_clicked, self, 0);
#line 85 "../core/Widgets/Calendar/Calendar.vala"
	_tmp9_ = self->priv->calendar_view;
#line 85 "../core/Widgets/Calendar/Calendar.vala"
	g_signal_connect_object (_tmp9_, "day-selected", (GCallback) __widgets_calendar_calendar___lambda104__widgets_calendar_calendar_view_day_selected, self, 0);
#line 91 "../core/Widgets/Calendar/Calendar.vala"
	_tmp10_ = services_settings_get_default ();
#line 91 "../core/Widgets/Calendar/Calendar.vala"
	_tmp11_ = _tmp10_;
#line 91 "../core/Widgets/Calendar/Calendar.vala"
	_tmp12_ = _tmp11_->settings;
#line 91 "../core/Widgets/Calendar/Calendar.vala"
	g_signal_connect_object (_tmp12_, "changed", (GCallback) __widgets_calendar_calendar___lambda105__g_settings_changed, self, 0);
#line 91 "../core/Widgets/Calendar/Calendar.vala"
	_g_object_unref0 (_tmp11_);
#line 62 "../core/Widgets/Calendar/Calendar.vala"
	return obj;
#line 654 "Calendar.c"
}

static void
widgets_calendar_calendar_class_init (WidgetsCalendarCalendarClass * klass,
                                      gpointer klass_data)
{
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsCalendarCalendar_private_offset);
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_calendar_calendar_get_property;
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_calendar_calendar_set_property;
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_calendar_calendar_constructor;
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_calendar_calendar_finalize;
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_CALENDAR_CALENDAR_BLOCK_PAST_DAYS_PROPERTY, widgets_calendar_calendar_properties[WIDGETS_CALENDAR_CALENDAR_BLOCK_PAST_DAYS_PROPERTY] = g_param_spec_boolean ("block-past-days", "block-past-days", "block-past-days", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_CALENDAR_CALENDAR_CURRENT_DATE_PROPERTY, widgets_calendar_calendar_properties[WIDGETS_CALENDAR_CALENDAR_CURRENT_DATE_PROPERTY] = g_param_spec_boxed ("current-date", "current-date", "current-date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_CALENDAR_CALENDAR_DATE_PROPERTY, widgets_calendar_calendar_properties[WIDGETS_CALENDAR_CALENDAR_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	widgets_calendar_calendar_signals[WIDGETS_CALENDAR_CALENDAR_DAY_SELECTED_SIGNAL] = g_signal_new ("day-selected", WIDGETS_CALENDAR_TYPE_CALENDAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 681 "Calendar.c"
}

static void
widgets_calendar_calendar_instance_init (WidgetsCalendarCalendar * self,
                                         gpointer klass)
{
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	self->priv = widgets_calendar_calendar_get_instance_private (self);
#line 690 "Calendar.c"
}

static void
widgets_calendar_calendar_finalize (GObject * obj)
{
	WidgetsCalendarCalendar * self;
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_CALENDAR_TYPE_CALENDAR, WidgetsCalendarCalendar);
#line 23 "../core/Widgets/Calendar/Calendar.vala"
	_g_object_unref0 (self->priv->calendar_header);
#line 24 "../core/Widgets/Calendar/Calendar.vala"
	_g_object_unref0 (self->priv->calendar_week);
#line 25 "../core/Widgets/Calendar/Calendar.vala"
	_g_object_unref0 (self->priv->calendar_view);
#line 33 "../core/Widgets/Calendar/Calendar.vala"
	_g_date_time_unref0 (self->priv->_current_date);
#line 41 "../core/Widgets/Calendar/Calendar.vala"
	_g_date_time_unref0 (self->priv->_date);
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	G_OBJECT_CLASS (widgets_calendar_calendar_parent_class)->finalize (obj);
#line 711 "Calendar.c"
}

static GType
widgets_calendar_calendar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsCalendarCalendarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_calendar_calendar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsCalendarCalendar), 0, (GInstanceInitFunc) widgets_calendar_calendar_instance_init, NULL };
	GType widgets_calendar_calendar_type_id;
	widgets_calendar_calendar_type_id = g_type_register_static (gtk_box_get_type (), "WidgetsCalendarCalendar", &g_define_type_info, 0);
	WidgetsCalendarCalendar_private_offset = g_type_add_instance_private (widgets_calendar_calendar_type_id, sizeof (WidgetsCalendarCalendarPrivate));
	return widgets_calendar_calendar_type_id;
}

GType
widgets_calendar_calendar_get_type (void)
{
	static volatile gsize widgets_calendar_calendar_type_id__once = 0;
	if (g_once_init_enter (&widgets_calendar_calendar_type_id__once)) {
		GType widgets_calendar_calendar_type_id;
		widgets_calendar_calendar_type_id = widgets_calendar_calendar_get_type_once ();
		g_once_init_leave (&widgets_calendar_calendar_type_id__once, widgets_calendar_calendar_type_id);
	}
	return widgets_calendar_calendar_type_id__once;
}

static void
_vala_widgets_calendar_calendar_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	WidgetsCalendarCalendar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_CALENDAR_TYPE_CALENDAR, WidgetsCalendarCalendar);
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	switch (property_id) {
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		case WIDGETS_CALENDAR_CALENDAR_BLOCK_PAST_DAYS_PROPERTY:
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		g_value_set_boolean (value, widgets_calendar_calendar_get_block_past_days (self));
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		break;
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		case WIDGETS_CALENDAR_CALENDAR_CURRENT_DATE_PROPERTY:
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		g_value_set_boxed (value, widgets_calendar_calendar_get_current_date (self));
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		break;
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		case WIDGETS_CALENDAR_CALENDAR_DATE_PROPERTY:
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		g_value_set_boxed (value, widgets_calendar_calendar_get_date (self));
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		break;
#line 764 "Calendar.c"
		default:
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		break;
#line 770 "Calendar.c"
	}
}

static void
_vala_widgets_calendar_calendar_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	WidgetsCalendarCalendar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_CALENDAR_TYPE_CALENDAR, WidgetsCalendarCalendar);
#line 22 "../core/Widgets/Calendar/Calendar.vala"
	switch (property_id) {
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		case WIDGETS_CALENDAR_CALENDAR_BLOCK_PAST_DAYS_PROPERTY:
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		widgets_calendar_calendar_set_block_past_days (self, g_value_get_boolean (value));
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		break;
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		case WIDGETS_CALENDAR_CALENDAR_DATE_PROPERTY:
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		widgets_calendar_calendar_set_date (self, g_value_get_boxed (value));
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		break;
#line 796 "Calendar.c"
		default:
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Widgets/Calendar/Calendar.vala"
		break;
#line 802 "Calendar.c"
	}
}

