/* CalendarView.c generated by valac 0.56.16, the Vala compiler
 * generated from CalendarView.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <gee.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <adwaita.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WIDGETS_CALENDAR_CALENDAR_VIEW_0_PROPERTY,
	WIDGETS_CALENDAR_CALENDAR_VIEW_CURRENT_DATE_PROPERTY,
	WIDGETS_CALENDAR_CALENDAR_VIEW_NUM_PROPERTIES
};
static GParamSpec* widgets_calendar_calendar_view_properties[WIDGETS_CALENDAR_CALENDAR_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
enum  {
	WIDGETS_CALENDAR_CALENDAR_VIEW_DAY_SELECTED_SIGNAL,
	WIDGETS_CALENDAR_CALENDAR_VIEW_NUM_SIGNALS
};
static guint widgets_calendar_calendar_view_signals[WIDGETS_CALENDAR_CALENDAR_VIEW_NUM_SIGNALS] = {0};

struct _WidgetsCalendarCalendarViewPrivate {
	GeeArrayList* days_arraylist;
	GtkGrid* days_grid;
	GDateTime* _current_date;
};

static gint WidgetsCalendarCalendarView_private_offset;
static gpointer widgets_calendar_calendar_view_parent_class = NULL;

static GDateTime* widgets_calendar_calendar_view_generate_date (WidgetsCalendarCalendarView* self,
                                                         GDateTime* date,
                                                         gint day);
static void widgets_calendar_calendar_view_day_selected_style (WidgetsCalendarCalendarView* self,
                                                        gint day);
static GObject * widgets_calendar_calendar_view_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static void _widgets_calendar_calendar_view______lambda100_ (WidgetsCalendarCalendarView* self,
                                                      gint day);
static void __widgets_calendar_calendar_view______lambda100__widgets_calendar_calendar_day_day_selected (WidgetsCalendarCalendarDay* _sender,
                                                                                                  gint day,
                                                                                                  gpointer self);
static void widgets_calendar_calendar_view_finalize (GObject * obj);
static GType widgets_calendar_calendar_view_get_type_once (void);
static void _vala_widgets_calendar_calendar_view_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);

static inline gpointer
widgets_calendar_calendar_view_get_instance_private (WidgetsCalendarCalendarView* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsCalendarCalendarView_private_offset);
}

WidgetsCalendarCalendarView*
widgets_calendar_calendar_view_construct (GType object_type)
{
	WidgetsCalendarCalendarView * self = NULL;
#line 47 "../core/Widgets/Calendar/CalendarView.vala"
	self = (WidgetsCalendarCalendarView*) g_object_new (object_type, "margin-start", 6, "margin-end", 6, NULL);
#line 46 "../core/Widgets/Calendar/CalendarView.vala"
	return self;
#line 101 "CalendarView.c"
}

WidgetsCalendarCalendarView*
widgets_calendar_calendar_view_new (void)
{
#line 46 "../core/Widgets/Calendar/CalendarView.vala"
	return widgets_calendar_calendar_view_construct (WIDGETS_CALENDAR_TYPE_CALENDAR_VIEW);
#line 109 "CalendarView.c"
}

void
widgets_calendar_calendar_view_fill_grid_days (WidgetsCalendarCalendarView* self,
                                               gint start_day,
                                               gint max_day,
                                               GDateTime* day,
                                               gboolean show_day,
                                               gboolean block_past_days)
{
	gint day_number = 0;
#line 86 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_if_fail (self != NULL);
#line 86 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_if_fail (day != NULL);
#line 88 "../core/Widgets/Calendar/CalendarView.vala"
	day_number = 1;
#line 127 "CalendarView.c"
	{
		gint i = 0;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
		i = 0;
#line 132 "CalendarView.c"
		{
			gboolean _tmp0_ = FALSE;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
			_tmp0_ = TRUE;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
			while (TRUE) {
#line 139 "CalendarView.c"
				WidgetsCalendarCalendarDay* item = NULL;
				GeeArrayList* _tmp2_;
				gpointer _tmp3_;
				WidgetsCalendarCalendarDay* _tmp4_;
				WidgetsCalendarCalendarDay* _tmp5_;
				WidgetsCalendarCalendarDay* _tmp6_;
				WidgetsCalendarCalendarDay* _tmp7_;
				gboolean _tmp8_ = FALSE;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
				if (!_tmp0_) {
#line 150 "CalendarView.c"
					gint _tmp1_;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp1_ = i;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
					i = _tmp1_ + 1;
#line 156 "CalendarView.c"
				}
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp0_ = FALSE;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
				if (!(i < 42)) {
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
					break;
#line 164 "CalendarView.c"
				}
#line 91 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp2_ = self->priv->days_arraylist;
#line 91 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, i);
#line 91 "../core/Widgets/Calendar/CalendarView.vala"
				item = (WidgetsCalendarCalendarDay*) _tmp3_;
#line 92 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp4_ = item;
#line 92 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
#line 93 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp5_ = item;
#line 93 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
#line 95 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp6_ = item;
#line 95 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_remove_css_class ((GtkWidget*) _tmp6_, "calendar-today");
#line 96 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp7_ = item;
#line 96 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_remove_css_class ((GtkWidget*) _tmp7_, "calendar-day-selected");
#line 98 "../core/Widgets/Calendar/CalendarView.vala"
				if (i < start_day) {
#line 98 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp8_ = TRUE;
#line 192 "CalendarView.c"
				} else {
#line 98 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp8_ = i >= (max_day + start_day);
#line 196 "CalendarView.c"
				}
#line 98 "../core/Widgets/Calendar/CalendarView.vala"
				if (_tmp8_) {
#line 200 "CalendarView.c"
					WidgetsCalendarCalendarDay* _tmp9_;
#line 99 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp9_ = item;
#line 99 "../core/Widgets/Calendar/CalendarView.vala"
					gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 206 "CalendarView.c"
				} else {
					gboolean _tmp10_ = FALSE;
					GDateTime* _tmp16_;
					GDateTime* _tmp17_;
					GDateTime* _tmp18_;
					GDateTime* _tmp19_;
					gboolean _tmp20_;
					gboolean _tmp22_ = FALSE;
					WidgetsCalendarCalendarDay* _tmp30_;
#line 101 "../core/Widgets/Calendar/CalendarView.vala"
					if (block_past_days) {
#line 218 "CalendarView.c"
						GDateTime* _tmp11_;
						GDateTime* _tmp12_;
						GDateTime* _tmp13_;
						GDateTime* _tmp14_;
#line 101 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp11_ = widgets_calendar_calendar_view_generate_date (self, day, day_number);
#line 101 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp12_ = _tmp11_;
#line 101 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp13_ = widgets_calendar_calendar_view_get_current_date (self);
#line 101 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp14_ = _tmp13_;
#line 101 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp10_ = g_date_time_compare (_tmp12_, _tmp14_) <= -1;
#line 101 "../core/Widgets/Calendar/CalendarView.vala"
						_g_date_time_unref0 (_tmp12_);
#line 235 "CalendarView.c"
					} else {
#line 101 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp10_ = FALSE;
#line 239 "CalendarView.c"
					}
#line 101 "../core/Widgets/Calendar/CalendarView.vala"
					if (_tmp10_) {
#line 243 "CalendarView.c"
						WidgetsCalendarCalendarDay* _tmp15_;
#line 102 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp15_ = item;
#line 102 "../core/Widgets/Calendar/CalendarView.vala"
						gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, FALSE);
#line 249 "CalendarView.c"
					}
#line 105 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp16_ = widgets_calendar_calendar_view_generate_date (self, day, day_number);
#line 105 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp17_ = _tmp16_;
#line 105 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp18_ = widgets_calendar_calendar_view_get_current_date (self);
#line 105 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp19_ = _tmp18_;
#line 105 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp20_ = g_date_time_compare (_tmp17_, _tmp19_) == 0;
#line 105 "../core/Widgets/Calendar/CalendarView.vala"
					_g_date_time_unref0 (_tmp17_);
#line 105 "../core/Widgets/Calendar/CalendarView.vala"
					if (_tmp20_) {
#line 265 "CalendarView.c"
						WidgetsCalendarCalendarDay* _tmp21_;
#line 106 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp21_ = item;
#line 106 "../core/Widgets/Calendar/CalendarView.vala"
						gtk_widget_add_css_class ((GtkWidget*) _tmp21_, "calendar-today");
#line 271 "CalendarView.c"
					}
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
					if (show_day) {
#line 275 "CalendarView.c"
						Util* _tmp23_;
						Util* _tmp24_;
						GDateTime* _tmp25_;
						GDateTime* _tmp26_;
						GDateTime* _tmp27_;
						GDateTime* _tmp28_;
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp23_ = util_get_default ();
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp24_ = _tmp23_;
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp25_ = util_get_format_date (_tmp24_, day);
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp26_ = _tmp25_;
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp27_ = widgets_calendar_calendar_view_generate_date (self, day, day_number);
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp28_ = _tmp27_;
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp22_ = g_date_time_compare (_tmp26_, _tmp28_) == 0;
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
						_g_date_time_unref0 (_tmp28_);
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
						_g_date_time_unref0 (_tmp26_);
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
						_g_object_unref0 (_tmp24_);
#line 302 "CalendarView.c"
					} else {
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp22_ = FALSE;
#line 306 "CalendarView.c"
					}
#line 109 "../core/Widgets/Calendar/CalendarView.vala"
					if (_tmp22_) {
#line 310 "CalendarView.c"
						WidgetsCalendarCalendarDay* _tmp29_;
#line 110 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp29_ = item;
#line 110 "../core/Widgets/Calendar/CalendarView.vala"
						gtk_widget_add_css_class ((GtkWidget*) _tmp29_, "calendar-day-selected");
#line 316 "CalendarView.c"
					}
#line 113 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp30_ = item;
#line 113 "../core/Widgets/Calendar/CalendarView.vala"
					widgets_calendar_calendar_day_set_day (_tmp30_, day_number);
#line 114 "../core/Widgets/Calendar/CalendarView.vala"
					day_number = day_number + 1;
#line 324 "CalendarView.c"
				}
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
				_g_object_unref0 (item);
#line 328 "CalendarView.c"
			}
		}
	}
}

void
widgets_calendar_calendar_view_clear_style (WidgetsCalendarCalendarView* self)
{
#line 119 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_if_fail (self != NULL);
#line 339 "CalendarView.c"
	{
		gint i = 0;
#line 120 "../core/Widgets/Calendar/CalendarView.vala"
		i = 0;
#line 344 "CalendarView.c"
		{
			gboolean _tmp0_ = FALSE;
#line 120 "../core/Widgets/Calendar/CalendarView.vala"
			_tmp0_ = TRUE;
#line 120 "../core/Widgets/Calendar/CalendarView.vala"
			while (TRUE) {
#line 351 "CalendarView.c"
				WidgetsCalendarCalendarDay* item = NULL;
				GeeArrayList* _tmp2_;
				gpointer _tmp3_;
				WidgetsCalendarCalendarDay* _tmp4_;
#line 120 "../core/Widgets/Calendar/CalendarView.vala"
				if (!_tmp0_) {
#line 358 "CalendarView.c"
					gint _tmp1_;
#line 120 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp1_ = i;
#line 120 "../core/Widgets/Calendar/CalendarView.vala"
					i = _tmp1_ + 1;
#line 364 "CalendarView.c"
				}
#line 120 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp0_ = FALSE;
#line 120 "../core/Widgets/Calendar/CalendarView.vala"
				if (!(i < 42)) {
#line 120 "../core/Widgets/Calendar/CalendarView.vala"
					break;
#line 372 "CalendarView.c"
				}
#line 121 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp2_ = self->priv->days_arraylist;
#line 121 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, i);
#line 121 "../core/Widgets/Calendar/CalendarView.vala"
				item = (WidgetsCalendarCalendarDay*) _tmp3_;
#line 122 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp4_ = item;
#line 122 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_remove_css_class ((GtkWidget*) _tmp4_, "calendar-day-selected");
#line 120 "../core/Widgets/Calendar/CalendarView.vala"
				_g_object_unref0 (item);
#line 386 "CalendarView.c"
			}
		}
	}
}

static GDateTime*
widgets_calendar_calendar_view_generate_date (WidgetsCalendarCalendarView* self,
                                              GDateTime* date,
                                              gint day)
{
	GDateTime* _tmp0_;
	GDateTime* result;
#line 126 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 126 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 127 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp0_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), day, 0, 0, (gdouble) 0);
#line 127 "../core/Widgets/Calendar/CalendarView.vala"
	result = _tmp0_;
#line 127 "../core/Widgets/Calendar/CalendarView.vala"
	return result;
#line 409 "CalendarView.c"
}

static void
widgets_calendar_calendar_view_day_selected_style (WidgetsCalendarCalendarView* self,
                                                   gint day)
{
#line 137 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_if_fail (self != NULL);
#line 138 "../core/Widgets/Calendar/CalendarView.vala"
	g_signal_emit (self, widgets_calendar_calendar_view_signals[WIDGETS_CALENDAR_CALENDAR_VIEW_DAY_SELECTED_SIGNAL], 0, day);
#line 420 "CalendarView.c"
	{
		gint i = 0;
#line 140 "../core/Widgets/Calendar/CalendarView.vala"
		i = 0;
#line 425 "CalendarView.c"
		{
			gboolean _tmp0_ = FALSE;
#line 140 "../core/Widgets/Calendar/CalendarView.vala"
			_tmp0_ = TRUE;
#line 140 "../core/Widgets/Calendar/CalendarView.vala"
			while (TRUE) {
#line 432 "CalendarView.c"
				WidgetsCalendarCalendarDay* day_item = NULL;
				GeeArrayList* _tmp2_;
				gpointer _tmp3_;
				WidgetsCalendarCalendarDay* _tmp4_;
#line 140 "../core/Widgets/Calendar/CalendarView.vala"
				if (!_tmp0_) {
#line 439 "CalendarView.c"
					gint _tmp1_;
#line 140 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp1_ = i;
#line 140 "../core/Widgets/Calendar/CalendarView.vala"
					i = _tmp1_ + 1;
#line 445 "CalendarView.c"
				}
#line 140 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp0_ = FALSE;
#line 140 "../core/Widgets/Calendar/CalendarView.vala"
				if (!(i < 42)) {
#line 140 "../core/Widgets/Calendar/CalendarView.vala"
					break;
#line 453 "CalendarView.c"
				}
#line 141 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp2_ = self->priv->days_arraylist;
#line 141 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, i);
#line 141 "../core/Widgets/Calendar/CalendarView.vala"
				day_item = (WidgetsCalendarCalendarDay*) _tmp3_;
#line 142 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp4_ = day_item;
#line 142 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_remove_css_class ((GtkWidget*) _tmp4_, "calendar-day-selected");
#line 140 "../core/Widgets/Calendar/CalendarView.vala"
				_g_object_unref0 (day_item);
#line 467 "CalendarView.c"
			}
		}
	}
}

GDateTime*
widgets_calendar_calendar_view_get_current_date (WidgetsCalendarCalendarView* self)
{
	GDateTime* result;
	GDateTime* today = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
#line 28 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 29 "../core/Widgets/Calendar/CalendarView.vala"
	today = _tmp0_;
#line 31 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (today), g_date_time_get_month (today), g_date_time_get_day_of_month (today), 0, 0, (gdouble) 0);
#line 31 "../core/Widgets/Calendar/CalendarView.vala"
	_g_date_time_unref0 (self->priv->_current_date);
#line 31 "../core/Widgets/Calendar/CalendarView.vala"
	self->priv->_current_date = _tmp1_;
#line 40 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp2_ = self->priv->_current_date;
#line 40 "../core/Widgets/Calendar/CalendarView.vala"
	result = _tmp2_;
#line 40 "../core/Widgets/Calendar/CalendarView.vala"
	_g_date_time_unref0 (today);
#line 40 "../core/Widgets/Calendar/CalendarView.vala"
	return result;
#line 501 "CalendarView.c"
}

static void
_widgets_calendar_calendar_view______lambda100_ (WidgetsCalendarCalendarView* self,
                                                 gint day)
{
#line 68 "../core/Widgets/Calendar/CalendarView.vala"
	widgets_calendar_calendar_view_day_selected_style (self, day);
#line 510 "CalendarView.c"
}

static void
__widgets_calendar_calendar_view______lambda100__widgets_calendar_calendar_day_day_selected (WidgetsCalendarCalendarDay* _sender,
                                                                                             gint day,
                                                                                             gpointer self)
{
#line 67 "../core/Widgets/Calendar/CalendarView.vala"
	_widgets_calendar_calendar_view______lambda100_ ((WidgetsCalendarCalendarView*) self, day);
#line 520 "CalendarView.c"
}

static GObject *
widgets_calendar_calendar_view_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsCalendarCalendarView * self;
	GeeArrayList* _tmp0_;
	GtkGrid* _tmp1_ = NULL;
	gint col = 0;
	gint row = 0;
	GtkGrid* _tmp12_;
#line 53 "../core/Widgets/Calendar/CalendarView.vala"
	parent_class = G_OBJECT_CLASS (widgets_calendar_calendar_view_parent_class);
#line 53 "../core/Widgets/Calendar/CalendarView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 53 "../core/Widgets/Calendar/CalendarView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_CALENDAR_TYPE_CALENDAR_VIEW, WidgetsCalendarCalendarView);
#line 54 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp0_ = gee_array_list_new (WIDGETS_CALENDAR_TYPE_CALENDAR_DAY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 54 "../core/Widgets/Calendar/CalendarView.vala"
	_g_object_unref0 (self->priv->days_arraylist);
#line 54 "../core/Widgets/Calendar/CalendarView.vala"
	self->priv->days_arraylist = _tmp0_;
#line 56 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp1_ = (GtkGrid*) gtk_grid_new ();
#line 56 "../core/Widgets/Calendar/CalendarView.vala"
	gtk_grid_set_column_homogeneous (_tmp1_, TRUE);
#line 56 "../core/Widgets/Calendar/CalendarView.vala"
	gtk_grid_set_row_homogeneous (_tmp1_, TRUE);
#line 56 "../core/Widgets/Calendar/CalendarView.vala"
	g_object_ref_sink (_tmp1_);
#line 56 "../core/Widgets/Calendar/CalendarView.vala"
	_g_object_unref0 (self->priv->days_grid);
#line 56 "../core/Widgets/Calendar/CalendarView.vala"
	self->priv->days_grid = _tmp1_;
#line 61 "../core/Widgets/Calendar/CalendarView.vala"
	col = 0;
#line 62 "../core/Widgets/Calendar/CalendarView.vala"
	row = 0;
#line 564 "CalendarView.c"
	{
		gint i = 0;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
		i = 0;
#line 569 "CalendarView.c"
		{
			gboolean _tmp2_ = FALSE;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
			_tmp2_ = TRUE;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
			while (TRUE) {
#line 576 "CalendarView.c"
				WidgetsCalendarCalendarDay* day = NULL;
				WidgetsCalendarCalendarDay* _tmp4_;
				WidgetsCalendarCalendarDay* _tmp5_;
				GtkGrid* _tmp6_;
				WidgetsCalendarCalendarDay* _tmp7_;
				gboolean _tmp8_ = FALSE;
				WidgetsCalendarCalendarDay* _tmp9_;
				GeeArrayList* _tmp10_;
				WidgetsCalendarCalendarDay* _tmp11_;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
				if (!_tmp2_) {
#line 588 "CalendarView.c"
					gint _tmp3_;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp3_ = i;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
					i = _tmp3_ + 1;
#line 594 "CalendarView.c"
				}
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp2_ = FALSE;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
				if (!(i < 42)) {
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
					break;
#line 602 "CalendarView.c"
				}
#line 65 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp4_ = widgets_calendar_calendar_day_new ();
#line 65 "../core/Widgets/Calendar/CalendarView.vala"
				g_object_ref_sink (_tmp4_);
#line 65 "../core/Widgets/Calendar/CalendarView.vala"
				day = _tmp4_;
#line 67 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp5_ = day;
#line 67 "../core/Widgets/Calendar/CalendarView.vala"
				g_signal_connect_object (_tmp5_, "day-selected", (GCallback) __widgets_calendar_calendar_view______lambda100__widgets_calendar_calendar_day_day_selected, self, 0);
#line 71 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp6_ = self->priv->days_grid;
#line 71 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp7_ = day;
#line 71 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_grid_attach (_tmp6_, (GtkWidget*) _tmp7_, col, row, 1, 1);
#line 72 "../core/Widgets/Calendar/CalendarView.vala"
				col = col + 1;
#line 74 "../core/Widgets/Calendar/CalendarView.vala"
				if (col != 0) {
#line 74 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp8_ = (col % 7) == 0;
#line 626 "CalendarView.c"
				} else {
#line 74 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp8_ = FALSE;
#line 630 "CalendarView.c"
				}
#line 74 "../core/Widgets/Calendar/CalendarView.vala"
				if (_tmp8_) {
#line 75 "../core/Widgets/Calendar/CalendarView.vala"
					row = row + 1;
#line 76 "../core/Widgets/Calendar/CalendarView.vala"
					col = 0;
#line 638 "CalendarView.c"
				}
#line 79 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp9_ = day;
#line 79 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 80 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp10_ = self->priv->days_arraylist;
#line 80 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp11_ = day;
#line 80 "../core/Widgets/Calendar/CalendarView.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
				_g_object_unref0 (day);
#line 652 "CalendarView.c"
			}
		}
	}
#line 83 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp12_ = self->priv->days_grid;
#line 83 "../core/Widgets/Calendar/CalendarView.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp12_);
#line 53 "../core/Widgets/Calendar/CalendarView.vala"
	return obj;
#line 662 "CalendarView.c"
}

static void
widgets_calendar_calendar_view_class_init (WidgetsCalendarCalendarViewClass * klass,
                                           gpointer klass_data)
{
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	widgets_calendar_calendar_view_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsCalendarCalendarView_private_offset);
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_calendar_calendar_view_get_property;
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_calendar_calendar_view_constructor;
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_calendar_calendar_view_finalize;
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_CALENDAR_CALENDAR_VIEW_CURRENT_DATE_PROPERTY, widgets_calendar_calendar_view_properties[WIDGETS_CALENDAR_CALENDAR_VIEW_CURRENT_DATE_PROPERTY] = g_param_spec_boxed ("current-date", "current-date", "current-date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	widgets_calendar_calendar_view_signals[WIDGETS_CALENDAR_CALENDAR_VIEW_DAY_SELECTED_SIGNAL] = g_signal_new ("day-selected", WIDGETS_CALENDAR_TYPE_CALENDAR_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 683 "CalendarView.c"
}

static void
widgets_calendar_calendar_view_instance_init (WidgetsCalendarCalendarView * self,
                                              gpointer klass)
{
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	self->priv = widgets_calendar_calendar_view_get_instance_private (self);
#line 692 "CalendarView.c"
}

static void
widgets_calendar_calendar_view_finalize (GObject * obj)
{
	WidgetsCalendarCalendarView * self;
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_CALENDAR_TYPE_CALENDAR_VIEW, WidgetsCalendarCalendarView);
#line 23 "../core/Widgets/Calendar/CalendarView.vala"
	_g_object_unref0 (self->priv->days_arraylist);
#line 24 "../core/Widgets/Calendar/CalendarView.vala"
	_g_object_unref0 (self->priv->days_grid);
#line 26 "../core/Widgets/Calendar/CalendarView.vala"
	_g_date_time_unref0 (self->priv->_current_date);
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	G_OBJECT_CLASS (widgets_calendar_calendar_view_parent_class)->finalize (obj);
#line 709 "CalendarView.c"
}

static GType
widgets_calendar_calendar_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsCalendarCalendarViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_calendar_calendar_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsCalendarCalendarView), 0, (GInstanceInitFunc) widgets_calendar_calendar_view_instance_init, NULL };
	GType widgets_calendar_calendar_view_type_id;
	widgets_calendar_calendar_view_type_id = g_type_register_static (adw_bin_get_type (), "WidgetsCalendarCalendarView", &g_define_type_info, 0);
	WidgetsCalendarCalendarView_private_offset = g_type_add_instance_private (widgets_calendar_calendar_view_type_id, sizeof (WidgetsCalendarCalendarViewPrivate));
	return widgets_calendar_calendar_view_type_id;
}

GType
widgets_calendar_calendar_view_get_type (void)
{
	static volatile gsize widgets_calendar_calendar_view_type_id__once = 0;
	if (g_once_init_enter (&widgets_calendar_calendar_view_type_id__once)) {
		GType widgets_calendar_calendar_view_type_id;
		widgets_calendar_calendar_view_type_id = widgets_calendar_calendar_view_get_type_once ();
		g_once_init_leave (&widgets_calendar_calendar_view_type_id__once, widgets_calendar_calendar_view_type_id);
	}
	return widgets_calendar_calendar_view_type_id__once;
}

static void
_vala_widgets_calendar_calendar_view_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	WidgetsCalendarCalendarView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_CALENDAR_TYPE_CALENDAR_VIEW, WidgetsCalendarCalendarView);
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	switch (property_id) {
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
		case WIDGETS_CALENDAR_CALENDAR_VIEW_CURRENT_DATE_PROPERTY:
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
		g_value_set_boxed (value, widgets_calendar_calendar_view_get_current_date (self));
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
		break;
#line 750 "CalendarView.c"
		default:
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
		break;
#line 756 "CalendarView.c"
	}
}

