/* Database.c generated by valac 0.56.16, the Vala compiler
 * generated from Database.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <gio/gio.h>
#include <granite-7.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SERVICES_DATABASE_0_PROPERTY,
	SERVICES_DATABASE_PROJECTS_PROPERTY,
	SERVICES_DATABASE_SECTIONS_PROPERTY,
	SERVICES_DATABASE_ITEMS_PROPERTY,
	SERVICES_DATABASE_LABELS_PROPERTY,
	SERVICES_DATABASE_REMINDERS_PROPERTY,
	SERVICES_DATABASE_NUM_PROPERTIES
};
static GParamSpec* services_database_properties[SERVICES_DATABASE_NUM_PROPERTIES];
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
enum  {
	SERVICES_DATABASE_OPENED_SIGNAL,
	SERVICES_DATABASE_RESET_SIGNAL,
	SERVICES_DATABASE_PROJECT_ADDED_SIGNAL,
	SERVICES_DATABASE_PROJECT_UPDATED_SIGNAL,
	SERVICES_DATABASE_PROJECT_DELETED_SIGNAL,
	SERVICES_DATABASE_LABEL_ADDED_SIGNAL,
	SERVICES_DATABASE_LABEL_UPDATED_SIGNAL,
	SERVICES_DATABASE_LABEL_DELETED_SIGNAL,
	SERVICES_DATABASE_SECTION_DELETED_SIGNAL,
	SERVICES_DATABASE_SECTION_MOVED_SIGNAL,
	SERVICES_DATABASE_ITEM_DELETED_SIGNAL,
	SERVICES_DATABASE_ITEM_ADDED_SIGNAL,
	SERVICES_DATABASE_ITEM_UPDATED_SIGNAL,
	SERVICES_DATABASE_ITEM_LABEL_ADDED_SIGNAL,
	SERVICES_DATABASE_ITEM_LABEL_DELETED_SIGNAL,
	SERVICES_DATABASE_REMINDER_ADDED_SIGNAL,
	SERVICES_DATABASE_REMINDER_DELETED_SIGNAL,
	SERVICES_DATABASE_NUM_SIGNALS
};
static guint services_database_signals[SERVICES_DATABASE_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ServicesDatabasePrivate {
	sqlite3* db;
	gchar* db_path;
	gchar* errormsg;
	gchar* sql;
	GeeArrayList* _projects;
	GRecMutex __lock__projects;
	GeeArrayList* _sections;
	GRecMutex __lock__sections;
	GeeArrayList* _items;
	GRecMutex __lock__items;
	GeeArrayList* _labels;
	GRecMutex __lock__labels;
	GeeArrayList* _reminders;
	GRecMutex __lock__reminders;
	JsonParser* parser;
};

static gint ServicesDatabase_private_offset;
static gpointer services_database_parent_class = NULL;
static ServicesDatabase* services_database__instance;
static ServicesDatabase* services_database__instance = NULL;

static void services_database_create_tables (ServicesDatabase* self);
static BackendType services_database_get_backend_type_by_text (ServicesDatabase* self,
                                                        sqlite3_stmt* stmt,
                                                        gint col);
static gboolean services_database_get_parameter_bool (ServicesDatabase* self,
                                               sqlite3_stmt* stmt,
                                               gint col);
static ProjectViewStyle services_database_get_view_style_by_text (ServicesDatabase* self,
                                                           sqlite3_stmt* stmt,
                                                           gint col);
static ProjectIconStyle services_database_get_icon_style_by_text (ServicesDatabase* self,
                                                           sqlite3_stmt* stmt,
                                                           gint col);
static void services_database_set_parameter_str (ServicesDatabase* self,
                                          sqlite3_stmt* stmt,
                                          const gchar* par,
                                          const gchar* val);
static void services_database_set_parameter_bool (ServicesDatabase* self,
                                           sqlite3_stmt* stmt,
                                           const gchar* par,
                                           gboolean val);
static void services_database_set_parameter_int (ServicesDatabase* self,
                                          sqlite3_stmt* stmt,
                                          const gchar* par,
                                          gint val);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static GObject * services_database_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _services_database___lambda29_ (ServicesDatabase* self,
                                     ObjectsLabel* label);
static void __services_database___lambda29__services_database_label_deleted (ServicesDatabase* _sender,
                                                                      ObjectsLabel* label,
                                                                      gpointer self);
static void _services_database___lambda30_ (ServicesDatabase* self,
                                     ObjectsProject* project);
static void __services_database___lambda30__services_database_project_deleted (ServicesDatabase* _sender,
                                                                        ObjectsProject* project,
                                                                        gpointer self);
static void _services_database___lambda31_ (ServicesDatabase* self,
                                     ObjectsSection* section);
static void __services_database___lambda31__services_database_section_deleted (ServicesDatabase* _sender,
                                                                        ObjectsSection* section,
                                                                        gpointer self);
static void _services_database___lambda32_ (ServicesDatabase* self,
                                     ObjectsItem* item);
static void __services_database___lambda32__services_database_item_deleted (ServicesDatabase* _sender,
                                                                     ObjectsItem* item,
                                                                     gpointer self);
static void _services_database___lambda33_ (ServicesDatabase* self,
                                     ObjectsReminder* reminder);
static void __services_database___lambda33__services_database_reminder_deleted (ServicesDatabase* _sender,
                                                                         ObjectsReminder* reminder,
                                                                         gpointer self);
static void services_database_finalize (GObject * obj);
static GType services_database_get_type_once (void);
static void _vala_services_database_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
services_database_get_instance_private (ServicesDatabase* self)
{
	return G_STRUCT_MEMBER_P (self, ServicesDatabase_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 58 "../core/Services/Database.vala"
	return self ? g_object_ref (self) : NULL;
#line 202 "Database.c"
}

ServicesDatabase*
services_database_get_default (void)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp2_;
	ServicesDatabase* _tmp3_;
	ServicesDatabase* result;
#line 54 "../core/Services/Database.vala"
	_tmp0_ = services_database__instance;
#line 54 "../core/Services/Database.vala"
	if (_tmp0_ == NULL) {
#line 216 "Database.c"
		ServicesDatabase* _tmp1_;
#line 55 "../core/Services/Database.vala"
		_tmp1_ = services_database_new ();
#line 55 "../core/Services/Database.vala"
		_g_object_unref0 (services_database__instance);
#line 55 "../core/Services/Database.vala"
		services_database__instance = _tmp1_;
#line 224 "Database.c"
	}
#line 58 "../core/Services/Database.vala"
	_tmp2_ = services_database__instance;
#line 58 "../core/Services/Database.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 58 "../core/Services/Database.vala"
	result = _tmp3_;
#line 58 "../core/Services/Database.vala"
	return result;
#line 234 "Database.c"
}

void
services_database_init_database (ServicesDatabase* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 144 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 145 "../core/Services/Database.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 145 "../core/Services/Database.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/io.github.alainm23.planify/database.db", NULL);
#line 145 "../core/Services/Database.vala"
	_g_free0 (self->priv->db_path);
#line 145 "../core/Services/Database.vala"
	self->priv->db_path = _tmp1_;
#line 147 "../core/Services/Database.vala"
	services_database_create_tables (self);
#line 148 "../core/Services/Database.vala"
	services_database_patch_database (self);
#line 149 "../core/Services/Database.vala"
	g_signal_emit (self, services_database_signals[SERVICES_DATABASE_OPENED_SIGNAL], 0);
#line 258 "Database.c"
}

void
services_database_patch_database (ServicesDatabase* self)
{
#line 152 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 158 "../core/Services/Database.vala"
	services_database_add_int_column (self, "Items", "pinned", 0);
#line 165 "../core/Services/Database.vala"
	services_database_add_int_column (self, "Projects", "show_completed", 0);
#line 173 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Projects", "description", "");
#line 182 "../core/Services/Database.vala"
	services_database_add_item_label_column (self);
#line 183 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Sections", "color", "blue");
#line 184 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Sections", "description", "");
#line 191 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Items", "extra_data", "");
#line 192 "../core/Services/Database.vala"
	services_database_add_int_column (self, "Sections", "hidded", 0);
#line 193 "../core/Services/Database.vala"
	services_database_add_int_column (self, "Projects", "inbox_section_hidded", 0);
#line 200 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Projects", "sync_id", "");
#line 286 "Database.c"
}

static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar** errmsg)
{
	gchar* _vala_errmsg = NULL;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
	gint result;
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "sqlite3.vapi"
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
#line 36 "sqlite3.vapi"
	sqlite_errmsg = _tmp0_;
#line 36 "sqlite3.vapi"
	ec = _tmp1_;
#line 37 "sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 315 "Database.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 38 "sqlite3.vapi"
		_tmp2_ = sqlite_errmsg;
#line 38 "sqlite3.vapi"
		_tmp3_ = g_strdup (_tmp2_);
#line 38 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "sqlite3.vapi"
		_vala_errmsg = _tmp3_;
#line 326 "Database.c"
	} else {
#line 40 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 40 "sqlite3.vapi"
		_vala_errmsg = NULL;
#line 332 "Database.c"
	}
#line 42 "sqlite3.vapi"
	_tmp4_ = sqlite_errmsg;
#line 42 "sqlite3.vapi"
	sqlite3_free ((void*) _tmp4_);
#line 43 "sqlite3.vapi"
	result = ec;
#line 43 "sqlite3.vapi"
	if (errmsg) {
#line 43 "sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 344 "Database.c"
	} else {
#line 43 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 348 "Database.c"
	}
#line 43 "sqlite3.vapi"
	return result;
#line 352 "Database.c"
}

static void
services_database_create_tables (ServicesDatabase* self)
{
	const gchar* _tmp0_;
	sqlite3* _tmp1_ = NULL;
	gchar* _tmp2_;
	sqlite3* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gint _tmp6_;
	gchar* _tmp8_;
	sqlite3* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	gint _tmp12_;
	gchar* _tmp14_;
	sqlite3* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_ = NULL;
	gint _tmp18_;
	gchar* _tmp20_;
	sqlite3* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_ = NULL;
	gint _tmp24_;
	gchar* _tmp26_;
	sqlite3* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_ = NULL;
	gint _tmp30_;
	gchar* _tmp32_;
	sqlite3* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_ = NULL;
	gint _tmp36_;
	gchar* _tmp38_;
	sqlite3* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_ = NULL;
	gint _tmp42_;
	gchar* _tmp44_;
	sqlite3* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_ = NULL;
	gint _tmp48_;
#line 203 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 204 "../core/Services/Database.vala"
	_tmp0_ = self->priv->db_path;
#line 204 "../core/Services/Database.vala"
	sqlite3_open (_tmp0_, &_tmp1_);
#line 204 "../core/Services/Database.vala"
	_sqlite3_close0 (self->priv->db);
#line 204 "../core/Services/Database.vala"
	self->priv->db = _tmp1_;
#line 206 "../core/Services/Database.vala"
	_tmp2_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Labels (\n" \
"                id              TEXT PRIMARY KEY,\n" \
"                name            TEXT,\n" \
"                color           TEXT,\n" \
"                item_order      INTEGER,\n" \
"                is_deleted      INTEGER,\n" \
"                is_favorite     INTEGER,\n" \
"                backend_type    TEXT,\n" \
"                CONSTRAINT unique_label UNIQUE (name)\n" \
"            );\n" \
"        ");
#line 206 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 206 "../core/Services/Database.vala"
	self->priv->sql = _tmp2_;
#line 219 "../core/Services/Database.vala"
	_tmp3_ = self->priv->db;
#line 219 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 219 "../core/Services/Database.vala"
	_tmp6_ = _sqlite3_exec (_tmp3_, _tmp4_, NULL, NULL, &_tmp5_);
#line 219 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 219 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp5_;
#line 219 "../core/Services/Database.vala"
	if (_tmp6_ != SQLITE_OK) {
#line 428 "Database.c"
		const gchar* _tmp7_;
#line 220 "../core/Services/Database.vala"
		_tmp7_ = self->priv->errormsg;
#line 220 "../core/Services/Database.vala"
		g_warning ("Database.vala:220: %s", _tmp7_);
#line 434 "Database.c"
	}
#line 223 "../core/Services/Database.vala"
	_tmp8_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Projects (\n" \
"                id                      TEXT PRIMARY KEY,\n" \
"                name                    TEXT NOT NULL,\n" \
"                color                   TEXT,\n" \
"                backend_type            TEXT,\n" \
"                inbox_project           INTEGER,\n" \
"                team_inbox              INTEGER,\n" \
"                child_order             INTEGER,\n" \
"                is_deleted              INTEGER,\n" \
"                is_archived             INTEGER,\n" \
"                is_favorite             INTEGER,\n" \
"                shared                  INTEGER,\n" \
"                view_style              TEXT,\n" \
"                sort_order              INTEGER,\n" \
"                parent_id               TEXT,\n" \
"                collapsed               INTEGER,\n" \
"                icon_style              TEXT,\n" \
"                emoji                   TEXT,\n" \
"                show_completed          INTEGER,\n" \
"                description             TEXT,\n" \
"                due_date                TEXT,\n" \
"                inbox_section_hidded    INTEGER,\n" \
"                sync_id                 TEXT\n" \
"            );\n" \
"        ");
#line 223 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 223 "../core/Services/Database.vala"
	self->priv->sql = _tmp8_;
#line 250 "../core/Services/Database.vala"
	_tmp9_ = self->priv->db;
#line 250 "../core/Services/Database.vala"
	_tmp10_ = self->priv->sql;
#line 250 "../core/Services/Database.vala"
	_tmp12_ = _sqlite3_exec (_tmp9_, _tmp10_, NULL, NULL, &_tmp11_);
#line 250 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 250 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp11_;
#line 250 "../core/Services/Database.vala"
	if (_tmp12_ != SQLITE_OK) {
#line 454 "Database.c"
		const gchar* _tmp13_;
#line 251 "../core/Services/Database.vala"
		_tmp13_ = self->priv->errormsg;
#line 251 "../core/Services/Database.vala"
		g_warning ("Database.vala:251: %s", _tmp13_);
#line 460 "Database.c"
	}
#line 254 "../core/Services/Database.vala"
	_tmp14_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Sections (\n" \
"                id              TEXT PRIMARY KEY,\n" \
"                name            TEXT,\n" \
"                archived_at     TEXT,\n" \
"                added_at        TEXT,\n" \
"                project_id      TEXT,\n" \
"                section_order   INTEGER,\n" \
"                collapsed       INTEGER,\n" \
"                is_deleted      INTEGER,\n" \
"                is_archived     INTEGER,\n" \
"                color           TEXT,\n" \
"                description     TEXT,\n" \
"                hidded          INTEGER,\n" \
"                FOREIGN KEY (project_id) REFERENCES Projects (id) ON D" \
"ELETE CASCADE\n" \
"            );\n" \
"        ");
#line 254 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 254 "../core/Services/Database.vala"
	self->priv->sql = _tmp14_;
#line 272 "../core/Services/Database.vala"
	_tmp15_ = self->priv->db;
#line 272 "../core/Services/Database.vala"
	_tmp16_ = self->priv->sql;
#line 272 "../core/Services/Database.vala"
	_tmp18_ = _sqlite3_exec (_tmp15_, _tmp16_, NULL, NULL, &_tmp17_);
#line 272 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 272 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp17_;
#line 272 "../core/Services/Database.vala"
	if (_tmp18_ != SQLITE_OK) {
#line 480 "Database.c"
		const gchar* _tmp19_;
#line 273 "../core/Services/Database.vala"
		_tmp19_ = self->priv->errormsg;
#line 273 "../core/Services/Database.vala"
		g_warning ("Database.vala:273: %s", _tmp19_);
#line 486 "Database.c"
	}
#line 276 "../core/Services/Database.vala"
	_tmp20_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Items (\n" \
"                id                  TEXT PRIMARY KEY,\n" \
"                content             TEXT NOT NULL,\n" \
"                description         TEXT,\n" \
"                due                 TEXT,\n" \
"                added_at            TEXT,\n" \
"                completed_at        TEXT,\n" \
"                updated_at          TEXT,\n" \
"                section_id          TEXT,\n" \
"                project_id          TEXT,\n" \
"                parent_id           TEXT,\n" \
"                priority            INTEGER,\n" \
"                child_order         INTEGER,\n" \
"                checked             INTEGER,\n" \
"                is_deleted          INTEGER,\n" \
"                day_order           INTEGER,\n" \
"                collapsed           INTEGER,\n" \
"                pinned              INTEGER,\n" \
"                labels              TEXT,\n" \
"                extra_data          TEXT\n" \
"            );\n" \
"        ");
#line 276 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 276 "../core/Services/Database.vala"
	self->priv->sql = _tmp20_;
#line 300 "../core/Services/Database.vala"
	_tmp21_ = self->priv->db;
#line 300 "../core/Services/Database.vala"
	_tmp22_ = self->priv->sql;
#line 300 "../core/Services/Database.vala"
	_tmp24_ = _sqlite3_exec (_tmp21_, _tmp22_, NULL, NULL, &_tmp23_);
#line 300 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 300 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp23_;
#line 300 "../core/Services/Database.vala"
	if (_tmp24_ != SQLITE_OK) {
#line 506 "Database.c"
		const gchar* _tmp25_;
#line 301 "../core/Services/Database.vala"
		_tmp25_ = self->priv->errormsg;
#line 301 "../core/Services/Database.vala"
		g_warning ("Database.vala:301: %s", _tmp25_);
#line 512 "Database.c"
	}
#line 304 "../core/Services/Database.vala"
	_tmp26_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Reminders (\n" \
"                id                  TEXT PRIMARY KEY,\n" \
"                notify_uid          INTEGER,\n" \
"                item_id             TEXT,\n" \
"                service             TEXT,\n" \
"                type                TEXT,\n" \
"                due                 TEXT,\n" \
"                mm_offset           INTEGER,\n" \
"                is_deleted          INTEGER,\n" \
"                FOREIGN KEY (item_id) REFERENCES Items (id) ON DELETE " \
"CASCADE\n" \
"            );\n" \
"        ");
#line 304 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 304 "../core/Services/Database.vala"
	self->priv->sql = _tmp26_;
#line 318 "../core/Services/Database.vala"
	_tmp27_ = self->priv->db;
#line 318 "../core/Services/Database.vala"
	_tmp28_ = self->priv->sql;
#line 318 "../core/Services/Database.vala"
	_tmp30_ = _sqlite3_exec (_tmp27_, _tmp28_, NULL, NULL, &_tmp29_);
#line 318 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 318 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp29_;
#line 318 "../core/Services/Database.vala"
	if (_tmp30_ != SQLITE_OK) {
#line 532 "Database.c"
		const gchar* _tmp31_;
#line 319 "../core/Services/Database.vala"
		_tmp31_ = self->priv->errormsg;
#line 319 "../core/Services/Database.vala"
		g_warning ("Database.vala:319: %s", _tmp31_);
#line 538 "Database.c"
	}
#line 322 "../core/Services/Database.vala"
	_tmp32_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Queue (\n" \
"                uuid       TEXT PRIMARY KEY,\n" \
"                object_id  TEXT,\n" \
"                query      TEXT,\n" \
"                temp_id    TEXT,\n" \
"                args       TEXT,\n" \
"                date_added TEXT\n" \
"            );\n" \
"        ");
#line 322 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 322 "../core/Services/Database.vala"
	self->priv->sql = _tmp32_;
#line 333 "../core/Services/Database.vala"
	_tmp33_ = self->priv->db;
#line 333 "../core/Services/Database.vala"
	_tmp34_ = self->priv->sql;
#line 333 "../core/Services/Database.vala"
	_tmp36_ = _sqlite3_exec (_tmp33_, _tmp34_, NULL, NULL, &_tmp35_);
#line 333 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 333 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp35_;
#line 333 "../core/Services/Database.vala"
	if (_tmp36_ != SQLITE_OK) {
#line 558 "Database.c"
		const gchar* _tmp37_;
#line 334 "../core/Services/Database.vala"
		_tmp37_ = self->priv->errormsg;
#line 334 "../core/Services/Database.vala"
		g_warning ("Database.vala:334: %s", _tmp37_);
#line 564 "Database.c"
	}
#line 337 "../core/Services/Database.vala"
	_tmp38_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS CurTempIds (\n" \
"                id          TEXT PRIMARY KEY,\n" \
"                temp_id     TEXT,\n" \
"                object      TEXT\n" \
"            );\n" \
"        ");
#line 337 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 337 "../core/Services/Database.vala"
	self->priv->sql = _tmp38_;
#line 345 "../core/Services/Database.vala"
	_tmp39_ = self->priv->db;
#line 345 "../core/Services/Database.vala"
	_tmp40_ = self->priv->sql;
#line 345 "../core/Services/Database.vala"
	_tmp42_ = _sqlite3_exec (_tmp39_, _tmp40_, NULL, NULL, &_tmp41_);
#line 345 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 345 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp41_;
#line 345 "../core/Services/Database.vala"
	if (_tmp42_ != SQLITE_OK) {
#line 584 "Database.c"
		const gchar* _tmp43_;
#line 346 "../core/Services/Database.vala"
		_tmp43_ = self->priv->errormsg;
#line 346 "../core/Services/Database.vala"
		g_warning ("Database.vala:346: %s", _tmp43_);
#line 590 "Database.c"
	}
#line 349 "../core/Services/Database.vala"
	_tmp44_ = g_strdup ("PRAGMA foreign_keys = ON;");
#line 349 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 349 "../core/Services/Database.vala"
	self->priv->sql = _tmp44_;
#line 351 "../core/Services/Database.vala"
	_tmp45_ = self->priv->db;
#line 351 "../core/Services/Database.vala"
	_tmp46_ = self->priv->sql;
#line 351 "../core/Services/Database.vala"
	_tmp48_ = _sqlite3_exec (_tmp45_, _tmp46_, NULL, NULL, &_tmp47_);
#line 351 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 351 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp47_;
#line 351 "../core/Services/Database.vala"
	if (_tmp48_ != SQLITE_OK) {
#line 610 "Database.c"
		const gchar* _tmp49_;
#line 352 "../core/Services/Database.vala"
		_tmp49_ = self->priv->errormsg;
#line 352 "../core/Services/Database.vala"
		g_warning ("Database.vala:352: %s", _tmp49_);
#line 616 "Database.c"
	}
}

void
services_database_clear_database (ServicesDatabase* self)
{
	gchar* db_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* db_file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 356 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 357 "../core/Services/Database.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 357 "../core/Services/Database.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/io.github.alainm23.planify/database.db", NULL);
#line 357 "../core/Services/Database.vala"
	db_path = _tmp1_;
#line 358 "../core/Services/Database.vala"
	_tmp2_ = db_path;
#line 358 "../core/Services/Database.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 358 "../core/Services/Database.vala"
	db_file = _tmp3_;
#line 360 "../core/Services/Database.vala"
	_tmp4_ = db_file;
#line 360 "../core/Services/Database.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 649 "Database.c"
		{
			GFile* _tmp5_;
#line 362 "../core/Services/Database.vala"
			_tmp5_ = db_file;
#line 362 "../core/Services/Database.vala"
			g_file_delete (_tmp5_, NULL, &_inner_error0_);
#line 362 "../core/Services/Database.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 658 "Database.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
#line 361 "../core/Services/Database.vala"
			err = _inner_error0_;
#line 361 "../core/Services/Database.vala"
			_inner_error0_ = NULL;
#line 364 "../core/Services/Database.vala"
			_tmp6_ = err;
#line 364 "../core/Services/Database.vala"
			_tmp7_ = _tmp6_->message;
#line 364 "../core/Services/Database.vala"
			g_warning ("Database.vala:364: %s", _tmp7_);
#line 361 "../core/Services/Database.vala"
			_g_error_free0 (err);
#line 680 "Database.c"
		}
		__finally0:
#line 361 "../core/Services/Database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 361 "../core/Services/Database.vala"
			_g_object_unref0 (db_file);
#line 361 "../core/Services/Database.vala"
			_g_free0 (db_path);
#line 361 "../core/Services/Database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 361 "../core/Services/Database.vala"
			g_clear_error (&_inner_error0_);
#line 361 "../core/Services/Database.vala"
			return;
#line 695 "Database.c"
		}
	}
#line 356 "../core/Services/Database.vala"
	_g_object_unref0 (db_file);
#line 356 "../core/Services/Database.vala"
	_g_free0 (db_path);
#line 702 "Database.c"
}

gboolean
services_database_is_database_empty (ServicesDatabase* self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean result;
#line 369 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 370 "../core/Services/Database.vala"
	_tmp0_ = services_database_get_projects (self);
#line 370 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 370 "../core/Services/Database.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 370 "../core/Services/Database.vala"
	_tmp3_ = _tmp2_;
#line 370 "../core/Services/Database.vala"
	result = _tmp3_ <= 0;
#line 370 "../core/Services/Database.vala"
	return result;
#line 727 "Database.c"
}

GeeArrayList*
services_database_get_collection_by_type (ServicesDatabase* self,
                                          ObjectsBaseObject* base_object)
{
	GeeArrayList* _tmp12_;
	GeeArrayList* result;
#line 373 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 373 "../core/Services/Database.vala"
	g_return_val_if_fail (base_object != NULL, NULL);
#line 374 "../core/Services/Database.vala"
	if (OBJECTS_IS_PROJECT (base_object)) {
#line 742 "Database.c"
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
#line 375 "../core/Services/Database.vala"
		_tmp0_ = services_database_get_projects (self);
#line 375 "../core/Services/Database.vala"
		_tmp1_ = _tmp0_;
#line 375 "../core/Services/Database.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 375 "../core/Services/Database.vala"
		result = _tmp2_;
#line 375 "../core/Services/Database.vala"
		return result;
#line 756 "Database.c"
	} else {
#line 376 "../core/Services/Database.vala"
		if (OBJECTS_IS_SECTION (base_object)) {
#line 760 "Database.c"
			GeeArrayList* _tmp3_;
			GeeArrayList* _tmp4_;
			GeeArrayList* _tmp5_;
#line 377 "../core/Services/Database.vala"
			_tmp3_ = services_database_get_sections (self);
#line 377 "../core/Services/Database.vala"
			_tmp4_ = _tmp3_;
#line 377 "../core/Services/Database.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 377 "../core/Services/Database.vala"
			result = _tmp5_;
#line 377 "../core/Services/Database.vala"
			return result;
#line 774 "Database.c"
		} else {
#line 378 "../core/Services/Database.vala"
			if (OBJECTS_IS_ITEM (base_object)) {
#line 778 "Database.c"
				GeeArrayList* _tmp6_;
				GeeArrayList* _tmp7_;
				GeeArrayList* _tmp8_;
#line 379 "../core/Services/Database.vala"
				_tmp6_ = services_database_get_items (self);
#line 379 "../core/Services/Database.vala"
				_tmp7_ = _tmp6_;
#line 379 "../core/Services/Database.vala"
				_tmp8_ = _g_object_ref0 (_tmp7_);
#line 379 "../core/Services/Database.vala"
				result = _tmp8_;
#line 379 "../core/Services/Database.vala"
				return result;
#line 792 "Database.c"
			} else {
#line 380 "../core/Services/Database.vala"
				if (OBJECTS_IS_LABEL (base_object)) {
#line 796 "Database.c"
					GeeArrayList* _tmp9_;
					GeeArrayList* _tmp10_;
					GeeArrayList* _tmp11_;
#line 381 "../core/Services/Database.vala"
					_tmp9_ = services_database_get_labels (self);
#line 381 "../core/Services/Database.vala"
					_tmp10_ = _tmp9_;
#line 381 "../core/Services/Database.vala"
					_tmp11_ = _g_object_ref0 (_tmp10_);
#line 381 "../core/Services/Database.vala"
					result = _tmp11_;
#line 381 "../core/Services/Database.vala"
					return result;
#line 810 "Database.c"
				}
			}
		}
	}
#line 384 "../core/Services/Database.vala"
	_tmp12_ = gee_array_list_new (OBJECTS_TYPE_BASE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 384 "../core/Services/Database.vala"
	result = _tmp12_;
#line 384 "../core/Services/Database.vala"
	return result;
#line 821 "Database.c"
}

GeeArrayList*
services_database_get_projects_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp13_;
	GeeArrayList* result;
#line 391 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 392 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 392 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 396 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n" \
"            SELECT * FROM Projects WHERE is_deleted = 0 ORDER BY child" \
"_order;\n" \
"        ");
#line 396 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 396 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 400 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 400 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 400 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 400 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 400 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 400 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 400 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 400 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 402 "../core/Services/Database.vala"
	while (TRUE) {
#line 869 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsProject* _tmp11_;
		ObjectsProject* _tmp12_;
#line 402 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 402 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 402 "../core/Services/Database.vala"
			break;
#line 881 "Database.c"
		}
#line 403 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 403 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 403 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_project (self, _tmp10_);
#line 403 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 403 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 403 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 895 "Database.c"
	}
#line 405 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 405 "../core/Services/Database.vala"
	sqlite3_reset (_tmp13_);
#line 406 "../core/Services/Database.vala"
	result = return_value;
#line 406 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 406 "../core/Services/Database.vala"
	return result;
#line 907 "Database.c"
}

GeeArrayList*
services_database_get_subprojects (ServicesDatabase* self,
                                   ObjectsProject* _project)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 409 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 409 "../core/Services/Database.vala"
	g_return_val_if_fail (_project != NULL, NULL);
#line 410 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 410 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 926 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 411 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_projects;
#line 411 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__projects);
#line 933 "Database.c"
		{
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _project_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _project_index = 0;
#line 412 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_projects (self);
#line 412 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 412 "../core/Services/Database.vala"
				_project_list = _tmp3_;
#line 412 "../core/Services/Database.vala"
				_tmp4_ = _project_list;
#line 412 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 412 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 412 "../core/Services/Database.vala"
				_project_size = _tmp6_;
#line 412 "../core/Services/Database.vala"
				_project_index = -1;
#line 412 "../core/Services/Database.vala"
				while (TRUE) {
#line 962 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsProject* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 412 "../core/Services/Database.vala"
					_project_index = _project_index + 1;
#line 412 "../core/Services/Database.vala"
					_tmp7_ = _project_index;
#line 412 "../core/Services/Database.vala"
					_tmp8_ = _project_size;
#line 412 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 412 "../core/Services/Database.vala"
						break;
#line 983 "Database.c"
					}
#line 412 "../core/Services/Database.vala"
					_tmp9_ = _project_list;
#line 412 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _project_index);
#line 412 "../core/Services/Database.vala"
					project = (ObjectsProject*) _tmp10_;
#line 413 "../core/Services/Database.vala"
					_tmp11_ = project;
#line 413 "../core/Services/Database.vala"
					_tmp12_ = objects_project_get_parent_id (_tmp11_);
#line 413 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 413 "../core/Services/Database.vala"
					_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) _project);
#line 413 "../core/Services/Database.vala"
					_tmp15_ = _tmp14_;
#line 413 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
#line 1003 "Database.c"
						GeeArrayList* _tmp16_;
						ObjectsProject* _tmp17_;
#line 414 "../core/Services/Database.vala"
						_tmp16_ = return_value;
#line 414 "../core/Services/Database.vala"
						_tmp17_ = project;
#line 414 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 1012 "Database.c"
					}
#line 412 "../core/Services/Database.vala"
					_g_object_unref0 (project);
#line 1016 "Database.c"
				}
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
#line 411 "../core/Services/Database.vala"
			_tmp18_ = self->priv->_projects;
#line 411 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 1027 "Database.c"
		}
#line 411 "../core/Services/Database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 411 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 411 "../core/Services/Database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 411 "../core/Services/Database.vala"
			g_clear_error (&_inner_error0_);
#line 411 "../core/Services/Database.vala"
			return NULL;
#line 1039 "Database.c"
		}
	}
#line 419 "../core/Services/Database.vala"
	result = return_value;
#line 419 "../core/Services/Database.vala"
	return result;
#line 1046 "Database.c"
}

GeeArrayList*
services_database_get_projects_by_backend_type (ServicesDatabase* self,
                                                BackendType backend_type)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 422 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 423 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 423 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1063 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 424 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_projects;
#line 424 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__projects);
#line 1070 "Database.c"
		{
			GeeArrayList* _tmp16_;
			GeeArrayList* _tmp17_;
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _project_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _project_index = 0;
#line 425 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_projects (self);
#line 425 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 425 "../core/Services/Database.vala"
				_project_list = _tmp3_;
#line 425 "../core/Services/Database.vala"
				_tmp4_ = _project_list;
#line 425 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 425 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 425 "../core/Services/Database.vala"
				_project_size = _tmp6_;
#line 425 "../core/Services/Database.vala"
				_project_index = -1;
#line 425 "../core/Services/Database.vala"
				while (TRUE) {
#line 1101 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsProject* _tmp11_;
					BackendType _tmp12_;
					BackendType _tmp13_;
#line 425 "../core/Services/Database.vala"
					_project_index = _project_index + 1;
#line 425 "../core/Services/Database.vala"
					_tmp7_ = _project_index;
#line 425 "../core/Services/Database.vala"
					_tmp8_ = _project_size;
#line 425 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 425 "../core/Services/Database.vala"
						break;
#line 1120 "Database.c"
					}
#line 425 "../core/Services/Database.vala"
					_tmp9_ = _project_list;
#line 425 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _project_index);
#line 425 "../core/Services/Database.vala"
					project = (ObjectsProject*) _tmp10_;
#line 426 "../core/Services/Database.vala"
					_tmp11_ = project;
#line 426 "../core/Services/Database.vala"
					_tmp12_ = objects_project_get_backend_type (_tmp11_);
#line 426 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 426 "../core/Services/Database.vala"
					if (_tmp13_ == backend_type) {
#line 1136 "Database.c"
						GeeArrayList* _tmp14_;
						ObjectsProject* _tmp15_;
#line 427 "../core/Services/Database.vala"
						_tmp14_ = return_value;
#line 427 "../core/Services/Database.vala"
						_tmp15_ = project;
#line 427 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 1145 "Database.c"
					}
#line 425 "../core/Services/Database.vala"
					_g_object_unref0 (project);
#line 1149 "Database.c"
				}
			}
#line 431 "../core/Services/Database.vala"
			_tmp16_ = return_value;
#line 431 "../core/Services/Database.vala"
			_tmp17_ = _g_object_ref0 (_tmp16_);
#line 431 "../core/Services/Database.vala"
			result = _tmp17_;
#line 1158 "Database.c"
			{
				GeeArrayList* _tmp18_;
#line 424 "../core/Services/Database.vala"
				_tmp18_ = self->priv->_projects;
#line 424 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 1165 "Database.c"
			}
#line 431 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 431 "../core/Services/Database.vala"
			return result;
#line 1171 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp19_;
#line 424 "../core/Services/Database.vala"
			_tmp19_ = self->priv->_projects;
#line 424 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 1180 "Database.c"
		}
#line 424 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 424 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 424 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 424 "../core/Services/Database.vala"
		return NULL;
#line 1190 "Database.c"
	}
}

GeeArrayList*
services_database_get_subitems (ServicesDatabase* self,
                                ObjectsItem* i)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 435 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 435 "../core/Services/Database.vala"
	g_return_val_if_fail (i != NULL, NULL);
#line 436 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 436 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1210 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 437 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 437 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 1217 "Database.c"
		{
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 438 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 438 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 438 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 438 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 438 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 438 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 438 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 438 "../core/Services/Database.vala"
				_item_index = -1;
#line 438 "../core/Services/Database.vala"
				while (TRUE) {
#line 1246 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 438 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 438 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 438 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 438 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 438 "../core/Services/Database.vala"
						break;
#line 1267 "Database.c"
					}
#line 438 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 438 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 438 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 439 "../core/Services/Database.vala"
					_tmp11_ = item;
#line 439 "../core/Services/Database.vala"
					_tmp12_ = objects_item_get_parent_id (_tmp11_);
#line 439 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 439 "../core/Services/Database.vala"
					_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) i);
#line 439 "../core/Services/Database.vala"
					_tmp15_ = _tmp14_;
#line 439 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
#line 1287 "Database.c"
						GeeArrayList* _tmp16_;
						ObjectsItem* _tmp17_;
#line 440 "../core/Services/Database.vala"
						_tmp16_ = return_value;
#line 440 "../core/Services/Database.vala"
						_tmp17_ = item;
#line 440 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 1296 "Database.c"
					}
#line 438 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 1300 "Database.c"
				}
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
#line 437 "../core/Services/Database.vala"
			_tmp18_ = self->priv->_items;
#line 437 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 1311 "Database.c"
		}
#line 437 "../core/Services/Database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 437 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 437 "../core/Services/Database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 437 "../core/Services/Database.vala"
			g_clear_error (&_inner_error0_);
#line 437 "../core/Services/Database.vala"
			return NULL;
#line 1323 "Database.c"
		}
	}
#line 445 "../core/Services/Database.vala"
	result = return_value;
#line 445 "../core/Services/Database.vala"
	return result;
#line 1330 "Database.c"
}

ObjectsProject*
_services_database_fill_project (ServicesDatabase* self,
                                 sqlite3_stmt* stmt)
{
	ObjectsProject* return_value = NULL;
	ObjectsProject* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	ObjectsProject* result;
#line 448 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 448 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 449 "../core/Services/Database.vala"
	_tmp0_ = objects_project_new ();
#line 449 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 450 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 450 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 451 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 451 "../core/Services/Database.vala"
	objects_base_object_set_name ((ObjectsBaseObject*) return_value, _tmp2_);
#line 452 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 452 "../core/Services/Database.vala"
	objects_project_set_color (return_value, _tmp3_);
#line 453 "../core/Services/Database.vala"
	objects_project_set_backend_type (return_value, services_database_get_backend_type_by_text (self, stmt, 3));
#line 454 "../core/Services/Database.vala"
	objects_project_set_inbox_project (return_value, services_database_get_parameter_bool (self, stmt, 4));
#line 455 "../core/Services/Database.vala"
	objects_project_set_team_inbox (return_value, services_database_get_parameter_bool (self, stmt, 5));
#line 456 "../core/Services/Database.vala"
	objects_project_set_child_order (return_value, sqlite3_column_int (stmt, 6));
#line 457 "../core/Services/Database.vala"
	objects_project_set_is_deleted (return_value, services_database_get_parameter_bool (self, stmt, 7));
#line 458 "../core/Services/Database.vala"
	objects_project_set_is_archived (return_value, services_database_get_parameter_bool (self, stmt, 8));
#line 459 "../core/Services/Database.vala"
	objects_project_set_is_favorite (return_value, services_database_get_parameter_bool (self, stmt, 9));
#line 460 "../core/Services/Database.vala"
	objects_project_set_shared (return_value, services_database_get_parameter_bool (self, stmt, 10));
#line 461 "../core/Services/Database.vala"
	objects_project_set_view_style (return_value, services_database_get_view_style_by_text (self, stmt, 11));
#line 462 "../core/Services/Database.vala"
	objects_project_set_sort_order (return_value, sqlite3_column_int (stmt, 12));
#line 463 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 13);
#line 463 "../core/Services/Database.vala"
	objects_project_set_parent_id (return_value, _tmp4_);
#line 464 "../core/Services/Database.vala"
	objects_project_set_collapsed (return_value, services_database_get_parameter_bool (self, stmt, 14));
#line 465 "../core/Services/Database.vala"
	objects_project_set_icon_style (return_value, services_database_get_icon_style_by_text (self, stmt, 15));
#line 466 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 16);
#line 466 "../core/Services/Database.vala"
	objects_project_set_emoji (return_value, _tmp5_);
#line 467 "../core/Services/Database.vala"
	objects_project_set_show_completed (return_value, services_database_get_parameter_bool (self, stmt, 17));
#line 468 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 18);
#line 468 "../core/Services/Database.vala"
	objects_project_set_description (return_value, _tmp6_);
#line 469 "../core/Services/Database.vala"
	_tmp7_ = (const gchar*) sqlite3_column_text (stmt, 19);
#line 469 "../core/Services/Database.vala"
	objects_project_set_due_date (return_value, _tmp7_);
#line 470 "../core/Services/Database.vala"
	objects_project_set_inbox_section_hidded (return_value, services_database_get_parameter_bool (self, stmt, 20));
#line 471 "../core/Services/Database.vala"
	_tmp8_ = (const gchar*) sqlite3_column_text (stmt, 21);
#line 471 "../core/Services/Database.vala"
	objects_project_set_sync_id (return_value, _tmp8_);
#line 472 "../core/Services/Database.vala"
	result = return_value;
#line 472 "../core/Services/Database.vala"
	return result;
#line 1420 "Database.c"
}

static ProjectViewStyle
services_database_get_view_style_by_text (ServicesDatabase* self,
                                          sqlite3_stmt* stmt,
                                          gint col)
{
	const gchar* _tmp0_;
	ProjectViewStyle result;
#line 475 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 475 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, 0);
#line 476 "../core/Services/Database.vala"
	_tmp0_ = (const gchar*) sqlite3_column_text (stmt, col);
#line 476 "../core/Services/Database.vala"
	if (g_strcmp0 (_tmp0_, "board") == 0) {
#line 477 "../core/Services/Database.vala"
		result = PROJECT_VIEW_STYLE_BOARD;
#line 477 "../core/Services/Database.vala"
		return result;
#line 1442 "Database.c"
	}
#line 480 "../core/Services/Database.vala"
	result = PROJECT_VIEW_STYLE_LIST;
#line 480 "../core/Services/Database.vala"
	return result;
#line 1448 "Database.c"
}

static ProjectIconStyle
services_database_get_icon_style_by_text (ServicesDatabase* self,
                                          sqlite3_stmt* stmt,
                                          gint col)
{
	const gchar* _tmp0_;
	ProjectIconStyle result;
#line 483 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 483 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, 0);
#line 484 "../core/Services/Database.vala"
	_tmp0_ = (const gchar*) sqlite3_column_text (stmt, col);
#line 484 "../core/Services/Database.vala"
	if (g_strcmp0 (_tmp0_, "emoji") == 0) {
#line 485 "../core/Services/Database.vala"
		result = PROJECT_ICON_STYLE_EMOJI;
#line 485 "../core/Services/Database.vala"
		return result;
#line 1470 "Database.c"
	}
#line 488 "../core/Services/Database.vala"
	result = PROJECT_ICON_STYLE_PROGRESS;
#line 488 "../core/Services/Database.vala"
	return result;
#line 1476 "Database.c"
}

static BackendType
services_database_get_backend_type_by_text (ServicesDatabase* self,
                                            sqlite3_stmt* stmt,
                                            gint col)
{
	const gchar* _tmp0_;
	BackendType result;
#line 491 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 491 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, 0);
#line 492 "../core/Services/Database.vala"
	_tmp0_ = (const gchar*) sqlite3_column_text (stmt, col);
#line 492 "../core/Services/Database.vala"
	if (g_strcmp0 (_tmp0_, "local") == 0) {
#line 493 "../core/Services/Database.vala"
		result = BACKEND_TYPE_LOCAL;
#line 493 "../core/Services/Database.vala"
		return result;
#line 1498 "Database.c"
	} else {
		const gchar* _tmp1_;
#line 494 "../core/Services/Database.vala"
		_tmp1_ = (const gchar*) sqlite3_column_text (stmt, col);
#line 494 "../core/Services/Database.vala"
		if (g_strcmp0 (_tmp1_, "todoist") == 0) {
#line 495 "../core/Services/Database.vala"
			result = BACKEND_TYPE_TODOIST;
#line 495 "../core/Services/Database.vala"
			return result;
#line 1509 "Database.c"
		} else {
			const gchar* _tmp2_;
#line 496 "../core/Services/Database.vala"
			_tmp2_ = (const gchar*) sqlite3_column_text (stmt, col);
#line 496 "../core/Services/Database.vala"
			if (g_strcmp0 (_tmp2_, "google-tasks") == 0) {
#line 497 "../core/Services/Database.vala"
				result = BACKEND_TYPE_GOOGLE_TASKS;
#line 497 "../core/Services/Database.vala"
				return result;
#line 1520 "Database.c"
			} else {
				const gchar* _tmp3_;
#line 498 "../core/Services/Database.vala"
				_tmp3_ = (const gchar*) sqlite3_column_text (stmt, col);
#line 498 "../core/Services/Database.vala"
				if (g_strcmp0 (_tmp3_, "caldav") == 0) {
#line 499 "../core/Services/Database.vala"
					result = BACKEND_TYPE_CALDAV;
#line 499 "../core/Services/Database.vala"
					return result;
#line 1531 "Database.c"
				} else {
#line 501 "../core/Services/Database.vala"
					result = BACKEND_TYPE_NONE;
#line 501 "../core/Services/Database.vala"
					return result;
#line 1537 "Database.c"
				}
			}
		}
	}
}

gint
services_database_next_project_child_order (ServicesDatabase* self,
                                            BackendType backend_type)
{
	gint child_order = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 505 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 506 "../core/Services/Database.vala"
	child_order = 0;
#line 1555 "Database.c"
	{
		GeeArrayList* _tmp0_;
		gint _tmp20_ = -1;
#line 508 "../core/Services/Database.vala"
		_tmp0_ = self->priv->_projects;
#line 508 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__projects);
#line 1563 "Database.c"
		{
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _project_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _project_index = 0;
#line 509 "../core/Services/Database.vala"
				_tmp1_ = services_database_get_projects (self);
#line 509 "../core/Services/Database.vala"
				_tmp2_ = _tmp1_;
#line 509 "../core/Services/Database.vala"
				_project_list = _tmp2_;
#line 509 "../core/Services/Database.vala"
				_tmp3_ = _project_list;
#line 509 "../core/Services/Database.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 509 "../core/Services/Database.vala"
				_tmp5_ = _tmp4_;
#line 509 "../core/Services/Database.vala"
				_project_size = _tmp5_;
#line 509 "../core/Services/Database.vala"
				_project_index = -1;
#line 509 "../core/Services/Database.vala"
				while (TRUE) {
#line 1592 "Database.c"
					gint _tmp6_;
					gint _tmp7_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					ObjectsProject* _tmp11_;
					BackendType _tmp12_;
					BackendType _tmp13_;
#line 509 "../core/Services/Database.vala"
					_project_index = _project_index + 1;
#line 509 "../core/Services/Database.vala"
					_tmp6_ = _project_index;
#line 509 "../core/Services/Database.vala"
					_tmp7_ = _project_size;
#line 509 "../core/Services/Database.vala"
					if (!(_tmp6_ < _tmp7_)) {
#line 509 "../core/Services/Database.vala"
						break;
#line 1612 "Database.c"
					}
#line 509 "../core/Services/Database.vala"
					_tmp8_ = _project_list;
#line 509 "../core/Services/Database.vala"
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _project_index);
#line 509 "../core/Services/Database.vala"
					project = (ObjectsProject*) _tmp9_;
#line 510 "../core/Services/Database.vala"
					_tmp11_ = project;
#line 510 "../core/Services/Database.vala"
					_tmp12_ = objects_project_get_backend_type (_tmp11_);
#line 510 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 510 "../core/Services/Database.vala"
					if (_tmp13_ == backend_type) {
#line 1628 "Database.c"
						ObjectsProject* _tmp14_;
						gboolean _tmp15_;
						gboolean _tmp16_;
#line 510 "../core/Services/Database.vala"
						_tmp14_ = project;
#line 510 "../core/Services/Database.vala"
						_tmp15_ = objects_project_get_is_deleted (_tmp14_);
#line 510 "../core/Services/Database.vala"
						_tmp16_ = _tmp15_;
#line 510 "../core/Services/Database.vala"
						_tmp10_ = !_tmp16_;
#line 1640 "Database.c"
					} else {
#line 510 "../core/Services/Database.vala"
						_tmp10_ = FALSE;
#line 1644 "Database.c"
					}
#line 510 "../core/Services/Database.vala"
					if (_tmp10_) {
#line 1648 "Database.c"
						gint _tmp17_;
#line 511 "../core/Services/Database.vala"
						_tmp17_ = child_order;
#line 511 "../core/Services/Database.vala"
						child_order = _tmp17_ + 1;
#line 1654 "Database.c"
					}
#line 509 "../core/Services/Database.vala"
					_g_object_unref0 (project);
#line 1658 "Database.c"
				}
			}
#line 515 "../core/Services/Database.vala"
			result = child_order;
#line 1663 "Database.c"
			{
				GeeArrayList* _tmp18_;
#line 508 "../core/Services/Database.vala"
				_tmp18_ = self->priv->_projects;
#line 508 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 1670 "Database.c"
			}
#line 515 "../core/Services/Database.vala"
			return result;
#line 1674 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp19_;
#line 508 "../core/Services/Database.vala"
			_tmp19_ = self->priv->_projects;
#line 508 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 1683 "Database.c"
		}
#line 508 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 508 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 508 "../core/Services/Database.vala"
		return _tmp20_;
#line 1691 "Database.c"
	}
}

gboolean
services_database_insert_project (ServicesDatabase* self,
                                  ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	BackendType _tmp17_;
	BackendType _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	sqlite3_stmt* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	sqlite3_stmt* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	sqlite3_stmt* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	sqlite3_stmt* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	sqlite3_stmt* _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp35_;
	sqlite3_stmt* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	sqlite3_stmt* _tmp39_;
	gboolean _tmp40_;
	gboolean _tmp41_;
	sqlite3_stmt* _tmp42_;
	ProjectViewStyle _tmp43_;
	ProjectViewStyle _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	sqlite3_stmt* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	sqlite3_stmt* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	sqlite3_stmt* _tmp53_;
	gboolean _tmp54_;
	gboolean _tmp55_;
	sqlite3_stmt* _tmp56_;
	ProjectIconStyle _tmp57_;
	ProjectIconStyle _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	sqlite3_stmt* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	sqlite3_stmt* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	sqlite3_stmt* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	sqlite3_stmt* _tmp70_;
	const gchar* _tmp71_;
	const gchar* _tmp72_;
	sqlite3_stmt* _tmp73_;
	gboolean _tmp74_;
	gboolean _tmp75_;
	sqlite3_stmt* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	sqlite3_stmt* _tmp79_;
	sqlite3_stmt* _tmp89_;
	sqlite3_stmt* _tmp90_;
	gboolean result;
#line 519 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 519 "../core/Services/Database.vala"
	g_return_val_if_fail (project != NULL, FALSE);
#line 522 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Projects (id, name, color, backend_t" \
"ype, inbox_project,\n" \
"                team_inbox, child_order, is_deleted, is_archived, is_f" \
"avorite, shared, view_style,\n" \
"                sort_order, parent_id, collapsed, icon_style, emoji, s" \
"how_completed, description, due_date,\n" \
"                inbox_section_hidded, sync_id)\n" \
"            VALUES ($id, $name, $color, $backend_type, $inbox_project," \
" $team_inbox,\n" \
"                $child_order, $is_deleted, $is_archived, $is_favorite," \
" $shared, $view_style,\n" \
"                $sort_order, $parent_id, $collapsed, $icon_style, $emo" \
"ji, $show_completed, $description, $due_date,\n" \
"                $inbox_section_hidded, $sync_id);\n" \
"        ");
#line 522 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 522 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 533 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 533 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 533 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 533 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 533 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 533 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 533 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 533 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 534 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 534 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 534 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 534 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 535 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 535 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_name ((ObjectsBaseObject*) project);
#line 535 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 535 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$name", _tmp12_);
#line 536 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 536 "../core/Services/Database.vala"
	_tmp14_ = objects_project_get_color (project);
#line 536 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 536 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$color", _tmp15_);
#line 537 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 537 "../core/Services/Database.vala"
	_tmp17_ = objects_project_get_backend_type (project);
#line 537 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 537 "../core/Services/Database.vala"
	_tmp19_ = backend_type_to_string (_tmp18_);
#line 537 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 537 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$backend_type", _tmp20_);
#line 537 "../core/Services/Database.vala"
	_g_free0 (_tmp20_);
#line 538 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 538 "../core/Services/Database.vala"
	_tmp22_ = objects_project_get_inbox_project (project);
#line 538 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 538 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp21_, "$inbox_project", _tmp23_);
#line 539 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 539 "../core/Services/Database.vala"
	_tmp25_ = objects_project_get_team_inbox (project);
#line 539 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 539 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp24_, "$team_inbox", _tmp26_);
#line 540 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 540 "../core/Services/Database.vala"
	_tmp28_ = objects_project_get_child_order (project);
#line 540 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 540 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp27_, "$child_order", _tmp29_);
#line 541 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 541 "../core/Services/Database.vala"
	_tmp31_ = objects_project_get_is_deleted (project);
#line 541 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 541 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp30_, "$is_deleted", _tmp32_);
#line 542 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 542 "../core/Services/Database.vala"
	_tmp34_ = objects_project_get_is_archived (project);
#line 542 "../core/Services/Database.vala"
	_tmp35_ = _tmp34_;
#line 542 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp33_, "$is_archived", _tmp35_);
#line 543 "../core/Services/Database.vala"
	_tmp36_ = stmt;
#line 543 "../core/Services/Database.vala"
	_tmp37_ = objects_project_get_is_favorite (project);
#line 543 "../core/Services/Database.vala"
	_tmp38_ = _tmp37_;
#line 543 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp36_, "$is_favorite", _tmp38_);
#line 544 "../core/Services/Database.vala"
	_tmp39_ = stmt;
#line 544 "../core/Services/Database.vala"
	_tmp40_ = objects_project_get_shared (project);
#line 544 "../core/Services/Database.vala"
	_tmp41_ = _tmp40_;
#line 544 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp39_, "$shared", _tmp41_);
#line 545 "../core/Services/Database.vala"
	_tmp42_ = stmt;
#line 545 "../core/Services/Database.vala"
	_tmp43_ = objects_project_get_view_style (project);
#line 545 "../core/Services/Database.vala"
	_tmp44_ = _tmp43_;
#line 545 "../core/Services/Database.vala"
	_tmp45_ = project_view_style_to_string (_tmp44_);
#line 545 "../core/Services/Database.vala"
	_tmp46_ = _tmp45_;
#line 545 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp42_, "$view_style", _tmp46_);
#line 545 "../core/Services/Database.vala"
	_g_free0 (_tmp46_);
#line 546 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 546 "../core/Services/Database.vala"
	_tmp48_ = objects_project_get_sort_order (project);
#line 546 "../core/Services/Database.vala"
	_tmp49_ = _tmp48_;
#line 546 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp47_, "$sort_order", _tmp49_);
#line 547 "../core/Services/Database.vala"
	_tmp50_ = stmt;
#line 547 "../core/Services/Database.vala"
	_tmp51_ = objects_project_get_parent_id (project);
#line 547 "../core/Services/Database.vala"
	_tmp52_ = _tmp51_;
#line 547 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp50_, "$parent_id", _tmp52_);
#line 548 "../core/Services/Database.vala"
	_tmp53_ = stmt;
#line 548 "../core/Services/Database.vala"
	_tmp54_ = objects_project_get_collapsed (project);
#line 548 "../core/Services/Database.vala"
	_tmp55_ = _tmp54_;
#line 548 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp53_, "$collapsed", _tmp55_);
#line 549 "../core/Services/Database.vala"
	_tmp56_ = stmt;
#line 549 "../core/Services/Database.vala"
	_tmp57_ = objects_project_get_icon_style (project);
#line 549 "../core/Services/Database.vala"
	_tmp58_ = _tmp57_;
#line 549 "../core/Services/Database.vala"
	_tmp59_ = project_icon_style_to_string (_tmp58_);
#line 549 "../core/Services/Database.vala"
	_tmp60_ = _tmp59_;
#line 549 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp56_, "$icon_style", _tmp60_);
#line 549 "../core/Services/Database.vala"
	_g_free0 (_tmp60_);
#line 550 "../core/Services/Database.vala"
	_tmp61_ = stmt;
#line 550 "../core/Services/Database.vala"
	_tmp62_ = objects_project_get_emoji (project);
#line 550 "../core/Services/Database.vala"
	_tmp63_ = _tmp62_;
#line 550 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp61_, "$emoji", _tmp63_);
#line 551 "../core/Services/Database.vala"
	_tmp64_ = stmt;
#line 551 "../core/Services/Database.vala"
	_tmp65_ = objects_project_get_show_completed (project);
#line 551 "../core/Services/Database.vala"
	_tmp66_ = _tmp65_;
#line 551 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp64_, "$show_completed", _tmp66_);
#line 552 "../core/Services/Database.vala"
	_tmp67_ = stmt;
#line 552 "../core/Services/Database.vala"
	_tmp68_ = objects_project_get_description (project);
#line 552 "../core/Services/Database.vala"
	_tmp69_ = _tmp68_;
#line 552 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp67_, "$description", _tmp69_);
#line 553 "../core/Services/Database.vala"
	_tmp70_ = stmt;
#line 553 "../core/Services/Database.vala"
	_tmp71_ = objects_project_get_due_date (project);
#line 553 "../core/Services/Database.vala"
	_tmp72_ = _tmp71_;
#line 553 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp70_, "$due_date", _tmp72_);
#line 554 "../core/Services/Database.vala"
	_tmp73_ = stmt;
#line 554 "../core/Services/Database.vala"
	_tmp74_ = objects_project_get_inbox_section_hidded (project);
#line 554 "../core/Services/Database.vala"
	_tmp75_ = _tmp74_;
#line 554 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp73_, "$inbox_section_hidded", _tmp75_);
#line 555 "../core/Services/Database.vala"
	_tmp76_ = stmt;
#line 555 "../core/Services/Database.vala"
	_tmp77_ = objects_project_get_sync_id (project);
#line 555 "../core/Services/Database.vala"
	_tmp78_ = _tmp77_;
#line 555 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp76_, "$sync_id", _tmp78_);
#line 557 "../core/Services/Database.vala"
	_tmp79_ = stmt;
#line 557 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp79_) == SQLITE_DONE) {
#line 2007 "Database.c"
		GeeArrayList* _tmp80_;
		GeeArrayList* _tmp81_;
		ObjectsProject* _tmp82_;
		ObjectsProject* _tmp83_;
#line 558 "../core/Services/Database.vala"
		_tmp80_ = services_database_get_projects (self);
#line 558 "../core/Services/Database.vala"
		_tmp81_ = _tmp80_;
#line 558 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp81_, project);
#line 560 "../core/Services/Database.vala"
		_tmp82_ = objects_project_get_parent (project);
#line 560 "../core/Services/Database.vala"
		_tmp83_ = _tmp82_;
#line 560 "../core/Services/Database.vala"
		if (_tmp83_ == NULL) {
#line 561 "../core/Services/Database.vala"
			g_signal_emit (self, services_database_signals[SERVICES_DATABASE_PROJECT_ADDED_SIGNAL], 0, project);
#line 2026 "Database.c"
		} else {
			ObjectsProject* _tmp84_;
			ObjectsProject* _tmp85_;
#line 563 "../core/Services/Database.vala"
			_tmp84_ = objects_project_get_parent (project);
#line 563 "../core/Services/Database.vala"
			_tmp85_ = _tmp84_;
#line 563 "../core/Services/Database.vala"
			g_signal_emit_by_name (_tmp85_, "subproject-added", project);
#line 2036 "Database.c"
		}
	} else {
		sqlite3* _tmp86_;
		sqlite3* _tmp87_;
		const gchar* _tmp88_;
#line 566 "../core/Services/Database.vala"
		_tmp86_ = self->priv->db;
#line 566 "../core/Services/Database.vala"
		_tmp87_ = self->priv->db;
#line 566 "../core/Services/Database.vala"
		_tmp88_ = sqlite3_errmsg (_tmp87_);
#line 566 "../core/Services/Database.vala"
		g_warning ("Database.vala:566: Error: %d: %s", sqlite3_errcode (_tmp86_), _tmp88_);
#line 2050 "Database.c"
	}
#line 569 "../core/Services/Database.vala"
	_tmp89_ = stmt;
#line 569 "../core/Services/Database.vala"
	sqlite3_reset (_tmp89_);
#line 570 "../core/Services/Database.vala"
	_tmp90_ = stmt;
#line 570 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp90_) == SQLITE_DONE;
#line 570 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 570 "../core/Services/Database.vala"
	return result;
#line 2064 "Database.c"
}

ObjectsProject*
services_database_get_project (ServicesDatabase* self,
                               const gchar* id)
{
	ObjectsProject* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsProject* result;
#line 573 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 573 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 574 "../core/Services/Database.vala"
	return_value = NULL;
#line 2080 "Database.c"
	{
		GeeArrayList* _tmp0_;
#line 575 "../core/Services/Database.vala"
		_tmp0_ = self->priv->_projects;
#line 575 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__projects);
#line 2087 "Database.c"
		{
			ObjectsProject* _tmp15_;
			ObjectsProject* _tmp16_;
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _project_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _project_index = 0;
#line 576 "../core/Services/Database.vala"
				_tmp1_ = services_database_get_projects (self);
#line 576 "../core/Services/Database.vala"
				_tmp2_ = _tmp1_;
#line 576 "../core/Services/Database.vala"
				_project_list = _tmp2_;
#line 576 "../core/Services/Database.vala"
				_tmp3_ = _project_list;
#line 576 "../core/Services/Database.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 576 "../core/Services/Database.vala"
				_tmp5_ = _tmp4_;
#line 576 "../core/Services/Database.vala"
				_project_size = _tmp5_;
#line 576 "../core/Services/Database.vala"
				_project_index = -1;
#line 576 "../core/Services/Database.vala"
				while (TRUE) {
#line 2118 "Database.c"
					gint _tmp6_;
					gint _tmp7_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsProject* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
#line 576 "../core/Services/Database.vala"
					_project_index = _project_index + 1;
#line 576 "../core/Services/Database.vala"
					_tmp6_ = _project_index;
#line 576 "../core/Services/Database.vala"
					_tmp7_ = _project_size;
#line 576 "../core/Services/Database.vala"
					if (!(_tmp6_ < _tmp7_)) {
#line 576 "../core/Services/Database.vala"
						break;
#line 2137 "Database.c"
					}
#line 576 "../core/Services/Database.vala"
					_tmp8_ = _project_list;
#line 576 "../core/Services/Database.vala"
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _project_index);
#line 576 "../core/Services/Database.vala"
					project = (ObjectsProject*) _tmp9_;
#line 577 "../core/Services/Database.vala"
					_tmp10_ = project;
#line 577 "../core/Services/Database.vala"
					_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp10_);
#line 577 "../core/Services/Database.vala"
					_tmp12_ = _tmp11_;
#line 577 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp12_, id) == 0) {
#line 2153 "Database.c"
						ObjectsProject* _tmp13_;
						ObjectsProject* _tmp14_;
#line 578 "../core/Services/Database.vala"
						_tmp13_ = project;
#line 578 "../core/Services/Database.vala"
						_tmp14_ = _g_object_ref0 (_tmp13_);
#line 578 "../core/Services/Database.vala"
						_g_object_unref0 (return_value);
#line 578 "../core/Services/Database.vala"
						return_value = _tmp14_;
#line 579 "../core/Services/Database.vala"
						_g_object_unref0 (project);
#line 579 "../core/Services/Database.vala"
						break;
#line 2168 "Database.c"
					}
#line 576 "../core/Services/Database.vala"
					_g_object_unref0 (project);
#line 2172 "Database.c"
				}
			}
#line 583 "../core/Services/Database.vala"
			_tmp15_ = return_value;
#line 583 "../core/Services/Database.vala"
			_tmp16_ = _g_object_ref0 (_tmp15_);
#line 583 "../core/Services/Database.vala"
			result = _tmp16_;
#line 2181 "Database.c"
			{
				GeeArrayList* _tmp17_;
#line 575 "../core/Services/Database.vala"
				_tmp17_ = self->priv->_projects;
#line 575 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 2188 "Database.c"
			}
#line 583 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 583 "../core/Services/Database.vala"
			return result;
#line 2194 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
#line 575 "../core/Services/Database.vala"
			_tmp18_ = self->priv->_projects;
#line 575 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 2203 "Database.c"
		}
#line 575 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 575 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 575 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 575 "../core/Services/Database.vala"
		return NULL;
#line 2213 "Database.c"
	}
}

void
services_database_delete_project (ServicesDatabase* self,
                                  ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp41_;
#line 587 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 587 "../core/Services/Database.vala"
	g_return_if_fail (project != NULL);
#line 590 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Projects WHERE id=$id;\n        ");
#line 590 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 590 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 594 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 594 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 594 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 594 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 594 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 594 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 594 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 594 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 595 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 595 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 595 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 595 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 597 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 597 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) == SQLITE_DONE) {
#line 2272 "Database.c"
		{
			GeeArrayList* _section_list = NULL;
			GeeArrayList* _tmp11_;
			gint _section_size = 0;
			GeeArrayList* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			gint _section_index = 0;
#line 598 "../core/Services/Database.vala"
			_tmp11_ = services_database_get_sections_by_project (self, project);
#line 598 "../core/Services/Database.vala"
			_section_list = _tmp11_;
#line 598 "../core/Services/Database.vala"
			_tmp12_ = _section_list;
#line 598 "../core/Services/Database.vala"
			_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 598 "../core/Services/Database.vala"
			_tmp14_ = _tmp13_;
#line 598 "../core/Services/Database.vala"
			_section_size = _tmp14_;
#line 598 "../core/Services/Database.vala"
			_section_index = -1;
#line 598 "../core/Services/Database.vala"
			while (TRUE) {
#line 2297 "Database.c"
				gint _tmp15_;
				gint _tmp16_;
				ObjectsSection* section = NULL;
				GeeArrayList* _tmp17_;
				gpointer _tmp18_;
				ObjectsSection* _tmp19_;
#line 598 "../core/Services/Database.vala"
				_section_index = _section_index + 1;
#line 598 "../core/Services/Database.vala"
				_tmp15_ = _section_index;
#line 598 "../core/Services/Database.vala"
				_tmp16_ = _section_size;
#line 598 "../core/Services/Database.vala"
				if (!(_tmp15_ < _tmp16_)) {
#line 598 "../core/Services/Database.vala"
					break;
#line 2314 "Database.c"
				}
#line 598 "../core/Services/Database.vala"
				_tmp17_ = _section_list;
#line 598 "../core/Services/Database.vala"
				_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _section_index);
#line 598 "../core/Services/Database.vala"
				section = (ObjectsSection*) _tmp18_;
#line 599 "../core/Services/Database.vala"
				_tmp19_ = section;
#line 599 "../core/Services/Database.vala"
				services_database_delete_section (self, _tmp19_);
#line 598 "../core/Services/Database.vala"
				_g_object_unref0 (section);
#line 2328 "Database.c"
			}
#line 598 "../core/Services/Database.vala"
			_g_object_unref0 (_section_list);
#line 2332 "Database.c"
		}
		{
			GeeArrayList* _item_list = NULL;
			GeeArrayList* _tmp20_;
			gint _item_size = 0;
			GeeArrayList* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			gint _item_index = 0;
#line 602 "../core/Services/Database.vala"
			_tmp20_ = services_database_get_items_by_project (self, project);
#line 602 "../core/Services/Database.vala"
			_item_list = _tmp20_;
#line 602 "../core/Services/Database.vala"
			_tmp21_ = _item_list;
#line 602 "../core/Services/Database.vala"
			_tmp22_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp21_);
#line 602 "../core/Services/Database.vala"
			_tmp23_ = _tmp22_;
#line 602 "../core/Services/Database.vala"
			_item_size = _tmp23_;
#line 602 "../core/Services/Database.vala"
			_item_index = -1;
#line 602 "../core/Services/Database.vala"
			while (TRUE) {
#line 2358 "Database.c"
				gint _tmp24_;
				gint _tmp25_;
				ObjectsItem* item = NULL;
				GeeArrayList* _tmp26_;
				gpointer _tmp27_;
				ObjectsItem* _tmp28_;
#line 602 "../core/Services/Database.vala"
				_item_index = _item_index + 1;
#line 602 "../core/Services/Database.vala"
				_tmp24_ = _item_index;
#line 602 "../core/Services/Database.vala"
				_tmp25_ = _item_size;
#line 602 "../core/Services/Database.vala"
				if (!(_tmp24_ < _tmp25_)) {
#line 602 "../core/Services/Database.vala"
					break;
#line 2375 "Database.c"
				}
#line 602 "../core/Services/Database.vala"
				_tmp26_ = _item_list;
#line 602 "../core/Services/Database.vala"
				_tmp27_ = gee_abstract_list_get ((GeeAbstractList*) _tmp26_, _item_index);
#line 602 "../core/Services/Database.vala"
				item = (ObjectsItem*) _tmp27_;
#line 603 "../core/Services/Database.vala"
				_tmp28_ = item;
#line 603 "../core/Services/Database.vala"
				services_database_delete_item (self, _tmp28_);
#line 602 "../core/Services/Database.vala"
				_g_object_unref0 (item);
#line 2389 "Database.c"
			}
#line 602 "../core/Services/Database.vala"
			_g_object_unref0 (_item_list);
#line 2393 "Database.c"
		}
		{
			GeeArrayList* _subproject_list = NULL;
			GeeArrayList* _tmp29_;
			gint _subproject_size = 0;
			GeeArrayList* _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			gint _subproject_index = 0;
#line 606 "../core/Services/Database.vala"
			_tmp29_ = services_database_get_subprojects (self, project);
#line 606 "../core/Services/Database.vala"
			_subproject_list = _tmp29_;
#line 606 "../core/Services/Database.vala"
			_tmp30_ = _subproject_list;
#line 606 "../core/Services/Database.vala"
			_tmp31_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp30_);
#line 606 "../core/Services/Database.vala"
			_tmp32_ = _tmp31_;
#line 606 "../core/Services/Database.vala"
			_subproject_size = _tmp32_;
#line 606 "../core/Services/Database.vala"
			_subproject_index = -1;
#line 606 "../core/Services/Database.vala"
			while (TRUE) {
#line 2419 "Database.c"
				gint _tmp33_;
				gint _tmp34_;
				ObjectsProject* subproject = NULL;
				GeeArrayList* _tmp35_;
				gpointer _tmp36_;
				ObjectsProject* _tmp37_;
#line 606 "../core/Services/Database.vala"
				_subproject_index = _subproject_index + 1;
#line 606 "../core/Services/Database.vala"
				_tmp33_ = _subproject_index;
#line 606 "../core/Services/Database.vala"
				_tmp34_ = _subproject_size;
#line 606 "../core/Services/Database.vala"
				if (!(_tmp33_ < _tmp34_)) {
#line 606 "../core/Services/Database.vala"
					break;
#line 2436 "Database.c"
				}
#line 606 "../core/Services/Database.vala"
				_tmp35_ = _subproject_list;
#line 606 "../core/Services/Database.vala"
				_tmp36_ = gee_abstract_list_get ((GeeAbstractList*) _tmp35_, _subproject_index);
#line 606 "../core/Services/Database.vala"
				subproject = (ObjectsProject*) _tmp36_;
#line 607 "../core/Services/Database.vala"
				_tmp37_ = subproject;
#line 607 "../core/Services/Database.vala"
				services_database_delete_project (self, _tmp37_);
#line 606 "../core/Services/Database.vala"
				_g_object_unref0 (subproject);
#line 2450 "Database.c"
			}
#line 606 "../core/Services/Database.vala"
			_g_object_unref0 (_subproject_list);
#line 2454 "Database.c"
		}
#line 610 "../core/Services/Database.vala"
		g_signal_emit_by_name ((ObjectsBaseObject*) project, "deleted");
#line 2458 "Database.c"
	} else {
		sqlite3* _tmp38_;
		sqlite3* _tmp39_;
		const gchar* _tmp40_;
#line 612 "../core/Services/Database.vala"
		_tmp38_ = self->priv->db;
#line 612 "../core/Services/Database.vala"
		_tmp39_ = self->priv->db;
#line 612 "../core/Services/Database.vala"
		_tmp40_ = sqlite3_errmsg (_tmp39_);
#line 612 "../core/Services/Database.vala"
		g_warning ("Database.vala:612: Error: %d: %s", sqlite3_errcode (_tmp38_), _tmp40_);
#line 2471 "Database.c"
	}
#line 615 "../core/Services/Database.vala"
	_tmp41_ = stmt;
#line 615 "../core/Services/Database.vala"
	sqlite3_reset (_tmp41_);
#line 587 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2479 "Database.c"
}

void
services_database_delete_project_db (ServicesDatabase* self,
                                     ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	sqlite3_stmt* _tmp20_;
#line 618 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 618 "../core/Services/Database.vala"
	g_return_if_fail (project != NULL);
#line 621 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            DELETE FROM Projects WHERE id=$id;\n" \
"            DELETE FROM Items WHERE project_id=$item_project_id;\n" \
"        ");
#line 621 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 621 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 626 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 626 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 626 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 626 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 626 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 626 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 626 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 626 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 627 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 627 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 627 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 627 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 628 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 628 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 628 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 628 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$section_project_id", _tmp12_);
#line 629 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 629 "../core/Services/Database.vala"
	_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 629 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 629 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$item_project_id", _tmp15_);
#line 631 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 631 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp16_) != SQLITE_DONE) {
#line 2559 "Database.c"
		sqlite3* _tmp17_;
		sqlite3* _tmp18_;
		const gchar* _tmp19_;
#line 632 "../core/Services/Database.vala"
		_tmp17_ = self->priv->db;
#line 632 "../core/Services/Database.vala"
		_tmp18_ = self->priv->db;
#line 632 "../core/Services/Database.vala"
		_tmp19_ = sqlite3_errmsg (_tmp18_);
#line 632 "../core/Services/Database.vala"
		g_warning ("Database.vala:632: Error: %d: %s", sqlite3_errcode (_tmp17_), _tmp19_);
#line 2571 "Database.c"
	}
#line 635 "../core/Services/Database.vala"
	_tmp20_ = stmt;
#line 635 "../core/Services/Database.vala"
	sqlite3_reset (_tmp20_);
#line 618 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2579 "Database.c"
}

void
services_database_update_project (ServicesDatabase* self,
                                  ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	BackendType _tmp14_;
	BackendType _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	sqlite3_stmt* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	sqlite3_stmt* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	sqlite3_stmt* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	sqlite3_stmt* _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	sqlite3_stmt* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	sqlite3_stmt* _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp35_;
	sqlite3_stmt* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	sqlite3_stmt* _tmp39_;
	ProjectViewStyle _tmp40_;
	ProjectViewStyle _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	sqlite3_stmt* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	sqlite3_stmt* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	sqlite3_stmt* _tmp50_;
	gboolean _tmp51_;
	gboolean _tmp52_;
	sqlite3_stmt* _tmp53_;
	ProjectIconStyle _tmp54_;
	ProjectIconStyle _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	sqlite3_stmt* _tmp58_;
	const gchar* _tmp59_;
	const gchar* _tmp60_;
	sqlite3_stmt* _tmp61_;
	gboolean _tmp62_;
	gboolean _tmp63_;
	sqlite3_stmt* _tmp64_;
	const gchar* _tmp65_;
	const gchar* _tmp66_;
	sqlite3_stmt* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	sqlite3_stmt* _tmp70_;
	gboolean _tmp71_;
	gboolean _tmp72_;
	sqlite3_stmt* _tmp73_;
	const gchar* _tmp74_;
	const gchar* _tmp75_;
	sqlite3_stmt* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	sqlite3_stmt* _tmp79_;
	sqlite3_stmt* _tmp83_;
#line 638 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 638 "../core/Services/Database.vala"
	g_return_if_fail (project != NULL);
#line 641 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Projects SET\n" \
"                name=$name,\n" \
"                color=$color,\n" \
"                backend_type=$backend_type,\n" \
"                inbox_project=$inbox_project,\n" \
"                team_inbox=$team_inbox,\n" \
"                child_order=$child_order,\n" \
"                is_deleted=$is_deleted,\n" \
"                is_archived=$is_archived,\n" \
"                is_favorite=$is_favorite,\n" \
"                shared=$shared,\n" \
"                view_style=$view_style,\n" \
"                sort_order=$sort_order,\n" \
"                parent_id=$parent_id,\n" \
"                collapsed=$collapsed,\n" \
"                icon_style=$icon_style,\n" \
"                emoji=$emoji,\n" \
"                show_completed=$show_completed,\n" \
"                description=$description,\n" \
"                due_date=$due_date,\n" \
"                inbox_section_hidded=$inbox_section_hidded,\n" \
"                sync_id=$sync_id\n" \
"            WHERE id=$id;\n" \
"        ");
#line 641 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 641 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 667 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 667 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 667 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 667 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 667 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 667 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 667 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 667 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 668 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 668 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_name ((ObjectsBaseObject*) project);
#line 668 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 668 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$name", _tmp9_);
#line 669 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 669 "../core/Services/Database.vala"
	_tmp11_ = objects_project_get_color (project);
#line 669 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 669 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$color", _tmp12_);
#line 670 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 670 "../core/Services/Database.vala"
	_tmp14_ = objects_project_get_backend_type (project);
#line 670 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 670 "../core/Services/Database.vala"
	_tmp16_ = backend_type_to_string (_tmp15_);
#line 670 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 670 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$backend_type", _tmp17_);
#line 670 "../core/Services/Database.vala"
	_g_free0 (_tmp17_);
#line 671 "../core/Services/Database.vala"
	_tmp18_ = stmt;
#line 671 "../core/Services/Database.vala"
	_tmp19_ = objects_project_get_inbox_project (project);
#line 671 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 671 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp18_, "$inbox_project", _tmp20_);
#line 672 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 672 "../core/Services/Database.vala"
	_tmp22_ = objects_project_get_team_inbox (project);
#line 672 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 672 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp21_, "$team_inbox", _tmp23_);
#line 673 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 673 "../core/Services/Database.vala"
	_tmp25_ = objects_project_get_child_order (project);
#line 673 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 673 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp24_, "$child_order", _tmp26_);
#line 674 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 674 "../core/Services/Database.vala"
	_tmp28_ = objects_project_get_is_deleted (project);
#line 674 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 674 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp27_, "$is_deleted", _tmp29_);
#line 675 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 675 "../core/Services/Database.vala"
	_tmp31_ = objects_project_get_is_archived (project);
#line 675 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 675 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp30_, "$is_archived", _tmp32_);
#line 676 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 676 "../core/Services/Database.vala"
	_tmp34_ = objects_project_get_is_favorite (project);
#line 676 "../core/Services/Database.vala"
	_tmp35_ = _tmp34_;
#line 676 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp33_, "$is_favorite", _tmp35_);
#line 677 "../core/Services/Database.vala"
	_tmp36_ = stmt;
#line 677 "../core/Services/Database.vala"
	_tmp37_ = objects_project_get_shared (project);
#line 677 "../core/Services/Database.vala"
	_tmp38_ = _tmp37_;
#line 677 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp36_, "$shared", _tmp38_);
#line 678 "../core/Services/Database.vala"
	_tmp39_ = stmt;
#line 678 "../core/Services/Database.vala"
	_tmp40_ = objects_project_get_view_style (project);
#line 678 "../core/Services/Database.vala"
	_tmp41_ = _tmp40_;
#line 678 "../core/Services/Database.vala"
	_tmp42_ = project_view_style_to_string (_tmp41_);
#line 678 "../core/Services/Database.vala"
	_tmp43_ = _tmp42_;
#line 678 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp39_, "$view_style", _tmp43_);
#line 678 "../core/Services/Database.vala"
	_g_free0 (_tmp43_);
#line 679 "../core/Services/Database.vala"
	_tmp44_ = stmt;
#line 679 "../core/Services/Database.vala"
	_tmp45_ = objects_project_get_sort_order (project);
#line 679 "../core/Services/Database.vala"
	_tmp46_ = _tmp45_;
#line 679 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp44_, "$sort_order", _tmp46_);
#line 680 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 680 "../core/Services/Database.vala"
	_tmp48_ = objects_project_get_parent_id (project);
#line 680 "../core/Services/Database.vala"
	_tmp49_ = _tmp48_;
#line 680 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp47_, "$parent_id", _tmp49_);
#line 681 "../core/Services/Database.vala"
	_tmp50_ = stmt;
#line 681 "../core/Services/Database.vala"
	_tmp51_ = objects_project_get_collapsed (project);
#line 681 "../core/Services/Database.vala"
	_tmp52_ = _tmp51_;
#line 681 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp50_, "$collapsed", _tmp52_);
#line 682 "../core/Services/Database.vala"
	_tmp53_ = stmt;
#line 682 "../core/Services/Database.vala"
	_tmp54_ = objects_project_get_icon_style (project);
#line 682 "../core/Services/Database.vala"
	_tmp55_ = _tmp54_;
#line 682 "../core/Services/Database.vala"
	_tmp56_ = project_icon_style_to_string (_tmp55_);
#line 682 "../core/Services/Database.vala"
	_tmp57_ = _tmp56_;
#line 682 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp53_, "$icon_style", _tmp57_);
#line 682 "../core/Services/Database.vala"
	_g_free0 (_tmp57_);
#line 683 "../core/Services/Database.vala"
	_tmp58_ = stmt;
#line 683 "../core/Services/Database.vala"
	_tmp59_ = objects_project_get_emoji (project);
#line 683 "../core/Services/Database.vala"
	_tmp60_ = _tmp59_;
#line 683 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp58_, "$emoji", _tmp60_);
#line 684 "../core/Services/Database.vala"
	_tmp61_ = stmt;
#line 684 "../core/Services/Database.vala"
	_tmp62_ = objects_project_get_show_completed (project);
#line 684 "../core/Services/Database.vala"
	_tmp63_ = _tmp62_;
#line 684 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp61_, "$show_completed", _tmp63_);
#line 685 "../core/Services/Database.vala"
	_tmp64_ = stmt;
#line 685 "../core/Services/Database.vala"
	_tmp65_ = objects_project_get_description (project);
#line 685 "../core/Services/Database.vala"
	_tmp66_ = _tmp65_;
#line 685 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp64_, "$description", _tmp66_);
#line 686 "../core/Services/Database.vala"
	_tmp67_ = stmt;
#line 686 "../core/Services/Database.vala"
	_tmp68_ = objects_project_get_due_date (project);
#line 686 "../core/Services/Database.vala"
	_tmp69_ = _tmp68_;
#line 686 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp67_, "$due_date", _tmp69_);
#line 687 "../core/Services/Database.vala"
	_tmp70_ = stmt;
#line 687 "../core/Services/Database.vala"
	_tmp71_ = objects_project_get_inbox_section_hidded (project);
#line 687 "../core/Services/Database.vala"
	_tmp72_ = _tmp71_;
#line 687 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp70_, "$inbox_section_hidded", _tmp72_);
#line 688 "../core/Services/Database.vala"
	_tmp73_ = stmt;
#line 688 "../core/Services/Database.vala"
	_tmp74_ = objects_project_get_sync_id (project);
#line 688 "../core/Services/Database.vala"
	_tmp75_ = _tmp74_;
#line 688 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp73_, "$sync_id", _tmp75_);
#line 689 "../core/Services/Database.vala"
	_tmp76_ = stmt;
#line 689 "../core/Services/Database.vala"
	_tmp77_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 689 "../core/Services/Database.vala"
	_tmp78_ = _tmp77_;
#line 689 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp76_, "$id", _tmp78_);
#line 691 "../core/Services/Database.vala"
	_tmp79_ = stmt;
#line 691 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp79_) == SQLITE_DONE) {
#line 692 "../core/Services/Database.vala"
		g_signal_emit_by_name ((ObjectsBaseObject*) project, "updated");
#line 693 "../core/Services/Database.vala"
		g_signal_emit (self, services_database_signals[SERVICES_DATABASE_PROJECT_UPDATED_SIGNAL], 0, project);
#line 2896 "Database.c"
	} else {
		sqlite3* _tmp80_;
		sqlite3* _tmp81_;
		const gchar* _tmp82_;
#line 695 "../core/Services/Database.vala"
		_tmp80_ = self->priv->db;
#line 695 "../core/Services/Database.vala"
		_tmp81_ = self->priv->db;
#line 695 "../core/Services/Database.vala"
		_tmp82_ = sqlite3_errmsg (_tmp81_);
#line 695 "../core/Services/Database.vala"
		g_warning ("Database.vala:695: Error: %d: %s", sqlite3_errcode (_tmp80_), _tmp82_);
#line 2909 "Database.c"
	}
#line 698 "../core/Services/Database.vala"
	_tmp83_ = stmt;
#line 698 "../core/Services/Database.vala"
	sqlite3_reset (_tmp83_);
#line 638 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2917 "Database.c"
}

GeeArrayList*
services_database_get_labels_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp13_;
	GeeArrayList* result;
#line 705 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 706 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_LABEL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 706 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 709 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n            SELECT * FROM Labels;\n        ");
#line 709 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 709 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 713 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 713 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 713 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 713 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 713 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 713 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 713 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 713 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 715 "../core/Services/Database.vala"
	while (TRUE) {
#line 2965 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsLabel* _tmp11_;
		ObjectsLabel* _tmp12_;
#line 715 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 715 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 715 "../core/Services/Database.vala"
			break;
#line 2977 "Database.c"
		}
#line 716 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 716 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 716 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_label (self, _tmp10_);
#line 716 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 716 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 716 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 2991 "Database.c"
	}
#line 718 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 718 "../core/Services/Database.vala"
	sqlite3_reset (_tmp13_);
#line 719 "../core/Services/Database.vala"
	result = return_value;
#line 719 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 719 "../core/Services/Database.vala"
	return result;
#line 3003 "Database.c"
}

GeeArrayList*
services_database_get_labels_by_backend_type (ServicesDatabase* self,
                                              BackendType backend_type)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 722 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 723 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_LABEL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 723 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 3020 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 724 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_labels;
#line 724 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__labels);
#line 3027 "Database.c"
		{
			GeeArrayList* _tmp17_;
			GeeArrayList* _tmp18_;
			{
				GeeArrayList* _label_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _label_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _label_index = 0;
#line 725 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_labels (self);
#line 725 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 725 "../core/Services/Database.vala"
				_label_list = _tmp3_;
#line 725 "../core/Services/Database.vala"
				_tmp4_ = _label_list;
#line 725 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 725 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 725 "../core/Services/Database.vala"
				_label_size = _tmp6_;
#line 725 "../core/Services/Database.vala"
				_label_index = -1;
#line 725 "../core/Services/Database.vala"
				while (TRUE) {
#line 3058 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
#line 725 "../core/Services/Database.vala"
					_label_index = _label_index + 1;
#line 725 "../core/Services/Database.vala"
					_tmp7_ = _label_index;
#line 725 "../core/Services/Database.vala"
					_tmp8_ = _label_size;
#line 725 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 725 "../core/Services/Database.vala"
						break;
#line 3075 "Database.c"
					}
#line 725 "../core/Services/Database.vala"
					_tmp9_ = _label_list;
#line 725 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _label_index);
#line 725 "../core/Services/Database.vala"
					label = (ObjectsLabel*) _tmp10_;
#line 726 "../core/Services/Database.vala"
					if (backend_type == BACKEND_TYPE_ALL) {
#line 726 "../core/Services/Database.vala"
						_tmp11_ = TRUE;
#line 3087 "Database.c"
					} else {
						ObjectsLabel* _tmp12_;
						BackendType _tmp13_;
						BackendType _tmp14_;
#line 726 "../core/Services/Database.vala"
						_tmp12_ = label;
#line 726 "../core/Services/Database.vala"
						_tmp13_ = objects_label_get_backend_type (_tmp12_);
#line 726 "../core/Services/Database.vala"
						_tmp14_ = _tmp13_;
#line 726 "../core/Services/Database.vala"
						_tmp11_ = _tmp14_ == backend_type;
#line 3100 "Database.c"
					}
#line 726 "../core/Services/Database.vala"
					if (_tmp11_) {
#line 3104 "Database.c"
						GeeArrayList* _tmp15_;
						ObjectsLabel* _tmp16_;
#line 727 "../core/Services/Database.vala"
						_tmp15_ = return_value;
#line 727 "../core/Services/Database.vala"
						_tmp16_ = label;
#line 727 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 3113 "Database.c"
					}
#line 725 "../core/Services/Database.vala"
					_g_object_unref0 (label);
#line 3117 "Database.c"
				}
			}
#line 731 "../core/Services/Database.vala"
			_tmp17_ = return_value;
#line 731 "../core/Services/Database.vala"
			_tmp18_ = _g_object_ref0 (_tmp17_);
#line 731 "../core/Services/Database.vala"
			result = _tmp18_;
#line 3126 "Database.c"
			{
				GeeArrayList* _tmp19_;
#line 724 "../core/Services/Database.vala"
				_tmp19_ = self->priv->_labels;
#line 724 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 3133 "Database.c"
			}
#line 731 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 731 "../core/Services/Database.vala"
			return result;
#line 3139 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp20_;
#line 724 "../core/Services/Database.vala"
			_tmp20_ = self->priv->_labels;
#line 724 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 3148 "Database.c"
		}
#line 724 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 724 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 724 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 724 "../core/Services/Database.vala"
		return NULL;
#line 3158 "Database.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1549 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1549 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1550 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1550 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1550 "glib-2.0.vapi"
	return result;
#line 3178 "Database.c"
}

GeeArrayList*
services_database_get_all_labels_by_search (ServicesDatabase* self,
                                            const gchar* search_text)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 735 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 735 "../core/Services/Database.vala"
	g_return_val_if_fail (search_text != NULL, NULL);
#line 736 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_LABEL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 736 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 3197 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 737 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_labels;
#line 737 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__labels);
#line 3204 "Database.c"
		{
			GeeArrayList* _tmp21_;
			GeeArrayList* _tmp22_;
			{
				GeeArrayList* _label_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _label_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _label_index = 0;
#line 738 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_labels (self);
#line 738 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 738 "../core/Services/Database.vala"
				_label_list = _tmp3_;
#line 738 "../core/Services/Database.vala"
				_tmp4_ = _label_list;
#line 738 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 738 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 738 "../core/Services/Database.vala"
				_label_size = _tmp6_;
#line 738 "../core/Services/Database.vala"
				_label_index = -1;
#line 738 "../core/Services/Database.vala"
				while (TRUE) {
#line 3235 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsLabel* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gboolean _tmp18_;
#line 738 "../core/Services/Database.vala"
					_label_index = _label_index + 1;
#line 738 "../core/Services/Database.vala"
					_tmp7_ = _label_index;
#line 738 "../core/Services/Database.vala"
					_tmp8_ = _label_size;
#line 738 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 738 "../core/Services/Database.vala"
						break;
#line 3259 "Database.c"
					}
#line 738 "../core/Services/Database.vala"
					_tmp9_ = _label_list;
#line 738 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _label_index);
#line 738 "../core/Services/Database.vala"
					label = (ObjectsLabel*) _tmp10_;
#line 739 "../core/Services/Database.vala"
					_tmp11_ = label;
#line 739 "../core/Services/Database.vala"
					_tmp12_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp11_);
#line 739 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 739 "../core/Services/Database.vala"
					_tmp14_ = g_utf8_strdown (_tmp13_, (gssize) -1);
#line 739 "../core/Services/Database.vala"
					_tmp15_ = _tmp14_;
#line 739 "../core/Services/Database.vala"
					_tmp16_ = g_utf8_strdown (search_text, (gssize) -1);
#line 739 "../core/Services/Database.vala"
					_tmp17_ = _tmp16_;
#line 739 "../core/Services/Database.vala"
					_tmp18_ = string_contains (_tmp15_, _tmp17_);
#line 739 "../core/Services/Database.vala"
					_g_free0 (_tmp17_);
#line 739 "../core/Services/Database.vala"
					_g_free0 (_tmp15_);
#line 739 "../core/Services/Database.vala"
					if (_tmp18_) {
#line 3289 "Database.c"
						GeeArrayList* _tmp19_;
						ObjectsLabel* _tmp20_;
#line 740 "../core/Services/Database.vala"
						_tmp19_ = return_value;
#line 740 "../core/Services/Database.vala"
						_tmp20_ = label;
#line 740 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp20_);
#line 3298 "Database.c"
					}
#line 738 "../core/Services/Database.vala"
					_g_object_unref0 (label);
#line 3302 "Database.c"
				}
			}
#line 744 "../core/Services/Database.vala"
			_tmp21_ = return_value;
#line 744 "../core/Services/Database.vala"
			_tmp22_ = _g_object_ref0 (_tmp21_);
#line 744 "../core/Services/Database.vala"
			result = _tmp22_;
#line 3311 "Database.c"
			{
				GeeArrayList* _tmp23_;
#line 737 "../core/Services/Database.vala"
				_tmp23_ = self->priv->_labels;
#line 737 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 3318 "Database.c"
			}
#line 744 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 744 "../core/Services/Database.vala"
			return result;
#line 3324 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp24_;
#line 737 "../core/Services/Database.vala"
			_tmp24_ = self->priv->_labels;
#line 737 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 3333 "Database.c"
		}
#line 737 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 737 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 737 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 737 "../core/Services/Database.vala"
		return NULL;
#line 3343 "Database.c"
	}
}

ObjectsLabel*
_services_database_fill_label (ServicesDatabase* self,
                               sqlite3_stmt* stmt)
{
	ObjectsLabel* return_value = NULL;
	ObjectsLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	ObjectsLabel* result;
#line 748 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 748 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 749 "../core/Services/Database.vala"
	_tmp0_ = objects_label_new ();
#line 749 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 750 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 750 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 751 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 751 "../core/Services/Database.vala"
	objects_base_object_set_name ((ObjectsBaseObject*) return_value, _tmp2_);
#line 752 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 752 "../core/Services/Database.vala"
	objects_label_set_color (return_value, _tmp3_);
#line 753 "../core/Services/Database.vala"
	objects_label_set_item_order (return_value, sqlite3_column_int (stmt, 3));
#line 754 "../core/Services/Database.vala"
	objects_label_set_is_deleted (return_value, services_database_get_parameter_bool (self, stmt, 4));
#line 755 "../core/Services/Database.vala"
	objects_label_set_is_favorite (return_value, services_database_get_parameter_bool (self, stmt, 5));
#line 756 "../core/Services/Database.vala"
	objects_label_set_backend_type (return_value, services_database_get_backend_type_by_text (self, stmt, 6));
#line 757 "../core/Services/Database.vala"
	result = return_value;
#line 757 "../core/Services/Database.vala"
	return result;
#line 3389 "Database.c"
}

gboolean
services_database_insert_label (ServicesDatabase* self,
                                ObjectsLabel* label)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	sqlite3_stmt* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	sqlite3_stmt* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	sqlite3_stmt* _tmp25_;
	BackendType _tmp26_;
	BackendType _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	sqlite3_stmt* _tmp30_;
	sqlite3_stmt* _tmp36_;
	sqlite3_stmt* _tmp37_;
	gboolean result;
#line 760 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 760 "../core/Services/Database.vala"
	g_return_val_if_fail (label != NULL, FALSE);
#line 763 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Labels (id, name, color, item_order," \
" is_deleted, is_favorite, backend_type)\n" \
"            VALUES ($id, $name, $color, $item_order, $is_deleted, $is_" \
"favorite, $backend_type);\n" \
"        ");
#line 763 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 763 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 768 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 768 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 768 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 768 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 768 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 768 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 768 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 768 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 769 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 769 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
#line 769 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 769 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 770 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 770 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_name ((ObjectsBaseObject*) label);
#line 770 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 770 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$name", _tmp12_);
#line 771 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 771 "../core/Services/Database.vala"
	_tmp14_ = objects_label_get_color (label);
#line 771 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 771 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$color", _tmp15_);
#line 772 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 772 "../core/Services/Database.vala"
	_tmp17_ = objects_label_get_item_order (label);
#line 772 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 772 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp16_, "$item_order", _tmp18_);
#line 773 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 773 "../core/Services/Database.vala"
	_tmp20_ = objects_label_get_is_deleted (label);
#line 773 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 773 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp19_, "$is_deleted", _tmp21_);
#line 774 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 774 "../core/Services/Database.vala"
	_tmp23_ = objects_label_get_is_favorite (label);
#line 774 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 774 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp22_, "$is_favorite", _tmp24_);
#line 775 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 775 "../core/Services/Database.vala"
	_tmp26_ = objects_label_get_backend_type (label);
#line 775 "../core/Services/Database.vala"
	_tmp27_ = _tmp26_;
#line 775 "../core/Services/Database.vala"
	_tmp28_ = backend_type_to_string (_tmp27_);
#line 775 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 775 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp25_, "$backend_type", _tmp29_);
#line 775 "../core/Services/Database.vala"
	_g_free0 (_tmp29_);
#line 777 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 777 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp30_) == SQLITE_DONE) {
#line 3523 "Database.c"
		GeeArrayList* _tmp31_;
		GeeArrayList* _tmp32_;
#line 778 "../core/Services/Database.vala"
		_tmp31_ = services_database_get_labels (self);
#line 778 "../core/Services/Database.vala"
		_tmp32_ = _tmp31_;
#line 778 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, label);
#line 779 "../core/Services/Database.vala"
		g_signal_emit (self, services_database_signals[SERVICES_DATABASE_LABEL_ADDED_SIGNAL], 0, label);
#line 3534 "Database.c"
	} else {
		sqlite3* _tmp33_;
		sqlite3* _tmp34_;
		const gchar* _tmp35_;
#line 781 "../core/Services/Database.vala"
		_tmp33_ = self->priv->db;
#line 781 "../core/Services/Database.vala"
		_tmp34_ = self->priv->db;
#line 781 "../core/Services/Database.vala"
		_tmp35_ = sqlite3_errmsg (_tmp34_);
#line 781 "../core/Services/Database.vala"
		g_warning ("Database.vala:781: Error: %d: %s", sqlite3_errcode (_tmp33_), _tmp35_);
#line 3547 "Database.c"
	}
#line 784 "../core/Services/Database.vala"
	_tmp36_ = stmt;
#line 784 "../core/Services/Database.vala"
	sqlite3_reset (_tmp36_);
#line 785 "../core/Services/Database.vala"
	_tmp37_ = stmt;
#line 785 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp37_) == SQLITE_DONE;
#line 785 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 785 "../core/Services/Database.vala"
	return result;
#line 3561 "Database.c"
}

gboolean
services_database_label_exists (ServicesDatabase* self,
                                const gchar* id)
{
	gboolean return_value = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 788 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 788 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, FALSE);
#line 789 "../core/Services/Database.vala"
	return_value = FALSE;
#line 3577 "Database.c"
	{
		GeeArrayList* _tmp0_;
		gboolean _tmp14_ = FALSE;
#line 790 "../core/Services/Database.vala"
		_tmp0_ = self->priv->_labels;
#line 790 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__labels);
#line 3585 "Database.c"
		{
			{
				GeeArrayList* _label_list = NULL;
				GeeArrayList* _tmp1_;
				gint _label_size = 0;
				GeeArrayList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _label_index = 0;
#line 791 "../core/Services/Database.vala"
				_tmp1_ = self->priv->_labels;
#line 791 "../core/Services/Database.vala"
				_label_list = _tmp1_;
#line 791 "../core/Services/Database.vala"
				_tmp2_ = _label_list;
#line 791 "../core/Services/Database.vala"
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 791 "../core/Services/Database.vala"
				_tmp4_ = _tmp3_;
#line 791 "../core/Services/Database.vala"
				_label_size = _tmp4_;
#line 791 "../core/Services/Database.vala"
				_label_index = -1;
#line 791 "../core/Services/Database.vala"
				while (TRUE) {
#line 3611 "Database.c"
					gint _tmp5_;
					gint _tmp6_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp7_;
					gpointer _tmp8_;
					ObjectsLabel* _tmp9_;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
#line 791 "../core/Services/Database.vala"
					_label_index = _label_index + 1;
#line 791 "../core/Services/Database.vala"
					_tmp5_ = _label_index;
#line 791 "../core/Services/Database.vala"
					_tmp6_ = _label_size;
#line 791 "../core/Services/Database.vala"
					if (!(_tmp5_ < _tmp6_)) {
#line 791 "../core/Services/Database.vala"
						break;
#line 3630 "Database.c"
					}
#line 791 "../core/Services/Database.vala"
					_tmp7_ = _label_list;
#line 791 "../core/Services/Database.vala"
					_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _label_index);
#line 791 "../core/Services/Database.vala"
					label = (ObjectsLabel*) _tmp8_;
#line 792 "../core/Services/Database.vala"
					_tmp9_ = label;
#line 792 "../core/Services/Database.vala"
					_tmp10_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp9_);
#line 792 "../core/Services/Database.vala"
					_tmp11_ = _tmp10_;
#line 792 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp11_, id) == 0) {
#line 793 "../core/Services/Database.vala"
						return_value = TRUE;
#line 794 "../core/Services/Database.vala"
						_g_object_unref0 (label);
#line 794 "../core/Services/Database.vala"
						break;
#line 3652 "Database.c"
					}
#line 791 "../core/Services/Database.vala"
					_g_object_unref0 (label);
#line 3656 "Database.c"
				}
			}
#line 798 "../core/Services/Database.vala"
			result = return_value;
#line 3661 "Database.c"
			{
				GeeArrayList* _tmp12_;
#line 790 "../core/Services/Database.vala"
				_tmp12_ = self->priv->_labels;
#line 790 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 3668 "Database.c"
			}
#line 798 "../core/Services/Database.vala"
			return result;
#line 3672 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp13_;
#line 790 "../core/Services/Database.vala"
			_tmp13_ = self->priv->_labels;
#line 790 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 3681 "Database.c"
		}
#line 790 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 790 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 790 "../core/Services/Database.vala"
		return _tmp14_;
#line 3689 "Database.c"
	}
}

ObjectsLabel*
services_database_get_label (ServicesDatabase* self,
                             const gchar* id)
{
	ObjectsLabel* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsLabel* result;
#line 802 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 802 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 803 "../core/Services/Database.vala"
	return_value = NULL;
#line 3706 "Database.c"
	{
		GeeArrayList* _tmp0_;
#line 804 "../core/Services/Database.vala"
		_tmp0_ = self->priv->_labels;
#line 804 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__labels);
#line 3713 "Database.c"
		{
			ObjectsLabel* _tmp15_;
			ObjectsLabel* _tmp16_;
			{
				GeeArrayList* _label_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _label_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _label_index = 0;
#line 805 "../core/Services/Database.vala"
				_tmp1_ = services_database_get_labels (self);
#line 805 "../core/Services/Database.vala"
				_tmp2_ = _tmp1_;
#line 805 "../core/Services/Database.vala"
				_label_list = _tmp2_;
#line 805 "../core/Services/Database.vala"
				_tmp3_ = _label_list;
#line 805 "../core/Services/Database.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 805 "../core/Services/Database.vala"
				_tmp5_ = _tmp4_;
#line 805 "../core/Services/Database.vala"
				_label_size = _tmp5_;
#line 805 "../core/Services/Database.vala"
				_label_index = -1;
#line 805 "../core/Services/Database.vala"
				while (TRUE) {
#line 3744 "Database.c"
					gint _tmp6_;
					gint _tmp7_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsLabel* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
#line 805 "../core/Services/Database.vala"
					_label_index = _label_index + 1;
#line 805 "../core/Services/Database.vala"
					_tmp6_ = _label_index;
#line 805 "../core/Services/Database.vala"
					_tmp7_ = _label_size;
#line 805 "../core/Services/Database.vala"
					if (!(_tmp6_ < _tmp7_)) {
#line 805 "../core/Services/Database.vala"
						break;
#line 3763 "Database.c"
					}
#line 805 "../core/Services/Database.vala"
					_tmp8_ = _label_list;
#line 805 "../core/Services/Database.vala"
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _label_index);
#line 805 "../core/Services/Database.vala"
					label = (ObjectsLabel*) _tmp9_;
#line 806 "../core/Services/Database.vala"
					_tmp10_ = label;
#line 806 "../core/Services/Database.vala"
					_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp10_);
#line 806 "../core/Services/Database.vala"
					_tmp12_ = _tmp11_;
#line 806 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp12_, id) == 0) {
#line 3779 "Database.c"
						ObjectsLabel* _tmp13_;
						ObjectsLabel* _tmp14_;
#line 807 "../core/Services/Database.vala"
						_tmp13_ = label;
#line 807 "../core/Services/Database.vala"
						_tmp14_ = _g_object_ref0 (_tmp13_);
#line 807 "../core/Services/Database.vala"
						_g_object_unref0 (return_value);
#line 807 "../core/Services/Database.vala"
						return_value = _tmp14_;
#line 808 "../core/Services/Database.vala"
						_g_object_unref0 (label);
#line 808 "../core/Services/Database.vala"
						break;
#line 3794 "Database.c"
					}
#line 805 "../core/Services/Database.vala"
					_g_object_unref0 (label);
#line 3798 "Database.c"
				}
			}
#line 812 "../core/Services/Database.vala"
			_tmp15_ = return_value;
#line 812 "../core/Services/Database.vala"
			_tmp16_ = _g_object_ref0 (_tmp15_);
#line 812 "../core/Services/Database.vala"
			result = _tmp16_;
#line 3807 "Database.c"
			{
				GeeArrayList* _tmp17_;
#line 804 "../core/Services/Database.vala"
				_tmp17_ = self->priv->_labels;
#line 804 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 3814 "Database.c"
			}
#line 812 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 812 "../core/Services/Database.vala"
			return result;
#line 3820 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
#line 804 "../core/Services/Database.vala"
			_tmp18_ = self->priv->_labels;
#line 804 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 3829 "Database.c"
		}
#line 804 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 804 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 804 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 804 "../core/Services/Database.vala"
		return NULL;
#line 3839 "Database.c"
	}
}

ObjectsLabel*
services_database_get_label_by_name (ServicesDatabase* self,
                                     const gchar* name,
                                     gboolean lowercase,
                                     BackendType backend_type)
{
	GError* _inner_error0_ = NULL;
	ObjectsLabel* result;
#line 816 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 816 "../core/Services/Database.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 3855 "Database.c"
	{
		GeeArrayList* _tmp0_;
#line 817 "../core/Services/Database.vala"
		_tmp0_ = self->priv->_labels;
#line 817 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__labels);
#line 3862 "Database.c"
		{
			gchar* _tmp1_ = NULL;
			gchar* compare_name = NULL;
			gchar* _tmp4_;
#line 818 "../core/Services/Database.vala"
			if (lowercase) {
#line 3869 "Database.c"
				gchar* _tmp2_;
#line 818 "../core/Services/Database.vala"
				_tmp2_ = g_utf8_strdown (name, (gssize) -1);
#line 818 "../core/Services/Database.vala"
				_g_free0 (_tmp1_);
#line 818 "../core/Services/Database.vala"
				_tmp1_ = _tmp2_;
#line 3877 "Database.c"
			} else {
				gchar* _tmp3_;
#line 818 "../core/Services/Database.vala"
				_tmp3_ = g_strdup (name);
#line 818 "../core/Services/Database.vala"
				_g_free0 (_tmp1_);
#line 818 "../core/Services/Database.vala"
				_tmp1_ = _tmp3_;
#line 3886 "Database.c"
			}
#line 818 "../core/Services/Database.vala"
			_tmp4_ = g_strdup (_tmp1_);
#line 818 "../core/Services/Database.vala"
			compare_name = _tmp4_;
#line 3892 "Database.c"
			{
				GeeArrayList* _label_list = NULL;
				GeeArrayList* _tmp5_;
				GeeArrayList* _tmp6_;
				gint _label_size = 0;
				GeeArrayList* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				gint _label_index = 0;
#line 820 "../core/Services/Database.vala"
				_tmp5_ = services_database_get_labels (self);
#line 820 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 820 "../core/Services/Database.vala"
				_label_list = _tmp6_;
#line 820 "../core/Services/Database.vala"
				_tmp7_ = _label_list;
#line 820 "../core/Services/Database.vala"
				_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 820 "../core/Services/Database.vala"
				_tmp9_ = _tmp8_;
#line 820 "../core/Services/Database.vala"
				_label_size = _tmp9_;
#line 820 "../core/Services/Database.vala"
				_label_index = -1;
#line 820 "../core/Services/Database.vala"
				while (TRUE) {
#line 3920 "Database.c"
					gint _tmp10_;
					gint _tmp11_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp12_;
					gpointer _tmp13_;
					gchar* _tmp14_ = NULL;
					gchar* label_name = NULL;
					gchar* _tmp23_;
					gboolean _tmp24_ = FALSE;
					ObjectsLabel* _tmp25_;
					BackendType _tmp26_;
					BackendType _tmp27_;
#line 820 "../core/Services/Database.vala"
					_label_index = _label_index + 1;
#line 820 "../core/Services/Database.vala"
					_tmp10_ = _label_index;
#line 820 "../core/Services/Database.vala"
					_tmp11_ = _label_size;
#line 820 "../core/Services/Database.vala"
					if (!(_tmp10_ < _tmp11_)) {
#line 820 "../core/Services/Database.vala"
						break;
#line 3943 "Database.c"
					}
#line 820 "../core/Services/Database.vala"
					_tmp12_ = _label_list;
#line 820 "../core/Services/Database.vala"
					_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _label_index);
#line 820 "../core/Services/Database.vala"
					label = (ObjectsLabel*) _tmp13_;
#line 821 "../core/Services/Database.vala"
					if (lowercase) {
#line 3953 "Database.c"
						ObjectsLabel* _tmp15_;
						const gchar* _tmp16_;
						const gchar* _tmp17_;
						gchar* _tmp18_;
#line 821 "../core/Services/Database.vala"
						_tmp15_ = label;
#line 821 "../core/Services/Database.vala"
						_tmp16_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp15_);
#line 821 "../core/Services/Database.vala"
						_tmp17_ = _tmp16_;
#line 821 "../core/Services/Database.vala"
						_tmp18_ = g_utf8_strdown (_tmp17_, (gssize) -1);
#line 821 "../core/Services/Database.vala"
						_g_free0 (_tmp14_);
#line 821 "../core/Services/Database.vala"
						_tmp14_ = _tmp18_;
#line 3970 "Database.c"
					} else {
						ObjectsLabel* _tmp19_;
						const gchar* _tmp20_;
						const gchar* _tmp21_;
						gchar* _tmp22_;
#line 821 "../core/Services/Database.vala"
						_tmp19_ = label;
#line 821 "../core/Services/Database.vala"
						_tmp20_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp19_);
#line 821 "../core/Services/Database.vala"
						_tmp21_ = _tmp20_;
#line 821 "../core/Services/Database.vala"
						_tmp22_ = g_strdup (_tmp21_);
#line 821 "../core/Services/Database.vala"
						_g_free0 (_tmp14_);
#line 821 "../core/Services/Database.vala"
						_tmp14_ = _tmp22_;
#line 3988 "Database.c"
					}
#line 821 "../core/Services/Database.vala"
					_tmp23_ = g_strdup (_tmp14_);
#line 821 "../core/Services/Database.vala"
					label_name = _tmp23_;
#line 822 "../core/Services/Database.vala"
					_tmp25_ = label;
#line 822 "../core/Services/Database.vala"
					_tmp26_ = objects_label_get_backend_type (_tmp25_);
#line 822 "../core/Services/Database.vala"
					_tmp27_ = _tmp26_;
#line 822 "../core/Services/Database.vala"
					if (_tmp27_ == backend_type) {
#line 4002 "Database.c"
						const gchar* _tmp28_;
						const gchar* _tmp29_;
#line 822 "../core/Services/Database.vala"
						_tmp28_ = label_name;
#line 822 "../core/Services/Database.vala"
						_tmp29_ = compare_name;
#line 822 "../core/Services/Database.vala"
						_tmp24_ = g_strcmp0 (_tmp28_, _tmp29_) == 0;
#line 4011 "Database.c"
					} else {
#line 822 "../core/Services/Database.vala"
						_tmp24_ = FALSE;
#line 4015 "Database.c"
					}
#line 822 "../core/Services/Database.vala"
					if (_tmp24_) {
#line 823 "../core/Services/Database.vala"
						result = label;
#line 823 "../core/Services/Database.vala"
						_g_free0 (label_name);
#line 823 "../core/Services/Database.vala"
						_g_free0 (_tmp14_);
#line 823 "../core/Services/Database.vala"
						_g_free0 (compare_name);
#line 823 "../core/Services/Database.vala"
						_g_free0 (_tmp1_);
#line 4029 "Database.c"
						{
							GeeArrayList* _tmp30_;
#line 817 "../core/Services/Database.vala"
							_tmp30_ = self->priv->_labels;
#line 817 "../core/Services/Database.vala"
							g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 4036 "Database.c"
						}
#line 823 "../core/Services/Database.vala"
						return result;
#line 4040 "Database.c"
					}
#line 820 "../core/Services/Database.vala"
					_g_free0 (label_name);
#line 820 "../core/Services/Database.vala"
					_g_free0 (_tmp14_);
#line 820 "../core/Services/Database.vala"
					_g_object_unref0 (label);
#line 4048 "Database.c"
				}
			}
#line 827 "../core/Services/Database.vala"
			result = NULL;
#line 827 "../core/Services/Database.vala"
			_g_free0 (compare_name);
#line 827 "../core/Services/Database.vala"
			_g_free0 (_tmp1_);
#line 4057 "Database.c"
			{
				GeeArrayList* _tmp31_;
#line 817 "../core/Services/Database.vala"
				_tmp31_ = self->priv->_labels;
#line 817 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 4064 "Database.c"
			}
#line 827 "../core/Services/Database.vala"
			return result;
#line 4068 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp32_;
#line 817 "../core/Services/Database.vala"
			_tmp32_ = self->priv->_labels;
#line 817 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 4077 "Database.c"
		}
#line 817 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 817 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 817 "../core/Services/Database.vala"
		return NULL;
#line 4085 "Database.c"
	}
}

void
services_database_delete_label (ServicesDatabase* self,
                                ObjectsLabel* label)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
#line 831 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 831 "../core/Services/Database.vala"
	g_return_if_fail (label != NULL);
#line 834 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Labels WHERE id=$id;\n        ");
#line 834 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 834 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 838 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 838 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 838 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 838 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 838 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 838 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 838 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 838 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 839 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 839 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
#line 839 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 839 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 841 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 841 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) == SQLITE_DONE) {
#line 842 "../core/Services/Database.vala"
		g_signal_emit_by_name ((ObjectsBaseObject*) label, "deleted");
#line 4146 "Database.c"
	} else {
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 844 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 844 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 844 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 844 "../core/Services/Database.vala"
		g_warning ("Database.vala:844: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 4159 "Database.c"
	}
#line 847 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 847 "../core/Services/Database.vala"
	sqlite3_reset (_tmp14_);
#line 831 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 4167 "Database.c"
}

void
services_database_update_label (ServicesDatabase* self,
                                ObjectsLabel* label)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	sqlite3_stmt* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	sqlite3_stmt* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	sqlite3_stmt* _tmp22_;
	BackendType _tmp23_;
	BackendType _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	sqlite3_stmt* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	sqlite3_stmt* _tmp30_;
	sqlite3_stmt* _tmp34_;
#line 850 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 850 "../core/Services/Database.vala"
	g_return_if_fail (label != NULL);
#line 853 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Labels SET name=$name, color=$color, item_order=$it" \
"em_order,\n" \
"                is_deleted=$is_deleted, is_favorite=$is_favorite, back" \
"end_type=$backend_type\n" \
"            WHERE id=$id;\n" \
"        ");
#line 853 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 853 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 859 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 859 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 859 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 859 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 859 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 859 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 859 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 859 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 860 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 860 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_name ((ObjectsBaseObject*) label);
#line 860 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 860 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$name", _tmp9_);
#line 861 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 861 "../core/Services/Database.vala"
	_tmp11_ = objects_label_get_color (label);
#line 861 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 861 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$color", _tmp12_);
#line 862 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 862 "../core/Services/Database.vala"
	_tmp14_ = objects_label_get_item_order (label);
#line 862 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 862 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp13_, "$item_order", _tmp15_);
#line 863 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 863 "../core/Services/Database.vala"
	_tmp17_ = objects_label_get_is_deleted (label);
#line 863 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 863 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp16_, "$is_deleted", _tmp18_);
#line 864 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 864 "../core/Services/Database.vala"
	_tmp20_ = objects_label_get_is_favorite (label);
#line 864 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 864 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp19_, "$is_favorite", _tmp21_);
#line 865 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 865 "../core/Services/Database.vala"
	_tmp23_ = objects_label_get_backend_type (label);
#line 865 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 865 "../core/Services/Database.vala"
	_tmp25_ = backend_type_to_string (_tmp24_);
#line 865 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 865 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp22_, "$backend_type", _tmp26_);
#line 865 "../core/Services/Database.vala"
	_g_free0 (_tmp26_);
#line 866 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 866 "../core/Services/Database.vala"
	_tmp28_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
#line 866 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 866 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp27_, "$id", _tmp29_);
#line 868 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 868 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp30_) == SQLITE_DONE) {
#line 869 "../core/Services/Database.vala"
		g_signal_emit_by_name ((ObjectsBaseObject*) label, "updated");
#line 870 "../core/Services/Database.vala"
		g_signal_emit (self, services_database_signals[SERVICES_DATABASE_LABEL_UPDATED_SIGNAL], 0, label);
#line 4303 "Database.c"
	} else {
		sqlite3* _tmp31_;
		sqlite3* _tmp32_;
		const gchar* _tmp33_;
#line 872 "../core/Services/Database.vala"
		_tmp31_ = self->priv->db;
#line 872 "../core/Services/Database.vala"
		_tmp32_ = self->priv->db;
#line 872 "../core/Services/Database.vala"
		_tmp33_ = sqlite3_errmsg (_tmp32_);
#line 872 "../core/Services/Database.vala"
		g_warning ("Database.vala:872: Error: %d: %s", sqlite3_errcode (_tmp31_), _tmp33_);
#line 4316 "Database.c"
	}
#line 874 "../core/Services/Database.vala"
	_tmp34_ = stmt;
#line 874 "../core/Services/Database.vala"
	sqlite3_reset (_tmp34_);
#line 850 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 4324 "Database.c"
}

GeeArrayList*
services_database_get_labels_by_item_labels (ServicesDatabase* self,
                                             const gchar* labels)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	GeeArrayList* result;
#line 877 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 877 "../core/Services/Database.vala"
	g_return_val_if_fail (labels != NULL, NULL);
#line 878 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_LABEL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 878 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 880 "../core/Services/Database.vala"
	_tmp2_ = _tmp1_ = g_strsplit (labels, ";", 0);
#line 4346 "Database.c"
	{
		gchar** id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 880 "../core/Services/Database.vala"
		id_collection = _tmp2_;
#line 880 "../core/Services/Database.vala"
		id_collection_length1 = _vala_array_length (_tmp1_);
#line 880 "../core/Services/Database.vala"
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
#line 4358 "Database.c"
			gchar* _tmp3_;
			gchar* id = NULL;
#line 880 "../core/Services/Database.vala"
			_tmp3_ = g_strdup (id_collection[id_it]);
#line 880 "../core/Services/Database.vala"
			id = _tmp3_;
#line 4365 "Database.c"
			{
				ObjectsLabel* label = NULL;
				const gchar* _tmp4_;
				ObjectsLabel* _tmp5_;
				ObjectsLabel* _tmp6_;
#line 881 "../core/Services/Database.vala"
				_tmp4_ = id;
#line 881 "../core/Services/Database.vala"
				_tmp5_ = services_database_get_label (self, _tmp4_);
#line 881 "../core/Services/Database.vala"
				label = _tmp5_;
#line 882 "../core/Services/Database.vala"
				_tmp6_ = label;
#line 882 "../core/Services/Database.vala"
				if (_tmp6_ != NULL) {
#line 4381 "Database.c"
					GeeArrayList* _tmp7_;
					ObjectsLabel* _tmp8_;
#line 883 "../core/Services/Database.vala"
					_tmp7_ = return_value;
#line 883 "../core/Services/Database.vala"
					_tmp8_ = label;
#line 883 "../core/Services/Database.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
#line 4390 "Database.c"
				}
#line 880 "../core/Services/Database.vala"
				_g_object_unref0 (label);
#line 880 "../core/Services/Database.vala"
				_g_free0 (id);
#line 4396 "Database.c"
			}
		}
#line 880 "../core/Services/Database.vala"
		id_collection = (_vala_array_free (id_collection, id_collection_length1, (GDestroyNotify) g_free), NULL);
#line 4401 "Database.c"
	}
#line 887 "../core/Services/Database.vala"
	result = return_value;
#line 887 "../core/Services/Database.vala"
	return result;
#line 4407 "Database.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1466 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1466 "glib-2.0.vapi"
	end = _tmp0_;
#line 1467 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1467 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1468 "glib-2.0.vapi"
		result = maxlen;
#line 1468 "glib-2.0.vapi"
		return result;
#line 4430 "Database.c"
	} else {
		gchar* _tmp2_;
#line 1470 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1470 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1470 "glib-2.0.vapi"
		return result;
#line 4439 "Database.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1479 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 4458 "Database.c"
	} else {
#line 1479 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 4462 "Database.c"
	}
#line 1479 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1481 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 4468 "Database.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1483 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1483 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1483 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 4478 "Database.c"
	}
#line 1486 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1487 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1488 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 4486 "Database.c"
	} else {
#line 1490 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 4490 "Database.c"
	}
#line 1492 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1493 "glib-2.0.vapi"
		len = string_length - offset;
#line 4496 "Database.c"
	}
#line 1495 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1496 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1496 "glib-2.0.vapi"
	result = _tmp3_;
#line 1496 "glib-2.0.vapi"
	return result;
#line 4506 "Database.c"
}

gchar*
services_database_get_labels_ids (ServicesDatabase* self,
                                  GeeArrayList* labels)
{
	gchar* return_value = NULL;
	gchar* _tmp0_;
	const gchar* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gchar* result;
#line 890 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 890 "../core/Services/Database.vala"
	g_return_val_if_fail (labels != NULL, NULL);
#line 891 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("");
#line 891 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 4527 "Database.c"
	{
		GeeArrayList* _label_list = NULL;
		gint _label_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _label_index = 0;
#line 893 "../core/Services/Database.vala"
		_label_list = labels;
#line 893 "../core/Services/Database.vala"
		_tmp1_ = _label_list;
#line 893 "../core/Services/Database.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 893 "../core/Services/Database.vala"
		_tmp3_ = _tmp2_;
#line 893 "../core/Services/Database.vala"
		_label_size = _tmp3_;
#line 893 "../core/Services/Database.vala"
		_label_index = -1;
#line 893 "../core/Services/Database.vala"
		while (TRUE) {
#line 4549 "Database.c"
			gint _tmp4_;
			gint _tmp5_;
			ObjectsLabel* label = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			const gchar* _tmp8_;
			ObjectsLabel* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 893 "../core/Services/Database.vala"
			_label_index = _label_index + 1;
#line 893 "../core/Services/Database.vala"
			_tmp4_ = _label_index;
#line 893 "../core/Services/Database.vala"
			_tmp5_ = _label_size;
#line 893 "../core/Services/Database.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 893 "../core/Services/Database.vala"
				break;
#line 4572 "Database.c"
			}
#line 893 "../core/Services/Database.vala"
			_tmp6_ = _label_list;
#line 893 "../core/Services/Database.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _label_index);
#line 893 "../core/Services/Database.vala"
			label = (ObjectsLabel*) _tmp7_;
#line 894 "../core/Services/Database.vala"
			_tmp8_ = return_value;
#line 894 "../core/Services/Database.vala"
			_tmp9_ = label;
#line 894 "../core/Services/Database.vala"
			_tmp10_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp9_);
#line 894 "../core/Services/Database.vala"
			_tmp11_ = _tmp10_;
#line 894 "../core/Services/Database.vala"
			_tmp12_ = g_strconcat (_tmp11_, ";", NULL);
#line 894 "../core/Services/Database.vala"
			_tmp13_ = _tmp12_;
#line 894 "../core/Services/Database.vala"
			_tmp14_ = g_strconcat (_tmp8_, _tmp13_, NULL);
#line 894 "../core/Services/Database.vala"
			_g_free0 (return_value);
#line 894 "../core/Services/Database.vala"
			return_value = _tmp14_;
#line 894 "../core/Services/Database.vala"
			_g_free0 (_tmp13_);
#line 893 "../core/Services/Database.vala"
			_g_object_unref0 (label);
#line 4602 "Database.c"
		}
	}
#line 897 "../core/Services/Database.vala"
	_tmp15_ = return_value;
#line 897 "../core/Services/Database.vala"
	_tmp16_ = strlen (_tmp15_);
#line 897 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 897 "../core/Services/Database.vala"
	if (_tmp17_ > 0) {
#line 4613 "Database.c"
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		gchar* _tmp22_;
#line 898 "../core/Services/Database.vala"
		_tmp18_ = return_value;
#line 898 "../core/Services/Database.vala"
		_tmp19_ = return_value;
#line 898 "../core/Services/Database.vala"
		_tmp20_ = strlen (_tmp19_);
#line 898 "../core/Services/Database.vala"
		_tmp21_ = _tmp20_;
#line 898 "../core/Services/Database.vala"
		_tmp22_ = string_substring (_tmp18_, (glong) 0, (glong) (_tmp21_ - 1));
#line 898 "../core/Services/Database.vala"
		_g_free0 (return_value);
#line 898 "../core/Services/Database.vala"
		return_value = _tmp22_;
#line 4633 "Database.c"
	}
#line 901 "../core/Services/Database.vala"
	result = return_value;
#line 901 "../core/Services/Database.vala"
	return result;
#line 4639 "Database.c"
}

gint
services_database_next_item_child_order (ServicesDatabase* self,
                                         const gchar* project_id,
                                         const gchar* section_id)
{
	gint child_order = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 904 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 904 "../core/Services/Database.vala"
	g_return_val_if_fail (project_id != NULL, 0);
#line 904 "../core/Services/Database.vala"
	g_return_val_if_fail (section_id != NULL, 0);
#line 905 "../core/Services/Database.vala"
	child_order = 0;
#line 4658 "Database.c"
	{
		GeeArrayList* _tmp0_;
		gint _tmp20_ = -1;
#line 907 "../core/Services/Database.vala"
		_tmp0_ = self->priv->_items;
#line 907 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 4666 "Database.c"
		{
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _item_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _item_index = 0;
#line 908 "../core/Services/Database.vala"
				_tmp1_ = services_database_get_items (self);
#line 908 "../core/Services/Database.vala"
				_tmp2_ = _tmp1_;
#line 908 "../core/Services/Database.vala"
				_item_list = _tmp2_;
#line 908 "../core/Services/Database.vala"
				_tmp3_ = _item_list;
#line 908 "../core/Services/Database.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 908 "../core/Services/Database.vala"
				_tmp5_ = _tmp4_;
#line 908 "../core/Services/Database.vala"
				_item_size = _tmp5_;
#line 908 "../core/Services/Database.vala"
				_item_index = -1;
#line 908 "../core/Services/Database.vala"
				while (TRUE) {
#line 4695 "Database.c"
					gint _tmp6_;
					gint _tmp7_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					ObjectsItem* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
#line 908 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 908 "../core/Services/Database.vala"
					_tmp6_ = _item_index;
#line 908 "../core/Services/Database.vala"
					_tmp7_ = _item_size;
#line 908 "../core/Services/Database.vala"
					if (!(_tmp6_ < _tmp7_)) {
#line 908 "../core/Services/Database.vala"
						break;
#line 4715 "Database.c"
					}
#line 908 "../core/Services/Database.vala"
					_tmp8_ = _item_list;
#line 908 "../core/Services/Database.vala"
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _item_index);
#line 908 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp9_;
#line 909 "../core/Services/Database.vala"
					_tmp11_ = item;
#line 909 "../core/Services/Database.vala"
					_tmp12_ = objects_item_get_project_id (_tmp11_);
#line 909 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 909 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp13_, project_id) == 0) {
#line 4731 "Database.c"
						ObjectsItem* _tmp14_;
						const gchar* _tmp15_;
						const gchar* _tmp16_;
#line 909 "../core/Services/Database.vala"
						_tmp14_ = item;
#line 909 "../core/Services/Database.vala"
						_tmp15_ = objects_item_get_section_id (_tmp14_);
#line 909 "../core/Services/Database.vala"
						_tmp16_ = _tmp15_;
#line 909 "../core/Services/Database.vala"
						_tmp10_ = g_strcmp0 (_tmp16_, section_id) == 0;
#line 4743 "Database.c"
					} else {
#line 909 "../core/Services/Database.vala"
						_tmp10_ = FALSE;
#line 4747 "Database.c"
					}
#line 909 "../core/Services/Database.vala"
					if (_tmp10_) {
#line 4751 "Database.c"
						gint _tmp17_;
#line 910 "../core/Services/Database.vala"
						_tmp17_ = child_order;
#line 910 "../core/Services/Database.vala"
						child_order = _tmp17_ + 1;
#line 4757 "Database.c"
					}
#line 908 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 4761 "Database.c"
				}
			}
#line 914 "../core/Services/Database.vala"
			result = child_order;
#line 4766 "Database.c"
			{
				GeeArrayList* _tmp18_;
#line 907 "../core/Services/Database.vala"
				_tmp18_ = self->priv->_items;
#line 907 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 4773 "Database.c"
			}
#line 914 "../core/Services/Database.vala"
			return result;
#line 4777 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp19_;
#line 907 "../core/Services/Database.vala"
			_tmp19_ = self->priv->_items;
#line 907 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 4786 "Database.c"
		}
#line 907 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 907 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 907 "../core/Services/Database.vala"
		return _tmp20_;
#line 4794 "Database.c"
	}
}

gboolean
services_database_insert_section (ServicesDatabase* self,
                                  ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	sqlite3_stmt* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	sqlite3_stmt* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	sqlite3_stmt* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	sqlite3_stmt* _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	sqlite3_stmt* _tmp31_;
	gboolean _tmp32_;
	gboolean _tmp33_;
	sqlite3_stmt* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	sqlite3_stmt* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	sqlite3_stmt* _tmp40_;
	gboolean _tmp41_;
	gboolean _tmp42_;
	sqlite3_stmt* _tmp43_;
	sqlite3_stmt* _tmp51_;
	sqlite3_stmt* _tmp52_;
	gboolean result;
#line 922 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 922 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 925 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Sections (id, name, archived_at, add" \
"ed_at, project_id, section_order,\n" \
"            collapsed, is_deleted, is_archived, color, description, hi" \
"dded)\n" \
"            VALUES ($id, $name, $archived_at, $added_at, $project_id, " \
"$section_order,\n" \
"            $collapsed, $is_deleted, $is_archived, $color, $descriptio" \
"n, $hidded);\n" \
"        ");
#line 925 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 925 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 932 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 932 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 932 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 932 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 932 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 932 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 932 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 932 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 933 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 933 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 933 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 933 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 934 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 934 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_name ((ObjectsBaseObject*) section);
#line 934 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 934 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$name", _tmp12_);
#line 935 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 935 "../core/Services/Database.vala"
	_tmp14_ = objects_section_get_archived_at (section);
#line 935 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 935 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$archived_at", _tmp15_);
#line 936 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 936 "../core/Services/Database.vala"
	_tmp17_ = objects_section_get_added_at (section);
#line 936 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 936 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$added_at", _tmp18_);
#line 937 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 937 "../core/Services/Database.vala"
	_tmp20_ = objects_section_get_project_id (section);
#line 937 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 937 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp19_, "$project_id", _tmp21_);
#line 938 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 938 "../core/Services/Database.vala"
	_tmp23_ = objects_section_get_section_order (section);
#line 938 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 938 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp22_, "$section_order", _tmp24_);
#line 939 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 939 "../core/Services/Database.vala"
	_tmp26_ = objects_section_get_collapsed (section);
#line 939 "../core/Services/Database.vala"
	_tmp27_ = _tmp26_;
#line 939 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp25_, "$collapsed", _tmp27_);
#line 940 "../core/Services/Database.vala"
	_tmp28_ = stmt;
#line 940 "../core/Services/Database.vala"
	_tmp29_ = objects_section_get_is_deleted (section);
#line 940 "../core/Services/Database.vala"
	_tmp30_ = _tmp29_;
#line 940 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp28_, "$is_deleted", _tmp30_);
#line 941 "../core/Services/Database.vala"
	_tmp31_ = stmt;
#line 941 "../core/Services/Database.vala"
	_tmp32_ = objects_section_get_is_archived (section);
#line 941 "../core/Services/Database.vala"
	_tmp33_ = _tmp32_;
#line 941 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp31_, "$is_archived", _tmp33_);
#line 942 "../core/Services/Database.vala"
	_tmp34_ = stmt;
#line 942 "../core/Services/Database.vala"
	_tmp35_ = objects_section_get_color (section);
#line 942 "../core/Services/Database.vala"
	_tmp36_ = _tmp35_;
#line 942 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp34_, "$color", _tmp36_);
#line 943 "../core/Services/Database.vala"
	_tmp37_ = stmt;
#line 943 "../core/Services/Database.vala"
	_tmp38_ = objects_section_get_description (section);
#line 943 "../core/Services/Database.vala"
	_tmp39_ = _tmp38_;
#line 943 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp37_, "$description", _tmp39_);
#line 944 "../core/Services/Database.vala"
	_tmp40_ = stmt;
#line 944 "../core/Services/Database.vala"
	_tmp41_ = objects_section_get_hidded (section);
#line 944 "../core/Services/Database.vala"
	_tmp42_ = _tmp41_;
#line 944 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp40_, "$hidded", _tmp42_);
#line 946 "../core/Services/Database.vala"
	_tmp43_ = stmt;
#line 946 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp43_) == SQLITE_DONE) {
#line 4976 "Database.c"
		GeeArrayList* _tmp44_;
		GeeArrayList* _tmp45_;
		ObjectsProject* _tmp46_;
		ObjectsProject* _tmp47_;
#line 947 "../core/Services/Database.vala"
		_tmp44_ = services_database_get_sections (self);
#line 947 "../core/Services/Database.vala"
		_tmp45_ = _tmp44_;
#line 947 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp45_, section);
#line 948 "../core/Services/Database.vala"
		_tmp46_ = objects_section_get_project (section);
#line 948 "../core/Services/Database.vala"
		_tmp47_ = _tmp46_;
#line 948 "../core/Services/Database.vala"
		g_signal_emit_by_name (_tmp47_, "section-added", section);
#line 4993 "Database.c"
	} else {
		sqlite3* _tmp48_;
		sqlite3* _tmp49_;
		const gchar* _tmp50_;
#line 950 "../core/Services/Database.vala"
		_tmp48_ = self->priv->db;
#line 950 "../core/Services/Database.vala"
		_tmp49_ = self->priv->db;
#line 950 "../core/Services/Database.vala"
		_tmp50_ = sqlite3_errmsg (_tmp49_);
#line 950 "../core/Services/Database.vala"
		g_warning ("Database.vala:950: Error: %d: %s", sqlite3_errcode (_tmp48_), _tmp50_);
#line 5006 "Database.c"
	}
#line 953 "../core/Services/Database.vala"
	_tmp51_ = stmt;
#line 953 "../core/Services/Database.vala"
	sqlite3_reset (_tmp51_);
#line 954 "../core/Services/Database.vala"
	_tmp52_ = stmt;
#line 954 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp52_) == SQLITE_DONE;
#line 954 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 954 "../core/Services/Database.vala"
	return result;
#line 5020 "Database.c"
}

GeeArrayList*
services_database_get_sections_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp13_;
	GeeArrayList* result;
#line 957 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 958 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_SECTION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 958 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 961 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("SELECT * FROM Sections WHERE is_deleted = 0;");
#line 961 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 961 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 963 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 963 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 963 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 963 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 963 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 963 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 963 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 963 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 965 "../core/Services/Database.vala"
	while (TRUE) {
#line 5068 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsSection* _tmp11_;
		ObjectsSection* _tmp12_;
#line 965 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 965 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 965 "../core/Services/Database.vala"
			break;
#line 5080 "Database.c"
		}
#line 966 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 966 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 966 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_section (self, _tmp10_);
#line 966 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 966 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 966 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 5094 "Database.c"
	}
#line 968 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 968 "../core/Services/Database.vala"
	sqlite3_reset (_tmp13_);
#line 969 "../core/Services/Database.vala"
	result = return_value;
#line 969 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 969 "../core/Services/Database.vala"
	return result;
#line 5106 "Database.c"
}

GeeArrayList*
services_database_get_sections_by_project (ServicesDatabase* self,
                                           ObjectsProject* project)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 972 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 972 "../core/Services/Database.vala"
	g_return_val_if_fail (project != NULL, NULL);
#line 973 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_SECTION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 973 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 5125 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 974 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_sections;
#line 974 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__sections);
#line 5132 "Database.c"
		{
			{
				GeeArrayList* _section_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _section_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _section_index = 0;
#line 975 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_sections (self);
#line 975 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 975 "../core/Services/Database.vala"
				_section_list = _tmp3_;
#line 975 "../core/Services/Database.vala"
				_tmp4_ = _section_list;
#line 975 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 975 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 975 "../core/Services/Database.vala"
				_section_size = _tmp6_;
#line 975 "../core/Services/Database.vala"
				_section_index = -1;
#line 975 "../core/Services/Database.vala"
				while (TRUE) {
#line 5161 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsSection* section = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsSection* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 975 "../core/Services/Database.vala"
					_section_index = _section_index + 1;
#line 975 "../core/Services/Database.vala"
					_tmp7_ = _section_index;
#line 975 "../core/Services/Database.vala"
					_tmp8_ = _section_size;
#line 975 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 975 "../core/Services/Database.vala"
						break;
#line 5182 "Database.c"
					}
#line 975 "../core/Services/Database.vala"
					_tmp9_ = _section_list;
#line 975 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _section_index);
#line 975 "../core/Services/Database.vala"
					section = (ObjectsSection*) _tmp10_;
#line 976 "../core/Services/Database.vala"
					_tmp11_ = section;
#line 976 "../core/Services/Database.vala"
					_tmp12_ = objects_section_get_project_id (_tmp11_);
#line 976 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 976 "../core/Services/Database.vala"
					_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 976 "../core/Services/Database.vala"
					_tmp15_ = _tmp14_;
#line 976 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
#line 5202 "Database.c"
						GeeArrayList* _tmp16_;
						ObjectsSection* _tmp17_;
#line 977 "../core/Services/Database.vala"
						_tmp16_ = return_value;
#line 977 "../core/Services/Database.vala"
						_tmp17_ = section;
#line 977 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 5211 "Database.c"
					}
#line 975 "../core/Services/Database.vala"
					_g_object_unref0 (section);
#line 5215 "Database.c"
				}
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
#line 974 "../core/Services/Database.vala"
			_tmp18_ = self->priv->_sections;
#line 974 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__sections);
#line 5226 "Database.c"
		}
#line 974 "../core/Services/Database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 974 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 974 "../core/Services/Database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 974 "../core/Services/Database.vala"
			g_clear_error (&_inner_error0_);
#line 974 "../core/Services/Database.vala"
			return NULL;
#line 5238 "Database.c"
		}
	}
#line 982 "../core/Services/Database.vala"
	result = return_value;
#line 982 "../core/Services/Database.vala"
	return result;
#line 5245 "Database.c"
}

ObjectsSection*
services_database_get_section (ServicesDatabase* self,
                               const gchar* id)
{
	ObjectsSection* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsSection* result;
#line 985 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 985 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 986 "../core/Services/Database.vala"
	return_value = NULL;
#line 5261 "Database.c"
	{
		GeeArrayList* _tmp0_;
#line 987 "../core/Services/Database.vala"
		_tmp0_ = self->priv->_sections;
#line 987 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__sections);
#line 5268 "Database.c"
		{
			ObjectsSection* _tmp15_;
			ObjectsSection* _tmp16_;
			{
				GeeArrayList* _section_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _section_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _section_index = 0;
#line 988 "../core/Services/Database.vala"
				_tmp1_ = services_database_get_sections (self);
#line 988 "../core/Services/Database.vala"
				_tmp2_ = _tmp1_;
#line 988 "../core/Services/Database.vala"
				_section_list = _tmp2_;
#line 988 "../core/Services/Database.vala"
				_tmp3_ = _section_list;
#line 988 "../core/Services/Database.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 988 "../core/Services/Database.vala"
				_tmp5_ = _tmp4_;
#line 988 "../core/Services/Database.vala"
				_section_size = _tmp5_;
#line 988 "../core/Services/Database.vala"
				_section_index = -1;
#line 988 "../core/Services/Database.vala"
				while (TRUE) {
#line 5299 "Database.c"
					gint _tmp6_;
					gint _tmp7_;
					ObjectsSection* section = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsSection* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
#line 988 "../core/Services/Database.vala"
					_section_index = _section_index + 1;
#line 988 "../core/Services/Database.vala"
					_tmp6_ = _section_index;
#line 988 "../core/Services/Database.vala"
					_tmp7_ = _section_size;
#line 988 "../core/Services/Database.vala"
					if (!(_tmp6_ < _tmp7_)) {
#line 988 "../core/Services/Database.vala"
						break;
#line 5318 "Database.c"
					}
#line 988 "../core/Services/Database.vala"
					_tmp8_ = _section_list;
#line 988 "../core/Services/Database.vala"
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _section_index);
#line 988 "../core/Services/Database.vala"
					section = (ObjectsSection*) _tmp9_;
#line 989 "../core/Services/Database.vala"
					_tmp10_ = section;
#line 989 "../core/Services/Database.vala"
					_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp10_);
#line 989 "../core/Services/Database.vala"
					_tmp12_ = _tmp11_;
#line 989 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp12_, id) == 0) {
#line 5334 "Database.c"
						ObjectsSection* _tmp13_;
						ObjectsSection* _tmp14_;
#line 990 "../core/Services/Database.vala"
						_tmp13_ = section;
#line 990 "../core/Services/Database.vala"
						_tmp14_ = _g_object_ref0 (_tmp13_);
#line 990 "../core/Services/Database.vala"
						_g_object_unref0 (return_value);
#line 990 "../core/Services/Database.vala"
						return_value = _tmp14_;
#line 991 "../core/Services/Database.vala"
						_g_object_unref0 (section);
#line 991 "../core/Services/Database.vala"
						break;
#line 5349 "Database.c"
					}
#line 988 "../core/Services/Database.vala"
					_g_object_unref0 (section);
#line 5353 "Database.c"
				}
			}
#line 995 "../core/Services/Database.vala"
			_tmp15_ = return_value;
#line 995 "../core/Services/Database.vala"
			_tmp16_ = _g_object_ref0 (_tmp15_);
#line 995 "../core/Services/Database.vala"
			result = _tmp16_;
#line 5362 "Database.c"
			{
				GeeArrayList* _tmp17_;
#line 987 "../core/Services/Database.vala"
				_tmp17_ = self->priv->_sections;
#line 987 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__sections);
#line 5369 "Database.c"
			}
#line 995 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 995 "../core/Services/Database.vala"
			return result;
#line 5375 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
#line 987 "../core/Services/Database.vala"
			_tmp18_ = self->priv->_sections;
#line 987 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__sections);
#line 5384 "Database.c"
		}
#line 987 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 987 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 987 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 987 "../core/Services/Database.vala"
		return NULL;
#line 5394 "Database.c"
	}
}

ObjectsSection*
_services_database_fill_section (ServicesDatabase* self,
                                 sqlite3_stmt* stmt)
{
	ObjectsSection* return_value = NULL;
	ObjectsSection* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	ObjectsSection* result;
#line 999 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 999 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1000 "../core/Services/Database.vala"
	_tmp0_ = objects_section_new ();
#line 1000 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1001 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1001 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 1002 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1002 "../core/Services/Database.vala"
	objects_base_object_set_name ((ObjectsBaseObject*) return_value, _tmp2_);
#line 1003 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1003 "../core/Services/Database.vala"
	objects_section_set_archived_at (return_value, _tmp3_);
#line 1004 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1004 "../core/Services/Database.vala"
	objects_section_set_added_at (return_value, _tmp4_);
#line 1005 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 1005 "../core/Services/Database.vala"
	objects_section_set_project_id (return_value, _tmp5_);
#line 1006 "../core/Services/Database.vala"
	objects_section_set_section_order (return_value, sqlite3_column_int (stmt, 5));
#line 1007 "../core/Services/Database.vala"
	objects_section_set_collapsed (return_value, services_database_get_parameter_bool (self, stmt, 6));
#line 1008 "../core/Services/Database.vala"
	objects_section_set_is_deleted (return_value, services_database_get_parameter_bool (self, stmt, 7));
#line 1009 "../core/Services/Database.vala"
	objects_section_set_is_archived (return_value, services_database_get_parameter_bool (self, stmt, 8));
#line 1010 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 9);
#line 1010 "../core/Services/Database.vala"
	objects_section_set_color (return_value, _tmp6_);
#line 1011 "../core/Services/Database.vala"
	_tmp7_ = (const gchar*) sqlite3_column_text (stmt, 10);
#line 1011 "../core/Services/Database.vala"
	objects_section_set_description (return_value, _tmp7_);
#line 1012 "../core/Services/Database.vala"
	objects_section_set_hidded (return_value, services_database_get_parameter_bool (self, stmt, 11));
#line 1013 "../core/Services/Database.vala"
	result = return_value;
#line 1013 "../core/Services/Database.vala"
	return result;
#line 5462 "Database.c"
}

void
services_database_delete_section (ServicesDatabase* self,
                                  ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp24_;
#line 1016 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1016 "../core/Services/Database.vala"
	g_return_if_fail (section != NULL);
#line 1019 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Sections WHERE id=$id;\n        ");
#line 1019 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1019 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1023 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1023 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1023 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1023 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1023 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1023 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1023 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1023 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1024 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1024 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1024 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1024 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1026 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1026 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) == SQLITE_DONE) {
#line 5520 "Database.c"
		{
			GeeArrayList* _item_list = NULL;
			GeeArrayList* _tmp11_;
			GeeArrayList* _tmp12_;
			gint _item_size = 0;
			GeeArrayList* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			gint _item_index = 0;
#line 1027 "../core/Services/Database.vala"
			_tmp11_ = objects_section_get_items (section);
#line 1027 "../core/Services/Database.vala"
			_tmp12_ = _tmp11_;
#line 1027 "../core/Services/Database.vala"
			_item_list = _tmp12_;
#line 1027 "../core/Services/Database.vala"
			_tmp13_ = _item_list;
#line 1027 "../core/Services/Database.vala"
			_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
#line 1027 "../core/Services/Database.vala"
			_tmp15_ = _tmp14_;
#line 1027 "../core/Services/Database.vala"
			_item_size = _tmp15_;
#line 1027 "../core/Services/Database.vala"
			_item_index = -1;
#line 1027 "../core/Services/Database.vala"
			while (TRUE) {
#line 5548 "Database.c"
				gint _tmp16_;
				gint _tmp17_;
				ObjectsItem* item = NULL;
				GeeArrayList* _tmp18_;
				gpointer _tmp19_;
				ObjectsItem* _tmp20_;
#line 1027 "../core/Services/Database.vala"
				_item_index = _item_index + 1;
#line 1027 "../core/Services/Database.vala"
				_tmp16_ = _item_index;
#line 1027 "../core/Services/Database.vala"
				_tmp17_ = _item_size;
#line 1027 "../core/Services/Database.vala"
				if (!(_tmp16_ < _tmp17_)) {
#line 1027 "../core/Services/Database.vala"
					break;
#line 5565 "Database.c"
				}
#line 1027 "../core/Services/Database.vala"
				_tmp18_ = _item_list;
#line 1027 "../core/Services/Database.vala"
				_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _item_index);
#line 1027 "../core/Services/Database.vala"
				item = (ObjectsItem*) _tmp19_;
#line 1028 "../core/Services/Database.vala"
				_tmp20_ = item;
#line 1028 "../core/Services/Database.vala"
				services_database_delete_item (self, _tmp20_);
#line 1027 "../core/Services/Database.vala"
				_g_object_unref0 (item);
#line 5579 "Database.c"
			}
		}
#line 1031 "../core/Services/Database.vala"
		g_signal_emit_by_name ((ObjectsBaseObject*) section, "deleted");
#line 5584 "Database.c"
	} else {
		sqlite3* _tmp21_;
		sqlite3* _tmp22_;
		const gchar* _tmp23_;
#line 1033 "../core/Services/Database.vala"
		_tmp21_ = self->priv->db;
#line 1033 "../core/Services/Database.vala"
		_tmp22_ = self->priv->db;
#line 1033 "../core/Services/Database.vala"
		_tmp23_ = sqlite3_errmsg (_tmp22_);
#line 1033 "../core/Services/Database.vala"
		g_warning ("Database.vala:1033: Error: %d: %s", sqlite3_errcode (_tmp21_), _tmp23_);
#line 5597 "Database.c"
	}
#line 1036 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 1036 "../core/Services/Database.vala"
	sqlite3_reset (_tmp24_);
#line 1016 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 5605 "Database.c"
}

void
services_database_update_section (ServicesDatabase* self,
                                  ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	sqlite3_stmt* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	sqlite3_stmt* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	sqlite3_stmt* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	sqlite3_stmt* _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	sqlite3_stmt* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	sqlite3_stmt* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	sqlite3_stmt* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	sqlite3_stmt* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	sqlite3_stmt* _tmp43_;
	sqlite3_stmt* _tmp47_;
#line 1039 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1039 "../core/Services/Database.vala"
	g_return_if_fail (section != NULL);
#line 1042 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sections SET name=$name, archived_at=$archived_at, " \
"added_at=$added_at,\n" \
"                project_id=$project_id, section_order=$section_order, " \
"collapsed=$collapsed,\n" \
"                is_deleted=$is_deleted, is_archived=$is_archived, colo" \
"r=$color, description=$description,\n" \
"                hidded=$hidded\n" \
"            WHERE id=$id;\n" \
"        ");
#line 1042 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1042 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1050 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1050 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1050 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1050 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1050 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1050 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1050 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1050 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1051 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1051 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_name ((ObjectsBaseObject*) section);
#line 1051 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1051 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$name", _tmp9_);
#line 1052 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1052 "../core/Services/Database.vala"
	_tmp11_ = objects_section_get_archived_at (section);
#line 1052 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1052 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$archived_at", _tmp12_);
#line 1053 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1053 "../core/Services/Database.vala"
	_tmp14_ = objects_section_get_added_at (section);
#line 1053 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1053 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$added_at", _tmp15_);
#line 1054 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1054 "../core/Services/Database.vala"
	_tmp17_ = objects_section_get_project_id (section);
#line 1054 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1054 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$project_id", _tmp18_);
#line 1055 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 1055 "../core/Services/Database.vala"
	_tmp20_ = objects_section_get_section_order (section);
#line 1055 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1055 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp19_, "$section_order", _tmp21_);
#line 1056 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1056 "../core/Services/Database.vala"
	_tmp23_ = objects_section_get_collapsed (section);
#line 1056 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1056 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp22_, "$collapsed", _tmp24_);
#line 1057 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1057 "../core/Services/Database.vala"
	_tmp26_ = objects_section_get_is_deleted (section);
#line 1057 "../core/Services/Database.vala"
	_tmp27_ = _tmp26_;
#line 1057 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp25_, "$is_deleted", _tmp27_);
#line 1058 "../core/Services/Database.vala"
	_tmp28_ = stmt;
#line 1058 "../core/Services/Database.vala"
	_tmp29_ = objects_section_get_is_archived (section);
#line 1058 "../core/Services/Database.vala"
	_tmp30_ = _tmp29_;
#line 1058 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp28_, "$is_archived", _tmp30_);
#line 1059 "../core/Services/Database.vala"
	_tmp31_ = stmt;
#line 1059 "../core/Services/Database.vala"
	_tmp32_ = objects_section_get_color (section);
#line 1059 "../core/Services/Database.vala"
	_tmp33_ = _tmp32_;
#line 1059 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp31_, "$color", _tmp33_);
#line 1060 "../core/Services/Database.vala"
	_tmp34_ = stmt;
#line 1060 "../core/Services/Database.vala"
	_tmp35_ = objects_section_get_description (section);
#line 1060 "../core/Services/Database.vala"
	_tmp36_ = _tmp35_;
#line 1060 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp34_, "$description", _tmp36_);
#line 1061 "../core/Services/Database.vala"
	_tmp37_ = stmt;
#line 1061 "../core/Services/Database.vala"
	_tmp38_ = objects_section_get_hidded (section);
#line 1061 "../core/Services/Database.vala"
	_tmp39_ = _tmp38_;
#line 1061 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp37_, "$hidded", _tmp39_);
#line 1062 "../core/Services/Database.vala"
	_tmp40_ = stmt;
#line 1062 "../core/Services/Database.vala"
	_tmp41_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1062 "../core/Services/Database.vala"
	_tmp42_ = _tmp41_;
#line 1062 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp40_, "$id", _tmp42_);
#line 1064 "../core/Services/Database.vala"
	_tmp43_ = stmt;
#line 1064 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp43_) == SQLITE_DONE) {
#line 1065 "../core/Services/Database.vala"
		g_signal_emit_by_name ((ObjectsBaseObject*) section, "updated");
#line 5786 "Database.c"
	} else {
		sqlite3* _tmp44_;
		sqlite3* _tmp45_;
		const gchar* _tmp46_;
#line 1067 "../core/Services/Database.vala"
		_tmp44_ = self->priv->db;
#line 1067 "../core/Services/Database.vala"
		_tmp45_ = self->priv->db;
#line 1067 "../core/Services/Database.vala"
		_tmp46_ = sqlite3_errmsg (_tmp45_);
#line 1067 "../core/Services/Database.vala"
		g_warning ("Database.vala:1067: Error: %d: %s", sqlite3_errcode (_tmp44_), _tmp46_);
#line 5799 "Database.c"
	}
#line 1070 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 1070 "../core/Services/Database.vala"
	sqlite3_reset (_tmp47_);
#line 1039 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 5807 "Database.c"
}

void
services_database_move_section (ServicesDatabase* self,
                                ObjectsSection* section,
                                const gchar* old_project_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
#line 1073 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1073 "../core/Services/Database.vala"
	g_return_if_fail (section != NULL);
#line 1073 "../core/Services/Database.vala"
	g_return_if_fail (old_project_id != NULL);
#line 1076 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sections SET project_id=$project_id WHERE id=$id;\n" \
"        ");
#line 1076 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1076 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1080 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1080 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1080 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1080 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1080 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1080 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1080 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1080 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1081 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1081 "../core/Services/Database.vala"
	_tmp8_ = objects_section_get_project_id (section);
#line 1081 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1081 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$project_id", _tmp9_);
#line 1082 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1082 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1082 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1082 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$id", _tmp12_);
#line 1084 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1084 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp13_) == SQLITE_DONE) {
#line 5878 "Database.c"
		sqlite3_stmt* _tmp14_;
		gchar* _tmp15_;
		sqlite3* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		sqlite3_stmt* _tmp21_ = NULL;
		sqlite3_stmt* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		sqlite3_stmt* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		sqlite3_stmt* _tmp28_;
		sqlite3_stmt* _tmp41_;
#line 1085 "../core/Services/Database.vala"
		_tmp14_ = stmt;
#line 1085 "../core/Services/Database.vala"
		sqlite3_reset (_tmp14_);
#line 1087 "../core/Services/Database.vala"
		_tmp15_ = g_strdup ("\n" \
"                UPDATE Items SET project_id=$project_id WHERE section_" \
"id=$section_id;\n" \
"            ");
#line 1087 "../core/Services/Database.vala"
		_g_free0 (self->priv->sql);
#line 1087 "../core/Services/Database.vala"
		self->priv->sql = _tmp15_;
#line 1091 "../core/Services/Database.vala"
		_tmp16_ = self->priv->db;
#line 1091 "../core/Services/Database.vala"
		_tmp17_ = self->priv->sql;
#line 1091 "../core/Services/Database.vala"
		_tmp18_ = self->priv->sql;
#line 1091 "../core/Services/Database.vala"
		_tmp19_ = strlen (_tmp18_);
#line 1091 "../core/Services/Database.vala"
		_tmp20_ = _tmp19_;
#line 1091 "../core/Services/Database.vala"
		sqlite3_prepare_v2 (_tmp16_, _tmp17_, _tmp20_, &_tmp21_, NULL);
#line 1091 "../core/Services/Database.vala"
		_sqlite3_finalize0 (stmt);
#line 1091 "../core/Services/Database.vala"
		stmt = _tmp21_;
#line 1092 "../core/Services/Database.vala"
		_tmp22_ = stmt;
#line 1092 "../core/Services/Database.vala"
		_tmp23_ = objects_section_get_project_id (section);
#line 1092 "../core/Services/Database.vala"
		_tmp24_ = _tmp23_;
#line 1092 "../core/Services/Database.vala"
		services_database_set_parameter_str (self, _tmp22_, "$project_id", _tmp24_);
#line 1093 "../core/Services/Database.vala"
		_tmp25_ = stmt;
#line 1093 "../core/Services/Database.vala"
		_tmp26_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1093 "../core/Services/Database.vala"
		_tmp27_ = _tmp26_;
#line 1093 "../core/Services/Database.vala"
		services_database_set_parameter_str (self, _tmp25_, "$section_id", _tmp27_);
#line 1095 "../core/Services/Database.vala"
		_tmp28_ = stmt;
#line 1095 "../core/Services/Database.vala"
		if (sqlite3_step (_tmp28_) == SQLITE_DONE) {
#line 5941 "Database.c"
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp29_;
				GeeArrayList* _tmp30_;
				gint _item_size = 0;
				GeeArrayList* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gint _item_index = 0;
#line 1096 "../core/Services/Database.vala"
				_tmp29_ = objects_section_get_items (section);
#line 1096 "../core/Services/Database.vala"
				_tmp30_ = _tmp29_;
#line 1096 "../core/Services/Database.vala"
				_item_list = _tmp30_;
#line 1096 "../core/Services/Database.vala"
				_tmp31_ = _item_list;
#line 1096 "../core/Services/Database.vala"
				_tmp32_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp31_);
#line 1096 "../core/Services/Database.vala"
				_tmp33_ = _tmp32_;
#line 1096 "../core/Services/Database.vala"
				_item_size = _tmp33_;
#line 1096 "../core/Services/Database.vala"
				_item_index = -1;
#line 1096 "../core/Services/Database.vala"
				while (TRUE) {
#line 5969 "Database.c"
					gint _tmp34_;
					gint _tmp35_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp36_;
					gpointer _tmp37_;
					ObjectsItem* _tmp38_;
					const gchar* _tmp39_;
					const gchar* _tmp40_;
#line 1096 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1096 "../core/Services/Database.vala"
					_tmp34_ = _item_index;
#line 1096 "../core/Services/Database.vala"
					_tmp35_ = _item_size;
#line 1096 "../core/Services/Database.vala"
					if (!(_tmp34_ < _tmp35_)) {
#line 1096 "../core/Services/Database.vala"
						break;
#line 5988 "Database.c"
					}
#line 1096 "../core/Services/Database.vala"
					_tmp36_ = _item_list;
#line 1096 "../core/Services/Database.vala"
					_tmp37_ = gee_abstract_list_get ((GeeAbstractList*) _tmp36_, _item_index);
#line 1096 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp37_;
#line 1097 "../core/Services/Database.vala"
					_tmp38_ = item;
#line 1097 "../core/Services/Database.vala"
					_tmp39_ = objects_section_get_project_id (section);
#line 1097 "../core/Services/Database.vala"
					_tmp40_ = _tmp39_;
#line 1097 "../core/Services/Database.vala"
					objects_item_set_project_id (_tmp38_, _tmp40_);
#line 1096 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 6006 "Database.c"
				}
			}
#line 1100 "../core/Services/Database.vala"
			g_signal_emit (self, services_database_signals[SERVICES_DATABASE_SECTION_MOVED_SIGNAL], 0, section, old_project_id);
#line 6011 "Database.c"
		}
#line 1103 "../core/Services/Database.vala"
		_tmp41_ = stmt;
#line 1103 "../core/Services/Database.vala"
		sqlite3_reset (_tmp41_);
#line 6017 "Database.c"
	} else {
		sqlite3* _tmp42_;
		sqlite3* _tmp43_;
		const gchar* _tmp44_;
#line 1105 "../core/Services/Database.vala"
		_tmp42_ = self->priv->db;
#line 1105 "../core/Services/Database.vala"
		_tmp43_ = self->priv->db;
#line 1105 "../core/Services/Database.vala"
		_tmp44_ = sqlite3_errmsg (_tmp43_);
#line 1105 "../core/Services/Database.vala"
		g_warning ("Database.vala:1105: Error: %d: %s", sqlite3_errcode (_tmp42_), _tmp44_);
#line 6030 "Database.c"
	}
#line 1073 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 6034 "Database.c"
}

gboolean
services_database_insert_item (ServicesDatabase* self,
                               ObjectsItem* item,
                               gboolean insert)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	ObjectsDueDate* _tmp17_;
	ObjectsDueDate* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	sqlite3_stmt* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	sqlite3_stmt* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	sqlite3_stmt* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	sqlite3_stmt* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	sqlite3_stmt* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	sqlite3_stmt* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	sqlite3_stmt* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	sqlite3_stmt* _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	sqlite3_stmt* _tmp45_;
	gboolean _tmp46_;
	gboolean _tmp47_;
	sqlite3_stmt* _tmp48_;
	gboolean _tmp49_;
	gboolean _tmp50_;
	sqlite3_stmt* _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	sqlite3_stmt* _tmp54_;
	gboolean _tmp55_;
	gboolean _tmp56_;
	sqlite3_stmt* _tmp57_;
	gboolean _tmp58_;
	gboolean _tmp59_;
	sqlite3_stmt* _tmp60_;
	GeeArrayList* _tmp61_;
	GeeArrayList* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	sqlite3_stmt* _tmp65_;
	const gchar* _tmp66_;
	const gchar* _tmp67_;
	sqlite3_stmt* _tmp68_;
	sqlite3_stmt* _tmp72_;
	sqlite3_stmt* _tmp73_;
	gboolean result;
#line 1113 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1113 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1116 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Items (id, content, description, due" \
", added_at, completed_at,\n" \
"                updated_at, section_id, project_id, parent_id, priorit" \
"y, child_order,\n" \
"                checked, is_deleted, day_order, collapsed, pinned, lab" \
"els, extra_data)\n" \
"            VALUES ($id, $content, $description, $due, $added_at, $com" \
"pleted_at,\n" \
"                $updated_at, $section_id, $project_id, $parent_id, $pr" \
"iority, $child_order,\n" \
"                $checked, $is_deleted, $day_order, $collapsed, $pinned" \
", $labels, $extra_data);\n" \
"        ");
#line 1116 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1116 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1125 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1125 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1125 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1125 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1125 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1125 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1125 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1125 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1126 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1126 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1126 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1126 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1127 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1127 "../core/Services/Database.vala"
	_tmp11_ = objects_item_get_content (item);
#line 1127 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1127 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$content", _tmp12_);
#line 1128 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1128 "../core/Services/Database.vala"
	_tmp14_ = objects_item_get_description (item);
#line 1128 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1128 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$description", _tmp15_);
#line 1129 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1129 "../core/Services/Database.vala"
	_tmp17_ = objects_item_get_due (item);
#line 1129 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1129 "../core/Services/Database.vala"
	_tmp19_ = objects_due_date_to_string (_tmp18_);
#line 1129 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 1129 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$due", _tmp20_);
#line 1129 "../core/Services/Database.vala"
	_g_free0 (_tmp20_);
#line 1130 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 1130 "../core/Services/Database.vala"
	_tmp22_ = objects_item_get_added_at (item);
#line 1130 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 1130 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp21_, "$added_at", _tmp23_);
#line 1131 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 1131 "../core/Services/Database.vala"
	_tmp25_ = objects_item_get_completed_at (item);
#line 1131 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 1131 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp24_, "$completed_at", _tmp26_);
#line 1132 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 1132 "../core/Services/Database.vala"
	_tmp28_ = objects_item_get_updated_at (item);
#line 1132 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 1132 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp27_, "$updated_at", _tmp29_);
#line 1133 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 1133 "../core/Services/Database.vala"
	_tmp31_ = objects_item_get_section_id (item);
#line 1133 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 1133 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp30_, "$section_id", _tmp32_);
#line 1134 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 1134 "../core/Services/Database.vala"
	_tmp34_ = objects_item_get_project_id (item);
#line 1134 "../core/Services/Database.vala"
	_tmp35_ = _tmp34_;
#line 1134 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp33_, "$project_id", _tmp35_);
#line 1135 "../core/Services/Database.vala"
	_tmp36_ = stmt;
#line 1135 "../core/Services/Database.vala"
	_tmp37_ = objects_item_get_parent_id (item);
#line 1135 "../core/Services/Database.vala"
	_tmp38_ = _tmp37_;
#line 1135 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp36_, "$parent_id", _tmp38_);
#line 1136 "../core/Services/Database.vala"
	_tmp39_ = stmt;
#line 1136 "../core/Services/Database.vala"
	_tmp40_ = objects_item_get_priority (item);
#line 1136 "../core/Services/Database.vala"
	_tmp41_ = _tmp40_;
#line 1136 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp39_, "$priority", _tmp41_);
#line 1137 "../core/Services/Database.vala"
	_tmp42_ = stmt;
#line 1137 "../core/Services/Database.vala"
	_tmp43_ = objects_item_get_child_order (item);
#line 1137 "../core/Services/Database.vala"
	_tmp44_ = _tmp43_;
#line 1137 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp42_, "$child_order", _tmp44_);
#line 1138 "../core/Services/Database.vala"
	_tmp45_ = stmt;
#line 1138 "../core/Services/Database.vala"
	_tmp46_ = objects_item_get_checked (item);
#line 1138 "../core/Services/Database.vala"
	_tmp47_ = _tmp46_;
#line 1138 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp45_, "$checked", _tmp47_);
#line 1139 "../core/Services/Database.vala"
	_tmp48_ = stmt;
#line 1139 "../core/Services/Database.vala"
	_tmp49_ = objects_item_get_is_deleted (item);
#line 1139 "../core/Services/Database.vala"
	_tmp50_ = _tmp49_;
#line 1139 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp48_, "$is_deleted", _tmp50_);
#line 1140 "../core/Services/Database.vala"
	_tmp51_ = stmt;
#line 1140 "../core/Services/Database.vala"
	_tmp52_ = objects_item_get_day_order (item);
#line 1140 "../core/Services/Database.vala"
	_tmp53_ = _tmp52_;
#line 1140 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp51_, "$day_order", _tmp53_);
#line 1141 "../core/Services/Database.vala"
	_tmp54_ = stmt;
#line 1141 "../core/Services/Database.vala"
	_tmp55_ = objects_item_get_collapsed (item);
#line 1141 "../core/Services/Database.vala"
	_tmp56_ = _tmp55_;
#line 1141 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp54_, "$collapsed", _tmp56_);
#line 1142 "../core/Services/Database.vala"
	_tmp57_ = stmt;
#line 1142 "../core/Services/Database.vala"
	_tmp58_ = objects_item_get_pinned (item);
#line 1142 "../core/Services/Database.vala"
	_tmp59_ = _tmp58_;
#line 1142 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp57_, "$pinned", _tmp59_);
#line 1143 "../core/Services/Database.vala"
	_tmp60_ = stmt;
#line 1143 "../core/Services/Database.vala"
	_tmp61_ = objects_item_get_labels (item);
#line 1143 "../core/Services/Database.vala"
	_tmp62_ = _tmp61_;
#line 1143 "../core/Services/Database.vala"
	_tmp63_ = services_database_get_labels_ids (self, _tmp62_);
#line 1143 "../core/Services/Database.vala"
	_tmp64_ = _tmp63_;
#line 1143 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp60_, "$labels", _tmp64_);
#line 1143 "../core/Services/Database.vala"
	_g_free0 (_tmp64_);
#line 1144 "../core/Services/Database.vala"
	_tmp65_ = stmt;
#line 1144 "../core/Services/Database.vala"
	_tmp66_ = objects_item_get_extra_data (item);
#line 1144 "../core/Services/Database.vala"
	_tmp67_ = _tmp66_;
#line 1144 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp65_, "$extra_data", _tmp67_);
#line 1146 "../core/Services/Database.vala"
	_tmp68_ = stmt;
#line 1146 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp68_) == SQLITE_DONE) {
#line 1147 "../core/Services/Database.vala"
		services_database_add_item (self, item, insert);
#line 6311 "Database.c"
	} else {
		sqlite3* _tmp69_;
		sqlite3* _tmp70_;
		const gchar* _tmp71_;
#line 1149 "../core/Services/Database.vala"
		_tmp69_ = self->priv->db;
#line 1149 "../core/Services/Database.vala"
		_tmp70_ = self->priv->db;
#line 1149 "../core/Services/Database.vala"
		_tmp71_ = sqlite3_errmsg (_tmp70_);
#line 1149 "../core/Services/Database.vala"
		g_warning ("Database.vala:1149: Error: %d: %s", sqlite3_errcode (_tmp69_), _tmp71_);
#line 6324 "Database.c"
	}
#line 1152 "../core/Services/Database.vala"
	_tmp72_ = stmt;
#line 1152 "../core/Services/Database.vala"
	sqlite3_reset (_tmp72_);
#line 1153 "../core/Services/Database.vala"
	_tmp73_ = stmt;
#line 1153 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp73_) == SQLITE_DONE;
#line 1153 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1153 "../core/Services/Database.vala"
	return result;
#line 6338 "Database.c"
}

void
services_database_add_item (ServicesDatabase* self,
                            ObjectsItem* item,
                            gboolean insert)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	ServicesEventBus* _tmp12_;
	ServicesEventBus* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
#line 1156 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1156 "../core/Services/Database.vala"
	g_return_if_fail (item != NULL);
#line 1157 "../core/Services/Database.vala"
	_tmp0_ = services_database_get_items (self);
#line 1157 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 1157 "../core/Services/Database.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, item);
#line 1158 "../core/Services/Database.vala"
	g_signal_emit (self, services_database_signals[SERVICES_DATABASE_ITEM_ADDED_SIGNAL], 0, item, insert);
#line 1160 "../core/Services/Database.vala"
	if (insert) {
#line 6368 "Database.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 1161 "../core/Services/Database.vala"
		_tmp2_ = objects_item_get_parent_id (item);
#line 1161 "../core/Services/Database.vala"
		_tmp3_ = _tmp2_;
#line 1161 "../core/Services/Database.vala"
		if (g_strcmp0 (_tmp3_, "") != 0) {
#line 6377 "Database.c"
			ObjectsItem* _tmp4_;
			ObjectsItem* _tmp5_;
#line 1162 "../core/Services/Database.vala"
			_tmp4_ = objects_item_get_parent (item);
#line 1162 "../core/Services/Database.vala"
			_tmp5_ = _tmp4_;
#line 1162 "../core/Services/Database.vala"
			g_signal_emit_by_name (_tmp5_, "item-added", item);
#line 6386 "Database.c"
		} else {
			const gchar* _tmp6_;
			const gchar* _tmp7_;
#line 1164 "../core/Services/Database.vala"
			_tmp6_ = objects_item_get_section_id (item);
#line 1164 "../core/Services/Database.vala"
			_tmp7_ = _tmp6_;
#line 1164 "../core/Services/Database.vala"
			if (g_strcmp0 (_tmp7_, "") == 0) {
#line 6396 "Database.c"
				ObjectsProject* _tmp8_;
				ObjectsProject* _tmp9_;
#line 1165 "../core/Services/Database.vala"
				_tmp8_ = objects_item_get_project (item);
#line 1165 "../core/Services/Database.vala"
				_tmp9_ = _tmp8_;
#line 1165 "../core/Services/Database.vala"
				g_signal_emit_by_name (_tmp9_, "item-added", item);
#line 6405 "Database.c"
			} else {
				ObjectsSection* _tmp10_;
				ObjectsSection* _tmp11_;
#line 1167 "../core/Services/Database.vala"
				_tmp10_ = objects_item_get_section (item);
#line 1167 "../core/Services/Database.vala"
				_tmp11_ = _tmp10_;
#line 1167 "../core/Services/Database.vala"
				g_signal_emit_by_name (_tmp11_, "item-added", item);
#line 6415 "Database.c"
			}
		}
	}
#line 1172 "../core/Services/Database.vala"
	_tmp12_ = services_event_bus_get_default ();
#line 1172 "../core/Services/Database.vala"
	_tmp13_ = _tmp12_;
#line 1172 "../core/Services/Database.vala"
	_tmp14_ = objects_item_get_project_id (item);
#line 1172 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1172 "../core/Services/Database.vala"
	_tmp16_ = objects_item_get_section_id (item);
#line 1172 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 1172 "../core/Services/Database.vala"
	g_signal_emit_by_name (_tmp13_, "update-items-position", _tmp15_, _tmp17_);
#line 1172 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp13_);
#line 6435 "Database.c"
}

GeeArrayList*
services_database_get_items_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp13_;
	GeeArrayList* result;
#line 1175 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1176 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1176 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1179 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("SELECT * FROM Items WHERE is_deleted = 0;");
#line 1179 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1179 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1181 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1181 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1181 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1181 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1181 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1181 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1181 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1181 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1183 "../core/Services/Database.vala"
	while (TRUE) {
#line 6483 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsItem* _tmp11_;
		ObjectsItem* _tmp12_;
#line 1183 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1183 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1183 "../core/Services/Database.vala"
			break;
#line 6495 "Database.c"
		}
#line 1184 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1184 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1184 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_item (self, _tmp10_);
#line 1184 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1184 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1184 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 6509 "Database.c"
	}
#line 1186 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1186 "../core/Services/Database.vala"
	sqlite3_reset (_tmp13_);
#line 1187 "../core/Services/Database.vala"
	result = return_value;
#line 1187 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1187 "../core/Services/Database.vala"
	return result;
#line 6521 "Database.c"
}

ObjectsItem*
services_database_get_item (ServicesDatabase* self,
                            const gchar* id)
{
	ObjectsItem* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsItem* result;
#line 1190 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1190 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1191 "../core/Services/Database.vala"
	return_value = NULL;
#line 6537 "Database.c"
	{
		GeeArrayList* _tmp0_;
#line 1192 "../core/Services/Database.vala"
		_tmp0_ = self->priv->_items;
#line 1192 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 6544 "Database.c"
		{
			ObjectsItem* _tmp15_;
			ObjectsItem* _tmp16_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _item_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _item_index = 0;
#line 1193 "../core/Services/Database.vala"
				_tmp1_ = services_database_get_items (self);
#line 1193 "../core/Services/Database.vala"
				_tmp2_ = _tmp1_;
#line 1193 "../core/Services/Database.vala"
				_item_list = _tmp2_;
#line 1193 "../core/Services/Database.vala"
				_tmp3_ = _item_list;
#line 1193 "../core/Services/Database.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 1193 "../core/Services/Database.vala"
				_tmp5_ = _tmp4_;
#line 1193 "../core/Services/Database.vala"
				_item_size = _tmp5_;
#line 1193 "../core/Services/Database.vala"
				_item_index = -1;
#line 1193 "../core/Services/Database.vala"
				while (TRUE) {
#line 6575 "Database.c"
					gint _tmp6_;
					gint _tmp7_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsItem* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
#line 1193 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1193 "../core/Services/Database.vala"
					_tmp6_ = _item_index;
#line 1193 "../core/Services/Database.vala"
					_tmp7_ = _item_size;
#line 1193 "../core/Services/Database.vala"
					if (!(_tmp6_ < _tmp7_)) {
#line 1193 "../core/Services/Database.vala"
						break;
#line 6594 "Database.c"
					}
#line 1193 "../core/Services/Database.vala"
					_tmp8_ = _item_list;
#line 1193 "../core/Services/Database.vala"
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _item_index);
#line 1193 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp9_;
#line 1194 "../core/Services/Database.vala"
					_tmp10_ = item;
#line 1194 "../core/Services/Database.vala"
					_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp10_);
#line 1194 "../core/Services/Database.vala"
					_tmp12_ = _tmp11_;
#line 1194 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp12_, id) == 0) {
#line 6610 "Database.c"
						ObjectsItem* _tmp13_;
						ObjectsItem* _tmp14_;
#line 1195 "../core/Services/Database.vala"
						_tmp13_ = item;
#line 1195 "../core/Services/Database.vala"
						_tmp14_ = _g_object_ref0 (_tmp13_);
#line 1195 "../core/Services/Database.vala"
						_g_object_unref0 (return_value);
#line 1195 "../core/Services/Database.vala"
						return_value = _tmp14_;
#line 1196 "../core/Services/Database.vala"
						_g_object_unref0 (item);
#line 1196 "../core/Services/Database.vala"
						break;
#line 6625 "Database.c"
					}
#line 1193 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 6629 "Database.c"
				}
			}
#line 1200 "../core/Services/Database.vala"
			_tmp15_ = return_value;
#line 1200 "../core/Services/Database.vala"
			_tmp16_ = _g_object_ref0 (_tmp15_);
#line 1200 "../core/Services/Database.vala"
			result = _tmp16_;
#line 6638 "Database.c"
			{
				GeeArrayList* _tmp17_;
#line 1192 "../core/Services/Database.vala"
				_tmp17_ = self->priv->_items;
#line 1192 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 6645 "Database.c"
			}
#line 1200 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1200 "../core/Services/Database.vala"
			return result;
#line 6651 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
#line 1192 "../core/Services/Database.vala"
			_tmp18_ = self->priv->_items;
#line 1192 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 6660 "Database.c"
		}
#line 1192 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1192 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1192 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1192 "../core/Services/Database.vala"
		return NULL;
#line 6670 "Database.c"
	}
}

ObjectsItem*
services_database_get_item_by_ics (ServicesDatabase* self,
                                   const gchar* ics)
{
	ObjectsItem* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsItem* result;
#line 1204 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1204 "../core/Services/Database.vala"
	g_return_val_if_fail (ics != NULL, NULL);
#line 1205 "../core/Services/Database.vala"
	return_value = NULL;
#line 6687 "Database.c"
	{
		GeeArrayList* _tmp0_;
#line 1206 "../core/Services/Database.vala"
		_tmp0_ = self->priv->_items;
#line 1206 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 6694 "Database.c"
		{
			ObjectsItem* _tmp15_;
			ObjectsItem* _tmp16_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _item_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _item_index = 0;
#line 1207 "../core/Services/Database.vala"
				_tmp1_ = services_database_get_items (self);
#line 1207 "../core/Services/Database.vala"
				_tmp2_ = _tmp1_;
#line 1207 "../core/Services/Database.vala"
				_item_list = _tmp2_;
#line 1207 "../core/Services/Database.vala"
				_tmp3_ = _item_list;
#line 1207 "../core/Services/Database.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 1207 "../core/Services/Database.vala"
				_tmp5_ = _tmp4_;
#line 1207 "../core/Services/Database.vala"
				_item_size = _tmp5_;
#line 1207 "../core/Services/Database.vala"
				_item_index = -1;
#line 1207 "../core/Services/Database.vala"
				while (TRUE) {
#line 6725 "Database.c"
					gint _tmp6_;
					gint _tmp7_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsItem* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
#line 1207 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1207 "../core/Services/Database.vala"
					_tmp6_ = _item_index;
#line 1207 "../core/Services/Database.vala"
					_tmp7_ = _item_size;
#line 1207 "../core/Services/Database.vala"
					if (!(_tmp6_ < _tmp7_)) {
#line 1207 "../core/Services/Database.vala"
						break;
#line 6744 "Database.c"
					}
#line 1207 "../core/Services/Database.vala"
					_tmp8_ = _item_list;
#line 1207 "../core/Services/Database.vala"
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _item_index);
#line 1207 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp9_;
#line 1208 "../core/Services/Database.vala"
					_tmp10_ = item;
#line 1208 "../core/Services/Database.vala"
					_tmp11_ = objects_item_get_ics (_tmp10_);
#line 1208 "../core/Services/Database.vala"
					_tmp12_ = _tmp11_;
#line 1208 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp12_, ics) == 0) {
#line 6760 "Database.c"
						ObjectsItem* _tmp13_;
						ObjectsItem* _tmp14_;
#line 1209 "../core/Services/Database.vala"
						_tmp13_ = item;
#line 1209 "../core/Services/Database.vala"
						_tmp14_ = _g_object_ref0 (_tmp13_);
#line 1209 "../core/Services/Database.vala"
						_g_object_unref0 (return_value);
#line 1209 "../core/Services/Database.vala"
						return_value = _tmp14_;
#line 1210 "../core/Services/Database.vala"
						_g_object_unref0 (item);
#line 1210 "../core/Services/Database.vala"
						break;
#line 6775 "Database.c"
					}
#line 1207 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 6779 "Database.c"
				}
			}
#line 1214 "../core/Services/Database.vala"
			_tmp15_ = return_value;
#line 1214 "../core/Services/Database.vala"
			_tmp16_ = _g_object_ref0 (_tmp15_);
#line 1214 "../core/Services/Database.vala"
			result = _tmp16_;
#line 6788 "Database.c"
			{
				GeeArrayList* _tmp17_;
#line 1206 "../core/Services/Database.vala"
				_tmp17_ = self->priv->_items;
#line 1206 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 6795 "Database.c"
			}
#line 1214 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1214 "../core/Services/Database.vala"
			return result;
#line 6801 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
#line 1206 "../core/Services/Database.vala"
			_tmp18_ = self->priv->_items;
#line 1206 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 6810 "Database.c"
		}
#line 1206 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1206 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1206 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1206 "../core/Services/Database.vala"
		return NULL;
#line 6820 "Database.c"
	}
}

ObjectsItem*
services_database_get_item_by_id (ServicesDatabase* self,
                                  const gchar* id)
{
	ObjectsItem* returned = NULL;
	ObjectsItem* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp12_;
	ObjectsItem* result;
#line 1218 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1218 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1219 "../core/Services/Database.vala"
	_tmp0_ = objects_item_new ();
#line 1219 "../core/Services/Database.vala"
	returned = _tmp0_;
#line 1222 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("SELECT * FROM Items WHERE id = $id LIMIT 1;");
#line 1222 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1222 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1224 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1224 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1224 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1224 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1224 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1224 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1224 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1224 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1225 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1225 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$id", id);
#line 1227 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1227 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) == SQLITE_ROW) {
#line 6880 "Database.c"
		sqlite3_stmt* _tmp10_;
		ObjectsItem* _tmp11_;
#line 1228 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1228 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_item (self, _tmp10_);
#line 1228 "../core/Services/Database.vala"
		_g_object_unref0 (returned);
#line 1228 "../core/Services/Database.vala"
		returned = _tmp11_;
#line 6891 "Database.c"
	}
#line 1231 "../core/Services/Database.vala"
	_tmp12_ = stmt;
#line 1231 "../core/Services/Database.vala"
	sqlite3_reset (_tmp12_);
#line 1232 "../core/Services/Database.vala"
	result = returned;
#line 1232 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1232 "../core/Services/Database.vala"
	return result;
#line 6903 "Database.c"
}

GeeArrayList*
services_database_get_item_by_baseobject (ServicesDatabase* self,
                                          ObjectsBaseObject* object)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1235 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1235 "../core/Services/Database.vala"
	g_return_val_if_fail (object != NULL, NULL);
#line 1236 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1236 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 6922 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1237 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1237 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 6929 "Database.c"
		{
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1238 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1238 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1238 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1238 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1238 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1238 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1238 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1238 "../core/Services/Database.vala"
				_item_index = -1;
#line 1238 "../core/Services/Database.vala"
				while (TRUE) {
#line 6958 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
#line 1238 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1238 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1238 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1238 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1238 "../core/Services/Database.vala"
						break;
#line 6974 "Database.c"
					}
#line 1238 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1238 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1238 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1239 "../core/Services/Database.vala"
					if (OBJECTS_IS_PROJECT (object)) {
#line 6984 "Database.c"
						gboolean _tmp11_ = FALSE;
						gboolean _tmp12_ = FALSE;
						ObjectsItem* _tmp13_;
						const gchar* _tmp14_;
						const gchar* _tmp15_;
						const gchar* _tmp16_;
						const gchar* _tmp17_;
#line 1240 "../core/Services/Database.vala"
						_tmp13_ = item;
#line 1240 "../core/Services/Database.vala"
						_tmp14_ = objects_item_get_project_id (_tmp13_);
#line 1240 "../core/Services/Database.vala"
						_tmp15_ = _tmp14_;
#line 1240 "../core/Services/Database.vala"
						_tmp16_ = objects_base_object_get_id (object);
#line 1240 "../core/Services/Database.vala"
						_tmp17_ = _tmp16_;
#line 1240 "../core/Services/Database.vala"
						if (g_strcmp0 (_tmp15_, _tmp17_) == 0) {
#line 7004 "Database.c"
							ObjectsItem* _tmp18_;
							const gchar* _tmp19_;
							const gchar* _tmp20_;
#line 1240 "../core/Services/Database.vala"
							_tmp18_ = item;
#line 1240 "../core/Services/Database.vala"
							_tmp19_ = objects_item_get_section_id (_tmp18_);
#line 1240 "../core/Services/Database.vala"
							_tmp20_ = _tmp19_;
#line 1240 "../core/Services/Database.vala"
							_tmp12_ = g_strcmp0 (_tmp20_, "") == 0;
#line 7016 "Database.c"
						} else {
#line 1240 "../core/Services/Database.vala"
							_tmp12_ = FALSE;
#line 7020 "Database.c"
						}
#line 1240 "../core/Services/Database.vala"
						if (_tmp12_) {
#line 7024 "Database.c"
							ObjectsItem* _tmp21_;
							const gchar* _tmp22_;
							const gchar* _tmp23_;
#line 1240 "../core/Services/Database.vala"
							_tmp21_ = item;
#line 1240 "../core/Services/Database.vala"
							_tmp22_ = objects_item_get_parent_id (_tmp21_);
#line 1240 "../core/Services/Database.vala"
							_tmp23_ = _tmp22_;
#line 1240 "../core/Services/Database.vala"
							_tmp11_ = g_strcmp0 (_tmp23_, "") == 0;
#line 7036 "Database.c"
						} else {
#line 1240 "../core/Services/Database.vala"
							_tmp11_ = FALSE;
#line 7040 "Database.c"
						}
#line 1240 "../core/Services/Database.vala"
						if (_tmp11_) {
#line 7044 "Database.c"
							GeeArrayList* _tmp24_;
							ObjectsItem* _tmp25_;
#line 1241 "../core/Services/Database.vala"
							_tmp24_ = return_value;
#line 1241 "../core/Services/Database.vala"
							_tmp25_ = item;
#line 1241 "../core/Services/Database.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp25_);
#line 7053 "Database.c"
						}
					}
#line 1245 "../core/Services/Database.vala"
					if (OBJECTS_IS_SECTION (object)) {
#line 7058 "Database.c"
						gboolean _tmp26_ = FALSE;
						ObjectsItem* _tmp27_;
						const gchar* _tmp28_;
						const gchar* _tmp29_;
						const gchar* _tmp30_;
						const gchar* _tmp31_;
#line 1246 "../core/Services/Database.vala"
						_tmp27_ = item;
#line 1246 "../core/Services/Database.vala"
						_tmp28_ = objects_item_get_section_id (_tmp27_);
#line 1246 "../core/Services/Database.vala"
						_tmp29_ = _tmp28_;
#line 1246 "../core/Services/Database.vala"
						_tmp30_ = objects_base_object_get_id (object);
#line 1246 "../core/Services/Database.vala"
						_tmp31_ = _tmp30_;
#line 1246 "../core/Services/Database.vala"
						if (g_strcmp0 (_tmp29_, _tmp31_) == 0) {
#line 7077 "Database.c"
							ObjectsItem* _tmp32_;
							const gchar* _tmp33_;
							const gchar* _tmp34_;
#line 1246 "../core/Services/Database.vala"
							_tmp32_ = item;
#line 1246 "../core/Services/Database.vala"
							_tmp33_ = objects_item_get_parent_id (_tmp32_);
#line 1246 "../core/Services/Database.vala"
							_tmp34_ = _tmp33_;
#line 1246 "../core/Services/Database.vala"
							_tmp26_ = g_strcmp0 (_tmp34_, "") == 0;
#line 7089 "Database.c"
						} else {
#line 1246 "../core/Services/Database.vala"
							_tmp26_ = FALSE;
#line 7093 "Database.c"
						}
#line 1246 "../core/Services/Database.vala"
						if (_tmp26_) {
#line 7097 "Database.c"
							GeeArrayList* _tmp35_;
							ObjectsItem* _tmp36_;
#line 1247 "../core/Services/Database.vala"
							_tmp35_ = return_value;
#line 1247 "../core/Services/Database.vala"
							_tmp36_ = item;
#line 1247 "../core/Services/Database.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp35_, _tmp36_);
#line 7106 "Database.c"
						}
					}
#line 1238 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 7111 "Database.c"
				}
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp37_;
#line 1237 "../core/Services/Database.vala"
			_tmp37_ = self->priv->_items;
#line 1237 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 7122 "Database.c"
		}
#line 1237 "../core/Services/Database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1237 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1237 "../core/Services/Database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1237 "../core/Services/Database.vala"
			g_clear_error (&_inner_error0_);
#line 1237 "../core/Services/Database.vala"
			return NULL;
#line 7134 "Database.c"
		}
	}
#line 1253 "../core/Services/Database.vala"
	result = return_value;
#line 1253 "../core/Services/Database.vala"
	return result;
#line 7141 "Database.c"
}

GeeArrayList*
services_database_get_items_by_project (ServicesDatabase* self,
                                        ObjectsProject* project)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1256 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1256 "../core/Services/Database.vala"
	g_return_val_if_fail (project != NULL, NULL);
#line 1257 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1257 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 7160 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1258 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1258 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 7167 "Database.c"
		{
			GeeArrayList* _tmp18_;
			GeeArrayList* _tmp19_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1259 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1259 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1259 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1259 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1259 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1259 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1259 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1259 "../core/Services/Database.vala"
				_item_index = -1;
#line 1259 "../core/Services/Database.vala"
				while (TRUE) {
#line 7198 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 1259 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1259 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1259 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1259 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1259 "../core/Services/Database.vala"
						break;
#line 7219 "Database.c"
					}
#line 1259 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1259 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1259 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1260 "../core/Services/Database.vala"
					_tmp11_ = item;
#line 1260 "../core/Services/Database.vala"
					_tmp12_ = objects_item_get_project_id (_tmp11_);
#line 1260 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 1260 "../core/Services/Database.vala"
					_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 1260 "../core/Services/Database.vala"
					_tmp15_ = _tmp14_;
#line 1260 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
#line 7239 "Database.c"
						GeeArrayList* _tmp16_;
						ObjectsItem* _tmp17_;
#line 1261 "../core/Services/Database.vala"
						_tmp16_ = return_value;
#line 1261 "../core/Services/Database.vala"
						_tmp17_ = item;
#line 1261 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 7248 "Database.c"
					}
#line 1259 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 7252 "Database.c"
				}
			}
#line 1265 "../core/Services/Database.vala"
			_tmp18_ = return_value;
#line 1265 "../core/Services/Database.vala"
			_tmp19_ = _g_object_ref0 (_tmp18_);
#line 1265 "../core/Services/Database.vala"
			result = _tmp19_;
#line 7261 "Database.c"
			{
				GeeArrayList* _tmp20_;
#line 1258 "../core/Services/Database.vala"
				_tmp20_ = self->priv->_items;
#line 1258 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 7268 "Database.c"
			}
#line 1265 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1265 "../core/Services/Database.vala"
			return result;
#line 7274 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp21_;
#line 1258 "../core/Services/Database.vala"
			_tmp21_ = self->priv->_items;
#line 1258 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 7283 "Database.c"
		}
#line 1258 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1258 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1258 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1258 "../core/Services/Database.vala"
		return NULL;
#line 7293 "Database.c"
	}
}

GeeArrayList*
services_database_get_items_checked_by_project (ServicesDatabase* self,
                                                ObjectsProject* project)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1269 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1269 "../core/Services/Database.vala"
	g_return_val_if_fail (project != NULL, NULL);
#line 1270 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1270 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 7313 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1271 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1271 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 7320 "Database.c"
		{
			GeeArrayList* _tmp22_;
			GeeArrayList* _tmp23_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1272 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1272 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1272 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1272 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1272 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1272 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1272 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1272 "../core/Services/Database.vala"
				_item_index = -1;
#line 1272 "../core/Services/Database.vala"
				while (TRUE) {
#line 7351 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsItem* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
#line 1272 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1272 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1272 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1272 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1272 "../core/Services/Database.vala"
						break;
#line 7373 "Database.c"
					}
#line 1272 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1272 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1272 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1273 "../core/Services/Database.vala"
					_tmp12_ = item;
#line 1273 "../core/Services/Database.vala"
					_tmp13_ = objects_item_get_project_id (_tmp12_);
#line 1273 "../core/Services/Database.vala"
					_tmp14_ = _tmp13_;
#line 1273 "../core/Services/Database.vala"
					_tmp15_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 1273 "../core/Services/Database.vala"
					_tmp16_ = _tmp15_;
#line 1273 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp14_, _tmp16_) == 0) {
#line 7393 "Database.c"
						ObjectsItem* _tmp17_;
						gboolean _tmp18_;
						gboolean _tmp19_;
#line 1273 "../core/Services/Database.vala"
						_tmp17_ = item;
#line 1273 "../core/Services/Database.vala"
						_tmp18_ = objects_item_get_checked (_tmp17_);
#line 1273 "../core/Services/Database.vala"
						_tmp19_ = _tmp18_;
#line 1273 "../core/Services/Database.vala"
						_tmp11_ = _tmp19_;
#line 7405 "Database.c"
					} else {
#line 1273 "../core/Services/Database.vala"
						_tmp11_ = FALSE;
#line 7409 "Database.c"
					}
#line 1273 "../core/Services/Database.vala"
					if (_tmp11_) {
#line 7413 "Database.c"
						GeeArrayList* _tmp20_;
						ObjectsItem* _tmp21_;
#line 1274 "../core/Services/Database.vala"
						_tmp20_ = return_value;
#line 1274 "../core/Services/Database.vala"
						_tmp21_ = item;
#line 1274 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 7422 "Database.c"
					}
#line 1272 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 7426 "Database.c"
				}
			}
#line 1278 "../core/Services/Database.vala"
			_tmp22_ = return_value;
#line 1278 "../core/Services/Database.vala"
			_tmp23_ = _g_object_ref0 (_tmp22_);
#line 1278 "../core/Services/Database.vala"
			result = _tmp23_;
#line 7435 "Database.c"
			{
				GeeArrayList* _tmp24_;
#line 1271 "../core/Services/Database.vala"
				_tmp24_ = self->priv->_items;
#line 1271 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 7442 "Database.c"
			}
#line 1278 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1278 "../core/Services/Database.vala"
			return result;
#line 7448 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp25_;
#line 1271 "../core/Services/Database.vala"
			_tmp25_ = self->priv->_items;
#line 1271 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 7457 "Database.c"
		}
#line 1271 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1271 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1271 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1271 "../core/Services/Database.vala"
		return NULL;
#line 7467 "Database.c"
	}
}

ObjectsItem*
_services_database_fill_item (ServicesDatabase* self,
                              sqlite3_stmt* stmt)
{
	ObjectsItem* return_value = NULL;
	ObjectsItem* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	ObjectsDueDate* _tmp4_;
	ObjectsDueDate* _tmp5_;
	const gchar* _tmp6_;
	JsonObject* _tmp7_;
	JsonObject* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GeeArrayList* _tmp16_;
	GeeArrayList* _tmp17_;
	const gchar* _tmp18_;
	ObjectsItem* result;
#line 1282 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1282 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1283 "../core/Services/Database.vala"
	_tmp0_ = objects_item_new ();
#line 1283 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1284 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1284 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 1285 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1285 "../core/Services/Database.vala"
	objects_item_set_content (return_value, _tmp2_);
#line 1286 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1286 "../core/Services/Database.vala"
	objects_item_set_description (return_value, _tmp3_);
#line 1287 "../core/Services/Database.vala"
	_tmp4_ = objects_item_get_due (return_value);
#line 1287 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1287 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1287 "../core/Services/Database.vala"
	_tmp7_ = services_database_get_due_parameter (self, _tmp6_);
#line 1287 "../core/Services/Database.vala"
	_tmp8_ = _tmp7_;
#line 1287 "../core/Services/Database.vala"
	objects_due_date_update_from_json (_tmp5_, _tmp8_);
#line 1287 "../core/Services/Database.vala"
	_json_object_unref0 (_tmp8_);
#line 1288 "../core/Services/Database.vala"
	_tmp9_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 1288 "../core/Services/Database.vala"
	objects_item_set_added_at (return_value, _tmp9_);
#line 1289 "../core/Services/Database.vala"
	_tmp10_ = (const gchar*) sqlite3_column_text (stmt, 5);
#line 1289 "../core/Services/Database.vala"
	objects_item_set_completed_at (return_value, _tmp10_);
#line 1290 "../core/Services/Database.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (stmt, 6);
#line 1290 "../core/Services/Database.vala"
	objects_item_set_updated_at (return_value, _tmp11_);
#line 1291 "../core/Services/Database.vala"
	_tmp12_ = (const gchar*) sqlite3_column_text (stmt, 7);
#line 1291 "../core/Services/Database.vala"
	objects_item_set_section_id (return_value, _tmp12_);
#line 1292 "../core/Services/Database.vala"
	_tmp13_ = (const gchar*) sqlite3_column_text (stmt, 8);
#line 1292 "../core/Services/Database.vala"
	objects_item_set_project_id (return_value, _tmp13_);
#line 1293 "../core/Services/Database.vala"
	_tmp14_ = (const gchar*) sqlite3_column_text (stmt, 9);
#line 1293 "../core/Services/Database.vala"
	objects_item_set_parent_id (return_value, _tmp14_);
#line 1294 "../core/Services/Database.vala"
	objects_item_set_priority (return_value, sqlite3_column_int (stmt, 10));
#line 1295 "../core/Services/Database.vala"
	objects_item_set_child_order (return_value, sqlite3_column_int (stmt, 11));
#line 1296 "../core/Services/Database.vala"
	objects_item_set_checked (return_value, services_database_get_parameter_bool (self, stmt, 12));
#line 1297 "../core/Services/Database.vala"
	objects_item_set_is_deleted (return_value, services_database_get_parameter_bool (self, stmt, 13));
#line 1298 "../core/Services/Database.vala"
	objects_item_set_day_order (return_value, sqlite3_column_int (stmt, 14));
#line 1299 "../core/Services/Database.vala"
	objects_item_set_collapsed (return_value, services_database_get_parameter_bool (self, stmt, 15));
#line 1300 "../core/Services/Database.vala"
	objects_item_set_pinned (return_value, services_database_get_parameter_bool (self, stmt, 16));
#line 1301 "../core/Services/Database.vala"
	_tmp15_ = (const gchar*) sqlite3_column_text (stmt, 17);
#line 1301 "../core/Services/Database.vala"
	_tmp16_ = services_database_get_labels_by_item_labels (self, _tmp15_);
#line 1301 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 1301 "../core/Services/Database.vala"
	objects_item_set_labels (return_value, _tmp17_);
#line 1301 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp17_);
#line 1302 "../core/Services/Database.vala"
	_tmp18_ = (const gchar*) sqlite3_column_text (stmt, 18);
#line 1302 "../core/Services/Database.vala"
	objects_item_set_extra_data (return_value, _tmp18_);
#line 1304 "../core/Services/Database.vala"
	result = return_value;
#line 1304 "../core/Services/Database.vala"
	return result;
#line 7586 "Database.c"
}

GeeArrayList*
services_database_get_items_by_date (ServicesDatabase* self,
                                     GDateTime* date,
                                     gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1307 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1307 "../core/Services/Database.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 1308 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1308 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 7606 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1309 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1309 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 7613 "Database.c"
		{
			GeeArrayList* _tmp14_;
			GeeArrayList* _tmp15_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1310 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1310 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1310 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1310 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1310 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1310 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1310 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1310 "../core/Services/Database.vala"
				_item_index = -1;
#line 1310 "../core/Services/Database.vala"
				while (TRUE) {
#line 7644 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
#line 1310 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1310 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1310 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1310 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1310 "../core/Services/Database.vala"
						break;
#line 7661 "Database.c"
					}
#line 1310 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1310 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1310 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1311 "../core/Services/Database.vala"
					_tmp11_ = item;
#line 1311 "../core/Services/Database.vala"
					if (services_database_valid_item_by_date (self, _tmp11_, date, checked)) {
#line 7673 "Database.c"
						GeeArrayList* _tmp12_;
						ObjectsItem* _tmp13_;
#line 1312 "../core/Services/Database.vala"
						_tmp12_ = return_value;
#line 1312 "../core/Services/Database.vala"
						_tmp13_ = item;
#line 1312 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 7682 "Database.c"
					}
#line 1310 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 7686 "Database.c"
				}
			}
#line 1316 "../core/Services/Database.vala"
			_tmp14_ = return_value;
#line 1316 "../core/Services/Database.vala"
			_tmp15_ = _g_object_ref0 (_tmp14_);
#line 1316 "../core/Services/Database.vala"
			result = _tmp15_;
#line 7695 "Database.c"
			{
				GeeArrayList* _tmp16_;
#line 1309 "../core/Services/Database.vala"
				_tmp16_ = self->priv->_items;
#line 1309 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 7702 "Database.c"
			}
#line 1316 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1316 "../core/Services/Database.vala"
			return result;
#line 7708 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp17_;
#line 1309 "../core/Services/Database.vala"
			_tmp17_ = self->priv->_items;
#line 1309 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 7717 "Database.c"
		}
#line 1309 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1309 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1309 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1309 "../core/Services/Database.vala"
		return NULL;
#line 7727 "Database.c"
	}
}

GeeArrayList*
services_database_get_items_no_date (ServicesDatabase* self,
                                     gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1320 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1321 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1321 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 7745 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1322 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1322 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 7752 "Database.c"
		{
			GeeArrayList* _tmp20_;
			GeeArrayList* _tmp21_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1323 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1323 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1323 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1323 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1323 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1323 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1323 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1323 "../core/Services/Database.vala"
				_item_index = -1;
#line 1323 "../core/Services/Database.vala"
				while (TRUE) {
#line 7783 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsItem* _tmp12_;
					gboolean _tmp13_;
					gboolean _tmp14_;
#line 1323 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1323 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1323 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1323 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1323 "../core/Services/Database.vala"
						break;
#line 7803 "Database.c"
					}
#line 1323 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1323 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1323 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1324 "../core/Services/Database.vala"
					_tmp12_ = item;
#line 1324 "../core/Services/Database.vala"
					_tmp13_ = objects_item_get_has_due (_tmp12_);
#line 1324 "../core/Services/Database.vala"
					_tmp14_ = _tmp13_;
#line 1324 "../core/Services/Database.vala"
					if (!_tmp14_) {
#line 7819 "Database.c"
						ObjectsItem* _tmp15_;
						gboolean _tmp16_;
						gboolean _tmp17_;
#line 1324 "../core/Services/Database.vala"
						_tmp15_ = item;
#line 1324 "../core/Services/Database.vala"
						_tmp16_ = objects_item_get_checked (_tmp15_);
#line 1324 "../core/Services/Database.vala"
						_tmp17_ = _tmp16_;
#line 1324 "../core/Services/Database.vala"
						_tmp11_ = _tmp17_ == checked;
#line 7831 "Database.c"
					} else {
#line 1324 "../core/Services/Database.vala"
						_tmp11_ = FALSE;
#line 7835 "Database.c"
					}
#line 1324 "../core/Services/Database.vala"
					if (_tmp11_) {
#line 7839 "Database.c"
						GeeArrayList* _tmp18_;
						ObjectsItem* _tmp19_;
#line 1325 "../core/Services/Database.vala"
						_tmp18_ = return_value;
#line 1325 "../core/Services/Database.vala"
						_tmp19_ = item;
#line 1325 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 7848 "Database.c"
					}
#line 1323 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 7852 "Database.c"
				}
			}
#line 1329 "../core/Services/Database.vala"
			_tmp20_ = return_value;
#line 1329 "../core/Services/Database.vala"
			_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1329 "../core/Services/Database.vala"
			result = _tmp21_;
#line 7861 "Database.c"
			{
				GeeArrayList* _tmp22_;
#line 1322 "../core/Services/Database.vala"
				_tmp22_ = self->priv->_items;
#line 1322 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 7868 "Database.c"
			}
#line 1329 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1329 "../core/Services/Database.vala"
			return result;
#line 7874 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp23_;
#line 1322 "../core/Services/Database.vala"
			_tmp23_ = self->priv->_items;
#line 1322 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 7883 "Database.c"
		}
#line 1322 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1322 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1322 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1322 "../core/Services/Database.vala"
		return NULL;
#line 7893 "Database.c"
	}
}

GeeArrayList*
services_database_get_items_repeating (ServicesDatabase* self,
                                       gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1333 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1334 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1334 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 7911 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1335 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1335 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 7918 "Database.c"
		{
			GeeArrayList* _tmp26_;
			GeeArrayList* _tmp27_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1336 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1336 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1336 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1336 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1336 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1336 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1336 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1336 "../core/Services/Database.vala"
				_item_index = -1;
#line 1336 "../core/Services/Database.vala"
				while (TRUE) {
#line 7949 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					ObjectsItem* _tmp13_;
					gboolean _tmp14_;
					gboolean _tmp15_;
#line 1336 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1336 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1336 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1336 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1336 "../core/Services/Database.vala"
						break;
#line 7970 "Database.c"
					}
#line 1336 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1336 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1336 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1337 "../core/Services/Database.vala"
					_tmp13_ = item;
#line 1337 "../core/Services/Database.vala"
					_tmp14_ = objects_item_get_has_due (_tmp13_);
#line 1337 "../core/Services/Database.vala"
					_tmp15_ = _tmp14_;
#line 1337 "../core/Services/Database.vala"
					if (_tmp15_) {
#line 7986 "Database.c"
						ObjectsItem* _tmp16_;
						ObjectsDueDate* _tmp17_;
						ObjectsDueDate* _tmp18_;
						gboolean _tmp19_;
						gboolean _tmp20_;
#line 1337 "../core/Services/Database.vala"
						_tmp16_ = item;
#line 1337 "../core/Services/Database.vala"
						_tmp17_ = objects_item_get_due (_tmp16_);
#line 1337 "../core/Services/Database.vala"
						_tmp18_ = _tmp17_;
#line 1337 "../core/Services/Database.vala"
						_tmp19_ = objects_due_date_get_is_recurring (_tmp18_);
#line 1337 "../core/Services/Database.vala"
						_tmp20_ = _tmp19_;
#line 1337 "../core/Services/Database.vala"
						_tmp12_ = _tmp20_;
#line 8004 "Database.c"
					} else {
#line 1337 "../core/Services/Database.vala"
						_tmp12_ = FALSE;
#line 8008 "Database.c"
					}
#line 1337 "../core/Services/Database.vala"
					if (_tmp12_) {
#line 8012 "Database.c"
						ObjectsItem* _tmp21_;
						gboolean _tmp22_;
						gboolean _tmp23_;
#line 1337 "../core/Services/Database.vala"
						_tmp21_ = item;
#line 1337 "../core/Services/Database.vala"
						_tmp22_ = objects_item_get_checked (_tmp21_);
#line 1337 "../core/Services/Database.vala"
						_tmp23_ = _tmp22_;
#line 1337 "../core/Services/Database.vala"
						_tmp11_ = _tmp23_ == checked;
#line 8024 "Database.c"
					} else {
#line 1337 "../core/Services/Database.vala"
						_tmp11_ = FALSE;
#line 8028 "Database.c"
					}
#line 1337 "../core/Services/Database.vala"
					if (_tmp11_) {
#line 8032 "Database.c"
						GeeArrayList* _tmp24_;
						ObjectsItem* _tmp25_;
#line 1338 "../core/Services/Database.vala"
						_tmp24_ = return_value;
#line 1338 "../core/Services/Database.vala"
						_tmp25_ = item;
#line 1338 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp25_);
#line 8041 "Database.c"
					}
#line 1336 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 8045 "Database.c"
				}
			}
#line 1342 "../core/Services/Database.vala"
			_tmp26_ = return_value;
#line 1342 "../core/Services/Database.vala"
			_tmp27_ = _g_object_ref0 (_tmp26_);
#line 1342 "../core/Services/Database.vala"
			result = _tmp27_;
#line 8054 "Database.c"
			{
				GeeArrayList* _tmp28_;
#line 1335 "../core/Services/Database.vala"
				_tmp28_ = self->priv->_items;
#line 1335 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 8061 "Database.c"
			}
#line 1342 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1342 "../core/Services/Database.vala"
			return result;
#line 8067 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp29_;
#line 1335 "../core/Services/Database.vala"
			_tmp29_ = self->priv->_items;
#line 1335 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 8076 "Database.c"
		}
#line 1335 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1335 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1335 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1335 "../core/Services/Database.vala"
		return NULL;
#line 8086 "Database.c"
	}
}

GeeArrayList*
services_database_get_items_by_date_range (ServicesDatabase* self,
                                           GDateTime* start_date,
                                           GDateTime* end_date,
                                           gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1346 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1346 "../core/Services/Database.vala"
	g_return_val_if_fail (start_date != NULL, NULL);
#line 1346 "../core/Services/Database.vala"
	g_return_val_if_fail (end_date != NULL, NULL);
#line 1347 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1347 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 8110 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1348 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1348 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 8117 "Database.c"
		{
			GeeArrayList* _tmp14_;
			GeeArrayList* _tmp15_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1349 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1349 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1349 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1349 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1349 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1349 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1349 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1349 "../core/Services/Database.vala"
				_item_index = -1;
#line 1349 "../core/Services/Database.vala"
				while (TRUE) {
#line 8148 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
#line 1349 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1349 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1349 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1349 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1349 "../core/Services/Database.vala"
						break;
#line 8165 "Database.c"
					}
#line 1349 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1349 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1349 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1350 "../core/Services/Database.vala"
					_tmp11_ = item;
#line 1350 "../core/Services/Database.vala"
					if (services_database_valid_item_by_date_range (self, _tmp11_, start_date, end_date, checked)) {
#line 8177 "Database.c"
						GeeArrayList* _tmp12_;
						ObjectsItem* _tmp13_;
#line 1351 "../core/Services/Database.vala"
						_tmp12_ = return_value;
#line 1351 "../core/Services/Database.vala"
						_tmp13_ = item;
#line 1351 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 8186 "Database.c"
					}
#line 1349 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 8190 "Database.c"
				}
			}
#line 1355 "../core/Services/Database.vala"
			_tmp14_ = return_value;
#line 1355 "../core/Services/Database.vala"
			_tmp15_ = _g_object_ref0 (_tmp14_);
#line 1355 "../core/Services/Database.vala"
			result = _tmp15_;
#line 8199 "Database.c"
			{
				GeeArrayList* _tmp16_;
#line 1348 "../core/Services/Database.vala"
				_tmp16_ = self->priv->_items;
#line 1348 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 8206 "Database.c"
			}
#line 1355 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1355 "../core/Services/Database.vala"
			return result;
#line 8212 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp17_;
#line 1348 "../core/Services/Database.vala"
			_tmp17_ = self->priv->_items;
#line 1348 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 8221 "Database.c"
		}
#line 1348 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1348 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1348 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1348 "../core/Services/Database.vala"
		return NULL;
#line 8231 "Database.c"
	}
}

GeeArrayList*
services_database_get_items_by_month (ServicesDatabase* self,
                                      GDateTime* date,
                                      gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1359 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1359 "../core/Services/Database.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 1360 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1360 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 8252 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1361 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1361 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 8259 "Database.c"
		{
			GeeArrayList* _tmp14_;
			GeeArrayList* _tmp15_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1362 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1362 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1362 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1362 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1362 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1362 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1362 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1362 "../core/Services/Database.vala"
				_item_index = -1;
#line 1362 "../core/Services/Database.vala"
				while (TRUE) {
#line 8290 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
#line 1362 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1362 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1362 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1362 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1362 "../core/Services/Database.vala"
						break;
#line 8307 "Database.c"
					}
#line 1362 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1362 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1362 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1363 "../core/Services/Database.vala"
					_tmp11_ = item;
#line 1363 "../core/Services/Database.vala"
					if (services_database_valid_item_by_month (self, _tmp11_, date, checked)) {
#line 8319 "Database.c"
						GeeArrayList* _tmp12_;
						ObjectsItem* _tmp13_;
#line 1364 "../core/Services/Database.vala"
						_tmp12_ = return_value;
#line 1364 "../core/Services/Database.vala"
						_tmp13_ = item;
#line 1364 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 8328 "Database.c"
					}
#line 1362 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 8332 "Database.c"
				}
			}
#line 1368 "../core/Services/Database.vala"
			_tmp14_ = return_value;
#line 1368 "../core/Services/Database.vala"
			_tmp15_ = _g_object_ref0 (_tmp14_);
#line 1368 "../core/Services/Database.vala"
			result = _tmp15_;
#line 8341 "Database.c"
			{
				GeeArrayList* _tmp16_;
#line 1361 "../core/Services/Database.vala"
				_tmp16_ = self->priv->_items;
#line 1361 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 8348 "Database.c"
			}
#line 1368 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1368 "../core/Services/Database.vala"
			return result;
#line 8354 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp17_;
#line 1361 "../core/Services/Database.vala"
			_tmp17_ = self->priv->_items;
#line 1361 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 8363 "Database.c"
		}
#line 1361 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1361 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1361 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1361 "../core/Services/Database.vala"
		return NULL;
#line 8373 "Database.c"
	}
}

GeeArrayList*
services_database_get_items_pinned (ServicesDatabase* self,
                                    gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1372 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1373 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1373 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 8391 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1374 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1374 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 8398 "Database.c"
		{
			GeeArrayList* _tmp20_;
			GeeArrayList* _tmp21_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1375 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1375 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1375 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1375 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1375 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1375 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1375 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1375 "../core/Services/Database.vala"
				_item_index = -1;
#line 1375 "../core/Services/Database.vala"
				while (TRUE) {
#line 8429 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsItem* _tmp12_;
					gboolean _tmp13_;
					gboolean _tmp14_;
#line 1375 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1375 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1375 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1375 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1375 "../core/Services/Database.vala"
						break;
#line 8449 "Database.c"
					}
#line 1375 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1375 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1375 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1376 "../core/Services/Database.vala"
					_tmp12_ = item;
#line 1376 "../core/Services/Database.vala"
					_tmp13_ = objects_item_get_pinned (_tmp12_);
#line 1376 "../core/Services/Database.vala"
					_tmp14_ = _tmp13_;
#line 1376 "../core/Services/Database.vala"
					if (_tmp14_) {
#line 8465 "Database.c"
						ObjectsItem* _tmp15_;
						gboolean _tmp16_;
						gboolean _tmp17_;
#line 1376 "../core/Services/Database.vala"
						_tmp15_ = item;
#line 1376 "../core/Services/Database.vala"
						_tmp16_ = objects_item_get_checked (_tmp15_);
#line 1376 "../core/Services/Database.vala"
						_tmp17_ = _tmp16_;
#line 1376 "../core/Services/Database.vala"
						_tmp11_ = _tmp17_ == checked;
#line 8477 "Database.c"
					} else {
#line 1376 "../core/Services/Database.vala"
						_tmp11_ = FALSE;
#line 8481 "Database.c"
					}
#line 1376 "../core/Services/Database.vala"
					if (_tmp11_) {
#line 8485 "Database.c"
						GeeArrayList* _tmp18_;
						ObjectsItem* _tmp19_;
#line 1377 "../core/Services/Database.vala"
						_tmp18_ = return_value;
#line 1377 "../core/Services/Database.vala"
						_tmp19_ = item;
#line 1377 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 8494 "Database.c"
					}
#line 1375 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 8498 "Database.c"
				}
			}
#line 1381 "../core/Services/Database.vala"
			_tmp20_ = return_value;
#line 1381 "../core/Services/Database.vala"
			_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1381 "../core/Services/Database.vala"
			result = _tmp21_;
#line 8507 "Database.c"
			{
				GeeArrayList* _tmp22_;
#line 1374 "../core/Services/Database.vala"
				_tmp22_ = self->priv->_items;
#line 1374 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 8514 "Database.c"
			}
#line 1381 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1381 "../core/Services/Database.vala"
			return result;
#line 8520 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp23_;
#line 1374 "../core/Services/Database.vala"
			_tmp23_ = self->priv->_items;
#line 1374 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 8529 "Database.c"
		}
#line 1374 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1374 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1374 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1374 "../core/Services/Database.vala"
		return NULL;
#line 8539 "Database.c"
	}
}

GeeArrayList*
services_database_get_items_by_priority (ServicesDatabase* self,
                                         gint priority,
                                         gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1385 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1386 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1386 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 8558 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1387 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1387 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 8565 "Database.c"
		{
			GeeArrayList* _tmp20_;
			GeeArrayList* _tmp21_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1388 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1388 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1388 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1388 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1388 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1388 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1388 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1388 "../core/Services/Database.vala"
				_item_index = -1;
#line 1388 "../core/Services/Database.vala"
				while (TRUE) {
#line 8596 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsItem* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1388 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1388 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1388 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1388 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1388 "../core/Services/Database.vala"
						break;
#line 8616 "Database.c"
					}
#line 1388 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1388 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1388 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1389 "../core/Services/Database.vala"
					_tmp12_ = item;
#line 1389 "../core/Services/Database.vala"
					_tmp13_ = objects_item_get_priority (_tmp12_);
#line 1389 "../core/Services/Database.vala"
					_tmp14_ = _tmp13_;
#line 1389 "../core/Services/Database.vala"
					if (_tmp14_ == priority) {
#line 8632 "Database.c"
						ObjectsItem* _tmp15_;
						gboolean _tmp16_;
						gboolean _tmp17_;
#line 1389 "../core/Services/Database.vala"
						_tmp15_ = item;
#line 1389 "../core/Services/Database.vala"
						_tmp16_ = objects_item_get_checked (_tmp15_);
#line 1389 "../core/Services/Database.vala"
						_tmp17_ = _tmp16_;
#line 1389 "../core/Services/Database.vala"
						_tmp11_ = _tmp17_ == checked;
#line 8644 "Database.c"
					} else {
#line 1389 "../core/Services/Database.vala"
						_tmp11_ = FALSE;
#line 8648 "Database.c"
					}
#line 1389 "../core/Services/Database.vala"
					if (_tmp11_) {
#line 8652 "Database.c"
						GeeArrayList* _tmp18_;
						ObjectsItem* _tmp19_;
#line 1390 "../core/Services/Database.vala"
						_tmp18_ = return_value;
#line 1390 "../core/Services/Database.vala"
						_tmp19_ = item;
#line 1390 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 8661 "Database.c"
					}
#line 1388 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 8665 "Database.c"
				}
			}
#line 1394 "../core/Services/Database.vala"
			_tmp20_ = return_value;
#line 1394 "../core/Services/Database.vala"
			_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1394 "../core/Services/Database.vala"
			result = _tmp21_;
#line 8674 "Database.c"
			{
				GeeArrayList* _tmp22_;
#line 1387 "../core/Services/Database.vala"
				_tmp22_ = self->priv->_items;
#line 1387 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 8681 "Database.c"
			}
#line 1394 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1394 "../core/Services/Database.vala"
			return result;
#line 8687 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp23_;
#line 1387 "../core/Services/Database.vala"
			_tmp23_ = self->priv->_items;
#line 1387 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 8696 "Database.c"
		}
#line 1387 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1387 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1387 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1387 "../core/Services/Database.vala"
		return NULL;
#line 8706 "Database.c"
	}
}

GeeArrayList*
services_database_get_items_completed (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1398 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1399 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1399 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 8723 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1400 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1400 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 8730 "Database.c"
		{
			GeeArrayList* _tmp16_;
			GeeArrayList* _tmp17_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1401 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1401 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1401 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1401 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1401 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1401 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1401 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1401 "../core/Services/Database.vala"
				_item_index = -1;
#line 1401 "../core/Services/Database.vala"
				while (TRUE) {
#line 8761 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
					gboolean _tmp12_;
					gboolean _tmp13_;
#line 1401 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1401 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1401 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1401 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1401 "../core/Services/Database.vala"
						break;
#line 8780 "Database.c"
					}
#line 1401 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1401 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1401 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1402 "../core/Services/Database.vala"
					_tmp11_ = item;
#line 1402 "../core/Services/Database.vala"
					_tmp12_ = objects_item_get_checked (_tmp11_);
#line 1402 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 1402 "../core/Services/Database.vala"
					if (_tmp13_) {
#line 8796 "Database.c"
						GeeArrayList* _tmp14_;
						ObjectsItem* _tmp15_;
#line 1403 "../core/Services/Database.vala"
						_tmp14_ = return_value;
#line 1403 "../core/Services/Database.vala"
						_tmp15_ = item;
#line 1403 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 8805 "Database.c"
					}
#line 1401 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 8809 "Database.c"
				}
			}
#line 1407 "../core/Services/Database.vala"
			_tmp16_ = return_value;
#line 1407 "../core/Services/Database.vala"
			_tmp17_ = _g_object_ref0 (_tmp16_);
#line 1407 "../core/Services/Database.vala"
			result = _tmp17_;
#line 8818 "Database.c"
			{
				GeeArrayList* _tmp18_;
#line 1400 "../core/Services/Database.vala"
				_tmp18_ = self->priv->_items;
#line 1400 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 8825 "Database.c"
			}
#line 1407 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1407 "../core/Services/Database.vala"
			return result;
#line 8831 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp19_;
#line 1400 "../core/Services/Database.vala"
			_tmp19_ = self->priv->_items;
#line 1400 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 8840 "Database.c"
		}
#line 1400 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1400 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1400 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1400 "../core/Services/Database.vala"
		return NULL;
#line 8850 "Database.c"
	}
}

GeeArrayList*
services_database_get_items_by_label (ServicesDatabase* self,
                                      ObjectsLabel* label,
                                      gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1411 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1411 "../core/Services/Database.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 1412 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1412 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 8871 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1413 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1413 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 8878 "Database.c"
		{
			GeeArrayList* _tmp23_;
			GeeArrayList* _tmp24_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1414 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1414 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1414 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1414 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1414 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1414 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1414 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1414 "../core/Services/Database.vala"
				_item_index = -1;
#line 1414 "../core/Services/Database.vala"
				while (TRUE) {
#line 8909 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsItem* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					ObjectsLabel* _tmp15_;
					ObjectsLabel* _tmp16_;
					gboolean _tmp17_;
#line 1414 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1414 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1414 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1414 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1414 "../core/Services/Database.vala"
						break;
#line 8932 "Database.c"
					}
#line 1414 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1414 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1414 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1415 "../core/Services/Database.vala"
					_tmp12_ = item;
#line 1415 "../core/Services/Database.vala"
					_tmp13_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
#line 1415 "../core/Services/Database.vala"
					_tmp14_ = _tmp13_;
#line 1415 "../core/Services/Database.vala"
					_tmp15_ = objects_item_get_label (_tmp12_, _tmp14_);
#line 1415 "../core/Services/Database.vala"
					_tmp16_ = _tmp15_;
#line 1415 "../core/Services/Database.vala"
					_tmp17_ = _tmp16_ != NULL;
#line 1415 "../core/Services/Database.vala"
					_g_object_unref0 (_tmp16_);
#line 1415 "../core/Services/Database.vala"
					if (_tmp17_) {
#line 8956 "Database.c"
						ObjectsItem* _tmp18_;
						gboolean _tmp19_;
						gboolean _tmp20_;
#line 1415 "../core/Services/Database.vala"
						_tmp18_ = item;
#line 1415 "../core/Services/Database.vala"
						_tmp19_ = objects_item_get_checked (_tmp18_);
#line 1415 "../core/Services/Database.vala"
						_tmp20_ = _tmp19_;
#line 1415 "../core/Services/Database.vala"
						_tmp11_ = _tmp20_ == checked;
#line 8968 "Database.c"
					} else {
#line 1415 "../core/Services/Database.vala"
						_tmp11_ = FALSE;
#line 8972 "Database.c"
					}
#line 1415 "../core/Services/Database.vala"
					if (_tmp11_) {
#line 8976 "Database.c"
						GeeArrayList* _tmp21_;
						ObjectsItem* _tmp22_;
#line 1416 "../core/Services/Database.vala"
						_tmp21_ = return_value;
#line 1416 "../core/Services/Database.vala"
						_tmp22_ = item;
#line 1416 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp22_);
#line 8985 "Database.c"
					}
#line 1414 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 8989 "Database.c"
				}
			}
#line 1420 "../core/Services/Database.vala"
			_tmp23_ = return_value;
#line 1420 "../core/Services/Database.vala"
			_tmp24_ = _g_object_ref0 (_tmp23_);
#line 1420 "../core/Services/Database.vala"
			result = _tmp24_;
#line 8998 "Database.c"
			{
				GeeArrayList* _tmp25_;
#line 1413 "../core/Services/Database.vala"
				_tmp25_ = self->priv->_items;
#line 1413 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 9005 "Database.c"
			}
#line 1420 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1420 "../core/Services/Database.vala"
			return result;
#line 9011 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp26_;
#line 1413 "../core/Services/Database.vala"
			_tmp26_ = self->priv->_items;
#line 1413 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 9020 "Database.c"
		}
#line 1413 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1413 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1413 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1413 "../core/Services/Database.vala"
		return NULL;
#line 9030 "Database.c"
	}
}

GeeArrayList*
services_database_get_items_unlabeled (ServicesDatabase* self,
                                       gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1424 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1425 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1425 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 9048 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1426 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1426 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 9055 "Database.c"
		{
			GeeArrayList* _tmp22_;
			GeeArrayList* _tmp23_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1427 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1427 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1427 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1427 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1427 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1427 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1427 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1427 "../core/Services/Database.vala"
				_item_index = -1;
#line 1427 "../core/Services/Database.vala"
				while (TRUE) {
#line 9086 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsItem* _tmp12_;
					GeeArrayList* _tmp13_;
					GeeArrayList* _tmp14_;
					gint _tmp15_;
					gint _tmp16_;
#line 1427 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1427 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1427 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1427 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1427 "../core/Services/Database.vala"
						break;
#line 9108 "Database.c"
					}
#line 1427 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1427 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1427 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1428 "../core/Services/Database.vala"
					_tmp12_ = item;
#line 1428 "../core/Services/Database.vala"
					_tmp13_ = objects_item_get_labels (_tmp12_);
#line 1428 "../core/Services/Database.vala"
					_tmp14_ = _tmp13_;
#line 1428 "../core/Services/Database.vala"
					_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 1428 "../core/Services/Database.vala"
					_tmp16_ = _tmp15_;
#line 1428 "../core/Services/Database.vala"
					if (_tmp16_ <= 0) {
#line 9128 "Database.c"
						ObjectsItem* _tmp17_;
						gboolean _tmp18_;
						gboolean _tmp19_;
#line 1428 "../core/Services/Database.vala"
						_tmp17_ = item;
#line 1428 "../core/Services/Database.vala"
						_tmp18_ = objects_item_get_checked (_tmp17_);
#line 1428 "../core/Services/Database.vala"
						_tmp19_ = _tmp18_;
#line 1428 "../core/Services/Database.vala"
						_tmp11_ = _tmp19_ == checked;
#line 9140 "Database.c"
					} else {
#line 1428 "../core/Services/Database.vala"
						_tmp11_ = FALSE;
#line 9144 "Database.c"
					}
#line 1428 "../core/Services/Database.vala"
					if (_tmp11_) {
#line 9148 "Database.c"
						GeeArrayList* _tmp20_;
						ObjectsItem* _tmp21_;
#line 1429 "../core/Services/Database.vala"
						_tmp20_ = return_value;
#line 1429 "../core/Services/Database.vala"
						_tmp21_ = item;
#line 1429 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 9157 "Database.c"
					}
#line 1427 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 9161 "Database.c"
				}
			}
#line 1433 "../core/Services/Database.vala"
			_tmp22_ = return_value;
#line 1433 "../core/Services/Database.vala"
			_tmp23_ = _g_object_ref0 (_tmp22_);
#line 1433 "../core/Services/Database.vala"
			result = _tmp23_;
#line 9170 "Database.c"
			{
				GeeArrayList* _tmp24_;
#line 1426 "../core/Services/Database.vala"
				_tmp24_ = self->priv->_items;
#line 1426 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 9177 "Database.c"
			}
#line 1433 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1433 "../core/Services/Database.vala"
			return result;
#line 9183 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp25_;
#line 1426 "../core/Services/Database.vala"
			_tmp25_ = self->priv->_items;
#line 1426 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 9192 "Database.c"
		}
#line 1426 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1426 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1426 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1426 "../core/Services/Database.vala"
		return NULL;
#line 9202 "Database.c"
	}
}

GeeArrayList*
services_database_get_items_by_scheduled (ServicesDatabase* self,
                                          gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1437 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1438 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1438 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 9220 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1439 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1439 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 9227 "Database.c"
		{
			GeeArrayList* _tmp28_;
			GeeArrayList* _tmp29_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1440 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1440 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1440 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1440 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1440 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1440 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1440 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1440 "../core/Services/Database.vala"
				_item_index = -1;
#line 1440 "../core/Services/Database.vala"
				while (TRUE) {
#line 9258 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					ObjectsItem* _tmp13_;
					gboolean _tmp14_;
					gboolean _tmp15_;
#line 1440 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1440 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1440 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1440 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1440 "../core/Services/Database.vala"
						break;
#line 9279 "Database.c"
					}
#line 1440 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1440 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1440 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1441 "../core/Services/Database.vala"
					_tmp13_ = item;
#line 1441 "../core/Services/Database.vala"
					_tmp14_ = objects_item_get_has_due (_tmp13_);
#line 1441 "../core/Services/Database.vala"
					_tmp15_ = _tmp14_;
#line 1441 "../core/Services/Database.vala"
					if (_tmp15_) {
#line 9295 "Database.c"
						ObjectsItem* _tmp16_;
						gboolean _tmp17_;
						gboolean _tmp18_;
#line 1442 "../core/Services/Database.vala"
						_tmp16_ = item;
#line 1442 "../core/Services/Database.vala"
						_tmp17_ = objects_item_get_checked (_tmp16_);
#line 1442 "../core/Services/Database.vala"
						_tmp18_ = _tmp17_;
#line 1442 "../core/Services/Database.vala"
						_tmp12_ = _tmp18_ == checked;
#line 9307 "Database.c"
					} else {
#line 1441 "../core/Services/Database.vala"
						_tmp12_ = FALSE;
#line 9311 "Database.c"
					}
#line 1441 "../core/Services/Database.vala"
					if (_tmp12_) {
#line 9315 "Database.c"
						ObjectsItem* _tmp19_;
						ObjectsDueDate* _tmp20_;
						ObjectsDueDate* _tmp21_;
						GDateTime* _tmp22_;
						GDateTime* _tmp23_;
						GDateTime* _tmp24_;
						GDateTime* _tmp25_;
#line 1443 "../core/Services/Database.vala"
						_tmp19_ = item;
#line 1443 "../core/Services/Database.vala"
						_tmp20_ = objects_item_get_due (_tmp19_);
#line 1443 "../core/Services/Database.vala"
						_tmp21_ = _tmp20_;
#line 1443 "../core/Services/Database.vala"
						_tmp22_ = objects_due_date_get_datetime (_tmp21_);
#line 1443 "../core/Services/Database.vala"
						_tmp23_ = _tmp22_;
#line 1443 "../core/Services/Database.vala"
						_tmp24_ = g_date_time_new_now_local ();
#line 1443 "../core/Services/Database.vala"
						_tmp25_ = _tmp24_;
#line 1443 "../core/Services/Database.vala"
						_tmp11_ = g_date_time_compare (_tmp23_, _tmp25_) > 0;
#line 1443 "../core/Services/Database.vala"
						_g_date_time_unref0 (_tmp25_);
#line 9341 "Database.c"
					} else {
#line 1441 "../core/Services/Database.vala"
						_tmp11_ = FALSE;
#line 9345 "Database.c"
					}
#line 1441 "../core/Services/Database.vala"
					if (_tmp11_) {
#line 9349 "Database.c"
						GeeArrayList* _tmp26_;
						ObjectsItem* _tmp27_;
#line 1444 "../core/Services/Database.vala"
						_tmp26_ = return_value;
#line 1444 "../core/Services/Database.vala"
						_tmp27_ = item;
#line 1444 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
#line 9358 "Database.c"
					}
#line 1440 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 9362 "Database.c"
				}
			}
#line 1448 "../core/Services/Database.vala"
			_tmp28_ = return_value;
#line 1448 "../core/Services/Database.vala"
			_tmp29_ = _g_object_ref0 (_tmp28_);
#line 1448 "../core/Services/Database.vala"
			result = _tmp29_;
#line 9371 "Database.c"
			{
				GeeArrayList* _tmp30_;
#line 1439 "../core/Services/Database.vala"
				_tmp30_ = self->priv->_items;
#line 1439 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 9378 "Database.c"
			}
#line 1448 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1448 "../core/Services/Database.vala"
			return result;
#line 9384 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp31_;
#line 1439 "../core/Services/Database.vala"
			_tmp31_ = self->priv->_items;
#line 1439 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 9393 "Database.c"
		}
#line 1439 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1439 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1439 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1439 "../core/Services/Database.vala"
		return NULL;
#line 9403 "Database.c"
	}
}

gboolean
services_database_valid_item_by_date (ServicesDatabase* self,
                                      ObjectsItem* item,
                                      GDateTime* date,
                                      gboolean checked)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 1452 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1452 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1452 "../core/Services/Database.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 1453 "../core/Services/Database.vala"
	_tmp2_ = objects_item_get_has_due (item);
#line 1453 "../core/Services/Database.vala"
	_tmp3_ = _tmp2_;
#line 1453 "../core/Services/Database.vala"
	if (_tmp3_) {
#line 9430 "Database.c"
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 1454 "../core/Services/Database.vala"
		_tmp4_ = objects_item_get_checked (item);
#line 1454 "../core/Services/Database.vala"
		_tmp5_ = _tmp4_;
#line 1454 "../core/Services/Database.vala"
		_tmp1_ = _tmp5_ == checked;
#line 9439 "Database.c"
	} else {
#line 1453 "../core/Services/Database.vala"
		_tmp1_ = FALSE;
#line 9443 "Database.c"
	}
#line 1453 "../core/Services/Database.vala"
	if (_tmp1_) {
#line 9447 "Database.c"
		ObjectsDueDate* _tmp6_;
		ObjectsDueDate* _tmp7_;
		GDateTime* _tmp8_;
		GDateTime* _tmp9_;
#line 1455 "../core/Services/Database.vala"
		_tmp6_ = objects_item_get_due (item);
#line 1455 "../core/Services/Database.vala"
		_tmp7_ = _tmp6_;
#line 1455 "../core/Services/Database.vala"
		_tmp8_ = objects_due_date_get_datetime (_tmp7_);
#line 1455 "../core/Services/Database.vala"
		_tmp9_ = _tmp8_;
#line 1455 "../core/Services/Database.vala"
		_tmp0_ = granite_date_time_is_same_day (_tmp9_, date);
#line 9462 "Database.c"
	} else {
#line 1453 "../core/Services/Database.vala"
		_tmp0_ = FALSE;
#line 9466 "Database.c"
	}
#line 1453 "../core/Services/Database.vala"
	result = _tmp0_;
#line 1453 "../core/Services/Database.vala"
	return result;
#line 9472 "Database.c"
}

gboolean
services_database_valid_item_by_date_range (ServicesDatabase* self,
                                            ObjectsItem* item,
                                            GDateTime* start_date,
                                            GDateTime* end_date,
                                            gboolean checked)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GDateTime* date = NULL;
	Util* _tmp2_;
	Util* _tmp3_;
	ObjectsDueDate* _tmp4_;
	ObjectsDueDate* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	GDateTime* start = NULL;
	Util* _tmp10_;
	Util* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_;
	GDateTime* end = NULL;
	Util* _tmp14_;
	Util* _tmp15_;
	GDateTime* _tmp16_;
	GDateTime* _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	gboolean _tmp21_;
	gboolean result;
#line 1458 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1458 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1458 "../core/Services/Database.vala"
	g_return_val_if_fail (start_date != NULL, FALSE);
#line 1458 "../core/Services/Database.vala"
	g_return_val_if_fail (end_date != NULL, FALSE);
#line 1459 "../core/Services/Database.vala"
	_tmp0_ = objects_item_get_has_due (item);
#line 1459 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 1459 "../core/Services/Database.vala"
	if (!_tmp1_) {
#line 1460 "../core/Services/Database.vala"
		result = FALSE;
#line 1460 "../core/Services/Database.vala"
		return result;
#line 9526 "Database.c"
	}
#line 1463 "../core/Services/Database.vala"
	_tmp2_ = util_get_default ();
#line 1463 "../core/Services/Database.vala"
	_tmp3_ = _tmp2_;
#line 1463 "../core/Services/Database.vala"
	_tmp4_ = objects_item_get_due (item);
#line 1463 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1463 "../core/Services/Database.vala"
	_tmp6_ = objects_due_date_get_datetime (_tmp5_);
#line 1463 "../core/Services/Database.vala"
	_tmp7_ = _tmp6_;
#line 1463 "../core/Services/Database.vala"
	_tmp8_ = util_get_format_date (_tmp3_, _tmp7_);
#line 1463 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1463 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp3_);
#line 1463 "../core/Services/Database.vala"
	date = _tmp9_;
#line 1464 "../core/Services/Database.vala"
	_tmp10_ = util_get_default ();
#line 1464 "../core/Services/Database.vala"
	_tmp11_ = _tmp10_;
#line 1464 "../core/Services/Database.vala"
	_tmp12_ = util_get_format_date (_tmp11_, start_date);
#line 1464 "../core/Services/Database.vala"
	_tmp13_ = _tmp12_;
#line 1464 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp11_);
#line 1464 "../core/Services/Database.vala"
	start = _tmp13_;
#line 1465 "../core/Services/Database.vala"
	_tmp14_ = util_get_default ();
#line 1465 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1465 "../core/Services/Database.vala"
	_tmp16_ = util_get_format_date (_tmp15_, end_date);
#line 1465 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 1465 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp15_);
#line 1465 "../core/Services/Database.vala"
	end = _tmp17_;
#line 1467 "../core/Services/Database.vala"
	_tmp20_ = objects_item_get_checked (item);
#line 1467 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1467 "../core/Services/Database.vala"
	if (_tmp21_ == checked) {
#line 9578 "Database.c"
		GDateTime* _tmp22_;
		GDateTime* _tmp23_;
#line 1468 "../core/Services/Database.vala"
		_tmp22_ = date;
#line 1468 "../core/Services/Database.vala"
		_tmp23_ = start;
#line 1468 "../core/Services/Database.vala"
		_tmp19_ = g_date_time_compare (_tmp22_, _tmp23_) >= 0;
#line 9587 "Database.c"
	} else {
#line 1467 "../core/Services/Database.vala"
		_tmp19_ = FALSE;
#line 9591 "Database.c"
	}
#line 1467 "../core/Services/Database.vala"
	if (_tmp19_) {
#line 9595 "Database.c"
		GDateTime* _tmp24_;
		GDateTime* _tmp25_;
#line 1468 "../core/Services/Database.vala"
		_tmp24_ = date;
#line 1468 "../core/Services/Database.vala"
		_tmp25_ = end;
#line 1468 "../core/Services/Database.vala"
		_tmp18_ = g_date_time_compare (_tmp24_, _tmp25_) <= 0;
#line 9604 "Database.c"
	} else {
#line 1467 "../core/Services/Database.vala"
		_tmp18_ = FALSE;
#line 9608 "Database.c"
	}
#line 1467 "../core/Services/Database.vala"
	result = _tmp18_;
#line 1467 "../core/Services/Database.vala"
	_g_date_time_unref0 (end);
#line 1467 "../core/Services/Database.vala"
	_g_date_time_unref0 (start);
#line 1467 "../core/Services/Database.vala"
	_g_date_time_unref0 (date);
#line 1467 "../core/Services/Database.vala"
	return result;
#line 9620 "Database.c"
}

gboolean
services_database_valid_item_by_month (ServicesDatabase* self,
                                       ObjectsItem* item,
                                       GDateTime* date,
                                       gboolean checked)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 1471 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1471 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1471 "../core/Services/Database.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 1472 "../core/Services/Database.vala"
	_tmp3_ = objects_item_get_has_due (item);
#line 1472 "../core/Services/Database.vala"
	_tmp4_ = _tmp3_;
#line 1472 "../core/Services/Database.vala"
	if (_tmp4_) {
#line 9647 "Database.c"
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 1473 "../core/Services/Database.vala"
		_tmp5_ = objects_item_get_checked (item);
#line 1473 "../core/Services/Database.vala"
		_tmp6_ = _tmp5_;
#line 1473 "../core/Services/Database.vala"
		_tmp2_ = _tmp6_ == checked;
#line 9656 "Database.c"
	} else {
#line 1472 "../core/Services/Database.vala"
		_tmp2_ = FALSE;
#line 9660 "Database.c"
	}
#line 1472 "../core/Services/Database.vala"
	if (_tmp2_) {
#line 9664 "Database.c"
		ObjectsDueDate* _tmp7_;
		ObjectsDueDate* _tmp8_;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
#line 1473 "../core/Services/Database.vala"
		_tmp7_ = objects_item_get_due (item);
#line 1473 "../core/Services/Database.vala"
		_tmp8_ = _tmp7_;
#line 1473 "../core/Services/Database.vala"
		_tmp9_ = objects_due_date_get_datetime (_tmp8_);
#line 1473 "../core/Services/Database.vala"
		_tmp10_ = _tmp9_;
#line 1473 "../core/Services/Database.vala"
		_tmp1_ = g_date_time_get_month (_tmp10_) == g_date_time_get_month (date);
#line 9679 "Database.c"
	} else {
#line 1472 "../core/Services/Database.vala"
		_tmp1_ = FALSE;
#line 9683 "Database.c"
	}
#line 1472 "../core/Services/Database.vala"
	if (_tmp1_) {
#line 9687 "Database.c"
		ObjectsDueDate* _tmp11_;
		ObjectsDueDate* _tmp12_;
		GDateTime* _tmp13_;
		GDateTime* _tmp14_;
#line 1474 "../core/Services/Database.vala"
		_tmp11_ = objects_item_get_due (item);
#line 1474 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1474 "../core/Services/Database.vala"
		_tmp13_ = objects_due_date_get_datetime (_tmp12_);
#line 1474 "../core/Services/Database.vala"
		_tmp14_ = _tmp13_;
#line 1474 "../core/Services/Database.vala"
		_tmp0_ = g_date_time_get_year (_tmp14_) == g_date_time_get_year (date);
#line 9702 "Database.c"
	} else {
#line 1472 "../core/Services/Database.vala"
		_tmp0_ = FALSE;
#line 9706 "Database.c"
	}
#line 1472 "../core/Services/Database.vala"
	result = _tmp0_;
#line 1472 "../core/Services/Database.vala"
	return result;
#line 9712 "Database.c"
}

GeeArrayList*
services_database_get_items_by_overdeue_view (ServicesDatabase* self,
                                              gboolean checked)
{
	GDateTime* date_now = NULL;
	GDateTime* _tmp0_;
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp1_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1477 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1478 "../core/Services/Database.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 1478 "../core/Services/Database.vala"
	date_now = _tmp0_;
#line 1479 "../core/Services/Database.vala"
	_tmp1_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1479 "../core/Services/Database.vala"
	return_value = _tmp1_;
#line 9735 "Database.c"
	{
		GeeArrayList* _tmp2_;
#line 1480 "../core/Services/Database.vala"
		_tmp2_ = self->priv->_items;
#line 1480 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 9742 "Database.c"
		{
			GeeArrayList* _tmp35_;
			GeeArrayList* _tmp36_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp3_;
				GeeArrayList* _tmp4_;
				gint _item_size = 0;
				GeeArrayList* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gint _item_index = 0;
#line 1481 "../core/Services/Database.vala"
				_tmp3_ = services_database_get_items (self);
#line 1481 "../core/Services/Database.vala"
				_tmp4_ = _tmp3_;
#line 1481 "../core/Services/Database.vala"
				_item_list = _tmp4_;
#line 1481 "../core/Services/Database.vala"
				_tmp5_ = _item_list;
#line 1481 "../core/Services/Database.vala"
				_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 1481 "../core/Services/Database.vala"
				_tmp7_ = _tmp6_;
#line 1481 "../core/Services/Database.vala"
				_item_size = _tmp7_;
#line 1481 "../core/Services/Database.vala"
				_item_index = -1;
#line 1481 "../core/Services/Database.vala"
				while (TRUE) {
#line 9773 "Database.c"
					gint _tmp8_;
					gint _tmp9_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp10_;
					gpointer _tmp11_;
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
					gboolean _tmp14_ = FALSE;
					ObjectsItem* _tmp15_;
					gboolean _tmp16_;
					gboolean _tmp17_;
#line 1481 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1481 "../core/Services/Database.vala"
					_tmp8_ = _item_index;
#line 1481 "../core/Services/Database.vala"
					_tmp9_ = _item_size;
#line 1481 "../core/Services/Database.vala"
					if (!(_tmp8_ < _tmp9_)) {
#line 1481 "../core/Services/Database.vala"
						break;
#line 9795 "Database.c"
					}
#line 1481 "../core/Services/Database.vala"
					_tmp10_ = _item_list;
#line 1481 "../core/Services/Database.vala"
					_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _item_index);
#line 1481 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp11_;
#line 1482 "../core/Services/Database.vala"
					_tmp15_ = item;
#line 1482 "../core/Services/Database.vala"
					_tmp16_ = objects_item_get_has_due (_tmp15_);
#line 1482 "../core/Services/Database.vala"
					_tmp17_ = _tmp16_;
#line 1482 "../core/Services/Database.vala"
					if (_tmp17_) {
#line 9811 "Database.c"
						ObjectsItem* _tmp18_;
						gboolean _tmp19_;
						gboolean _tmp20_;
#line 1483 "../core/Services/Database.vala"
						_tmp18_ = item;
#line 1483 "../core/Services/Database.vala"
						_tmp19_ = objects_item_get_checked (_tmp18_);
#line 1483 "../core/Services/Database.vala"
						_tmp20_ = _tmp19_;
#line 1483 "../core/Services/Database.vala"
						_tmp14_ = _tmp20_ == checked;
#line 9823 "Database.c"
					} else {
#line 1482 "../core/Services/Database.vala"
						_tmp14_ = FALSE;
#line 9827 "Database.c"
					}
#line 1482 "../core/Services/Database.vala"
					if (_tmp14_) {
#line 9831 "Database.c"
						ObjectsItem* _tmp21_;
						ObjectsDueDate* _tmp22_;
						ObjectsDueDate* _tmp23_;
						GDateTime* _tmp24_;
						GDateTime* _tmp25_;
						GDateTime* _tmp26_;
#line 1484 "../core/Services/Database.vala"
						_tmp21_ = item;
#line 1484 "../core/Services/Database.vala"
						_tmp22_ = objects_item_get_due (_tmp21_);
#line 1484 "../core/Services/Database.vala"
						_tmp23_ = _tmp22_;
#line 1484 "../core/Services/Database.vala"
						_tmp24_ = objects_due_date_get_datetime (_tmp23_);
#line 1484 "../core/Services/Database.vala"
						_tmp25_ = _tmp24_;
#line 1484 "../core/Services/Database.vala"
						_tmp26_ = date_now;
#line 1484 "../core/Services/Database.vala"
						_tmp13_ = g_date_time_compare (_tmp25_, _tmp26_) < 0;
#line 9852 "Database.c"
					} else {
#line 1482 "../core/Services/Database.vala"
						_tmp13_ = FALSE;
#line 9856 "Database.c"
					}
#line 1482 "../core/Services/Database.vala"
					if (_tmp13_) {
#line 9860 "Database.c"
						ObjectsItem* _tmp27_;
						ObjectsDueDate* _tmp28_;
						ObjectsDueDate* _tmp29_;
						GDateTime* _tmp30_;
						GDateTime* _tmp31_;
						GDateTime* _tmp32_;
#line 1485 "../core/Services/Database.vala"
						_tmp27_ = item;
#line 1485 "../core/Services/Database.vala"
						_tmp28_ = objects_item_get_due (_tmp27_);
#line 1485 "../core/Services/Database.vala"
						_tmp29_ = _tmp28_;
#line 1485 "../core/Services/Database.vala"
						_tmp30_ = objects_due_date_get_datetime (_tmp29_);
#line 1485 "../core/Services/Database.vala"
						_tmp31_ = _tmp30_;
#line 1485 "../core/Services/Database.vala"
						_tmp32_ = date_now;
#line 1485 "../core/Services/Database.vala"
						_tmp12_ = !granite_date_time_is_same_day (_tmp31_, _tmp32_);
#line 9881 "Database.c"
					} else {
#line 1482 "../core/Services/Database.vala"
						_tmp12_ = FALSE;
#line 9885 "Database.c"
					}
#line 1482 "../core/Services/Database.vala"
					if (_tmp12_) {
#line 9889 "Database.c"
						GeeArrayList* _tmp33_;
						ObjectsItem* _tmp34_;
#line 1486 "../core/Services/Database.vala"
						_tmp33_ = return_value;
#line 1486 "../core/Services/Database.vala"
						_tmp34_ = item;
#line 1486 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp33_, _tmp34_);
#line 9898 "Database.c"
					}
#line 1481 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 9902 "Database.c"
				}
			}
#line 1490 "../core/Services/Database.vala"
			_tmp35_ = return_value;
#line 1490 "../core/Services/Database.vala"
			_tmp36_ = _g_object_ref0 (_tmp35_);
#line 1490 "../core/Services/Database.vala"
			result = _tmp36_;
#line 9911 "Database.c"
			{
				GeeArrayList* _tmp37_;
#line 1480 "../core/Services/Database.vala"
				_tmp37_ = self->priv->_items;
#line 1480 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 9918 "Database.c"
			}
#line 1490 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1490 "../core/Services/Database.vala"
			_g_date_time_unref0 (date_now);
#line 1490 "../core/Services/Database.vala"
			return result;
#line 9926 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp38_;
#line 1480 "../core/Services/Database.vala"
			_tmp38_ = self->priv->_items;
#line 1480 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 9935 "Database.c"
		}
#line 1480 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1480 "../core/Services/Database.vala"
		_g_date_time_unref0 (date_now);
#line 1480 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1480 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1480 "../core/Services/Database.vala"
		return NULL;
#line 9947 "Database.c"
	}
}

gboolean
services_database_valid_item_by_overdue (ServicesDatabase* self,
                                         ObjectsItem* item,
                                         GDateTime* date,
                                         gboolean checked)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 1494 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1494 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1494 "../core/Services/Database.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 1495 "../core/Services/Database.vala"
	_tmp3_ = objects_item_get_has_due (item);
#line 1495 "../core/Services/Database.vala"
	_tmp4_ = _tmp3_;
#line 1495 "../core/Services/Database.vala"
	if (_tmp4_) {
#line 9975 "Database.c"
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 1496 "../core/Services/Database.vala"
		_tmp5_ = objects_item_get_checked (item);
#line 1496 "../core/Services/Database.vala"
		_tmp6_ = _tmp5_;
#line 1496 "../core/Services/Database.vala"
		_tmp2_ = _tmp6_ == checked;
#line 9984 "Database.c"
	} else {
#line 1495 "../core/Services/Database.vala"
		_tmp2_ = FALSE;
#line 9988 "Database.c"
	}
#line 1495 "../core/Services/Database.vala"
	if (_tmp2_) {
#line 9992 "Database.c"
		ObjectsDueDate* _tmp7_;
		ObjectsDueDate* _tmp8_;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
		GDateTime* _tmp12_;
#line 1497 "../core/Services/Database.vala"
		_tmp7_ = objects_item_get_due (item);
#line 1497 "../core/Services/Database.vala"
		_tmp8_ = _tmp7_;
#line 1497 "../core/Services/Database.vala"
		_tmp9_ = objects_due_date_get_datetime (_tmp8_);
#line 1497 "../core/Services/Database.vala"
		_tmp10_ = _tmp9_;
#line 1497 "../core/Services/Database.vala"
		_tmp11_ = g_date_time_new_now_local ();
#line 1497 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1497 "../core/Services/Database.vala"
		_tmp1_ = g_date_time_compare (_tmp10_, _tmp12_) < 0;
#line 1497 "../core/Services/Database.vala"
		_g_date_time_unref0 (_tmp12_);
#line 10015 "Database.c"
	} else {
#line 1495 "../core/Services/Database.vala"
		_tmp1_ = FALSE;
#line 10019 "Database.c"
	}
#line 1495 "../core/Services/Database.vala"
	if (_tmp1_) {
#line 10023 "Database.c"
		ObjectsDueDate* _tmp13_;
		ObjectsDueDate* _tmp14_;
		GDateTime* _tmp15_;
		GDateTime* _tmp16_;
		GDateTime* _tmp17_;
		GDateTime* _tmp18_;
#line 1498 "../core/Services/Database.vala"
		_tmp13_ = objects_item_get_due (item);
#line 1498 "../core/Services/Database.vala"
		_tmp14_ = _tmp13_;
#line 1498 "../core/Services/Database.vala"
		_tmp15_ = objects_due_date_get_datetime (_tmp14_);
#line 1498 "../core/Services/Database.vala"
		_tmp16_ = _tmp15_;
#line 1498 "../core/Services/Database.vala"
		_tmp17_ = g_date_time_new_now_local ();
#line 1498 "../core/Services/Database.vala"
		_tmp18_ = _tmp17_;
#line 1498 "../core/Services/Database.vala"
		_tmp0_ = !granite_date_time_is_same_day (_tmp16_, _tmp18_);
#line 1498 "../core/Services/Database.vala"
		_g_date_time_unref0 (_tmp18_);
#line 10046 "Database.c"
	} else {
#line 1495 "../core/Services/Database.vala"
		_tmp0_ = FALSE;
#line 10050 "Database.c"
	}
#line 1495 "../core/Services/Database.vala"
	result = _tmp0_;
#line 1495 "../core/Services/Database.vala"
	return result;
#line 10056 "Database.c"
}

void
services_database_delete_item (ServicesDatabase* self,
                               ObjectsItem* item)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp33_;
#line 1501 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1501 "../core/Services/Database.vala"
	g_return_if_fail (item != NULL);
#line 1504 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Items WHERE id=$id;\n        ");
#line 1504 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1504 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1508 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1508 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1508 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1508 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1508 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1508 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1508 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1508 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1509 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1509 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1509 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1509 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1511 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1511 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) == SQLITE_DONE) {
#line 10114 "Database.c"
		gboolean _tmp11_ = FALSE;
		ObjectsProject* _tmp12_;
		ObjectsProject* _tmp13_;
		BackendType _tmp14_;
		BackendType _tmp15_;
#line 1512 "../core/Services/Database.vala"
		_tmp12_ = objects_item_get_project (item);
#line 1512 "../core/Services/Database.vala"
		_tmp13_ = _tmp12_;
#line 1512 "../core/Services/Database.vala"
		_tmp14_ = objects_project_get_backend_type (_tmp13_);
#line 1512 "../core/Services/Database.vala"
		_tmp15_ = _tmp14_;
#line 1512 "../core/Services/Database.vala"
		if (_tmp15_ == BACKEND_TYPE_LOCAL) {
#line 1512 "../core/Services/Database.vala"
			_tmp11_ = TRUE;
#line 10132 "Database.c"
		} else {
			ObjectsProject* _tmp16_;
			ObjectsProject* _tmp17_;
			BackendType _tmp18_;
			BackendType _tmp19_;
#line 1512 "../core/Services/Database.vala"
			_tmp16_ = objects_item_get_project (item);
#line 1512 "../core/Services/Database.vala"
			_tmp17_ = _tmp16_;
#line 1512 "../core/Services/Database.vala"
			_tmp18_ = objects_project_get_backend_type (_tmp17_);
#line 1512 "../core/Services/Database.vala"
			_tmp19_ = _tmp18_;
#line 1512 "../core/Services/Database.vala"
			_tmp11_ = _tmp19_ == BACKEND_TYPE_TODOIST;
#line 10148 "Database.c"
		}
#line 1512 "../core/Services/Database.vala"
		if (_tmp11_) {
#line 10152 "Database.c"
			{
				GeeArrayList* _subitem_list = NULL;
				GeeArrayList* _tmp20_;
				GeeArrayList* _tmp21_;
				gint _subitem_size = 0;
				GeeArrayList* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _subitem_index = 0;
#line 1513 "../core/Services/Database.vala"
				_tmp20_ = objects_item_get_items (item);
#line 1513 "../core/Services/Database.vala"
				_tmp21_ = _tmp20_;
#line 1513 "../core/Services/Database.vala"
				_subitem_list = _tmp21_;
#line 1513 "../core/Services/Database.vala"
				_tmp22_ = _subitem_list;
#line 1513 "../core/Services/Database.vala"
				_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
#line 1513 "../core/Services/Database.vala"
				_tmp24_ = _tmp23_;
#line 1513 "../core/Services/Database.vala"
				_subitem_size = _tmp24_;
#line 1513 "../core/Services/Database.vala"
				_subitem_index = -1;
#line 1513 "../core/Services/Database.vala"
				while (TRUE) {
#line 10180 "Database.c"
					gint _tmp25_;
					gint _tmp26_;
					ObjectsItem* subitem = NULL;
					GeeArrayList* _tmp27_;
					gpointer _tmp28_;
					ObjectsItem* _tmp29_;
#line 1513 "../core/Services/Database.vala"
					_subitem_index = _subitem_index + 1;
#line 1513 "../core/Services/Database.vala"
					_tmp25_ = _subitem_index;
#line 1513 "../core/Services/Database.vala"
					_tmp26_ = _subitem_size;
#line 1513 "../core/Services/Database.vala"
					if (!(_tmp25_ < _tmp26_)) {
#line 1513 "../core/Services/Database.vala"
						break;
#line 10197 "Database.c"
					}
#line 1513 "../core/Services/Database.vala"
					_tmp27_ = _subitem_list;
#line 1513 "../core/Services/Database.vala"
					_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _subitem_index);
#line 1513 "../core/Services/Database.vala"
					subitem = (ObjectsItem*) _tmp28_;
#line 1514 "../core/Services/Database.vala"
					_tmp29_ = subitem;
#line 1514 "../core/Services/Database.vala"
					services_database_delete_item (self, _tmp29_);
#line 1513 "../core/Services/Database.vala"
					_g_object_unref0 (subitem);
#line 10211 "Database.c"
				}
			}
		}
#line 1518 "../core/Services/Database.vala"
		g_signal_emit_by_name ((ObjectsBaseObject*) item, "deleted");
#line 10217 "Database.c"
	} else {
		sqlite3* _tmp30_;
		sqlite3* _tmp31_;
		const gchar* _tmp32_;
#line 1520 "../core/Services/Database.vala"
		_tmp30_ = self->priv->db;
#line 1520 "../core/Services/Database.vala"
		_tmp31_ = self->priv->db;
#line 1520 "../core/Services/Database.vala"
		_tmp32_ = sqlite3_errmsg (_tmp31_);
#line 1520 "../core/Services/Database.vala"
		g_warning ("Database.vala:1520: Error: %d: %s", sqlite3_errcode (_tmp30_), _tmp32_);
#line 10230 "Database.c"
	}
#line 1523 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 1523 "../core/Services/Database.vala"
	sqlite3_reset (_tmp33_);
#line 1501 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 10238 "Database.c"
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3375 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3376 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3376 "glib-2.0.vapi"
	result = _tmp0_;
#line 3376 "glib-2.0.vapi"
	return result;
#line 10254 "Database.c"
}

void
services_database_update_item (ServicesDatabase* self,
                               ObjectsItem* item,
                               const gchar* update_id)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	sqlite3_stmt* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	sqlite3_stmt* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	sqlite3_stmt* _tmp17_;
	ObjectsDueDate* _tmp18_;
	ObjectsDueDate* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	sqlite3_stmt* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	sqlite3_stmt* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	sqlite3_stmt* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	sqlite3_stmt* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	sqlite3_stmt* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	sqlite3_stmt* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	sqlite3_stmt* _tmp46_;
	gboolean _tmp47_;
	gboolean _tmp48_;
	sqlite3_stmt* _tmp49_;
	gboolean _tmp50_;
	gboolean _tmp51_;
	sqlite3_stmt* _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	sqlite3_stmt* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp57_;
	sqlite3_stmt* _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	sqlite3_stmt* _tmp61_;
	GeeArrayList* _tmp62_;
	GeeArrayList* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	sqlite3_stmt* _tmp66_;
	const gchar* _tmp67_;
	const gchar* _tmp68_;
	sqlite3_stmt* _tmp69_;
	const gchar* _tmp70_;
	const gchar* _tmp71_;
	sqlite3_stmt* _tmp72_;
	sqlite3_stmt* _tmp76_;
#line 1526 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1526 "../core/Services/Database.vala"
	g_return_if_fail (item != NULL);
#line 1526 "../core/Services/Database.vala"
	g_return_if_fail (update_id != NULL);
#line 1527 "../core/Services/Database.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 1527 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 1527 "../core/Services/Database.vala"
	_tmp2_ = g_date_time_to_string (_tmp1_);
#line 1527 "../core/Services/Database.vala"
	_tmp3_ = _tmp2_;
#line 1527 "../core/Services/Database.vala"
	objects_item_set_updated_at (item, _tmp3_);
#line 1527 "../core/Services/Database.vala"
	_g_free0 (_tmp3_);
#line 1527 "../core/Services/Database.vala"
	_g_date_time_unref0 (_tmp1_);
#line 1530 "../core/Services/Database.vala"
	_tmp4_ = g_strdup ("\n" \
"            UPDATE Items SET content=$content, description=$descriptio" \
"n, due=$due,\n" \
"                added_at=$added_at, completed_at=$completed_at, update" \
"d_at=$updated_at,\n" \
"                section_id=$section_id, project_id=$project_id, parent" \
"_id=$parent_id,\n" \
"                priority=$priority, child_order=$child_order, checked=" \
"$checked,\n" \
"                is_deleted=$is_deleted, day_order=$day_order, collapse" \
"d=$collapsed,\n" \
"                pinned=$pinned, labels=$labels, extra_data=$extra_data" \
"\n" \
"            WHERE id=$id;\n" \
"        ");
#line 1530 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1530 "../core/Services/Database.vala"
	self->priv->sql = _tmp4_;
#line 1540 "../core/Services/Database.vala"
	_tmp5_ = self->priv->db;
#line 1540 "../core/Services/Database.vala"
	_tmp6_ = self->priv->sql;
#line 1540 "../core/Services/Database.vala"
	_tmp7_ = self->priv->sql;
#line 1540 "../core/Services/Database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 1540 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1540 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 1540 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1540 "../core/Services/Database.vala"
	stmt = _tmp10_;
#line 1541 "../core/Services/Database.vala"
	_tmp11_ = stmt;
#line 1541 "../core/Services/Database.vala"
	_tmp12_ = objects_item_get_content (item);
#line 1541 "../core/Services/Database.vala"
	_tmp13_ = _tmp12_;
#line 1541 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp11_, "$content", _tmp13_);
#line 1542 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1542 "../core/Services/Database.vala"
	_tmp15_ = objects_item_get_description (item);
#line 1542 "../core/Services/Database.vala"
	_tmp16_ = _tmp15_;
#line 1542 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp14_, "$description", _tmp16_);
#line 1543 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1543 "../core/Services/Database.vala"
	_tmp18_ = objects_item_get_due (item);
#line 1543 "../core/Services/Database.vala"
	_tmp19_ = _tmp18_;
#line 1543 "../core/Services/Database.vala"
	_tmp20_ = objects_due_date_to_string (_tmp19_);
#line 1543 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1543 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp17_, "$due", _tmp21_);
#line 1543 "../core/Services/Database.vala"
	_g_free0 (_tmp21_);
#line 1544 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1544 "../core/Services/Database.vala"
	_tmp23_ = objects_item_get_added_at (item);
#line 1544 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1544 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp22_, "$added_at", _tmp24_);
#line 1545 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1545 "../core/Services/Database.vala"
	_tmp26_ = objects_item_get_completed_at (item);
#line 1545 "../core/Services/Database.vala"
	_tmp27_ = _tmp26_;
#line 1545 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp25_, "$completed_at", _tmp27_);
#line 1546 "../core/Services/Database.vala"
	_tmp28_ = stmt;
#line 1546 "../core/Services/Database.vala"
	_tmp29_ = objects_item_get_updated_at (item);
#line 1546 "../core/Services/Database.vala"
	_tmp30_ = _tmp29_;
#line 1546 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp28_, "$updated_at", _tmp30_);
#line 1547 "../core/Services/Database.vala"
	_tmp31_ = stmt;
#line 1547 "../core/Services/Database.vala"
	_tmp32_ = objects_item_get_section_id (item);
#line 1547 "../core/Services/Database.vala"
	_tmp33_ = _tmp32_;
#line 1547 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp31_, "$section_id", _tmp33_);
#line 1548 "../core/Services/Database.vala"
	_tmp34_ = stmt;
#line 1548 "../core/Services/Database.vala"
	_tmp35_ = objects_item_get_project_id (item);
#line 1548 "../core/Services/Database.vala"
	_tmp36_ = _tmp35_;
#line 1548 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp34_, "$project_id", _tmp36_);
#line 1549 "../core/Services/Database.vala"
	_tmp37_ = stmt;
#line 1549 "../core/Services/Database.vala"
	_tmp38_ = objects_item_get_parent_id (item);
#line 1549 "../core/Services/Database.vala"
	_tmp39_ = _tmp38_;
#line 1549 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp37_, "$parent_id", _tmp39_);
#line 1550 "../core/Services/Database.vala"
	_tmp40_ = stmt;
#line 1550 "../core/Services/Database.vala"
	_tmp41_ = objects_item_get_priority (item);
#line 1550 "../core/Services/Database.vala"
	_tmp42_ = _tmp41_;
#line 1550 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp40_, "$priority", _tmp42_);
#line 1551 "../core/Services/Database.vala"
	_tmp43_ = stmt;
#line 1551 "../core/Services/Database.vala"
	_tmp44_ = objects_item_get_child_order (item);
#line 1551 "../core/Services/Database.vala"
	_tmp45_ = _tmp44_;
#line 1551 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp43_, "$child_order", _tmp45_);
#line 1552 "../core/Services/Database.vala"
	_tmp46_ = stmt;
#line 1552 "../core/Services/Database.vala"
	_tmp47_ = objects_item_get_checked (item);
#line 1552 "../core/Services/Database.vala"
	_tmp48_ = _tmp47_;
#line 1552 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp46_, "$checked", _tmp48_);
#line 1553 "../core/Services/Database.vala"
	_tmp49_ = stmt;
#line 1553 "../core/Services/Database.vala"
	_tmp50_ = objects_item_get_is_deleted (item);
#line 1553 "../core/Services/Database.vala"
	_tmp51_ = _tmp50_;
#line 1553 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp49_, "$is_deleted", _tmp51_);
#line 1554 "../core/Services/Database.vala"
	_tmp52_ = stmt;
#line 1554 "../core/Services/Database.vala"
	_tmp53_ = objects_item_get_day_order (item);
#line 1554 "../core/Services/Database.vala"
	_tmp54_ = _tmp53_;
#line 1554 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp52_, "$day_order", _tmp54_);
#line 1555 "../core/Services/Database.vala"
	_tmp55_ = stmt;
#line 1555 "../core/Services/Database.vala"
	_tmp56_ = objects_item_get_collapsed (item);
#line 1555 "../core/Services/Database.vala"
	_tmp57_ = _tmp56_;
#line 1555 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp55_, "$collapsed", _tmp57_);
#line 1556 "../core/Services/Database.vala"
	_tmp58_ = stmt;
#line 1556 "../core/Services/Database.vala"
	_tmp59_ = objects_item_get_pinned (item);
#line 1556 "../core/Services/Database.vala"
	_tmp60_ = _tmp59_;
#line 1556 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp58_, "$pinned", _tmp60_);
#line 1557 "../core/Services/Database.vala"
	_tmp61_ = stmt;
#line 1557 "../core/Services/Database.vala"
	_tmp62_ = objects_item_get_labels (item);
#line 1557 "../core/Services/Database.vala"
	_tmp63_ = _tmp62_;
#line 1557 "../core/Services/Database.vala"
	_tmp64_ = services_database_get_labels_ids (self, _tmp63_);
#line 1557 "../core/Services/Database.vala"
	_tmp65_ = _tmp64_;
#line 1557 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp61_, "$labels", _tmp65_);
#line 1557 "../core/Services/Database.vala"
	_g_free0 (_tmp65_);
#line 1558 "../core/Services/Database.vala"
	_tmp66_ = stmt;
#line 1558 "../core/Services/Database.vala"
	_tmp67_ = objects_item_get_extra_data (item);
#line 1558 "../core/Services/Database.vala"
	_tmp68_ = _tmp67_;
#line 1558 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp66_, "$extra_data", _tmp68_);
#line 1559 "../core/Services/Database.vala"
	_tmp69_ = stmt;
#line 1559 "../core/Services/Database.vala"
	_tmp70_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1559 "../core/Services/Database.vala"
	_tmp71_ = _tmp70_;
#line 1559 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp69_, "$id", _tmp71_);
#line 1561 "../core/Services/Database.vala"
	_tmp72_ = stmt;
#line 1561 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp72_) == SQLITE_DONE) {
#line 1562 "../core/Services/Database.vala"
		g_signal_emit_by_name ((ObjectsBaseObject*) item, "updated");
#line 1563 "../core/Services/Database.vala"
		g_signal_emit (self, services_database_signals[SERVICES_DATABASE_ITEM_UPDATED_SIGNAL], 0, item, update_id);
#line 10551 "Database.c"
	} else {
		sqlite3* _tmp73_;
		sqlite3* _tmp74_;
		const gchar* _tmp75_;
#line 1565 "../core/Services/Database.vala"
		_tmp73_ = self->priv->db;
#line 1565 "../core/Services/Database.vala"
		_tmp74_ = self->priv->db;
#line 1565 "../core/Services/Database.vala"
		_tmp75_ = sqlite3_errmsg (_tmp74_);
#line 1565 "../core/Services/Database.vala"
		g_warning ("Database.vala:1565: Error: %d: %s", sqlite3_errcode (_tmp73_), _tmp75_);
#line 10564 "Database.c"
	}
#line 1568 "../core/Services/Database.vala"
	_tmp76_ = stmt;
#line 1568 "../core/Services/Database.vala"
	sqlite3_reset (_tmp76_);
#line 1526 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 10572 "Database.c"
}

void
services_database_move_item (ServicesDatabase* self,
                             ObjectsItem* item)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	sqlite3_stmt* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	sqlite3_stmt* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	sqlite3_stmt* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	sqlite3_stmt* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	sqlite3_stmt* _tmp23_;
	sqlite3_stmt* _tmp40_;
#line 1571 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1571 "../core/Services/Database.vala"
	g_return_if_fail (item != NULL);
#line 1572 "../core/Services/Database.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 1572 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 1572 "../core/Services/Database.vala"
	_tmp2_ = g_date_time_to_string (_tmp1_);
#line 1572 "../core/Services/Database.vala"
	_tmp3_ = _tmp2_;
#line 1572 "../core/Services/Database.vala"
	objects_item_set_updated_at (item, _tmp3_);
#line 1572 "../core/Services/Database.vala"
	_g_free0 (_tmp3_);
#line 1572 "../core/Services/Database.vala"
	_g_date_time_unref0 (_tmp1_);
#line 1575 "../core/Services/Database.vala"
	_tmp4_ = g_strdup ("\n" \
"            UPDATE Items SET\n" \
"                section_id=$section_id,\n" \
"                project_id=$project_id,\n" \
"                parent_id=$parent_id\n" \
"            WHERE id=$id;\n" \
"        ");
#line 1575 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1575 "../core/Services/Database.vala"
	self->priv->sql = _tmp4_;
#line 1583 "../core/Services/Database.vala"
	_tmp5_ = self->priv->db;
#line 1583 "../core/Services/Database.vala"
	_tmp6_ = self->priv->sql;
#line 1583 "../core/Services/Database.vala"
	_tmp7_ = self->priv->sql;
#line 1583 "../core/Services/Database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 1583 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1583 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 1583 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1583 "../core/Services/Database.vala"
	stmt = _tmp10_;
#line 1584 "../core/Services/Database.vala"
	_tmp11_ = stmt;
#line 1584 "../core/Services/Database.vala"
	_tmp12_ = objects_item_get_section_id (item);
#line 1584 "../core/Services/Database.vala"
	_tmp13_ = _tmp12_;
#line 1584 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp11_, "$section_id", _tmp13_);
#line 1585 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1585 "../core/Services/Database.vala"
	_tmp15_ = objects_item_get_project_id (item);
#line 1585 "../core/Services/Database.vala"
	_tmp16_ = _tmp15_;
#line 1585 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp14_, "$project_id", _tmp16_);
#line 1586 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1586 "../core/Services/Database.vala"
	_tmp18_ = objects_item_get_parent_id (item);
#line 1586 "../core/Services/Database.vala"
	_tmp19_ = _tmp18_;
#line 1586 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp17_, "$parent_id", _tmp19_);
#line 1587 "../core/Services/Database.vala"
	_tmp20_ = stmt;
#line 1587 "../core/Services/Database.vala"
	_tmp21_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1587 "../core/Services/Database.vala"
	_tmp22_ = _tmp21_;
#line 1587 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp20_, "$id", _tmp22_);
#line 1589 "../core/Services/Database.vala"
	_tmp23_ = stmt;
#line 1589 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp23_) == SQLITE_DONE) {
#line 10681 "Database.c"
		{
			GeeArrayList* _subitem_list = NULL;
			GeeArrayList* _tmp24_;
			GeeArrayList* _tmp25_;
			gint _subitem_size = 0;
			GeeArrayList* _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
			gint _subitem_index = 0;
#line 1590 "../core/Services/Database.vala"
			_tmp24_ = objects_item_get_items (item);
#line 1590 "../core/Services/Database.vala"
			_tmp25_ = _tmp24_;
#line 1590 "../core/Services/Database.vala"
			_subitem_list = _tmp25_;
#line 1590 "../core/Services/Database.vala"
			_tmp26_ = _subitem_list;
#line 1590 "../core/Services/Database.vala"
			_tmp27_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp26_);
#line 1590 "../core/Services/Database.vala"
			_tmp28_ = _tmp27_;
#line 1590 "../core/Services/Database.vala"
			_subitem_size = _tmp28_;
#line 1590 "../core/Services/Database.vala"
			_subitem_index = -1;
#line 1590 "../core/Services/Database.vala"
			while (TRUE) {
#line 10709 "Database.c"
				gint _tmp29_;
				gint _tmp30_;
				ObjectsItem* subitem = NULL;
				GeeArrayList* _tmp31_;
				gpointer _tmp32_;
				ObjectsItem* _tmp33_;
				const gchar* _tmp34_;
				const gchar* _tmp35_;
				ObjectsItem* _tmp36_;
#line 1590 "../core/Services/Database.vala"
				_subitem_index = _subitem_index + 1;
#line 1590 "../core/Services/Database.vala"
				_tmp29_ = _subitem_index;
#line 1590 "../core/Services/Database.vala"
				_tmp30_ = _subitem_size;
#line 1590 "../core/Services/Database.vala"
				if (!(_tmp29_ < _tmp30_)) {
#line 1590 "../core/Services/Database.vala"
					break;
#line 10729 "Database.c"
				}
#line 1590 "../core/Services/Database.vala"
				_tmp31_ = _subitem_list;
#line 1590 "../core/Services/Database.vala"
				_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, _subitem_index);
#line 1590 "../core/Services/Database.vala"
				subitem = (ObjectsItem*) _tmp32_;
#line 1591 "../core/Services/Database.vala"
				_tmp33_ = subitem;
#line 1591 "../core/Services/Database.vala"
				_tmp34_ = objects_item_get_project_id (item);
#line 1591 "../core/Services/Database.vala"
				_tmp35_ = _tmp34_;
#line 1591 "../core/Services/Database.vala"
				objects_item_set_project_id (_tmp33_, _tmp35_);
#line 1592 "../core/Services/Database.vala"
				_tmp36_ = subitem;
#line 1592 "../core/Services/Database.vala"
				services_database_move_item (self, _tmp36_);
#line 1590 "../core/Services/Database.vala"
				_g_object_unref0 (subitem);
#line 10751 "Database.c"
			}
		}
#line 1595 "../core/Services/Database.vala"
		g_signal_emit_by_name ((ObjectsBaseObject*) item, "updated");
#line 1596 "../core/Services/Database.vala"
		g_signal_emit (self, services_database_signals[SERVICES_DATABASE_ITEM_UPDATED_SIGNAL], 0, item, "");
#line 10758 "Database.c"
	} else {
		sqlite3* _tmp37_;
		sqlite3* _tmp38_;
		const gchar* _tmp39_;
#line 1598 "../core/Services/Database.vala"
		_tmp37_ = self->priv->db;
#line 1598 "../core/Services/Database.vala"
		_tmp38_ = self->priv->db;
#line 1598 "../core/Services/Database.vala"
		_tmp39_ = sqlite3_errmsg (_tmp38_);
#line 1598 "../core/Services/Database.vala"
		g_warning ("Database.vala:1598: Error: %d: %s", sqlite3_errcode (_tmp37_), _tmp39_);
#line 10771 "Database.c"
	}
#line 1601 "../core/Services/Database.vala"
	_tmp40_ = stmt;
#line 1601 "../core/Services/Database.vala"
	sqlite3_reset (_tmp40_);
#line 1571 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 10779 "Database.c"
}

void
services_database_checked_toggled (ServicesDatabase* self,
                                   ObjectsItem* item,
                                   gboolean old_checked)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	sqlite3_stmt* _tmp38_;
#line 1604 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1604 "../core/Services/Database.vala"
	g_return_if_fail (item != NULL);
#line 1607 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET checked=$checked, completed_at=$completed" \
"_at\n" \
"            WHERE id=$id OR parent_id=$id;\n" \
"        ");
#line 1607 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1607 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1612 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1612 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1612 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1612 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1612 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1612 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1612 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1612 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1613 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1613 "../core/Services/Database.vala"
	_tmp8_ = objects_item_get_checked (item);
#line 1613 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1613 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp7_, "$checked", _tmp9_);
#line 1614 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1614 "../core/Services/Database.vala"
	_tmp11_ = objects_item_get_completed_at (item);
#line 1614 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1614 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$completed_at", _tmp12_);
#line 1615 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1615 "../core/Services/Database.vala"
	_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1615 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1615 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$id", _tmp15_);
#line 1617 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1617 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp16_) == SQLITE_DONE) {
#line 10860 "Database.c"
		ServicesEventBus* _tmp33_;
		ServicesEventBus* _tmp34_;
		{
			GeeArrayList* _subitem_list = NULL;
			GeeArrayList* _tmp17_;
			GeeArrayList* _tmp18_;
			gint _subitem_size = 0;
			GeeArrayList* _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			gint _subitem_index = 0;
#line 1618 "../core/Services/Database.vala"
			_tmp17_ = objects_item_get_items (item);
#line 1618 "../core/Services/Database.vala"
			_tmp18_ = _tmp17_;
#line 1618 "../core/Services/Database.vala"
			_subitem_list = _tmp18_;
#line 1618 "../core/Services/Database.vala"
			_tmp19_ = _subitem_list;
#line 1618 "../core/Services/Database.vala"
			_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
#line 1618 "../core/Services/Database.vala"
			_tmp21_ = _tmp20_;
#line 1618 "../core/Services/Database.vala"
			_subitem_size = _tmp21_;
#line 1618 "../core/Services/Database.vala"
			_subitem_index = -1;
#line 1618 "../core/Services/Database.vala"
			while (TRUE) {
#line 10890 "Database.c"
				gint _tmp22_;
				gint _tmp23_;
				ObjectsItem* subitem = NULL;
				GeeArrayList* _tmp24_;
				gpointer _tmp25_;
				ObjectsItem* _tmp26_;
				gboolean _tmp27_;
				gboolean _tmp28_;
				ObjectsItem* _tmp29_;
				const gchar* _tmp30_;
				const gchar* _tmp31_;
				ObjectsItem* _tmp32_;
#line 1618 "../core/Services/Database.vala"
				_subitem_index = _subitem_index + 1;
#line 1618 "../core/Services/Database.vala"
				_tmp22_ = _subitem_index;
#line 1618 "../core/Services/Database.vala"
				_tmp23_ = _subitem_size;
#line 1618 "../core/Services/Database.vala"
				if (!(_tmp22_ < _tmp23_)) {
#line 1618 "../core/Services/Database.vala"
					break;
#line 10913 "Database.c"
				}
#line 1618 "../core/Services/Database.vala"
				_tmp24_ = _subitem_list;
#line 1618 "../core/Services/Database.vala"
				_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, _subitem_index);
#line 1618 "../core/Services/Database.vala"
				subitem = (ObjectsItem*) _tmp25_;
#line 1619 "../core/Services/Database.vala"
				_tmp26_ = subitem;
#line 1619 "../core/Services/Database.vala"
				_tmp27_ = objects_item_get_checked (item);
#line 1619 "../core/Services/Database.vala"
				_tmp28_ = _tmp27_;
#line 1619 "../core/Services/Database.vala"
				objects_item_set_checked (_tmp26_, _tmp28_);
#line 1620 "../core/Services/Database.vala"
				_tmp29_ = subitem;
#line 1620 "../core/Services/Database.vala"
				_tmp30_ = objects_item_get_completed_at (item);
#line 1620 "../core/Services/Database.vala"
				_tmp31_ = _tmp30_;
#line 1620 "../core/Services/Database.vala"
				objects_item_set_completed_at (_tmp29_, _tmp31_);
#line 1621 "../core/Services/Database.vala"
				_tmp32_ = subitem;
#line 1621 "../core/Services/Database.vala"
				services_database_checked_toggled (self, _tmp32_, old_checked);
#line 1618 "../core/Services/Database.vala"
				_g_object_unref0 (subitem);
#line 10943 "Database.c"
			}
		}
#line 1624 "../core/Services/Database.vala"
		g_signal_emit_by_name ((ObjectsBaseObject*) item, "updated");
#line 1625 "../core/Services/Database.vala"
		g_signal_emit (self, services_database_signals[SERVICES_DATABASE_ITEM_UPDATED_SIGNAL], 0, item, "");
#line 1627 "../core/Services/Database.vala"
		_tmp33_ = services_event_bus_get_default ();
#line 1627 "../core/Services/Database.vala"
		_tmp34_ = _tmp33_;
#line 1627 "../core/Services/Database.vala"
		g_signal_emit_by_name (_tmp34_, "checked-toggled", item, old_checked);
#line 1627 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp34_);
#line 10958 "Database.c"
	} else {
		sqlite3* _tmp35_;
		sqlite3* _tmp36_;
		const gchar* _tmp37_;
#line 1629 "../core/Services/Database.vala"
		_tmp35_ = self->priv->db;
#line 1629 "../core/Services/Database.vala"
		_tmp36_ = self->priv->db;
#line 1629 "../core/Services/Database.vala"
		_tmp37_ = sqlite3_errmsg (_tmp36_);
#line 1629 "../core/Services/Database.vala"
		g_warning ("Database.vala:1629: Error: %d: %s", sqlite3_errcode (_tmp35_), _tmp37_);
#line 10971 "Database.c"
	}
#line 1632 "../core/Services/Database.vala"
	_tmp38_ = stmt;
#line 1632 "../core/Services/Database.vala"
	sqlite3_reset (_tmp38_);
#line 1604 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 10979 "Database.c"
}

void
services_database_update_child_order (ServicesDatabase* self,
                                      ObjectsBaseObject* base_object)
{
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	sqlite3_stmt* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	sqlite3_stmt* _tmp26_;
	sqlite3_stmt* _tmp30_;
#line 1635 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1635 "../core/Services/Database.vala"
	g_return_if_fail (base_object != NULL);
#line 1638 "../core/Services/Database.vala"
	_tmp0_ = objects_base_object_get_table_name (base_object);
#line 1638 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 1638 "../core/Services/Database.vala"
	_tmp2_ = objects_base_object_get_column_order_name (base_object);
#line 1638 "../core/Services/Database.vala"
	_tmp3_ = _tmp2_;
#line 1638 "../core/Services/Database.vala"
	_tmp4_ = g_strdup_printf ("\n            UPDATE %s SET %s=$order WHERE id=$id;\n        ", _tmp1_, _tmp3_);
#line 1638 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1638 "../core/Services/Database.vala"
	self->priv->sql = _tmp4_;
#line 1642 "../core/Services/Database.vala"
	_tmp5_ = self->priv->db;
#line 1642 "../core/Services/Database.vala"
	_tmp6_ = self->priv->sql;
#line 1642 "../core/Services/Database.vala"
	_tmp7_ = self->priv->sql;
#line 1642 "../core/Services/Database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 1642 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1642 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 1642 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1642 "../core/Services/Database.vala"
	stmt = _tmp10_;
#line 1644 "../core/Services/Database.vala"
	if (OBJECTS_IS_ITEM (base_object)) {
#line 11039 "Database.c"
		sqlite3_stmt* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
#line 1645 "../core/Services/Database.vala"
		_tmp11_ = stmt;
#line 1645 "../core/Services/Database.vala"
		_tmp12_ = objects_item_get_child_order (G_TYPE_CHECK_INSTANCE_CAST (base_object, OBJECTS_TYPE_ITEM, ObjectsItem));
#line 1645 "../core/Services/Database.vala"
		_tmp13_ = _tmp12_;
#line 1645 "../core/Services/Database.vala"
		services_database_set_parameter_int (self, _tmp11_, "$order", _tmp13_);
#line 11051 "Database.c"
	} else {
#line 1646 "../core/Services/Database.vala"
		if (OBJECTS_IS_SECTION (base_object)) {
#line 11055 "Database.c"
			sqlite3_stmt* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
#line 1647 "../core/Services/Database.vala"
			_tmp14_ = stmt;
#line 1647 "../core/Services/Database.vala"
			_tmp15_ = objects_section_get_section_order (G_TYPE_CHECK_INSTANCE_CAST (base_object, OBJECTS_TYPE_SECTION, ObjectsSection));
#line 1647 "../core/Services/Database.vala"
			_tmp16_ = _tmp15_;
#line 1647 "../core/Services/Database.vala"
			services_database_set_parameter_int (self, _tmp14_, "$order", _tmp16_);
#line 11067 "Database.c"
		} else {
#line 1648 "../core/Services/Database.vala"
			if (OBJECTS_IS_PROJECT (base_object)) {
#line 11071 "Database.c"
				sqlite3_stmt* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 1649 "../core/Services/Database.vala"
				_tmp17_ = stmt;
#line 1649 "../core/Services/Database.vala"
				_tmp18_ = objects_project_get_child_order (G_TYPE_CHECK_INSTANCE_CAST (base_object, OBJECTS_TYPE_PROJECT, ObjectsProject));
#line 1649 "../core/Services/Database.vala"
				_tmp19_ = _tmp18_;
#line 1649 "../core/Services/Database.vala"
				services_database_set_parameter_int (self, _tmp17_, "$order", _tmp19_);
#line 11083 "Database.c"
			} else {
#line 1650 "../core/Services/Database.vala"
				if (OBJECTS_IS_LABEL (base_object)) {
#line 11087 "Database.c"
					sqlite3_stmt* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
#line 1651 "../core/Services/Database.vala"
					_tmp20_ = stmt;
#line 1651 "../core/Services/Database.vala"
					_tmp21_ = objects_label_get_item_order (G_TYPE_CHECK_INSTANCE_CAST (base_object, OBJECTS_TYPE_LABEL, ObjectsLabel));
#line 1651 "../core/Services/Database.vala"
					_tmp22_ = _tmp21_;
#line 1651 "../core/Services/Database.vala"
					services_database_set_parameter_int (self, _tmp20_, "$order", _tmp22_);
#line 11099 "Database.c"
				}
			}
		}
	}
#line 1654 "../core/Services/Database.vala"
	_tmp23_ = stmt;
#line 1654 "../core/Services/Database.vala"
	_tmp24_ = objects_base_object_get_id (base_object);
#line 1654 "../core/Services/Database.vala"
	_tmp25_ = _tmp24_;
#line 1654 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp23_, "$id", _tmp25_);
#line 1656 "../core/Services/Database.vala"
	_tmp26_ = stmt;
#line 1656 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp26_) != SQLITE_DONE) {
#line 11116 "Database.c"
		sqlite3* _tmp27_;
		sqlite3* _tmp28_;
		const gchar* _tmp29_;
#line 1657 "../core/Services/Database.vala"
		_tmp27_ = self->priv->db;
#line 1657 "../core/Services/Database.vala"
		_tmp28_ = self->priv->db;
#line 1657 "../core/Services/Database.vala"
		_tmp29_ = sqlite3_errmsg (_tmp28_);
#line 1657 "../core/Services/Database.vala"
		g_warning ("Database.vala:1657: Error: %d: %s", sqlite3_errcode (_tmp27_), _tmp29_);
#line 11128 "Database.c"
	}
#line 1660 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 1660 "../core/Services/Database.vala"
	sqlite3_reset (_tmp30_);
#line 1635 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 11136 "Database.c"
}

GeeArrayList*
services_database_get_all_projects_by_search (ServicesDatabase* self,
                                              const gchar* search_text)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1667 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1667 "../core/Services/Database.vala"
	g_return_val_if_fail (search_text != NULL, NULL);
#line 1668 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1668 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 11155 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1669 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_projects;
#line 1669 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__projects);
#line 11162 "Database.c"
		{
			GeeArrayList* _tmp21_;
			GeeArrayList* _tmp22_;
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _project_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _project_index = 0;
#line 1670 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_projects (self);
#line 1670 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1670 "../core/Services/Database.vala"
				_project_list = _tmp3_;
#line 1670 "../core/Services/Database.vala"
				_tmp4_ = _project_list;
#line 1670 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1670 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1670 "../core/Services/Database.vala"
				_project_size = _tmp6_;
#line 1670 "../core/Services/Database.vala"
				_project_index = -1;
#line 1670 "../core/Services/Database.vala"
				while (TRUE) {
#line 11193 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsProject* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gboolean _tmp18_;
#line 1670 "../core/Services/Database.vala"
					_project_index = _project_index + 1;
#line 1670 "../core/Services/Database.vala"
					_tmp7_ = _project_index;
#line 1670 "../core/Services/Database.vala"
					_tmp8_ = _project_size;
#line 1670 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1670 "../core/Services/Database.vala"
						break;
#line 11217 "Database.c"
					}
#line 1670 "../core/Services/Database.vala"
					_tmp9_ = _project_list;
#line 1670 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _project_index);
#line 1670 "../core/Services/Database.vala"
					project = (ObjectsProject*) _tmp10_;
#line 1671 "../core/Services/Database.vala"
					_tmp11_ = project;
#line 1671 "../core/Services/Database.vala"
					_tmp12_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp11_);
#line 1671 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 1671 "../core/Services/Database.vala"
					_tmp14_ = g_utf8_strdown (_tmp13_, (gssize) -1);
#line 1671 "../core/Services/Database.vala"
					_tmp15_ = _tmp14_;
#line 1671 "../core/Services/Database.vala"
					_tmp16_ = g_utf8_strdown (search_text, (gssize) -1);
#line 1671 "../core/Services/Database.vala"
					_tmp17_ = _tmp16_;
#line 1671 "../core/Services/Database.vala"
					_tmp18_ = string_contains (_tmp15_, _tmp17_);
#line 1671 "../core/Services/Database.vala"
					_g_free0 (_tmp17_);
#line 1671 "../core/Services/Database.vala"
					_g_free0 (_tmp15_);
#line 1671 "../core/Services/Database.vala"
					if (_tmp18_) {
#line 11247 "Database.c"
						GeeArrayList* _tmp19_;
						ObjectsProject* _tmp20_;
#line 1672 "../core/Services/Database.vala"
						_tmp19_ = return_value;
#line 1672 "../core/Services/Database.vala"
						_tmp20_ = project;
#line 1672 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp20_);
#line 11256 "Database.c"
					}
#line 1670 "../core/Services/Database.vala"
					_g_object_unref0 (project);
#line 11260 "Database.c"
				}
			}
#line 1676 "../core/Services/Database.vala"
			_tmp21_ = return_value;
#line 1676 "../core/Services/Database.vala"
			_tmp22_ = _g_object_ref0 (_tmp21_);
#line 1676 "../core/Services/Database.vala"
			result = _tmp22_;
#line 11269 "Database.c"
			{
				GeeArrayList* _tmp23_;
#line 1669 "../core/Services/Database.vala"
				_tmp23_ = self->priv->_projects;
#line 1669 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 11276 "Database.c"
			}
#line 1676 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1676 "../core/Services/Database.vala"
			return result;
#line 11282 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp24_;
#line 1669 "../core/Services/Database.vala"
			_tmp24_ = self->priv->_projects;
#line 1669 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 11291 "Database.c"
		}
#line 1669 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1669 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1669 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1669 "../core/Services/Database.vala"
		return NULL;
#line 11301 "Database.c"
	}
}

GeeArrayList*
services_database_get_all_sections_by_search (ServicesDatabase* self,
                                              const gchar* search_text)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1680 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1680 "../core/Services/Database.vala"
	g_return_val_if_fail (search_text != NULL, NULL);
#line 1681 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_SECTION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1681 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 11321 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1682 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_projects;
#line 1682 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__projects);
#line 11328 "Database.c"
		{
			GeeArrayList* _tmp21_;
			GeeArrayList* _tmp22_;
			{
				GeeArrayList* _section_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _section_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _section_index = 0;
#line 1683 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_sections (self);
#line 1683 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1683 "../core/Services/Database.vala"
				_section_list = _tmp3_;
#line 1683 "../core/Services/Database.vala"
				_tmp4_ = _section_list;
#line 1683 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1683 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1683 "../core/Services/Database.vala"
				_section_size = _tmp6_;
#line 1683 "../core/Services/Database.vala"
				_section_index = -1;
#line 1683 "../core/Services/Database.vala"
				while (TRUE) {
#line 11359 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsSection* section = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsSection* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gboolean _tmp18_;
#line 1683 "../core/Services/Database.vala"
					_section_index = _section_index + 1;
#line 1683 "../core/Services/Database.vala"
					_tmp7_ = _section_index;
#line 1683 "../core/Services/Database.vala"
					_tmp8_ = _section_size;
#line 1683 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1683 "../core/Services/Database.vala"
						break;
#line 11383 "Database.c"
					}
#line 1683 "../core/Services/Database.vala"
					_tmp9_ = _section_list;
#line 1683 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _section_index);
#line 1683 "../core/Services/Database.vala"
					section = (ObjectsSection*) _tmp10_;
#line 1684 "../core/Services/Database.vala"
					_tmp11_ = section;
#line 1684 "../core/Services/Database.vala"
					_tmp12_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp11_);
#line 1684 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 1684 "../core/Services/Database.vala"
					_tmp14_ = g_utf8_strdown (_tmp13_, (gssize) -1);
#line 1684 "../core/Services/Database.vala"
					_tmp15_ = _tmp14_;
#line 1684 "../core/Services/Database.vala"
					_tmp16_ = g_utf8_strdown (search_text, (gssize) -1);
#line 1684 "../core/Services/Database.vala"
					_tmp17_ = _tmp16_;
#line 1684 "../core/Services/Database.vala"
					_tmp18_ = string_contains (_tmp15_, _tmp17_);
#line 1684 "../core/Services/Database.vala"
					_g_free0 (_tmp17_);
#line 1684 "../core/Services/Database.vala"
					_g_free0 (_tmp15_);
#line 1684 "../core/Services/Database.vala"
					if (_tmp18_) {
#line 11413 "Database.c"
						GeeArrayList* _tmp19_;
						ObjectsSection* _tmp20_;
#line 1685 "../core/Services/Database.vala"
						_tmp19_ = return_value;
#line 1685 "../core/Services/Database.vala"
						_tmp20_ = section;
#line 1685 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp20_);
#line 11422 "Database.c"
					}
#line 1683 "../core/Services/Database.vala"
					_g_object_unref0 (section);
#line 11426 "Database.c"
				}
			}
#line 1689 "../core/Services/Database.vala"
			_tmp21_ = return_value;
#line 1689 "../core/Services/Database.vala"
			_tmp22_ = _g_object_ref0 (_tmp21_);
#line 1689 "../core/Services/Database.vala"
			result = _tmp22_;
#line 11435 "Database.c"
			{
				GeeArrayList* _tmp23_;
#line 1682 "../core/Services/Database.vala"
				_tmp23_ = self->priv->_projects;
#line 1682 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 11442 "Database.c"
			}
#line 1689 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1689 "../core/Services/Database.vala"
			return result;
#line 11448 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp24_;
#line 1682 "../core/Services/Database.vala"
			_tmp24_ = self->priv->_projects;
#line 1682 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 11457 "Database.c"
		}
#line 1682 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1682 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1682 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1682 "../core/Services/Database.vala"
		return NULL;
#line 11467 "Database.c"
	}
}

GeeArrayList*
services_database_get_all_projects_by_todoist (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1693 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1694 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1694 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 11484 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1695 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_projects;
#line 1695 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__projects);
#line 11491 "Database.c"
		{
			GeeArrayList* _tmp16_;
			GeeArrayList* _tmp17_;
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _project_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _project_index = 0;
#line 1696 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_projects (self);
#line 1696 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1696 "../core/Services/Database.vala"
				_project_list = _tmp3_;
#line 1696 "../core/Services/Database.vala"
				_tmp4_ = _project_list;
#line 1696 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1696 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1696 "../core/Services/Database.vala"
				_project_size = _tmp6_;
#line 1696 "../core/Services/Database.vala"
				_project_index = -1;
#line 1696 "../core/Services/Database.vala"
				while (TRUE) {
#line 11522 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsProject* _tmp11_;
					BackendType _tmp12_;
					BackendType _tmp13_;
#line 1696 "../core/Services/Database.vala"
					_project_index = _project_index + 1;
#line 1696 "../core/Services/Database.vala"
					_tmp7_ = _project_index;
#line 1696 "../core/Services/Database.vala"
					_tmp8_ = _project_size;
#line 1696 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1696 "../core/Services/Database.vala"
						break;
#line 11541 "Database.c"
					}
#line 1696 "../core/Services/Database.vala"
					_tmp9_ = _project_list;
#line 1696 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _project_index);
#line 1696 "../core/Services/Database.vala"
					project = (ObjectsProject*) _tmp10_;
#line 1697 "../core/Services/Database.vala"
					_tmp11_ = project;
#line 1697 "../core/Services/Database.vala"
					_tmp12_ = objects_project_get_backend_type (_tmp11_);
#line 1697 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 1697 "../core/Services/Database.vala"
					if (_tmp13_ == BACKEND_TYPE_TODOIST) {
#line 11557 "Database.c"
						GeeArrayList* _tmp14_;
						ObjectsProject* _tmp15_;
#line 1698 "../core/Services/Database.vala"
						_tmp14_ = return_value;
#line 1698 "../core/Services/Database.vala"
						_tmp15_ = project;
#line 1698 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 11566 "Database.c"
					}
#line 1696 "../core/Services/Database.vala"
					_g_object_unref0 (project);
#line 11570 "Database.c"
				}
			}
#line 1702 "../core/Services/Database.vala"
			_tmp16_ = return_value;
#line 1702 "../core/Services/Database.vala"
			_tmp17_ = _g_object_ref0 (_tmp16_);
#line 1702 "../core/Services/Database.vala"
			result = _tmp17_;
#line 11579 "Database.c"
			{
				GeeArrayList* _tmp18_;
#line 1695 "../core/Services/Database.vala"
				_tmp18_ = self->priv->_projects;
#line 1695 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 11586 "Database.c"
			}
#line 1702 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1702 "../core/Services/Database.vala"
			return result;
#line 11592 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp19_;
#line 1695 "../core/Services/Database.vala"
			_tmp19_ = self->priv->_projects;
#line 1695 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 11601 "Database.c"
		}
#line 1695 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1695 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1695 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1695 "../core/Services/Database.vala"
		return NULL;
#line 11611 "Database.c"
	}
}

GeeArrayList*
services_database_get_all_projects_by_backend_type (ServicesDatabase* self,
                                                    BackendType backend_type)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1706 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1707 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1707 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 11629 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1708 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_projects;
#line 1708 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__projects);
#line 11636 "Database.c"
		{
			GeeArrayList* _tmp16_;
			GeeArrayList* _tmp17_;
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _project_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _project_index = 0;
#line 1709 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_projects (self);
#line 1709 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1709 "../core/Services/Database.vala"
				_project_list = _tmp3_;
#line 1709 "../core/Services/Database.vala"
				_tmp4_ = _project_list;
#line 1709 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1709 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1709 "../core/Services/Database.vala"
				_project_size = _tmp6_;
#line 1709 "../core/Services/Database.vala"
				_project_index = -1;
#line 1709 "../core/Services/Database.vala"
				while (TRUE) {
#line 11667 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsProject* _tmp11_;
					BackendType _tmp12_;
					BackendType _tmp13_;
#line 1709 "../core/Services/Database.vala"
					_project_index = _project_index + 1;
#line 1709 "../core/Services/Database.vala"
					_tmp7_ = _project_index;
#line 1709 "../core/Services/Database.vala"
					_tmp8_ = _project_size;
#line 1709 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1709 "../core/Services/Database.vala"
						break;
#line 11686 "Database.c"
					}
#line 1709 "../core/Services/Database.vala"
					_tmp9_ = _project_list;
#line 1709 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _project_index);
#line 1709 "../core/Services/Database.vala"
					project = (ObjectsProject*) _tmp10_;
#line 1710 "../core/Services/Database.vala"
					_tmp11_ = project;
#line 1710 "../core/Services/Database.vala"
					_tmp12_ = objects_project_get_backend_type (_tmp11_);
#line 1710 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 1710 "../core/Services/Database.vala"
					if (_tmp13_ == backend_type) {
#line 11702 "Database.c"
						GeeArrayList* _tmp14_;
						ObjectsProject* _tmp15_;
#line 1711 "../core/Services/Database.vala"
						_tmp14_ = return_value;
#line 1711 "../core/Services/Database.vala"
						_tmp15_ = project;
#line 1711 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 11711 "Database.c"
					}
#line 1709 "../core/Services/Database.vala"
					_g_object_unref0 (project);
#line 11715 "Database.c"
				}
			}
#line 1715 "../core/Services/Database.vala"
			_tmp16_ = return_value;
#line 1715 "../core/Services/Database.vala"
			_tmp17_ = _g_object_ref0 (_tmp16_);
#line 1715 "../core/Services/Database.vala"
			result = _tmp17_;
#line 11724 "Database.c"
			{
				GeeArrayList* _tmp18_;
#line 1708 "../core/Services/Database.vala"
				_tmp18_ = self->priv->_projects;
#line 1708 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 11731 "Database.c"
			}
#line 1715 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1715 "../core/Services/Database.vala"
			return result;
#line 11737 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp19_;
#line 1708 "../core/Services/Database.vala"
			_tmp19_ = self->priv->_projects;
#line 1708 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__projects);
#line 11746 "Database.c"
		}
#line 1708 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1708 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1708 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1708 "../core/Services/Database.vala"
		return NULL;
#line 11756 "Database.c"
	}
}

GeeArrayList*
services_database_get_all_labels_by_todoist (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1719 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1720 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_LABEL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1720 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 11773 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1721 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_labels;
#line 1721 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__labels);
#line 11780 "Database.c"
		{
			GeeArrayList* _tmp16_;
			GeeArrayList* _tmp17_;
			{
				GeeArrayList* _label_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _label_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _label_index = 0;
#line 1722 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_labels (self);
#line 1722 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1722 "../core/Services/Database.vala"
				_label_list = _tmp3_;
#line 1722 "../core/Services/Database.vala"
				_tmp4_ = _label_list;
#line 1722 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1722 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1722 "../core/Services/Database.vala"
				_label_size = _tmp6_;
#line 1722 "../core/Services/Database.vala"
				_label_index = -1;
#line 1722 "../core/Services/Database.vala"
				while (TRUE) {
#line 11811 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsLabel* _tmp11_;
					BackendType _tmp12_;
					BackendType _tmp13_;
#line 1722 "../core/Services/Database.vala"
					_label_index = _label_index + 1;
#line 1722 "../core/Services/Database.vala"
					_tmp7_ = _label_index;
#line 1722 "../core/Services/Database.vala"
					_tmp8_ = _label_size;
#line 1722 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1722 "../core/Services/Database.vala"
						break;
#line 11830 "Database.c"
					}
#line 1722 "../core/Services/Database.vala"
					_tmp9_ = _label_list;
#line 1722 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _label_index);
#line 1722 "../core/Services/Database.vala"
					label = (ObjectsLabel*) _tmp10_;
#line 1723 "../core/Services/Database.vala"
					_tmp11_ = label;
#line 1723 "../core/Services/Database.vala"
					_tmp12_ = objects_label_get_backend_type (_tmp11_);
#line 1723 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 1723 "../core/Services/Database.vala"
					if (_tmp13_ == BACKEND_TYPE_TODOIST) {
#line 11846 "Database.c"
						GeeArrayList* _tmp14_;
						ObjectsLabel* _tmp15_;
#line 1724 "../core/Services/Database.vala"
						_tmp14_ = return_value;
#line 1724 "../core/Services/Database.vala"
						_tmp15_ = label;
#line 1724 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 11855 "Database.c"
					}
#line 1722 "../core/Services/Database.vala"
					_g_object_unref0 (label);
#line 11859 "Database.c"
				}
			}
#line 1728 "../core/Services/Database.vala"
			_tmp16_ = return_value;
#line 1728 "../core/Services/Database.vala"
			_tmp17_ = _g_object_ref0 (_tmp16_);
#line 1728 "../core/Services/Database.vala"
			result = _tmp17_;
#line 11868 "Database.c"
			{
				GeeArrayList* _tmp18_;
#line 1721 "../core/Services/Database.vala"
				_tmp18_ = self->priv->_labels;
#line 1721 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 11875 "Database.c"
			}
#line 1728 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1728 "../core/Services/Database.vala"
			return result;
#line 11881 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp19_;
#line 1721 "../core/Services/Database.vala"
			_tmp19_ = self->priv->_labels;
#line 1721 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__labels);
#line 11890 "Database.c"
		}
#line 1721 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1721 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1721 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1721 "../core/Services/Database.vala"
		return NULL;
#line 11900 "Database.c"
	}
}

GeeArrayList*
services_database_get_all_items_by_search (ServicesDatabase* self,
                                           const gchar* search_text)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1732 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1732 "../core/Services/Database.vala"
	g_return_val_if_fail (search_text != NULL, NULL);
#line 1733 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1733 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 11920 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1734 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_items;
#line 1734 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__items);
#line 11927 "Database.c"
		{
			GeeArrayList* _tmp33_;
			GeeArrayList* _tmp34_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
#line 1735 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_items (self);
#line 1735 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1735 "../core/Services/Database.vala"
				_item_list = _tmp3_;
#line 1735 "../core/Services/Database.vala"
				_tmp4_ = _item_list;
#line 1735 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1735 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1735 "../core/Services/Database.vala"
				_item_size = _tmp6_;
#line 1735 "../core/Services/Database.vala"
				_item_index = -1;
#line 1735 "../core/Services/Database.vala"
				while (TRUE) {
#line 11958 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsItem* _tmp12_;
					gboolean _tmp13_;
					gboolean _tmp14_;
#line 1735 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 1735 "../core/Services/Database.vala"
					_tmp7_ = _item_index;
#line 1735 "../core/Services/Database.vala"
					_tmp8_ = _item_size;
#line 1735 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1735 "../core/Services/Database.vala"
						break;
#line 11978 "Database.c"
					}
#line 1735 "../core/Services/Database.vala"
					_tmp9_ = _item_list;
#line 1735 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
#line 1735 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp10_;
#line 1736 "../core/Services/Database.vala"
					_tmp12_ = item;
#line 1736 "../core/Services/Database.vala"
					_tmp13_ = objects_item_get_checked (_tmp12_);
#line 1736 "../core/Services/Database.vala"
					_tmp14_ = _tmp13_;
#line 1736 "../core/Services/Database.vala"
					if (!_tmp14_) {
#line 11994 "Database.c"
						gboolean _tmp15_ = FALSE;
						ObjectsItem* _tmp16_;
						const gchar* _tmp17_;
						const gchar* _tmp18_;
						gchar* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
						gboolean _tmp23_;
#line 1736 "../core/Services/Database.vala"
						_tmp16_ = item;
#line 1736 "../core/Services/Database.vala"
						_tmp17_ = objects_item_get_content (_tmp16_);
#line 1736 "../core/Services/Database.vala"
						_tmp18_ = _tmp17_;
#line 1736 "../core/Services/Database.vala"
						_tmp19_ = g_utf8_strdown (_tmp18_, (gssize) -1);
#line 1736 "../core/Services/Database.vala"
						_tmp20_ = _tmp19_;
#line 1736 "../core/Services/Database.vala"
						_tmp21_ = g_utf8_strdown (search_text, (gssize) -1);
#line 1736 "../core/Services/Database.vala"
						_tmp22_ = _tmp21_;
#line 1736 "../core/Services/Database.vala"
						_tmp23_ = string_contains (_tmp20_, _tmp22_);
#line 1736 "../core/Services/Database.vala"
						_g_free0 (_tmp22_);
#line 1736 "../core/Services/Database.vala"
						_g_free0 (_tmp20_);
#line 1736 "../core/Services/Database.vala"
						if (_tmp23_) {
#line 1736 "../core/Services/Database.vala"
							_tmp15_ = TRUE;
#line 12028 "Database.c"
						} else {
							ObjectsItem* _tmp24_;
							const gchar* _tmp25_;
							const gchar* _tmp26_;
							gchar* _tmp27_;
							gchar* _tmp28_;
							gchar* _tmp29_;
							gchar* _tmp30_;
#line 1737 "../core/Services/Database.vala"
							_tmp24_ = item;
#line 1737 "../core/Services/Database.vala"
							_tmp25_ = objects_item_get_description (_tmp24_);
#line 1737 "../core/Services/Database.vala"
							_tmp26_ = _tmp25_;
#line 1737 "../core/Services/Database.vala"
							_tmp27_ = g_utf8_strdown (_tmp26_, (gssize) -1);
#line 1737 "../core/Services/Database.vala"
							_tmp28_ = _tmp27_;
#line 1737 "../core/Services/Database.vala"
							_tmp29_ = g_utf8_strdown (search_text, (gssize) -1);
#line 1737 "../core/Services/Database.vala"
							_tmp30_ = _tmp29_;
#line 1737 "../core/Services/Database.vala"
							_tmp15_ = string_contains (_tmp28_, _tmp30_);
#line 1737 "../core/Services/Database.vala"
							_g_free0 (_tmp30_);
#line 1737 "../core/Services/Database.vala"
							_g_free0 (_tmp28_);
#line 12057 "Database.c"
						}
#line 1736 "../core/Services/Database.vala"
						_tmp11_ = _tmp15_;
#line 12061 "Database.c"
					} else {
#line 1736 "../core/Services/Database.vala"
						_tmp11_ = FALSE;
#line 12065 "Database.c"
					}
#line 1736 "../core/Services/Database.vala"
					if (_tmp11_) {
#line 12069 "Database.c"
						GeeArrayList* _tmp31_;
						ObjectsItem* _tmp32_;
#line 1738 "../core/Services/Database.vala"
						_tmp31_ = return_value;
#line 1738 "../core/Services/Database.vala"
						_tmp32_ = item;
#line 1738 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp31_, _tmp32_);
#line 12078 "Database.c"
					}
#line 1735 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 12082 "Database.c"
				}
			}
#line 1742 "../core/Services/Database.vala"
			_tmp33_ = return_value;
#line 1742 "../core/Services/Database.vala"
			_tmp34_ = _g_object_ref0 (_tmp33_);
#line 1742 "../core/Services/Database.vala"
			result = _tmp34_;
#line 12091 "Database.c"
			{
				GeeArrayList* _tmp35_;
#line 1734 "../core/Services/Database.vala"
				_tmp35_ = self->priv->_items;
#line 1734 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__items);
#line 12098 "Database.c"
			}
#line 1742 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1742 "../core/Services/Database.vala"
			return result;
#line 12104 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp36_;
#line 1734 "../core/Services/Database.vala"
			_tmp36_ = self->priv->_items;
#line 1734 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__items);
#line 12113 "Database.c"
		}
#line 1734 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1734 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1734 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1734 "../core/Services/Database.vala"
		return NULL;
#line 12123 "Database.c"
	}
}

void
services_database_insert_reminder (ServicesDatabase* self,
                                   ObjectsReminder* reminder)
{
	sqlite3_stmt* stmt = NULL;
	gchar* sql = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	ObjectsDueDate* _tmp14_;
	ObjectsDueDate* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	sqlite3_stmt* _tmp18_;
	sqlite3_stmt* _tmp26_;
#line 1748 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1748 "../core/Services/Database.vala"
	g_return_if_fail (reminder != NULL);
#line 1752 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Reminders (id, item_id, due)\n" \
"            VALUES ($id, $item_id, $due);\n" \
"        ");
#line 1752 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1752 "../core/Services/Database.vala"
	sql = _tmp0_;
#line 1757 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1757 "../core/Services/Database.vala"
	_tmp2_ = sql;
#line 1757 "../core/Services/Database.vala"
	_tmp3_ = sql;
#line 1757 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1757 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1757 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1757 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1757 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1758 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1758 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) reminder);
#line 1758 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1758 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1759 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1759 "../core/Services/Database.vala"
	_tmp11_ = objects_reminder_get_item_id (reminder);
#line 1759 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1759 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$item_id", _tmp12_);
#line 1760 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1760 "../core/Services/Database.vala"
	_tmp14_ = objects_reminder_get_due (reminder);
#line 1760 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1760 "../core/Services/Database.vala"
	_tmp16_ = objects_due_date_to_string (_tmp15_);
#line 1760 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 1760 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$due", _tmp17_);
#line 1760 "../core/Services/Database.vala"
	_g_free0 (_tmp17_);
#line 1762 "../core/Services/Database.vala"
	_tmp18_ = stmt;
#line 1762 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp18_) != SQLITE_DONE) {
#line 12213 "Database.c"
		sqlite3* _tmp19_;
		sqlite3* _tmp20_;
		const gchar* _tmp21_;
#line 1763 "../core/Services/Database.vala"
		_tmp19_ = self->priv->db;
#line 1763 "../core/Services/Database.vala"
		_tmp20_ = self->priv->db;
#line 1763 "../core/Services/Database.vala"
		_tmp21_ = sqlite3_errmsg (_tmp20_);
#line 1763 "../core/Services/Database.vala"
		g_warning ("Database.vala:1763: Error: %d: %s", sqlite3_errcode (_tmp19_), _tmp21_);
#line 12225 "Database.c"
	} else {
		GeeArrayList* _tmp22_;
		GeeArrayList* _tmp23_;
		ObjectsItem* _tmp24_;
		ObjectsItem* _tmp25_;
#line 1765 "../core/Services/Database.vala"
		g_signal_emit (self, services_database_signals[SERVICES_DATABASE_REMINDER_ADDED_SIGNAL], 0, reminder);
#line 1766 "../core/Services/Database.vala"
		_tmp22_ = services_database_get_reminders (self);
#line 1766 "../core/Services/Database.vala"
		_tmp23_ = _tmp22_;
#line 1766 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, reminder);
#line 1767 "../core/Services/Database.vala"
		_tmp24_ = objects_reminder_get_item (reminder);
#line 1767 "../core/Services/Database.vala"
		_tmp25_ = _tmp24_;
#line 1767 "../core/Services/Database.vala"
		g_signal_emit_by_name (_tmp25_, "reminder-added", reminder);
#line 12245 "Database.c"
	}
#line 1770 "../core/Services/Database.vala"
	_tmp26_ = stmt;
#line 1770 "../core/Services/Database.vala"
	sqlite3_reset (_tmp26_);
#line 1748 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1748 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 12255 "Database.c"
}

GeeArrayList*
services_database_get_reminders_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp13_;
	GeeArrayList* result;
#line 1773 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1774 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_REMINDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1774 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1777 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n            SELECT id, item_id, due FROM Reminders;\n        ");
#line 1777 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1777 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1781 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1781 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1781 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1781 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1781 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1781 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1781 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1781 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1783 "../core/Services/Database.vala"
	while (TRUE) {
#line 12303 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsReminder* _tmp11_;
		ObjectsReminder* _tmp12_;
#line 1783 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1783 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1783 "../core/Services/Database.vala"
			break;
#line 12315 "Database.c"
		}
#line 1784 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1784 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1784 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_reminder (self, _tmp10_);
#line 1784 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1784 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1784 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 12329 "Database.c"
	}
#line 1786 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1786 "../core/Services/Database.vala"
	sqlite3_reset (_tmp13_);
#line 1787 "../core/Services/Database.vala"
	result = return_value;
#line 1787 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1787 "../core/Services/Database.vala"
	return result;
#line 12341 "Database.c"
}

ObjectsReminder*
_services_database_fill_reminder (ServicesDatabase* self,
                                  sqlite3_stmt* stmt)
{
	ObjectsReminder* return_value = NULL;
	ObjectsReminder* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	ObjectsDueDate* _tmp3_;
	ObjectsDueDate* _tmp4_;
	const gchar* _tmp5_;
	JsonObject* _tmp6_;
	JsonObject* _tmp7_;
	ObjectsReminder* result;
#line 1790 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1790 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1791 "../core/Services/Database.vala"
	_tmp0_ = objects_reminder_new ();
#line 1791 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1792 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1792 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 1793 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1793 "../core/Services/Database.vala"
	objects_reminder_set_item_id (return_value, _tmp2_);
#line 1794 "../core/Services/Database.vala"
	_tmp3_ = objects_reminder_get_due (return_value);
#line 1794 "../core/Services/Database.vala"
	_tmp4_ = _tmp3_;
#line 1794 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1794 "../core/Services/Database.vala"
	_tmp6_ = services_database_get_due_parameter (self, _tmp5_);
#line 1794 "../core/Services/Database.vala"
	_tmp7_ = _tmp6_;
#line 1794 "../core/Services/Database.vala"
	objects_due_date_update_from_json (_tmp4_, _tmp7_);
#line 1794 "../core/Services/Database.vala"
	_json_object_unref0 (_tmp7_);
#line 1795 "../core/Services/Database.vala"
	result = return_value;
#line 1795 "../core/Services/Database.vala"
	return result;
#line 12392 "Database.c"
}

GeeArrayList*
services_database_get_reminders_by_item (ServicesDatabase* self,
                                         ObjectsItem* item)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 1798 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1798 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 1799 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_REMINDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1799 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 12411 "Database.c"
	{
		GeeArrayList* _tmp1_;
#line 1800 "../core/Services/Database.vala"
		_tmp1_ = self->priv->_reminders;
#line 1800 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__reminders);
#line 12418 "Database.c"
		{
			GeeArrayList* _tmp18_;
			GeeArrayList* _tmp19_;
			{
				GeeArrayList* _reminder_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _reminder_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _reminder_index = 0;
#line 1801 "../core/Services/Database.vala"
				_tmp2_ = services_database_get_reminders (self);
#line 1801 "../core/Services/Database.vala"
				_tmp3_ = _tmp2_;
#line 1801 "../core/Services/Database.vala"
				_reminder_list = _tmp3_;
#line 1801 "../core/Services/Database.vala"
				_tmp4_ = _reminder_list;
#line 1801 "../core/Services/Database.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1801 "../core/Services/Database.vala"
				_tmp6_ = _tmp5_;
#line 1801 "../core/Services/Database.vala"
				_reminder_size = _tmp6_;
#line 1801 "../core/Services/Database.vala"
				_reminder_index = -1;
#line 1801 "../core/Services/Database.vala"
				while (TRUE) {
#line 12449 "Database.c"
					gint _tmp7_;
					gint _tmp8_;
					ObjectsReminder* reminder = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsReminder* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 1801 "../core/Services/Database.vala"
					_reminder_index = _reminder_index + 1;
#line 1801 "../core/Services/Database.vala"
					_tmp7_ = _reminder_index;
#line 1801 "../core/Services/Database.vala"
					_tmp8_ = _reminder_size;
#line 1801 "../core/Services/Database.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 1801 "../core/Services/Database.vala"
						break;
#line 12470 "Database.c"
					}
#line 1801 "../core/Services/Database.vala"
					_tmp9_ = _reminder_list;
#line 1801 "../core/Services/Database.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _reminder_index);
#line 1801 "../core/Services/Database.vala"
					reminder = (ObjectsReminder*) _tmp10_;
#line 1802 "../core/Services/Database.vala"
					_tmp11_ = reminder;
#line 1802 "../core/Services/Database.vala"
					_tmp12_ = objects_reminder_get_item_id (_tmp11_);
#line 1802 "../core/Services/Database.vala"
					_tmp13_ = _tmp12_;
#line 1802 "../core/Services/Database.vala"
					_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1802 "../core/Services/Database.vala"
					_tmp15_ = _tmp14_;
#line 1802 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
#line 12490 "Database.c"
						GeeArrayList* _tmp16_;
						ObjectsReminder* _tmp17_;
#line 1803 "../core/Services/Database.vala"
						_tmp16_ = return_value;
#line 1803 "../core/Services/Database.vala"
						_tmp17_ = reminder;
#line 1803 "../core/Services/Database.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 12499 "Database.c"
					}
#line 1801 "../core/Services/Database.vala"
					_g_object_unref0 (reminder);
#line 12503 "Database.c"
				}
			}
#line 1807 "../core/Services/Database.vala"
			_tmp18_ = return_value;
#line 1807 "../core/Services/Database.vala"
			_tmp19_ = _g_object_ref0 (_tmp18_);
#line 1807 "../core/Services/Database.vala"
			result = _tmp19_;
#line 12512 "Database.c"
			{
				GeeArrayList* _tmp20_;
#line 1800 "../core/Services/Database.vala"
				_tmp20_ = self->priv->_reminders;
#line 1800 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__reminders);
#line 12519 "Database.c"
			}
#line 1807 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1807 "../core/Services/Database.vala"
			return result;
#line 12525 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp21_;
#line 1800 "../core/Services/Database.vala"
			_tmp21_ = self->priv->_reminders;
#line 1800 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__reminders);
#line 12534 "Database.c"
		}
#line 1800 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1800 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1800 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1800 "../core/Services/Database.vala"
		return NULL;
#line 12544 "Database.c"
	}
}

ObjectsReminder*
services_database_get_reminder (ServicesDatabase* self,
                                const gchar* id)
{
	ObjectsReminder* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsReminder* result;
#line 1811 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1811 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1812 "../core/Services/Database.vala"
	return_value = NULL;
#line 12561 "Database.c"
	{
		GeeArrayList* _tmp0_;
#line 1813 "../core/Services/Database.vala"
		_tmp0_ = self->priv->_reminders;
#line 1813 "../core/Services/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__reminders);
#line 12568 "Database.c"
		{
			ObjectsReminder* _tmp15_;
			ObjectsReminder* _tmp16_;
			{
				GeeArrayList* _reminder_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _reminder_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _reminder_index = 0;
#line 1814 "../core/Services/Database.vala"
				_tmp1_ = services_database_get_reminders (self);
#line 1814 "../core/Services/Database.vala"
				_tmp2_ = _tmp1_;
#line 1814 "../core/Services/Database.vala"
				_reminder_list = _tmp2_;
#line 1814 "../core/Services/Database.vala"
				_tmp3_ = _reminder_list;
#line 1814 "../core/Services/Database.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 1814 "../core/Services/Database.vala"
				_tmp5_ = _tmp4_;
#line 1814 "../core/Services/Database.vala"
				_reminder_size = _tmp5_;
#line 1814 "../core/Services/Database.vala"
				_reminder_index = -1;
#line 1814 "../core/Services/Database.vala"
				while (TRUE) {
#line 12599 "Database.c"
					gint _tmp6_;
					gint _tmp7_;
					ObjectsReminder* reminder = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsReminder* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
#line 1814 "../core/Services/Database.vala"
					_reminder_index = _reminder_index + 1;
#line 1814 "../core/Services/Database.vala"
					_tmp6_ = _reminder_index;
#line 1814 "../core/Services/Database.vala"
					_tmp7_ = _reminder_size;
#line 1814 "../core/Services/Database.vala"
					if (!(_tmp6_ < _tmp7_)) {
#line 1814 "../core/Services/Database.vala"
						break;
#line 12618 "Database.c"
					}
#line 1814 "../core/Services/Database.vala"
					_tmp8_ = _reminder_list;
#line 1814 "../core/Services/Database.vala"
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _reminder_index);
#line 1814 "../core/Services/Database.vala"
					reminder = (ObjectsReminder*) _tmp9_;
#line 1815 "../core/Services/Database.vala"
					_tmp10_ = reminder;
#line 1815 "../core/Services/Database.vala"
					_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp10_);
#line 1815 "../core/Services/Database.vala"
					_tmp12_ = _tmp11_;
#line 1815 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp12_, id) == 0) {
#line 12634 "Database.c"
						ObjectsReminder* _tmp13_;
						ObjectsReminder* _tmp14_;
#line 1816 "../core/Services/Database.vala"
						_tmp13_ = reminder;
#line 1816 "../core/Services/Database.vala"
						_tmp14_ = _g_object_ref0 (_tmp13_);
#line 1816 "../core/Services/Database.vala"
						_g_object_unref0 (return_value);
#line 1816 "../core/Services/Database.vala"
						return_value = _tmp14_;
#line 1817 "../core/Services/Database.vala"
						_g_object_unref0 (reminder);
#line 1817 "../core/Services/Database.vala"
						break;
#line 12649 "Database.c"
					}
#line 1814 "../core/Services/Database.vala"
					_g_object_unref0 (reminder);
#line 12653 "Database.c"
				}
			}
#line 1821 "../core/Services/Database.vala"
			_tmp15_ = return_value;
#line 1821 "../core/Services/Database.vala"
			_tmp16_ = _g_object_ref0 (_tmp15_);
#line 1821 "../core/Services/Database.vala"
			result = _tmp16_;
#line 12662 "Database.c"
			{
				GeeArrayList* _tmp17_;
#line 1813 "../core/Services/Database.vala"
				_tmp17_ = self->priv->_reminders;
#line 1813 "../core/Services/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__reminders);
#line 12669 "Database.c"
			}
#line 1821 "../core/Services/Database.vala"
			_g_object_unref0 (return_value);
#line 1821 "../core/Services/Database.vala"
			return result;
#line 12675 "Database.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
#line 1813 "../core/Services/Database.vala"
			_tmp18_ = self->priv->_reminders;
#line 1813 "../core/Services/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__reminders);
#line 12684 "Database.c"
		}
#line 1813 "../core/Services/Database.vala"
		_g_object_unref0 (return_value);
#line 1813 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1813 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1813 "../core/Services/Database.vala"
		return NULL;
#line 12694 "Database.c"
	}
}

void
services_database_delete_reminder (ServicesDatabase* self,
                                   ObjectsReminder* reminder)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp16_;
#line 1825 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1825 "../core/Services/Database.vala"
	g_return_if_fail (reminder != NULL);
#line 1828 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Reminders WHERE id=$id;\n        ");
#line 1828 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1828 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1832 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1832 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1832 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1832 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1832 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1832 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1832 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1832 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1833 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1833 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) reminder);
#line 1833 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1833 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1835 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1835 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) == SQLITE_DONE) {
#line 12753 "Database.c"
		ObjectsItem* _tmp11_;
		ObjectsItem* _tmp12_;
#line 1836 "../core/Services/Database.vala"
		g_signal_emit_by_name ((ObjectsBaseObject*) reminder, "deleted");
#line 1837 "../core/Services/Database.vala"
		_tmp11_ = objects_reminder_get_item (reminder);
#line 1837 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1837 "../core/Services/Database.vala"
		g_signal_emit_by_name (_tmp12_, "reminder-deleted", reminder);
#line 12764 "Database.c"
	} else {
		sqlite3* _tmp13_;
		sqlite3* _tmp14_;
		const gchar* _tmp15_;
#line 1839 "../core/Services/Database.vala"
		_tmp13_ = self->priv->db;
#line 1839 "../core/Services/Database.vala"
		_tmp14_ = self->priv->db;
#line 1839 "../core/Services/Database.vala"
		_tmp15_ = sqlite3_errmsg (_tmp14_);
#line 1839 "../core/Services/Database.vala"
		g_warning ("Database.vala:1839: Error: %d: %s", sqlite3_errcode (_tmp13_), _tmp15_);
#line 12777 "Database.c"
	}
#line 1842 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1842 "../core/Services/Database.vala"
	sqlite3_reset (_tmp16_);
#line 1825 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 12785 "Database.c"
}

void
services_database_insert_queue (ServicesDatabase* self,
                                ObjectsQueue* queue)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	sqlite3_stmt* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_;
	sqlite3_stmt* _tmp29_;
#line 1849 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1849 "../core/Services/Database.vala"
	g_return_if_fail (queue != NULL);
#line 1852 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Queue (uuid, object_id, query, temp_" \
"id, args, date_added)\n" \
"            VALUES ($uuid, $object_id, $query, $temp_id, $args, $date_" \
"added);\n" \
"        ");
#line 1852 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1852 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1857 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1857 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1857 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1857 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1857 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1857 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1857 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1857 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1858 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1858 "../core/Services/Database.vala"
	_tmp8_ = objects_queue_get_uuid (queue);
#line 1858 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1858 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$uuid", _tmp9_);
#line 1859 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1859 "../core/Services/Database.vala"
	_tmp11_ = objects_queue_get_object_id (queue);
#line 1859 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1859 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$object_id", _tmp12_);
#line 1860 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1860 "../core/Services/Database.vala"
	_tmp14_ = objects_queue_get_query (queue);
#line 1860 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1860 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$query", _tmp15_);
#line 1861 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1861 "../core/Services/Database.vala"
	_tmp17_ = objects_queue_get_temp_id (queue);
#line 1861 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1861 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$temp_id", _tmp18_);
#line 1862 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 1862 "../core/Services/Database.vala"
	_tmp20_ = objects_queue_get_args (queue);
#line 1862 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1862 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp19_, "$args", _tmp21_);
#line 1863 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1863 "../core/Services/Database.vala"
	_tmp23_ = objects_queue_get_date_added (queue);
#line 1863 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1863 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp22_, "$date_added", _tmp24_);
#line 1865 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1865 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp25_) != SQLITE_DONE) {
#line 12898 "Database.c"
		sqlite3* _tmp26_;
		sqlite3* _tmp27_;
		const gchar* _tmp28_;
#line 1866 "../core/Services/Database.vala"
		_tmp26_ = self->priv->db;
#line 1866 "../core/Services/Database.vala"
		_tmp27_ = self->priv->db;
#line 1866 "../core/Services/Database.vala"
		_tmp28_ = sqlite3_errmsg (_tmp27_);
#line 1866 "../core/Services/Database.vala"
		g_warning ("Database.vala:1866: Error: %d: %s", sqlite3_errcode (_tmp26_), _tmp28_);
#line 12910 "Database.c"
	}
#line 1869 "../core/Services/Database.vala"
	_tmp29_ = stmt;
#line 1869 "../core/Services/Database.vala"
	sqlite3_reset (_tmp29_);
#line 1849 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 12918 "Database.c"
}

GeeArrayList*
services_database_get_all_queue (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp13_;
	GeeArrayList* result;
#line 1872 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1873 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_QUEUE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1873 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1876 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n            SELECT * FROM Queue ORDER BY date_added;\n        ");
#line 1876 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1876 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1880 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1880 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1880 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1880 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1880 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1880 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1880 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1880 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1882 "../core/Services/Database.vala"
	while (TRUE) {
#line 12966 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsQueue* _tmp11_;
		ObjectsQueue* _tmp12_;
#line 1882 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1882 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1882 "../core/Services/Database.vala"
			break;
#line 12978 "Database.c"
		}
#line 1883 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1883 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1883 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_queue (self, _tmp10_);
#line 1883 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1883 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1883 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 12992 "Database.c"
	}
#line 1885 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1885 "../core/Services/Database.vala"
	sqlite3_reset (_tmp13_);
#line 1886 "../core/Services/Database.vala"
	result = return_value;
#line 1886 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1886 "../core/Services/Database.vala"
	return result;
#line 13004 "Database.c"
}

ObjectsQueue*
_services_database_fill_queue (ServicesDatabase* self,
                               sqlite3_stmt* stmt)
{
	ObjectsQueue* return_value = NULL;
	ObjectsQueue* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	ObjectsQueue* result;
#line 1889 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1889 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1890 "../core/Services/Database.vala"
	_tmp0_ = objects_queue_new ();
#line 1890 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1891 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1891 "../core/Services/Database.vala"
	objects_queue_set_uuid (return_value, _tmp1_);
#line 1892 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1892 "../core/Services/Database.vala"
	objects_queue_set_object_id (return_value, _tmp2_);
#line 1893 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1893 "../core/Services/Database.vala"
	objects_queue_set_query (return_value, _tmp3_);
#line 1894 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1894 "../core/Services/Database.vala"
	objects_queue_set_temp_id (return_value, _tmp4_);
#line 1895 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 1895 "../core/Services/Database.vala"
	objects_queue_set_args (return_value, _tmp5_);
#line 1896 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 5);
#line 1896 "../core/Services/Database.vala"
	objects_queue_set_date_added (return_value, _tmp6_);
#line 1897 "../core/Services/Database.vala"
	result = return_value;
#line 1897 "../core/Services/Database.vala"
	return result;
#line 13056 "Database.c"
}

void
services_database_insert_CurTempIds (ServicesDatabase* self,
                                     const gchar* id,
                                     const gchar* temp_id,
                                     const gchar* object)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
#line 1900 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1900 "../core/Services/Database.vala"
	g_return_if_fail (id != NULL);
#line 1900 "../core/Services/Database.vala"
	g_return_if_fail (temp_id != NULL);
#line 1900 "../core/Services/Database.vala"
	g_return_if_fail (object != NULL);
#line 1903 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO CurTempIds (id, temp_id, object)\n" \
"            VALUES ($id, $temp_id, $object);\n" \
"        ");
#line 1903 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1903 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1908 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1908 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1908 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1908 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1908 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1908 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1908 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1908 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1909 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1909 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", id);
#line 1910 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1910 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$temp_id", temp_id);
#line 1911 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1911 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp9_, "$object", object);
#line 1913 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1913 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 13124 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 1914 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1914 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 1914 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 1914 "../core/Services/Database.vala"
		g_warning ("Database.vala:1914: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 13136 "Database.c"
	}
#line 1917 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1917 "../core/Services/Database.vala"
	sqlite3_reset (_tmp14_);
#line 1900 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 13144 "Database.c"
}

gboolean
services_database_curTempIds_exists (ServicesDatabase* self,
                                     const gchar* id)
{
	gboolean returned = FALSE;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp10_;
	gboolean result;
#line 1920 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1920 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, FALSE);
#line 1921 "../core/Services/Database.vala"
	returned = FALSE;
#line 1924 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            SELECT COUNT (*) FROM CurTempIds WHERE id = $id;\n" \
"        ");
#line 1924 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1924 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1928 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1928 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1928 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1928 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1928 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1928 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1928 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1928 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1929 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1929 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", id);
#line 1931 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1931 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp8_) == SQLITE_ROW) {
#line 13200 "Database.c"
		sqlite3_stmt* _tmp9_;
#line 1932 "../core/Services/Database.vala"
		_tmp9_ = stmt;
#line 1932 "../core/Services/Database.vala"
		returned = sqlite3_column_int (_tmp9_, 0) > 0;
#line 13206 "Database.c"
	}
#line 1935 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1935 "../core/Services/Database.vala"
	sqlite3_reset (_tmp10_);
#line 1936 "../core/Services/Database.vala"
	result = returned;
#line 1936 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1936 "../core/Services/Database.vala"
	return result;
#line 13218 "Database.c"
}

gchar*
services_database_get_temp_id (ServicesDatabase* self,
                               const gchar* id)
{
	gchar* returned = NULL;
	gchar* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gchar* result;
#line 1939 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1939 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1940 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("");
#line 1940 "../core/Services/Database.vala"
	returned = _tmp0_;
#line 1943 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n" \
"            SELECT temp_id FROM CurTempIds WHERE id = $id;\n" \
"        ");
#line 1943 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1943 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1947 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1947 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1947 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1947 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1947 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1947 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1947 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1947 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1948 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1948 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$id", id);
#line 1950 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1950 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) == SQLITE_ROW) {
#line 13277 "Database.c"
		sqlite3_stmt* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 1951 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1951 "../core/Services/Database.vala"
		_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 0);
#line 1951 "../core/Services/Database.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 1951 "../core/Services/Database.vala"
		_g_free0 (returned);
#line 1951 "../core/Services/Database.vala"
		returned = _tmp12_;
#line 13291 "Database.c"
	}
#line 1954 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1954 "../core/Services/Database.vala"
	sqlite3_reset (_tmp13_);
#line 1955 "../core/Services/Database.vala"
	result = returned;
#line 1955 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1955 "../core/Services/Database.vala"
	return result;
#line 13303 "Database.c"
}

void
services_database_update_project_id (ServicesDatabase* self,
                                     const gchar* current_id,
                                     const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp61_;
#line 1958 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1958 "../core/Services/Database.vala"
	g_return_if_fail (current_id != NULL);
#line 1958 "../core/Services/Database.vala"
	g_return_if_fail (new_id != NULL);
#line 1961 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Projects SET id = $new_id WHERE id = $current_id;\n" \
"        ");
#line 1961 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1961 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1965 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1965 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1965 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1965 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1965 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1965 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1965 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1965 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1966 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1966 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1967 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1967 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1969 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1969 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) == SQLITE_DONE) {
#line 13363 "Database.c"
		ObjectsProject* project = NULL;
		ObjectsProject* _tmp10_;
		ObjectsProject* _tmp11_;
		sqlite3_stmt* _tmp13_;
		gchar* _tmp14_;
		sqlite3* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		sqlite3_stmt* _tmp20_ = NULL;
		sqlite3_stmt* _tmp21_;
		sqlite3_stmt* _tmp22_;
		sqlite3_stmt* _tmp23_;
#line 1970 "../core/Services/Database.vala"
		_tmp10_ = services_database_get_project (self, current_id);
#line 1970 "../core/Services/Database.vala"
		project = _tmp10_;
#line 1971 "../core/Services/Database.vala"
		_tmp11_ = project;
#line 1971 "../core/Services/Database.vala"
		if (_tmp11_ != NULL) {
#line 13386 "Database.c"
			ObjectsProject* _tmp12_;
#line 1972 "../core/Services/Database.vala"
			_tmp12_ = project;
#line 1972 "../core/Services/Database.vala"
			objects_base_object_set_id ((ObjectsBaseObject*) _tmp12_, new_id);
#line 13392 "Database.c"
		}
#line 1975 "../core/Services/Database.vala"
		_tmp13_ = stmt;
#line 1975 "../core/Services/Database.vala"
		sqlite3_reset (_tmp13_);
#line 1977 "../core/Services/Database.vala"
		_tmp14_ = g_strdup ("\n" \
"                UPDATE Sections SET project_id = $new_id WHERE project" \
"_id = $current_id;\n" \
"            ");
#line 1977 "../core/Services/Database.vala"
		_g_free0 (self->priv->sql);
#line 1977 "../core/Services/Database.vala"
		self->priv->sql = _tmp14_;
#line 1981 "../core/Services/Database.vala"
		_tmp15_ = self->priv->db;
#line 1981 "../core/Services/Database.vala"
		_tmp16_ = self->priv->sql;
#line 1981 "../core/Services/Database.vala"
		_tmp17_ = self->priv->sql;
#line 1981 "../core/Services/Database.vala"
		_tmp18_ = strlen (_tmp17_);
#line 1981 "../core/Services/Database.vala"
		_tmp19_ = _tmp18_;
#line 1981 "../core/Services/Database.vala"
		sqlite3_prepare_v2 (_tmp15_, _tmp16_, _tmp19_, &_tmp20_, NULL);
#line 1981 "../core/Services/Database.vala"
		_sqlite3_finalize0 (stmt);
#line 1981 "../core/Services/Database.vala"
		stmt = _tmp20_;
#line 1982 "../core/Services/Database.vala"
		_tmp21_ = stmt;
#line 1982 "../core/Services/Database.vala"
		services_database_set_parameter_str (self, _tmp21_, "$new_id", new_id);
#line 1983 "../core/Services/Database.vala"
		_tmp22_ = stmt;
#line 1983 "../core/Services/Database.vala"
		services_database_set_parameter_str (self, _tmp22_, "$current_id", current_id);
#line 1985 "../core/Services/Database.vala"
		_tmp23_ = stmt;
#line 1985 "../core/Services/Database.vala"
		if (sqlite3_step (_tmp23_) == SQLITE_DONE) {
#line 13432 "Database.c"
			sqlite3_stmt* _tmp37_;
			gchar* _tmp38_;
			sqlite3* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			gint _tmp42_;
			gint _tmp43_;
			sqlite3_stmt* _tmp44_ = NULL;
			sqlite3_stmt* _tmp45_;
			sqlite3_stmt* _tmp46_;
			sqlite3_stmt* _tmp47_;
			{
				GeeArrayList* _section_list = NULL;
				GeeArrayList* _tmp24_;
				GeeArrayList* _tmp25_;
				gint _section_size = 0;
				GeeArrayList* _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
				gint _section_index = 0;
#line 1986 "../core/Services/Database.vala"
				_tmp24_ = services_database_get_sections (self);
#line 1986 "../core/Services/Database.vala"
				_tmp25_ = _tmp24_;
#line 1986 "../core/Services/Database.vala"
				_section_list = _tmp25_;
#line 1986 "../core/Services/Database.vala"
				_tmp26_ = _section_list;
#line 1986 "../core/Services/Database.vala"
				_tmp27_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp26_);
#line 1986 "../core/Services/Database.vala"
				_tmp28_ = _tmp27_;
#line 1986 "../core/Services/Database.vala"
				_section_size = _tmp28_;
#line 1986 "../core/Services/Database.vala"
				_section_index = -1;
#line 1986 "../core/Services/Database.vala"
				while (TRUE) {
#line 13471 "Database.c"
					gint _tmp29_;
					gint _tmp30_;
					ObjectsSection* section = NULL;
					GeeArrayList* _tmp31_;
					gpointer _tmp32_;
					ObjectsSection* _tmp33_;
					const gchar* _tmp34_;
					const gchar* _tmp35_;
#line 1986 "../core/Services/Database.vala"
					_section_index = _section_index + 1;
#line 1986 "../core/Services/Database.vala"
					_tmp29_ = _section_index;
#line 1986 "../core/Services/Database.vala"
					_tmp30_ = _section_size;
#line 1986 "../core/Services/Database.vala"
					if (!(_tmp29_ < _tmp30_)) {
#line 1986 "../core/Services/Database.vala"
						break;
#line 13490 "Database.c"
					}
#line 1986 "../core/Services/Database.vala"
					_tmp31_ = _section_list;
#line 1986 "../core/Services/Database.vala"
					_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, _section_index);
#line 1986 "../core/Services/Database.vala"
					section = (ObjectsSection*) _tmp32_;
#line 1987 "../core/Services/Database.vala"
					_tmp33_ = section;
#line 1987 "../core/Services/Database.vala"
					_tmp34_ = objects_section_get_project_id (_tmp33_);
#line 1987 "../core/Services/Database.vala"
					_tmp35_ = _tmp34_;
#line 1987 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp35_, current_id) == 0) {
#line 13506 "Database.c"
						ObjectsSection* _tmp36_;
#line 1988 "../core/Services/Database.vala"
						_tmp36_ = section;
#line 1988 "../core/Services/Database.vala"
						objects_section_set_project_id (_tmp36_, new_id);
#line 13512 "Database.c"
					}
#line 1986 "../core/Services/Database.vala"
					_g_object_unref0 (section);
#line 13516 "Database.c"
				}
			}
#line 1992 "../core/Services/Database.vala"
			_tmp37_ = stmt;
#line 1992 "../core/Services/Database.vala"
			sqlite3_reset (_tmp37_);
#line 1994 "../core/Services/Database.vala"
			_tmp38_ = g_strdup ("\n" \
"                    UPDATE Items SET project_id = $new_id WHERE projec" \
"t_id = $current_id;\n" \
"                ");
#line 1994 "../core/Services/Database.vala"
			_g_free0 (self->priv->sql);
#line 1994 "../core/Services/Database.vala"
			self->priv->sql = _tmp38_;
#line 1998 "../core/Services/Database.vala"
			_tmp39_ = self->priv->db;
#line 1998 "../core/Services/Database.vala"
			_tmp40_ = self->priv->sql;
#line 1998 "../core/Services/Database.vala"
			_tmp41_ = self->priv->sql;
#line 1998 "../core/Services/Database.vala"
			_tmp42_ = strlen (_tmp41_);
#line 1998 "../core/Services/Database.vala"
			_tmp43_ = _tmp42_;
#line 1998 "../core/Services/Database.vala"
			sqlite3_prepare_v2 (_tmp39_, _tmp40_, _tmp43_, &_tmp44_, NULL);
#line 1998 "../core/Services/Database.vala"
			_sqlite3_finalize0 (stmt);
#line 1998 "../core/Services/Database.vala"
			stmt = _tmp44_;
#line 1999 "../core/Services/Database.vala"
			_tmp45_ = stmt;
#line 1999 "../core/Services/Database.vala"
			services_database_set_parameter_str (self, _tmp45_, "$new_id", new_id);
#line 2000 "../core/Services/Database.vala"
			_tmp46_ = stmt;
#line 2000 "../core/Services/Database.vala"
			services_database_set_parameter_str (self, _tmp46_, "$current_id", current_id);
#line 2002 "../core/Services/Database.vala"
			_tmp47_ = stmt;
#line 2002 "../core/Services/Database.vala"
			if (sqlite3_step (_tmp47_) == SQLITE_DONE) {
#line 13557 "Database.c"
				{
					GeeArrayList* _item_list = NULL;
					GeeArrayList* _tmp48_;
					GeeArrayList* _tmp49_;
					gint _item_size = 0;
					GeeArrayList* _tmp50_;
					gint _tmp51_;
					gint _tmp52_;
					gint _item_index = 0;
#line 2003 "../core/Services/Database.vala"
					_tmp48_ = services_database_get_items (self);
#line 2003 "../core/Services/Database.vala"
					_tmp49_ = _tmp48_;
#line 2003 "../core/Services/Database.vala"
					_item_list = _tmp49_;
#line 2003 "../core/Services/Database.vala"
					_tmp50_ = _item_list;
#line 2003 "../core/Services/Database.vala"
					_tmp51_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp50_);
#line 2003 "../core/Services/Database.vala"
					_tmp52_ = _tmp51_;
#line 2003 "../core/Services/Database.vala"
					_item_size = _tmp52_;
#line 2003 "../core/Services/Database.vala"
					_item_index = -1;
#line 2003 "../core/Services/Database.vala"
					while (TRUE) {
#line 13585 "Database.c"
						gint _tmp53_;
						gint _tmp54_;
						ObjectsItem* item = NULL;
						GeeArrayList* _tmp55_;
						gpointer _tmp56_;
						ObjectsItem* _tmp57_;
						const gchar* _tmp58_;
						const gchar* _tmp59_;
#line 2003 "../core/Services/Database.vala"
						_item_index = _item_index + 1;
#line 2003 "../core/Services/Database.vala"
						_tmp53_ = _item_index;
#line 2003 "../core/Services/Database.vala"
						_tmp54_ = _item_size;
#line 2003 "../core/Services/Database.vala"
						if (!(_tmp53_ < _tmp54_)) {
#line 2003 "../core/Services/Database.vala"
							break;
#line 13604 "Database.c"
						}
#line 2003 "../core/Services/Database.vala"
						_tmp55_ = _item_list;
#line 2003 "../core/Services/Database.vala"
						_tmp56_ = gee_abstract_list_get ((GeeAbstractList*) _tmp55_, _item_index);
#line 2003 "../core/Services/Database.vala"
						item = (ObjectsItem*) _tmp56_;
#line 2004 "../core/Services/Database.vala"
						_tmp57_ = item;
#line 2004 "../core/Services/Database.vala"
						_tmp58_ = objects_item_get_project_id (_tmp57_);
#line 2004 "../core/Services/Database.vala"
						_tmp59_ = _tmp58_;
#line 2004 "../core/Services/Database.vala"
						if (g_strcmp0 (_tmp59_, current_id) == 0) {
#line 13620 "Database.c"
							ObjectsItem* _tmp60_;
#line 2005 "../core/Services/Database.vala"
							_tmp60_ = item;
#line 2005 "../core/Services/Database.vala"
							objects_item_set_project_id (_tmp60_, new_id);
#line 13626 "Database.c"
						}
#line 2003 "../core/Services/Database.vala"
						_g_object_unref0 (item);
#line 13630 "Database.c"
					}
				}
			}
		}
#line 1969 "../core/Services/Database.vala"
		_g_object_unref0 (project);
#line 13637 "Database.c"
	}
#line 2012 "../core/Services/Database.vala"
	_tmp61_ = stmt;
#line 2012 "../core/Services/Database.vala"
	sqlite3_reset (_tmp61_);
#line 1958 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 13645 "Database.c"
}

void
services_database_update_section_id (ServicesDatabase* self,
                                     const gchar* current_id,
                                     const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp47_;
#line 2015 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2015 "../core/Services/Database.vala"
	g_return_if_fail (current_id != NULL);
#line 2015 "../core/Services/Database.vala"
	g_return_if_fail (new_id != NULL);
#line 2018 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sections SET id = $new_id WHERE id = $current_id;\n" \
"        ");
#line 2018 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2018 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2022 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2022 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2022 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2022 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2022 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2022 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2022 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2022 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2023 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2023 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 2024 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 2024 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 2026 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 2026 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) == SQLITE_DONE) {
#line 13705 "Database.c"
		sqlite3_stmt* _tmp23_;
		gchar* _tmp24_;
		sqlite3* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
		sqlite3_stmt* _tmp30_ = NULL;
		sqlite3_stmt* _tmp31_;
		sqlite3_stmt* _tmp32_;
		sqlite3_stmt* _tmp33_;
		{
			GeeArrayList* _section_list = NULL;
			GeeArrayList* _tmp10_;
			GeeArrayList* _tmp11_;
			gint _section_size = 0;
			GeeArrayList* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			gint _section_index = 0;
#line 2027 "../core/Services/Database.vala"
			_tmp10_ = services_database_get_sections (self);
#line 2027 "../core/Services/Database.vala"
			_tmp11_ = _tmp10_;
#line 2027 "../core/Services/Database.vala"
			_section_list = _tmp11_;
#line 2027 "../core/Services/Database.vala"
			_tmp12_ = _section_list;
#line 2027 "../core/Services/Database.vala"
			_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 2027 "../core/Services/Database.vala"
			_tmp14_ = _tmp13_;
#line 2027 "../core/Services/Database.vala"
			_section_size = _tmp14_;
#line 2027 "../core/Services/Database.vala"
			_section_index = -1;
#line 2027 "../core/Services/Database.vala"
			while (TRUE) {
#line 13744 "Database.c"
				gint _tmp15_;
				gint _tmp16_;
				ObjectsSection* section = NULL;
				GeeArrayList* _tmp17_;
				gpointer _tmp18_;
				ObjectsSection* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
#line 2027 "../core/Services/Database.vala"
				_section_index = _section_index + 1;
#line 2027 "../core/Services/Database.vala"
				_tmp15_ = _section_index;
#line 2027 "../core/Services/Database.vala"
				_tmp16_ = _section_size;
#line 2027 "../core/Services/Database.vala"
				if (!(_tmp15_ < _tmp16_)) {
#line 2027 "../core/Services/Database.vala"
					break;
#line 13763 "Database.c"
				}
#line 2027 "../core/Services/Database.vala"
				_tmp17_ = _section_list;
#line 2027 "../core/Services/Database.vala"
				_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _section_index);
#line 2027 "../core/Services/Database.vala"
				section = (ObjectsSection*) _tmp18_;
#line 2028 "../core/Services/Database.vala"
				_tmp19_ = section;
#line 2028 "../core/Services/Database.vala"
				_tmp20_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp19_);
#line 2028 "../core/Services/Database.vala"
				_tmp21_ = _tmp20_;
#line 2028 "../core/Services/Database.vala"
				if (g_strcmp0 (_tmp21_, current_id) == 0) {
#line 13779 "Database.c"
					ObjectsSection* _tmp22_;
#line 2029 "../core/Services/Database.vala"
					_tmp22_ = section;
#line 2029 "../core/Services/Database.vala"
					objects_base_object_set_id ((ObjectsBaseObject*) _tmp22_, new_id);
#line 13785 "Database.c"
				}
#line 2027 "../core/Services/Database.vala"
				_g_object_unref0 (section);
#line 13789 "Database.c"
			}
		}
#line 2033 "../core/Services/Database.vala"
		_tmp23_ = stmt;
#line 2033 "../core/Services/Database.vala"
		sqlite3_reset (_tmp23_);
#line 2035 "../core/Services/Database.vala"
		_tmp24_ = g_strdup ("\n" \
"                UPDATE Items SET section_id = $new_id WHERE section_id" \
" = $current_id;\n" \
"            ");
#line 2035 "../core/Services/Database.vala"
		_g_free0 (self->priv->sql);
#line 2035 "../core/Services/Database.vala"
		self->priv->sql = _tmp24_;
#line 2039 "../core/Services/Database.vala"
		_tmp25_ = self->priv->db;
#line 2039 "../core/Services/Database.vala"
		_tmp26_ = self->priv->sql;
#line 2039 "../core/Services/Database.vala"
		_tmp27_ = self->priv->sql;
#line 2039 "../core/Services/Database.vala"
		_tmp28_ = strlen (_tmp27_);
#line 2039 "../core/Services/Database.vala"
		_tmp29_ = _tmp28_;
#line 2039 "../core/Services/Database.vala"
		sqlite3_prepare_v2 (_tmp25_, _tmp26_, _tmp29_, &_tmp30_, NULL);
#line 2039 "../core/Services/Database.vala"
		_sqlite3_finalize0 (stmt);
#line 2039 "../core/Services/Database.vala"
		stmt = _tmp30_;
#line 2040 "../core/Services/Database.vala"
		_tmp31_ = stmt;
#line 2040 "../core/Services/Database.vala"
		services_database_set_parameter_str (self, _tmp31_, "$new_id", new_id);
#line 2041 "../core/Services/Database.vala"
		_tmp32_ = stmt;
#line 2041 "../core/Services/Database.vala"
		services_database_set_parameter_str (self, _tmp32_, "$current_id", current_id);
#line 2043 "../core/Services/Database.vala"
		_tmp33_ = stmt;
#line 2043 "../core/Services/Database.vala"
		if (sqlite3_step (_tmp33_) == SQLITE_DONE) {
#line 13830 "Database.c"
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp34_;
				GeeArrayList* _tmp35_;
				gint _item_size = 0;
				GeeArrayList* _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				gint _item_index = 0;
#line 2044 "../core/Services/Database.vala"
				_tmp34_ = services_database_get_items (self);
#line 2044 "../core/Services/Database.vala"
				_tmp35_ = _tmp34_;
#line 2044 "../core/Services/Database.vala"
				_item_list = _tmp35_;
#line 2044 "../core/Services/Database.vala"
				_tmp36_ = _item_list;
#line 2044 "../core/Services/Database.vala"
				_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 2044 "../core/Services/Database.vala"
				_tmp38_ = _tmp37_;
#line 2044 "../core/Services/Database.vala"
				_item_size = _tmp38_;
#line 2044 "../core/Services/Database.vala"
				_item_index = -1;
#line 2044 "../core/Services/Database.vala"
				while (TRUE) {
#line 13858 "Database.c"
					gint _tmp39_;
					gint _tmp40_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp41_;
					gpointer _tmp42_;
					ObjectsItem* _tmp43_;
					const gchar* _tmp44_;
					const gchar* _tmp45_;
#line 2044 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 2044 "../core/Services/Database.vala"
					_tmp39_ = _item_index;
#line 2044 "../core/Services/Database.vala"
					_tmp40_ = _item_size;
#line 2044 "../core/Services/Database.vala"
					if (!(_tmp39_ < _tmp40_)) {
#line 2044 "../core/Services/Database.vala"
						break;
#line 13877 "Database.c"
					}
#line 2044 "../core/Services/Database.vala"
					_tmp41_ = _item_list;
#line 2044 "../core/Services/Database.vala"
					_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, _item_index);
#line 2044 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp42_;
#line 2045 "../core/Services/Database.vala"
					_tmp43_ = item;
#line 2045 "../core/Services/Database.vala"
					_tmp44_ = objects_item_get_section_id (_tmp43_);
#line 2045 "../core/Services/Database.vala"
					_tmp45_ = _tmp44_;
#line 2045 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp45_, current_id) == 0) {
#line 13893 "Database.c"
						ObjectsItem* _tmp46_;
#line 2046 "../core/Services/Database.vala"
						_tmp46_ = item;
#line 2046 "../core/Services/Database.vala"
						objects_item_set_section_id (_tmp46_, new_id);
#line 13899 "Database.c"
					}
#line 2044 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 13903 "Database.c"
				}
			}
		}
	}
#line 2052 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 2052 "../core/Services/Database.vala"
	sqlite3_reset (_tmp47_);
#line 2015 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 13914 "Database.c"
}

void
services_database_update_item_id (ServicesDatabase* self,
                                  const gchar* current_id,
                                  const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp47_;
#line 2055 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2055 "../core/Services/Database.vala"
	g_return_if_fail (current_id != NULL);
#line 2055 "../core/Services/Database.vala"
	g_return_if_fail (new_id != NULL);
#line 2058 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET id = $new_id WHERE id = $current_id;\n" \
"        ");
#line 2058 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2058 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2062 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2062 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2062 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2062 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2062 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2062 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2062 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2062 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2063 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2063 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 2064 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 2064 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 2066 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 2066 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) == SQLITE_DONE) {
#line 13974 "Database.c"
		sqlite3_stmt* _tmp23_;
		gchar* _tmp24_;
		sqlite3* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
		sqlite3_stmt* _tmp30_ = NULL;
		sqlite3_stmt* _tmp31_;
		sqlite3_stmt* _tmp32_;
		sqlite3_stmt* _tmp33_;
		{
			GeeArrayList* _item_list = NULL;
			GeeArrayList* _tmp10_;
			GeeArrayList* _tmp11_;
			gint _item_size = 0;
			GeeArrayList* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			gint _item_index = 0;
#line 2067 "../core/Services/Database.vala"
			_tmp10_ = services_database_get_items (self);
#line 2067 "../core/Services/Database.vala"
			_tmp11_ = _tmp10_;
#line 2067 "../core/Services/Database.vala"
			_item_list = _tmp11_;
#line 2067 "../core/Services/Database.vala"
			_tmp12_ = _item_list;
#line 2067 "../core/Services/Database.vala"
			_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 2067 "../core/Services/Database.vala"
			_tmp14_ = _tmp13_;
#line 2067 "../core/Services/Database.vala"
			_item_size = _tmp14_;
#line 2067 "../core/Services/Database.vala"
			_item_index = -1;
#line 2067 "../core/Services/Database.vala"
			while (TRUE) {
#line 14013 "Database.c"
				gint _tmp15_;
				gint _tmp16_;
				ObjectsItem* item = NULL;
				GeeArrayList* _tmp17_;
				gpointer _tmp18_;
				ObjectsItem* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
#line 2067 "../core/Services/Database.vala"
				_item_index = _item_index + 1;
#line 2067 "../core/Services/Database.vala"
				_tmp15_ = _item_index;
#line 2067 "../core/Services/Database.vala"
				_tmp16_ = _item_size;
#line 2067 "../core/Services/Database.vala"
				if (!(_tmp15_ < _tmp16_)) {
#line 2067 "../core/Services/Database.vala"
					break;
#line 14032 "Database.c"
				}
#line 2067 "../core/Services/Database.vala"
				_tmp17_ = _item_list;
#line 2067 "../core/Services/Database.vala"
				_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _item_index);
#line 2067 "../core/Services/Database.vala"
				item = (ObjectsItem*) _tmp18_;
#line 2068 "../core/Services/Database.vala"
				_tmp19_ = item;
#line 2068 "../core/Services/Database.vala"
				_tmp20_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp19_);
#line 2068 "../core/Services/Database.vala"
				_tmp21_ = _tmp20_;
#line 2068 "../core/Services/Database.vala"
				if (g_strcmp0 (_tmp21_, current_id) == 0) {
#line 14048 "Database.c"
					ObjectsItem* _tmp22_;
#line 2069 "../core/Services/Database.vala"
					_tmp22_ = item;
#line 2069 "../core/Services/Database.vala"
					objects_base_object_set_id ((ObjectsBaseObject*) _tmp22_, new_id);
#line 14054 "Database.c"
				}
#line 2067 "../core/Services/Database.vala"
				_g_object_unref0 (item);
#line 14058 "Database.c"
			}
		}
#line 2073 "../core/Services/Database.vala"
		_tmp23_ = stmt;
#line 2073 "../core/Services/Database.vala"
		sqlite3_reset (_tmp23_);
#line 2075 "../core/Services/Database.vala"
		_tmp24_ = g_strdup ("\n" \
"                UPDATE Items SET parent_id = $new_id WHERE parent_id =" \
" $current_id;\n" \
"            ");
#line 2075 "../core/Services/Database.vala"
		_g_free0 (self->priv->sql);
#line 2075 "../core/Services/Database.vala"
		self->priv->sql = _tmp24_;
#line 2079 "../core/Services/Database.vala"
		_tmp25_ = self->priv->db;
#line 2079 "../core/Services/Database.vala"
		_tmp26_ = self->priv->sql;
#line 2079 "../core/Services/Database.vala"
		_tmp27_ = self->priv->sql;
#line 2079 "../core/Services/Database.vala"
		_tmp28_ = strlen (_tmp27_);
#line 2079 "../core/Services/Database.vala"
		_tmp29_ = _tmp28_;
#line 2079 "../core/Services/Database.vala"
		sqlite3_prepare_v2 (_tmp25_, _tmp26_, _tmp29_, &_tmp30_, NULL);
#line 2079 "../core/Services/Database.vala"
		_sqlite3_finalize0 (stmt);
#line 2079 "../core/Services/Database.vala"
		stmt = _tmp30_;
#line 2080 "../core/Services/Database.vala"
		_tmp31_ = stmt;
#line 2080 "../core/Services/Database.vala"
		services_database_set_parameter_str (self, _tmp31_, "$new_id", new_id);
#line 2081 "../core/Services/Database.vala"
		_tmp32_ = stmt;
#line 2081 "../core/Services/Database.vala"
		services_database_set_parameter_str (self, _tmp32_, "$current_id", current_id);
#line 2083 "../core/Services/Database.vala"
		_tmp33_ = stmt;
#line 2083 "../core/Services/Database.vala"
		if (sqlite3_step (_tmp33_) == SQLITE_DONE) {
#line 14099 "Database.c"
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp34_;
				GeeArrayList* _tmp35_;
				gint _item_size = 0;
				GeeArrayList* _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				gint _item_index = 0;
#line 2084 "../core/Services/Database.vala"
				_tmp34_ = services_database_get_items (self);
#line 2084 "../core/Services/Database.vala"
				_tmp35_ = _tmp34_;
#line 2084 "../core/Services/Database.vala"
				_item_list = _tmp35_;
#line 2084 "../core/Services/Database.vala"
				_tmp36_ = _item_list;
#line 2084 "../core/Services/Database.vala"
				_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 2084 "../core/Services/Database.vala"
				_tmp38_ = _tmp37_;
#line 2084 "../core/Services/Database.vala"
				_item_size = _tmp38_;
#line 2084 "../core/Services/Database.vala"
				_item_index = -1;
#line 2084 "../core/Services/Database.vala"
				while (TRUE) {
#line 14127 "Database.c"
					gint _tmp39_;
					gint _tmp40_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp41_;
					gpointer _tmp42_;
					ObjectsItem* _tmp43_;
					const gchar* _tmp44_;
					const gchar* _tmp45_;
#line 2084 "../core/Services/Database.vala"
					_item_index = _item_index + 1;
#line 2084 "../core/Services/Database.vala"
					_tmp39_ = _item_index;
#line 2084 "../core/Services/Database.vala"
					_tmp40_ = _item_size;
#line 2084 "../core/Services/Database.vala"
					if (!(_tmp39_ < _tmp40_)) {
#line 2084 "../core/Services/Database.vala"
						break;
#line 14146 "Database.c"
					}
#line 2084 "../core/Services/Database.vala"
					_tmp41_ = _item_list;
#line 2084 "../core/Services/Database.vala"
					_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, _item_index);
#line 2084 "../core/Services/Database.vala"
					item = (ObjectsItem*) _tmp42_;
#line 2085 "../core/Services/Database.vala"
					_tmp43_ = item;
#line 2085 "../core/Services/Database.vala"
					_tmp44_ = objects_item_get_parent_id (_tmp43_);
#line 2085 "../core/Services/Database.vala"
					_tmp45_ = _tmp44_;
#line 2085 "../core/Services/Database.vala"
					if (g_strcmp0 (_tmp45_, current_id) == 0) {
#line 14162 "Database.c"
						ObjectsItem* _tmp46_;
#line 2086 "../core/Services/Database.vala"
						_tmp46_ = item;
#line 2086 "../core/Services/Database.vala"
						objects_item_set_parent_id (_tmp46_, new_id);
#line 14168 "Database.c"
					}
#line 2084 "../core/Services/Database.vala"
					_g_object_unref0 (item);
#line 14172 "Database.c"
				}
			}
		}
	}
#line 2092 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 2092 "../core/Services/Database.vala"
	sqlite3_reset (_tmp47_);
#line 2055 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 14183 "Database.c"
}

void
services_database_remove_CurTempIds (ServicesDatabase* self,
                                     const gchar* id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp12_;
#line 2095 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2095 "../core/Services/Database.vala"
	g_return_if_fail (id != NULL);
#line 2098 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM CurTempIds WHERE id = $id;\n        ");
#line 2098 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2098 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2102 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2102 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2102 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2102 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2102 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2102 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2102 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2102 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2103 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2103 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", id);
#line 2105 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 2105 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp8_) != SQLITE_DONE) {
#line 14235 "Database.c"
		sqlite3* _tmp9_;
		sqlite3* _tmp10_;
		const gchar* _tmp11_;
#line 2106 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 2106 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 2106 "../core/Services/Database.vala"
		_tmp11_ = sqlite3_errmsg (_tmp10_);
#line 2106 "../core/Services/Database.vala"
		g_warning ("Database.vala:2106: Error: %d: %s", sqlite3_errcode (_tmp9_), _tmp11_);
#line 14247 "Database.c"
	}
#line 2109 "../core/Services/Database.vala"
	_tmp12_ = stmt;
#line 2109 "../core/Services/Database.vala"
	sqlite3_reset (_tmp12_);
#line 2095 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 14255 "Database.c"
}

void
services_database_remove_queue (ServicesDatabase* self,
                                const gchar* uuid)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp12_;
#line 2112 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2112 "../core/Services/Database.vala"
	g_return_if_fail (uuid != NULL);
#line 2115 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Queue WHERE uuid = $uuid;\n        ");
#line 2115 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2115 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2119 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2119 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2119 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2119 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2119 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2119 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2119 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2119 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2120 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2120 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$uuid", uuid);
#line 2122 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 2122 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp8_) != SQLITE_DONE) {
#line 14307 "Database.c"
		sqlite3* _tmp9_;
		sqlite3* _tmp10_;
		const gchar* _tmp11_;
#line 2123 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 2123 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 2123 "../core/Services/Database.vala"
		_tmp11_ = sqlite3_errmsg (_tmp10_);
#line 2123 "../core/Services/Database.vala"
		g_warning ("Database.vala:2123: Error: %d: %s", sqlite3_errcode (_tmp9_), _tmp11_);
#line 14319 "Database.c"
	}
#line 2126 "../core/Services/Database.vala"
	_tmp12_ = stmt;
#line 2126 "../core/Services/Database.vala"
	sqlite3_reset (_tmp12_);
#line 2112 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 14327 "Database.c"
}

void
services_database_clear_queue (ServicesDatabase* self)
{
	sqlite3_stmt* stmt = NULL;
	gchar* sql = NULL;
	gint res = 0;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	sqlite3_stmt* _tmp5_;
	sqlite3_stmt* _tmp9_;
#line 2129 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2134 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Queue;\n        ");
#line 2134 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 2134 "../core/Services/Database.vala"
	sql = _tmp0_;
#line 2138 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2138 "../core/Services/Database.vala"
	_tmp2_ = sql;
#line 2138 "../core/Services/Database.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp1_, _tmp2_, -1, &_tmp3_, NULL);
#line 2138 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2138 "../core/Services/Database.vala"
	stmt = _tmp3_;
#line 2138 "../core/Services/Database.vala"
	res = _tmp4_;
#line 2139 "../core/Services/Database.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 2141 "../core/Services/Database.vala"
	_tmp5_ = stmt;
#line 2141 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp5_) != SQLITE_DONE) {
#line 14369 "Database.c"
		sqlite3* _tmp6_;
		sqlite3* _tmp7_;
		const gchar* _tmp8_;
#line 2142 "../core/Services/Database.vala"
		_tmp6_ = self->priv->db;
#line 2142 "../core/Services/Database.vala"
		_tmp7_ = self->priv->db;
#line 2142 "../core/Services/Database.vala"
		_tmp8_ = sqlite3_errmsg (_tmp7_);
#line 2142 "../core/Services/Database.vala"
		g_warning ("Database.vala:2142: Error: %d: %s", sqlite3_errcode (_tmp6_), _tmp8_);
#line 14381 "Database.c"
	}
#line 2145 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 2145 "../core/Services/Database.vala"
	sqlite3_reset (_tmp9_);
#line 2129 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 2129 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 14391 "Database.c"
}

void
services_database_clear_cur_temp_ids (ServicesDatabase* self)
{
	sqlite3_stmt* stmt = NULL;
	gchar* sql = NULL;
	gint res = 0;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	sqlite3_stmt* _tmp5_;
	sqlite3_stmt* _tmp9_;
#line 2148 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2153 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM CurTempIds;\n        ");
#line 2153 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 2153 "../core/Services/Database.vala"
	sql = _tmp0_;
#line 2157 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2157 "../core/Services/Database.vala"
	_tmp2_ = sql;
#line 2157 "../core/Services/Database.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp1_, _tmp2_, -1, &_tmp3_, NULL);
#line 2157 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2157 "../core/Services/Database.vala"
	stmt = _tmp3_;
#line 2157 "../core/Services/Database.vala"
	res = _tmp4_;
#line 2158 "../core/Services/Database.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 2160 "../core/Services/Database.vala"
	_tmp5_ = stmt;
#line 2160 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp5_) != SQLITE_DONE) {
#line 14433 "Database.c"
		sqlite3* _tmp6_;
		sqlite3* _tmp7_;
		const gchar* _tmp8_;
#line 2161 "../core/Services/Database.vala"
		_tmp6_ = self->priv->db;
#line 2161 "../core/Services/Database.vala"
		_tmp7_ = self->priv->db;
#line 2161 "../core/Services/Database.vala"
		_tmp8_ = sqlite3_errmsg (_tmp7_);
#line 2161 "../core/Services/Database.vala"
		g_warning ("Database.vala:2161: Error: %d: %s", sqlite3_errcode (_tmp6_), _tmp8_);
#line 14445 "Database.c"
	}
#line 2164 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 2164 "../core/Services/Database.vala"
	sqlite3_reset (_tmp9_);
#line 2148 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 2148 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 14455 "Database.c"
}

static void
services_database_set_parameter_int (ServicesDatabase* self,
                                     sqlite3_stmt* stmt,
                                     const gchar* par,
                                     gint val)
{
	gint par_position = 0;
#line 2168 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2168 "../core/Services/Database.vala"
	g_return_if_fail (par != NULL);
#line 2169 "../core/Services/Database.vala"
	par_position = sqlite3_bind_parameter_index (stmt, par);
#line 2170 "../core/Services/Database.vala"
	sqlite3_bind_int (stmt, par_position, val);
#line 14473 "Database.c"
}

static void
services_database_set_parameter_str (ServicesDatabase* self,
                                     sqlite3_stmt* stmt,
                                     const gchar* par,
                                     const gchar* val)
{
	gint par_position = 0;
	gchar* _tmp0_;
	GDestroyNotify _tmp1_;
#line 2178 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2178 "../core/Services/Database.vala"
	g_return_if_fail (par != NULL);
#line 2178 "../core/Services/Database.vala"
	g_return_if_fail (val != NULL);
#line 2179 "../core/Services/Database.vala"
	par_position = sqlite3_bind_parameter_index (stmt, par);
#line 2180 "../core/Services/Database.vala"
	_tmp0_ = g_strdup (val);
#line 2180 "../core/Services/Database.vala"
	_tmp1_ = g_free;
#line 2180 "../core/Services/Database.vala"
	sqlite3_bind_text (stmt, par_position, _tmp0_, -1, _tmp1_);
#line 14499 "Database.c"
}

static void
services_database_set_parameter_bool (ServicesDatabase* self,
                                      sqlite3_stmt* stmt,
                                      const gchar* par,
                                      gboolean val)
{
	gint par_position = 0;
	gint _tmp0_ = 0;
#line 2183 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2183 "../core/Services/Database.vala"
	g_return_if_fail (par != NULL);
#line 2184 "../core/Services/Database.vala"
	par_position = sqlite3_bind_parameter_index (stmt, par);
#line 2185 "../core/Services/Database.vala"
	if (val) {
#line 2185 "../core/Services/Database.vala"
		_tmp0_ = 1;
#line 14520 "Database.c"
	} else {
#line 2185 "../core/Services/Database.vala"
		_tmp0_ = 0;
#line 14524 "Database.c"
	}
#line 2185 "../core/Services/Database.vala"
	sqlite3_bind_int (stmt, par_position, _tmp0_);
#line 14528 "Database.c"
}

static gboolean
services_database_get_parameter_bool (ServicesDatabase* self,
                                      sqlite3_stmt* stmt,
                                      gint col)
{
	gboolean result;
#line 2188 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2188 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, FALSE);
#line 2189 "../core/Services/Database.vala"
	result = sqlite3_column_int (stmt, col) == 1;
#line 2189 "../core/Services/Database.vala"
	return result;
#line 14545 "Database.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 2204 "../core/Services/Database.vala"
	return self ? json_object_ref (self) : NULL;
#line 14553 "Database.c"
}

JsonObject*
services_database_get_due_parameter (ServicesDatabase* self,
                                     const gchar* data)
{
	JsonParser* _tmp0_;
	JsonParser* _tmp5_;
	JsonNode* _tmp6_;
	JsonObject* _tmp7_;
	JsonObject* _tmp8_;
	GError* _inner_error0_ = NULL;
	JsonObject* result;
#line 2193 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2193 "../core/Services/Database.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 2194 "../core/Services/Database.vala"
	_tmp0_ = self->priv->parser;
#line 2194 "../core/Services/Database.vala"
	if (_tmp0_ == NULL) {
#line 14575 "Database.c"
		JsonParser* _tmp1_;
#line 2195 "../core/Services/Database.vala"
		_tmp1_ = json_parser_new ();
#line 2195 "../core/Services/Database.vala"
		_g_object_unref0 (self->priv->parser);
#line 2195 "../core/Services/Database.vala"
		self->priv->parser = _tmp1_;
#line 14583 "Database.c"
	}
	{
		JsonParser* _tmp2_;
#line 2199 "../core/Services/Database.vala"
		_tmp2_ = self->priv->parser;
#line 2199 "../core/Services/Database.vala"
		json_parser_load_from_data (_tmp2_, data, (gssize) -1, &_inner_error0_);
#line 2199 "../core/Services/Database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14593 "Database.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 2198 "../core/Services/Database.vala"
		e = _inner_error0_;
#line 2198 "../core/Services/Database.vala"
		_inner_error0_ = NULL;
#line 2201 "../core/Services/Database.vala"
		_tmp3_ = e;
#line 2201 "../core/Services/Database.vala"
		_tmp4_ = _tmp3_->message;
#line 2201 "../core/Services/Database.vala"
		g_debug ("Database.vala:2201: %s", _tmp4_);
#line 2198 "../core/Services/Database.vala"
		_g_error_free0 (e);
#line 14615 "Database.c"
	}
	__finally0:
#line 2198 "../core/Services/Database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2198 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2198 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 2198 "../core/Services/Database.vala"
		return NULL;
#line 14626 "Database.c"
	}
#line 2204 "../core/Services/Database.vala"
	_tmp5_ = self->priv->parser;
#line 2204 "../core/Services/Database.vala"
	_tmp6_ = json_parser_get_root (_tmp5_);
#line 2204 "../core/Services/Database.vala"
	_tmp7_ = json_node_get_object (_tmp6_);
#line 2204 "../core/Services/Database.vala"
	_tmp8_ = _json_object_ref0 (_tmp7_);
#line 2204 "../core/Services/Database.vala"
	result = _tmp8_;
#line 2204 "../core/Services/Database.vala"
	return result;
#line 14640 "Database.c"
}

gboolean
services_database_column_exists (ServicesDatabase* self,
                                 const gchar* table,
                                 const gchar* column)
{
	sqlite3_stmt* stmt = NULL;
	gboolean returned = FALSE;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	gboolean result;
#line 2207 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2207 "../core/Services/Database.vala"
	g_return_val_if_fail (table != NULL, FALSE);
#line 2207 "../core/Services/Database.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 2209 "../core/Services/Database.vala"
	returned = FALSE;
#line 2211 "../core/Services/Database.vala"
	_tmp0_ = g_strdup_printf ("\n            SELECT * FROM %s LIMIT 1;\n        ", table);
#line 2211 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2211 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2215 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2215 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2215 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2215 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2215 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2215 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2215 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2215 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2217 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2217 "../core/Services/Database.vala"
	sqlite3_step (_tmp7_);
#line 14693 "Database.c"
	{
		gint i = 0;
#line 2219 "../core/Services/Database.vala"
		i = 0;
#line 14698 "Database.c"
		{
			gboolean _tmp8_ = FALSE;
#line 2219 "../core/Services/Database.vala"
			_tmp8_ = TRUE;
#line 2219 "../core/Services/Database.vala"
			while (TRUE) {
#line 14705 "Database.c"
				sqlite3_stmt* _tmp10_;
				sqlite3_stmt* _tmp11_;
				const gchar* _tmp12_;
#line 2219 "../core/Services/Database.vala"
				if (!_tmp8_) {
#line 14711 "Database.c"
					gint _tmp9_;
#line 2219 "../core/Services/Database.vala"
					_tmp9_ = i;
#line 2219 "../core/Services/Database.vala"
					i = _tmp9_ + 1;
#line 14717 "Database.c"
				}
#line 2219 "../core/Services/Database.vala"
				_tmp8_ = FALSE;
#line 2219 "../core/Services/Database.vala"
				_tmp10_ = stmt;
#line 2219 "../core/Services/Database.vala"
				if (!(i < sqlite3_column_count (_tmp10_))) {
#line 2219 "../core/Services/Database.vala"
					break;
#line 14727 "Database.c"
				}
#line 2220 "../core/Services/Database.vala"
				_tmp11_ = stmt;
#line 2220 "../core/Services/Database.vala"
				_tmp12_ = sqlite3_column_name (_tmp11_, i);
#line 2220 "../core/Services/Database.vala"
				if (g_strcmp0 (_tmp12_, column) == 0) {
#line 2221 "../core/Services/Database.vala"
					returned = TRUE;
#line 14737 "Database.c"
				}
			}
		}
	}
#line 2225 "../core/Services/Database.vala"
	result = returned;
#line 2225 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2225 "../core/Services/Database.vala"
	return result;
#line 14748 "Database.c"
}

void
services_database_add_text_column (ServicesDatabase* self,
                                   const gchar* table,
                                   const gchar* column,
                                   const gchar* default_value)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp11_;
#line 2228 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2228 "../core/Services/Database.vala"
	g_return_if_fail (table != NULL);
#line 2228 "../core/Services/Database.vala"
	g_return_if_fail (column != NULL);
#line 2228 "../core/Services/Database.vala"
	g_return_if_fail (default_value != NULL);
#line 2229 "../core/Services/Database.vala"
	if (services_database_column_exists (self, table, column)) {
#line 2230 "../core/Services/Database.vala"
		return;
#line 14779 "Database.c"
	}
#line 2235 "../core/Services/Database.vala"
	_tmp0_ = g_strdup_printf ("\n" \
"            ALTER TABLE %s ADD COLUMN %s TEXT DEFAULT '%s';\n" \
"        ", table, column, default_value);
#line 2235 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2235 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2239 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2239 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2239 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2239 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2239 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2239 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2239 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2239 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2241 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2241 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp7_) != SQLITE_DONE) {
#line 14807 "Database.c"
		sqlite3* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
#line 2242 "../core/Services/Database.vala"
		_tmp8_ = self->priv->db;
#line 2242 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 2242 "../core/Services/Database.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 2242 "../core/Services/Database.vala"
		g_warning ("Database.vala:2242: Error: %d: %s", sqlite3_errcode (_tmp8_), _tmp10_);
#line 14819 "Database.c"
	}
#line 2245 "../core/Services/Database.vala"
	_tmp11_ = stmt;
#line 2245 "../core/Services/Database.vala"
	sqlite3_reset (_tmp11_);
#line 2228 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 14827 "Database.c"
}

void
services_database_add_int_column (ServicesDatabase* self,
                                  const gchar* table,
                                  const gchar* column,
                                  gint default_value)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp11_;
#line 2248 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2248 "../core/Services/Database.vala"
	g_return_if_fail (table != NULL);
#line 2248 "../core/Services/Database.vala"
	g_return_if_fail (column != NULL);
#line 2249 "../core/Services/Database.vala"
	if (services_database_column_exists (self, table, column)) {
#line 2250 "../core/Services/Database.vala"
		return;
#line 14856 "Database.c"
	}
#line 2255 "../core/Services/Database.vala"
	_tmp0_ = g_strdup_printf ("\n" \
"            ALTER TABLE %s ADD COLUMN %s INTEGER DEFAULT %i;\n" \
"        ", table, column, default_value);
#line 2255 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2255 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2259 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2259 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2259 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2259 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2259 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2259 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2259 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2259 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2261 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2261 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp7_) != SQLITE_DONE) {
#line 14884 "Database.c"
		sqlite3* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
#line 2262 "../core/Services/Database.vala"
		_tmp8_ = self->priv->db;
#line 2262 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 2262 "../core/Services/Database.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 2262 "../core/Services/Database.vala"
		g_warning ("Database.vala:2262: Error: %d: %s", sqlite3_errcode (_tmp8_), _tmp10_);
#line 14896 "Database.c"
	}
#line 2265 "../core/Services/Database.vala"
	_tmp11_ = stmt;
#line 2265 "../core/Services/Database.vala"
	sqlite3_reset (_tmp11_);
#line 2248 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 14904 "Database.c"
}

void
services_database_add_item_label_column (ServicesDatabase* self)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp11_;
#line 2268 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2269 "../core/Services/Database.vala"
	if (services_database_column_exists (self, "Items", "labels")) {
#line 2270 "../core/Services/Database.vala"
		return;
#line 14926 "Database.c"
	}
#line 2275 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            ALTER TABLE Items ADD COLUMN labels TEXT;\n" \
"            \n" \
"            UPDATE Items\n" \
"            SET labels = (\n" \
"                SELECT GROUP_CONCAT(label_id, ';')\n" \
"                FROM Items_Labels\n" \
"                WHERE item_id = Items.id\n" \
"            );\n" \
"        ");
#line 2275 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2275 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2286 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2286 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2286 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2286 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2286 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2286 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2286 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2286 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2288 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2288 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp7_) != SQLITE_DONE) {
#line 14954 "Database.c"
		sqlite3* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
#line 2289 "../core/Services/Database.vala"
		_tmp8_ = self->priv->db;
#line 2289 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 2289 "../core/Services/Database.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 2289 "../core/Services/Database.vala"
		g_warning ("Database.vala:2289: Error: %d: %s", sqlite3_errcode (_tmp8_), _tmp10_);
#line 14966 "Database.c"
	}
#line 2292 "../core/Services/Database.vala"
	_tmp11_ = stmt;
#line 2292 "../core/Services/Database.vala"
	sqlite3_reset (_tmp11_);
#line 2268 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 14974 "Database.c"
}

ServicesDatabase*
services_database_construct (GType object_type)
{
	ServicesDatabase * self = NULL;
#line 22 "../core/Services/Database.vala"
	self = (ServicesDatabase*) g_object_new (object_type, NULL);
#line 22 "../core/Services/Database.vala"
	return self;
#line 14985 "Database.c"
}

ServicesDatabase*
services_database_new (void)
{
#line 22 "../core/Services/Database.vala"
	return services_database_construct (SERVICES_TYPE_DATABASE);
#line 14993 "Database.c"
}

GeeArrayList*
services_database_get_projects (ServicesDatabase* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp2_;
#line 63 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../core/Services/Database.vala"
	_tmp0_ = self->priv->_projects;
#line 64 "../core/Services/Database.vala"
	if (_tmp0_ == NULL) {
#line 15008 "Database.c"
		GeeArrayList* _tmp1_;
#line 65 "../core/Services/Database.vala"
		_tmp1_ = services_database_get_projects_collection (self);
#line 65 "../core/Services/Database.vala"
		_g_object_unref0 (self->priv->_projects);
#line 65 "../core/Services/Database.vala"
		self->priv->_projects = _tmp1_;
#line 15016 "Database.c"
	}
#line 67 "../core/Services/Database.vala"
	_tmp2_ = self->priv->_projects;
#line 67 "../core/Services/Database.vala"
	result = _tmp2_;
#line 67 "../core/Services/Database.vala"
	return result;
#line 15024 "Database.c"
}

GeeArrayList*
services_database_get_sections (ServicesDatabase* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp2_;
#line 73 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../core/Services/Database.vala"
	_tmp0_ = self->priv->_sections;
#line 74 "../core/Services/Database.vala"
	if (_tmp0_ == NULL) {
#line 15039 "Database.c"
		GeeArrayList* _tmp1_;
#line 75 "../core/Services/Database.vala"
		_tmp1_ = services_database_get_sections_collection (self);
#line 75 "../core/Services/Database.vala"
		_g_object_unref0 (self->priv->_sections);
#line 75 "../core/Services/Database.vala"
		self->priv->_sections = _tmp1_;
#line 15047 "Database.c"
	}
#line 77 "../core/Services/Database.vala"
	_tmp2_ = self->priv->_sections;
#line 77 "../core/Services/Database.vala"
	result = _tmp2_;
#line 77 "../core/Services/Database.vala"
	return result;
#line 15055 "Database.c"
}

GeeArrayList*
services_database_get_items (ServicesDatabase* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp2_;
#line 83 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "../core/Services/Database.vala"
	_tmp0_ = self->priv->_items;
#line 84 "../core/Services/Database.vala"
	if (_tmp0_ == NULL) {
#line 15070 "Database.c"
		GeeArrayList* _tmp1_;
#line 85 "../core/Services/Database.vala"
		_tmp1_ = services_database_get_items_collection (self);
#line 85 "../core/Services/Database.vala"
		_g_object_unref0 (self->priv->_items);
#line 85 "../core/Services/Database.vala"
		self->priv->_items = _tmp1_;
#line 15078 "Database.c"
	}
#line 87 "../core/Services/Database.vala"
	_tmp2_ = self->priv->_items;
#line 87 "../core/Services/Database.vala"
	result = _tmp2_;
#line 87 "../core/Services/Database.vala"
	return result;
#line 15086 "Database.c"
}

GeeArrayList*
services_database_get_labels (ServicesDatabase* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp2_;
#line 93 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "../core/Services/Database.vala"
	_tmp0_ = self->priv->_labels;
#line 94 "../core/Services/Database.vala"
	if (_tmp0_ == NULL) {
#line 15101 "Database.c"
		GeeArrayList* _tmp1_;
#line 95 "../core/Services/Database.vala"
		_tmp1_ = services_database_get_labels_collection (self);
#line 95 "../core/Services/Database.vala"
		_g_object_unref0 (self->priv->_labels);
#line 95 "../core/Services/Database.vala"
		self->priv->_labels = _tmp1_;
#line 15109 "Database.c"
	}
#line 97 "../core/Services/Database.vala"
	_tmp2_ = self->priv->_labels;
#line 97 "../core/Services/Database.vala"
	result = _tmp2_;
#line 97 "../core/Services/Database.vala"
	return result;
#line 15117 "Database.c"
}

GeeArrayList*
services_database_get_reminders (ServicesDatabase* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp2_;
#line 103 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "../core/Services/Database.vala"
	_tmp0_ = self->priv->_reminders;
#line 104 "../core/Services/Database.vala"
	if (_tmp0_ == NULL) {
#line 15132 "Database.c"
		GeeArrayList* _tmp1_;
#line 105 "../core/Services/Database.vala"
		_tmp1_ = services_database_get_reminders_collection (self);
#line 105 "../core/Services/Database.vala"
		_g_object_unref0 (self->priv->_reminders);
#line 105 "../core/Services/Database.vala"
		self->priv->_reminders = _tmp1_;
#line 15140 "Database.c"
	}
#line 108 "../core/Services/Database.vala"
	_tmp2_ = self->priv->_reminders;
#line 108 "../core/Services/Database.vala"
	result = _tmp2_;
#line 108 "../core/Services/Database.vala"
	return result;
#line 15148 "Database.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 22 "../core/Services/Database.vala"
	g_return_if_fail (n_param_values == 3);
#line 22 "../core/Services/Database.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 22 "../core/Services/Database.vala"
		data1 = closure->data;
#line 22 "../core/Services/Database.vala"
		data2 = param_values->data[0].v_pointer;
#line 15173 "Database.c"
	} else {
#line 22 "../core/Services/Database.vala"
		data1 = param_values->data[0].v_pointer;
#line 22 "../core/Services/Database.vala"
		data2 = closure->data;
#line 15179 "Database.c"
	}
#line 22 "../core/Services/Database.vala"
	callback = (GMarshalFunc_VOID__OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 22 "../core/Services/Database.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 15185 "Database.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 22 "../core/Services/Database.vala"
	g_return_if_fail (n_param_values == 3);
#line 22 "../core/Services/Database.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 22 "../core/Services/Database.vala"
		data1 = closure->data;
#line 22 "../core/Services/Database.vala"
		data2 = param_values->data[0].v_pointer;
#line 15210 "Database.c"
	} else {
#line 22 "../core/Services/Database.vala"
		data1 = param_values->data[0].v_pointer;
#line 22 "../core/Services/Database.vala"
		data2 = closure->data;
#line 15216 "Database.c"
	}
#line 22 "../core/Services/Database.vala"
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 22 "../core/Services/Database.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 15222 "Database.c"
}

static void
_services_database___lambda29_ (ServicesDatabase* self,
                                ObjectsLabel* label)
{
	GeeArrayList* _tmp0_;
#line 113 "../core/Services/Database.vala"
	g_return_if_fail (label != NULL);
#line 114 "../core/Services/Database.vala"
	_tmp0_ = self->priv->_labels;
#line 114 "../core/Services/Database.vala"
	if (gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, label)) {
#line 15236 "Database.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 115 "../core/Services/Database.vala"
		_tmp1_ = objects_base_object_get_name ((ObjectsBaseObject*) label);
#line 115 "../core/Services/Database.vala"
		_tmp2_ = _tmp1_;
#line 115 "../core/Services/Database.vala"
		g_debug ("Database.vala:115: Label Removed: %s", _tmp2_);
#line 15245 "Database.c"
	}
}

static void
__services_database___lambda29__services_database_label_deleted (ServicesDatabase* _sender,
                                                                 ObjectsLabel* label,
                                                                 gpointer self)
{
#line 113 "../core/Services/Database.vala"
	_services_database___lambda29_ ((ServicesDatabase*) self, label);
#line 15256 "Database.c"
}

static void
_services_database___lambda30_ (ServicesDatabase* self,
                                ObjectsProject* project)
{
	GeeArrayList* _tmp0_;
#line 119 "../core/Services/Database.vala"
	g_return_if_fail (project != NULL);
#line 120 "../core/Services/Database.vala"
	_tmp0_ = self->priv->_projects;
#line 120 "../core/Services/Database.vala"
	if (gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, project)) {
#line 15270 "Database.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 121 "../core/Services/Database.vala"
		_tmp1_ = objects_base_object_get_name ((ObjectsBaseObject*) project);
#line 121 "../core/Services/Database.vala"
		_tmp2_ = _tmp1_;
#line 121 "../core/Services/Database.vala"
		g_debug ("Database.vala:121: Project Removed: %s", _tmp2_);
#line 15279 "Database.c"
	}
}

static void
__services_database___lambda30__services_database_project_deleted (ServicesDatabase* _sender,
                                                                   ObjectsProject* project,
                                                                   gpointer self)
{
#line 119 "../core/Services/Database.vala"
	_services_database___lambda30_ ((ServicesDatabase*) self, project);
#line 15290 "Database.c"
}

static void
_services_database___lambda31_ (ServicesDatabase* self,
                                ObjectsSection* section)
{
	GeeArrayList* _tmp0_;
#line 125 "../core/Services/Database.vala"
	g_return_if_fail (section != NULL);
#line 126 "../core/Services/Database.vala"
	_tmp0_ = self->priv->_sections;
#line 126 "../core/Services/Database.vala"
	if (gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, section)) {
#line 15304 "Database.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 127 "../core/Services/Database.vala"
		_tmp1_ = objects_base_object_get_name ((ObjectsBaseObject*) section);
#line 127 "../core/Services/Database.vala"
		_tmp2_ = _tmp1_;
#line 127 "../core/Services/Database.vala"
		g_debug ("Database.vala:127: Section Removed: %s", _tmp2_);
#line 15313 "Database.c"
	}
}

static void
__services_database___lambda31__services_database_section_deleted (ServicesDatabase* _sender,
                                                                   ObjectsSection* section,
                                                                   gpointer self)
{
#line 125 "../core/Services/Database.vala"
	_services_database___lambda31_ ((ServicesDatabase*) self, section);
#line 15324 "Database.c"
}

static void
_services_database___lambda32_ (ServicesDatabase* self,
                                ObjectsItem* item)
{
	GeeArrayList* _tmp0_;
#line 131 "../core/Services/Database.vala"
	g_return_if_fail (item != NULL);
#line 132 "../core/Services/Database.vala"
	_tmp0_ = self->priv->_items;
#line 132 "../core/Services/Database.vala"
	if (gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, item)) {
#line 15338 "Database.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 133 "../core/Services/Database.vala"
		_tmp1_ = objects_item_get_content (item);
#line 133 "../core/Services/Database.vala"
		_tmp2_ = _tmp1_;
#line 133 "../core/Services/Database.vala"
		g_debug ("Database.vala:133: item Removed: %s", _tmp2_);
#line 15347 "Database.c"
	}
}

static void
__services_database___lambda32__services_database_item_deleted (ServicesDatabase* _sender,
                                                                ObjectsItem* item,
                                                                gpointer self)
{
#line 131 "../core/Services/Database.vala"
	_services_database___lambda32_ ((ServicesDatabase*) self, item);
#line 15358 "Database.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1589 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1590 "glib-2.0.vapi"
	result = self;
#line 1590 "glib-2.0.vapi"
	return result;
#line 15371 "Database.c"
}

static void
_services_database___lambda33_ (ServicesDatabase* self,
                                ObjectsReminder* reminder)
{
	GeeArrayList* _tmp0_;
#line 137 "../core/Services/Database.vala"
	g_return_if_fail (reminder != NULL);
#line 138 "../core/Services/Database.vala"
	_tmp0_ = self->priv->_reminders;
#line 138 "../core/Services/Database.vala"
	if (gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, reminder)) {
#line 15385 "Database.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 139 "../core/Services/Database.vala"
		_tmp1_ = objects_base_object_get_id ((ObjectsBaseObject*) reminder);
#line 139 "../core/Services/Database.vala"
		_tmp2_ = _tmp1_;
#line 139 "../core/Services/Database.vala"
		_tmp3_ = string_to_string (_tmp2_);
#line 139 "../core/Services/Database.vala"
		g_debug ("Database.vala:139: Reminder Removed: %s", _tmp3_);
#line 15397 "Database.c"
	}
}

static void
__services_database___lambda33__services_database_reminder_deleted (ServicesDatabase* _sender,
                                                                    ObjectsReminder* reminder,
                                                                    gpointer self)
{
#line 137 "../core/Services/Database.vala"
	_services_database___lambda33_ ((ServicesDatabase*) self, reminder);
#line 15408 "Database.c"
}

static GObject *
services_database_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ServicesDatabase * self;
#line 112 "../core/Services/Database.vala"
	parent_class = G_OBJECT_CLASS (services_database_parent_class);
#line 112 "../core/Services/Database.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 112 "../core/Services/Database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SERVICES_TYPE_DATABASE, ServicesDatabase);
#line 113 "../core/Services/Database.vala"
	g_signal_connect_object (self, "label-deleted", (GCallback) __services_database___lambda29__services_database_label_deleted, self, 0);
#line 119 "../core/Services/Database.vala"
	g_signal_connect_object (self, "project-deleted", (GCallback) __services_database___lambda30__services_database_project_deleted, self, 0);
#line 125 "../core/Services/Database.vala"
	g_signal_connect_object (self, "section-deleted", (GCallback) __services_database___lambda31__services_database_section_deleted, self, 0);
#line 131 "../core/Services/Database.vala"
	g_signal_connect_object (self, "item-deleted", (GCallback) __services_database___lambda32__services_database_item_deleted, self, 0);
#line 137 "../core/Services/Database.vala"
	g_signal_connect_object (self, "reminder-deleted", (GCallback) __services_database___lambda33__services_database_reminder_deleted, self, 0);
#line 112 "../core/Services/Database.vala"
	return obj;
#line 15437 "Database.c"
}

static void
services_database_class_init (ServicesDatabaseClass * klass,
                              gpointer klass_data)
{
#line 22 "../core/Services/Database.vala"
	services_database_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Services/Database.vala"
	g_type_class_adjust_private_offset (klass, &ServicesDatabase_private_offset);
#line 22 "../core/Services/Database.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_services_database_get_property;
#line 22 "../core/Services/Database.vala"
	G_OBJECT_CLASS (klass)->constructor = services_database_constructor;
#line 22 "../core/Services/Database.vala"
	G_OBJECT_CLASS (klass)->finalize = services_database_finalize;
#line 22 "../core/Services/Database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_DATABASE_PROJECTS_PROPERTY, services_database_properties[SERVICES_DATABASE_PROJECTS_PROPERTY] = g_param_spec_object ("projects", "projects", "projects", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Services/Database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_DATABASE_SECTIONS_PROPERTY, services_database_properties[SERVICES_DATABASE_SECTIONS_PROPERTY] = g_param_spec_object ("sections", "sections", "sections", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Services/Database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_DATABASE_ITEMS_PROPERTY, services_database_properties[SERVICES_DATABASE_ITEMS_PROPERTY] = g_param_spec_object ("items", "items", "items", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Services/Database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_DATABASE_LABELS_PROPERTY, services_database_properties[SERVICES_DATABASE_LABELS_PROPERTY] = g_param_spec_object ("labels", "labels", "labels", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Services/Database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_DATABASE_REMINDERS_PROPERTY, services_database_properties[SERVICES_DATABASE_REMINDERS_PROPERTY] = g_param_spec_object ("reminders", "reminders", "reminders", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_OPENED_SIGNAL] = g_signal_new ("opened", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_RESET_SIGNAL] = g_signal_new ("reset", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_PROJECT_ADDED_SIGNAL] = g_signal_new ("project-added", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_PROJECT);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_PROJECT_UPDATED_SIGNAL] = g_signal_new ("project-updated", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_PROJECT);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_PROJECT_DELETED_SIGNAL] = g_signal_new ("project-deleted", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_PROJECT);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_LABEL_ADDED_SIGNAL] = g_signal_new ("label-added", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_LABEL);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_LABEL_UPDATED_SIGNAL] = g_signal_new ("label-updated", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_LABEL);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_LABEL_DELETED_SIGNAL] = g_signal_new ("label-deleted", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_LABEL);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_SECTION_DELETED_SIGNAL] = g_signal_new ("section-deleted", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_SECTION);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_SECTION_MOVED_SIGNAL] = g_signal_new ("section-moved", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, OBJECTS_TYPE_SECTION, G_TYPE_STRING);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_ITEM_DELETED_SIGNAL] = g_signal_new ("item-deleted", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_ITEM);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_ITEM_ADDED_SIGNAL] = g_signal_new ("item-added", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, OBJECTS_TYPE_ITEM, G_TYPE_BOOLEAN);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_ITEM_UPDATED_SIGNAL] = g_signal_new ("item-updated", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, OBJECTS_TYPE_ITEM, G_TYPE_STRING);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_ITEM_LABEL_ADDED_SIGNAL] = g_signal_new ("item-label-added", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_LABEL);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_ITEM_LABEL_DELETED_SIGNAL] = g_signal_new ("item-label-deleted", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_LABEL);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_REMINDER_ADDED_SIGNAL] = g_signal_new ("reminder-added", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_REMINDER);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_REMINDER_DELETED_SIGNAL] = g_signal_new ("reminder-deleted", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_REMINDER);
#line 15498 "Database.c"
}

static void
services_database_instance_init (ServicesDatabase * self,
                                 gpointer klass)
{
#line 22 "../core/Services/Database.vala"
	self->priv = services_database_get_instance_private (self);
#line 61 "../core/Services/Database.vala"
	g_rec_mutex_init (&self->priv->__lock__projects);
#line 61 "../core/Services/Database.vala"
	self->priv->_projects = NULL;
#line 71 "../core/Services/Database.vala"
	g_rec_mutex_init (&self->priv->__lock__sections);
#line 71 "../core/Services/Database.vala"
	self->priv->_sections = NULL;
#line 81 "../core/Services/Database.vala"
	g_rec_mutex_init (&self->priv->__lock__items);
#line 81 "../core/Services/Database.vala"
	self->priv->_items = NULL;
#line 91 "../core/Services/Database.vala"
	g_rec_mutex_init (&self->priv->__lock__labels);
#line 91 "../core/Services/Database.vala"
	self->priv->_labels = NULL;
#line 101 "../core/Services/Database.vala"
	g_rec_mutex_init (&self->priv->__lock__reminders);
#line 101 "../core/Services/Database.vala"
	self->priv->_reminders = NULL;
#line 15527 "Database.c"
}

static void
services_database_finalize (GObject * obj)
{
	ServicesDatabase * self;
#line 22 "../core/Services/Database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SERVICES_TYPE_DATABASE, ServicesDatabase);
#line 23 "../core/Services/Database.vala"
	_sqlite3_close0 (self->priv->db);
#line 24 "../core/Services/Database.vala"
	_g_free0 (self->priv->db_path);
#line 25 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 26 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 61 "../core/Services/Database.vala"
	g_rec_mutex_clear (&self->priv->__lock__projects);
#line 61 "../core/Services/Database.vala"
	_g_object_unref0 (self->priv->_projects);
#line 71 "../core/Services/Database.vala"
	g_rec_mutex_clear (&self->priv->__lock__sections);
#line 71 "../core/Services/Database.vala"
	_g_object_unref0 (self->priv->_sections);
#line 81 "../core/Services/Database.vala"
	g_rec_mutex_clear (&self->priv->__lock__items);
#line 81 "../core/Services/Database.vala"
	_g_object_unref0 (self->priv->_items);
#line 91 "../core/Services/Database.vala"
	g_rec_mutex_clear (&self->priv->__lock__labels);
#line 91 "../core/Services/Database.vala"
	_g_object_unref0 (self->priv->_labels);
#line 101 "../core/Services/Database.vala"
	g_rec_mutex_clear (&self->priv->__lock__reminders);
#line 101 "../core/Services/Database.vala"
	_g_object_unref0 (self->priv->_reminders);
#line 2192 "../core/Services/Database.vala"
	_g_object_unref0 (self->priv->parser);
#line 22 "../core/Services/Database.vala"
	G_OBJECT_CLASS (services_database_parent_class)->finalize (obj);
#line 15568 "Database.c"
}

static GType
services_database_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ServicesDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) services_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServicesDatabase), 0, (GInstanceInitFunc) services_database_instance_init, NULL };
	GType services_database_type_id;
	services_database_type_id = g_type_register_static (G_TYPE_OBJECT, "ServicesDatabase", &g_define_type_info, 0);
	ServicesDatabase_private_offset = g_type_add_instance_private (services_database_type_id, sizeof (ServicesDatabasePrivate));
	return services_database_type_id;
}

GType
services_database_get_type (void)
{
	static volatile gsize services_database_type_id__once = 0;
	if (g_once_init_enter (&services_database_type_id__once)) {
		GType services_database_type_id;
		services_database_type_id = services_database_get_type_once ();
		g_once_init_leave (&services_database_type_id__once, services_database_type_id);
	}
	return services_database_type_id__once;
}

static void
_vala_services_database_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	ServicesDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SERVICES_TYPE_DATABASE, ServicesDatabase);
#line 22 "../core/Services/Database.vala"
	switch (property_id) {
#line 22 "../core/Services/Database.vala"
		case SERVICES_DATABASE_PROJECTS_PROPERTY:
#line 22 "../core/Services/Database.vala"
		g_value_set_object (value, services_database_get_projects (self));
#line 22 "../core/Services/Database.vala"
		break;
#line 22 "../core/Services/Database.vala"
		case SERVICES_DATABASE_SECTIONS_PROPERTY:
#line 22 "../core/Services/Database.vala"
		g_value_set_object (value, services_database_get_sections (self));
#line 22 "../core/Services/Database.vala"
		break;
#line 22 "../core/Services/Database.vala"
		case SERVICES_DATABASE_ITEMS_PROPERTY:
#line 22 "../core/Services/Database.vala"
		g_value_set_object (value, services_database_get_items (self));
#line 22 "../core/Services/Database.vala"
		break;
#line 22 "../core/Services/Database.vala"
		case SERVICES_DATABASE_LABELS_PROPERTY:
#line 22 "../core/Services/Database.vala"
		g_value_set_object (value, services_database_get_labels (self));
#line 22 "../core/Services/Database.vala"
		break;
#line 22 "../core/Services/Database.vala"
		case SERVICES_DATABASE_REMINDERS_PROPERTY:
#line 22 "../core/Services/Database.vala"
		g_value_set_object (value, services_database_get_reminders (self));
#line 22 "../core/Services/Database.vala"
		break;
#line 15633 "Database.c"
		default:
#line 22 "../core/Services/Database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Services/Database.vala"
		break;
#line 15639 "Database.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

